/**
 * XLSYS常量定义类
 */
qx.Interface.define("xlsys.base.XLSYS",
{
	statics :
	{		
		JSON_OBJ_HASHCODE : "_hashcode",
		JSON_OBJ_CONTENT : "_content",
		JSON_OBJ_DATA_TYPE : "_datatype",
		JSON_OBJ_CLASS : "_classname",
		
		PLATFORM : "_PLATFORM",
		PLATFORM_WEB : 1,
		PLATFORM_MOBILE : 2,
		PLATFORM_TEMPLATE : 3,
		PLATFORM_DESKTOP : 4,
		PLATFORM_PURE_JSON : 5,
		
		OS_ANDROID : 1,
		OS_IOS : 2,

		DATA_TYPE_NULL : 0,
		DATA_TYPE_STR : 1,
		DATA_TYPE_SHORT : 2,
		DATA_TYPE_INT : 3,
		DATA_TYPE_LONG : 4,
		DATA_TYPE_CHAR : 5,
		DATA_TYPE_BOOL : 7,
		DATA_TYPE_FLOAT : 8,
		DATA_TYPE_DOUBLE : 9,
		DATA_TYPE_BYTE : 10,
		DATA_TYPE_BYTE_ARRAY : 11,
		DATA_TYPE_OBJECT : 12,
		DATA_TYPE_OBJECT_ARRAY : 13,
		DATA_TYPE_COLLECTION : 14,
		DATA_TYPE_MAP : 15,
		DATA_TYPE_BIGDECIMAL : 16,
		DATA_TYPE_DATE : 17,
		DATA_TYPE_ENTRY : 18,
		DATA_TYPE_ENTRY_ARRAY : 19,
		DATA_TYPE_STR_ARRAY : 20,
		DATA_TYPE_EXCEPTION : 21,
		DATA_TYPE_DATA_SET_ROW : 22,
		
		COMMAND_PERMISSION_DENIED : "_COMMAND_PERMISSION_DENIED",
		COMMAND_OK : "_COMMAND_OK",
		COMMAND_WHOLE_SESSION : "_COMMAND_WHOLE_SESSION",
		COMMAND_BUSY : "_COMMAND_BUSY",
		COMMAND_INFO : "_COMMAND_INFO",
		COMMAND_ERROR : "_COMMAND_ERROR",
		
		COMMAND_FOR_TEST : "_COMMAND_FOR_TEST",

		COMMAND_DB_GET_ALL_TABLE_BASE_INFO : "_COMMAND_DB_GET_ALL_TABLE_BASE_INFO",
		COMMAND_DB_GET_TABLE_INFO : "_COMMAND_DB_GET_TABLE_INFO",
		COMMAND_DB_SQL_SELECT : "_COMMAND_DB_SQL_SELECT",
		COMMAND_DB_SQL_EXECUTE : "_COMMAND_DB_SQL_EXECUTE",
		COMMAND_DB_GET_RESULT_COUNT : "_COMMAND_DB_GET_RESULT_COUNT",
		COMMAND_DB_SQL_SELECT_AS_ONE_VALUE : "_COMMAND_DB_SQL_SELECT_AS_ONE_VALUE",
		COMMAND_DB_GET_SPLITED_PARAM_BEAN : "_COMMAND_DB_GET_SPLITED_PARAM_BEAN",
		COMMAND_DB_DISABLE_CONSTRAINT : "_COMMAND_DB_DISABLE_CONSTRAINT",
		COMMAND_DB_ENABLE_CONSTRAINT : "_COMMAND_DB_ENABLE_CONSTRAINT",
		COMMAND_DB_FUNC_LOWER : "_COMMAND_DB_FUNC_LOWER",
		COMMAND_DB_FUNC_UPPER : "_COMMAND_DB_FUNC_UPPER",
		COMMAND_DB_FUNC_BYTELENGTH : "_COMMAND_DB_FUNC_BYTELENGTH",
		COMMAND_DB_FUNC_SUBSTRING : "_COMMAND_DB_FUNC_SUBSTRING",
		COMMAND_DB_FUNC_TODATE : "_COMMAND_DB_FUNC_TODATE",
		
		COMMAND_ALLOC_ID : "_COMMAND_ALLOC_ID",
		COMMAND_GET_NEXT_VALUE : "_COMMAND_GET_NEXT_VALUE",
		COMMAND_GET_DATE : "_COMMAND_GET_DATE",
		COMMAND_MULTI_IDENTITY : "_COMMAND_MULTI_IDENTITY",
		COMMAND_MULTI_USER : "_COMMAND_MULTI_USER",
		COMMAND_GET_LOCK : "_COMMAND_GET_LOCK",
		COMMAND_TRY_LOCK : "_COMMAND_TRY_LOCK",
		COMMAND_RELEASE_LOCK : "_COMMAND_RELEASE_LOCK",
		COMMAND_UPLOAD_FILE : "_COMMAND_UPLOAD_FILE",
		COMMAND_DOWNLOAD_FILE : "_COMMAND_DOWNLOAD_FILE",
		COMMAND_GET_VIDEO_KEY_PIC : "COMMAND_GET_VIDEO_KEY_PIC",
		COMMAND_GET_FILE_URL : "_COMMAND_GET_FILE_URL",
		COMMAND_TRANSPORT_DATA : "_COMMAND_TRANSPORT_DATA",
		COMMAND_REFRESH_BUFFER : "_COMMAND_REFRESH_BUFFER",
		COMMAND_FORCE_RELOAD_BUFFER : "_COMMAND_FORCE_RELOAD_BUFFER",
		COMMAND_UPDATE_BUFFER_VERSION : "_COMMAND_UPDATE_BUFFER_VERSION",
		COMMAND_GET_BUFFER_VERSION : "_COMMAND_GET_BUFFER_VERSION",
		COMMAND_GET_LOCAL_BUFFER_VERSION : "_COMMAND_GET_LOCAL_BUFFER_VERSION",
		COMMAND_GET_ALL_BUFFER_NAME : "_COMMAND_GET_ALL_BUFFER_NAME",
		COMMAND_GET_ENV_MODEL : "_COMMAND_GET_ENV_MODEL",
		COMMAND_GET_MODEL : "_COMMAND_GET_MODEL",
		COMMAND_GET_ALL_MODEL : "_COMMAND_GET_ALL_MODEL",
		COMMAND_GET_MODEL_COUNT : "_COMMAND_GET_MODEL_COUNT",
		COMMAND_GET_TRANSLATE_DATA : "_COMMAND_GET_TRANSLATE_DATA",
		COMMAND_EXPORT_DATA : "_COMMAND_EXPORT_DATA",
		COMMAND_EXPORT_DATA_PROGRESS : "_COMMAND_EXPORT_DATA_PROGRESS",
		COMMAND_DB_BACKUP : "_COMMAND_DB_BACKUP",
		COMMAND_IMPORT_DATA : "_COMMAND_IMPORT_DATA",
		COMMAND_IMPORT_DATA_PROGRESS : "_COMMAND_IMPORT_DATA_PROGRESS",
		COMMAND_PRINT_EXCEL : "_COMMAND_PRINT_EXCEL",
		COMMAND_PASTE_RELATION_RECORD : "_COMMAND_PASTE_RELATION_RECORD",
		COMMAND_REMOVE_RELATION_RECORD : "_COMMAND_REMOVE_RELATION_RECORD",
		COMMAND_REMUXING_VIDEO : "_COMMAND_REMUXING_VIDEO",
		COMMAND_CHECK_UPDATE : "_COMMAND_CHECK_UPDATE",
		COMMAND_SAVE_CLIENT_BUFFER_TO_FILE : "_COMMAND_SAVE_CLIENT_BUFFER_TO_FILE",
		COMMAND_SAVE_CLIENT_BUFFER_TO_JS : "_COMMAND_SAVE_CLIENT_BUFFER_TO_JS",
		COMMAND_CREATE_PRELOAD_AND_CONFIG_JS : "_COMMAND_CREATE_PRELOAD_AND_CONFIG_JS",
		
		// Client端专用的Command命令
		COMMAND_GET_ALL_DB_ID : "_COMMAND_GET_ALL_DB_ID",
		COMMAND_GET_ALL_ENV_ID : "_COMMAND_GET_ALL_ENV_ID",
		COMMAND_IDENTITY_VERIFICATION : "_COMMAND_IDENTITY_VERIFICATION",
		
		// 以下是Base包中的Session相关常量
		SESSION_DEFAULT_ID : "_SESSION_DEFAULT_ID",
		SESSION_ENV_ID : "_SESSION_ENV_ID",
		SESSION_USER_ID : "_SESSION_USER_ID",
		SESSION_USER_NAME : "_SESSION_USER_NAME",
		SESSION_PASS_WORD : "_SESSION_PASS_WORD",
		SESSION_DEPT_ID : "_SESSION_DEPT_ID",
		SESSION_PST_ID : "_SESSION_PST_ID",
		SESSION_KEEPDEPT_ID : "_SESSION_KEEPDEPT_ID",
		SESSION_IDENTITY : "_SESSION_IDENTITY",
		SESSION_ADMIN : "_SESSION_ADMIN",
		SESSION_SUPERMODE : "_SESSION_SUPERMODE",
		SESSION_SUPERMODE_ADMIN_ID : "_SESSION_SUPERMODE_ADMIN_ID",
		SESSION_SUPERMODE_ADMIN_NAME : "_SESSION_SUPERMODE_ADMIN_NAME",
		SESSION_LANGUAGE : "_SESSION_LANGUAGE",
		SESSION_OS : "_SESSION_OS",
		
		SESSION_TEMP_CONTEXT : "_SESSION_TEMP_CONTEXT",
		SESSION_TEMP_DATASET : "_SESSION_TEMP_DATASET",
		SESSION_TEMP_TABLE_NAME : "_SESSION_TEMP_TABLE_NAME",
		SESSION_TEMP_COLUMN_NAME : "_SESSION_TEMP_COLUMN_NAME",
		SESSION_TEMP_CODE_LIKE : "_SESSION_TEMP_CODE_LIKE",
		SESSION_TEMP_USE_CACHE : "_SESSION_TEMP_USE_CACHE",
		SESSION_TEMP_STEP : "_SESSION_TEMP_STEP",
		
		CODE_NAME_RELATION : ":",
		KEY_CODE_SEPARATOR : ";",
		PARAM_RELATION : "=",
		PARAM_QUESTION : "?",
		PARAM_AND : "&",
		
		BUFFER_FRAME_MODEL : "_BUFFER_FRAME_MODEL",
		BUFFER_UIMODULE_MODEL : "_BUFFER_UIMODULE_MODEL",
		BUFFER_TRANSLATION_PREFIX : "_BUFFER_TRANSLATION_",
		BUFFER_MENU_MODEL : "_BUFFER_MENU_MODEL",
		BUFFER_VIEW_MODEL : "_BUFFER_VIEW_MODEL",
		BUFFER_TOOL_MODEL : "_BUFFER_TOOL_MODEL",
		BUFFER_HANDLER_MODEL : "_BUFFER_HANDLER_MODEL",
		BUFFER_TABLE_INFO_PREFIX : "_BUFFER_TABLE_INFO_",
		
		STATIC_METHOD_PREFIX : "StaticMethod:",
		
		UPLOAD_PARAM_ATTACHMENT : "_UPLOAD_PARAM_ATTACHMENT",
		DOWNLOAD_PARAM_URL : "_DOWNLOAD_PARAM_URL",
		DOWNLOAD_PARAM_FILE_NAME : "_DOWNLOAD_PARAM_FILE_NAME",
		
		ENV_SERVLET_URL : "xlsys.servleturl",
		ENV_UPLOAD_URL : "xlsys.uploadurl",
		ENV_DOWNLOAD_URL : "xlsys.downloadurl",
		ENV_ENTRY_POINT : "xlsys.entrypoint",
		ENV_COOKIE_EXPIRES : "xlsys.cookieexpires",
		ENV_LOG_LEVEL : "xlsys.loglevel",
		ENV_LOG_CLASS : "xlsys.logclass",
		ENV_APP_VERSION : "xlsys.appversion",
		ENV_APP_NAME : "xlsys.appname",
		ENV_DEFAULT_ENV_ID : "xlsys.defaultEnvId",
		ENV_PRELOAD_BUFFER : "xlsys.preloadbuffer",
		
		CODELIKE_COMMON : "________________"
	}
});