/**
 * 缓冲抽象类
 */
qx.Class.define("xlsys.base.buffer.AbstractBuffer", 
{
	type : "abstract",
	extend : qx.core.Object,
	implement : [xlsys.base.buffer.XlsysBuffer],
	include : [xlsys.base.buffer.MXlsysBuffer],

	construct : function()
	{
		this.base(arguments);
		this.allEnvBufferMap = new xlsys.java.util.HashMap();
	},
	
	members : 
	{
		allEnvBufferMap : null,

		/**
		 * 支持以下方法:
		 * getBufferMap(envId, bufferName);
		 * getBufferMap(envId, bufferName, mapClass);
		 */
		getBufferMap : function(envId, bufferName, mapClass)
		{
			if(mapClass==null) mapClass = "xlsys.java.util.LinkedHashMap";
			var envBufferMap = this.allEnvBufferMap.get(envId);
			if(envBufferMap==null)
			{
				envBufferMap = new xlsys.java.util.HashMap();
				this.allEnvBufferMap.put(envId, envBufferMap);
			}
			var bufferMap = envBufferMap.get(bufferName);
			if(bufferMap==null)
			{
				try
				{
					bufferMap = xlsys.base.util.ObjectUtil.tryInitObj(mapClass);
				}
				catch(err)
				{
					bufferMap = new xlsys.java.util.LinkedHashMap();
				}
				envBufferMap.put(bufferName, bufferMap);
			}
			return bufferMap;
		},
		
		getFinalStorageObject : function(bufferName, paramMap)
		{
			return this._getFinalStorageObject(bufferName, paramMap);
		},
		
		getBufferData : function(bufferName, paramMap, callback)
		{
			return this._getBufferData(bufferName, paramMap, callback);
		},
		
		updateCurrentVersion : function(bufferName, callback)
		{
			return this._updateCurrentVersion(bufferName, callback);
		},
		
		getCurrentVersion : function(bufferName, callback)
		{
			return this._getCurrentVersion(bufferName, callback);
		},
		
		reloadAllData : function(bufferName, forceLoad, callback)
		{
			this._reloadAllData(bufferName, forceLoad, callback);
		},
		
		reloadData : function(bufferName, paramMap, forceLoad, callback)
		{
			this._reloadData(bufferName, paramMap, forceLoad, callback);
		}
	}
});