/**
 * 缓冲接口中的部分接口默认实现
 * @lint environmentNonLiteralKey(xlsys.base.XLSYS.ENV_PRELOAD_BUFFER)
 */
qx.Mixin.define("xlsys.base.buffer.MXlsysBuffer", 
{
	statics : 
	{
		versionMap : null,
		accessBuffers : {}
	},
	
	members : 
	{
		_getFinalStorageObject : function(bufferName, mark)
		{
			// 查找是否存在代理, 如果不存在代理则直接调用getStorageObject方法, 否则调用代理方法
			var preloadBuffer = qx.core.Environment.get(xlsys.base.XLSYS.ENV_PRELOAD_BUFFER);
			var delegateClass = null;
			if(preloadBuffer!=null&&
				preloadBuffer["bufferConfig"]&&
				preloadBuffer["bufferConfig"][bufferName])
			{
				var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
				var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
				var cfgArr = preloadBuffer["bufferConfig"][bufferName];
				for(var i=0;i<cfgArr.length;++i)
				{
					var cfg = cfgArr[i];
					var tempEnvId = cfg["envId"];
					var tempMark = cfg["mark"];
					if(tempEnvId!=envId||tempMark!=mark) continue;
					var tempDelegate = cfg["delegate"];
					if(tempDelegate!=null) delegateClass = tempDelegate;
					break;
				}
			}
			var storageObject = null;
			if(delegateClass==null) storageObject = this.getStorageObject(bufferName, mark);
			else
			{
				var delegate = xlsys.base.util.ReflectUtil.newInstance(delegateClass);
				storageObject = delegate.getStorageObject(this, bufferName, mark);
			}
			return storageObject;
		},
		
		_getBufferData : function(bufferName, paramMap, callback)
		{
			if(callback) this.isBufferComplete(bufferName, qx.Bootstrap.bind(this.__getBufferData0, this, bufferName, paramMap, callback));
			else
			{
				var isComplete = this.isBufferComplete(bufferName);
				if(!isComplete) this.reloadDataFromLocalStorage(bufferName);
				var ret = this.doGetBufferData(bufferName, paramMap);
				if(!isComplete&&this.isBufferComplete(bufferName))
				{
					var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
					this.saveDataToLocalStorage(bufferName, storageObject);
				}
				return ret;
			}
		},
		
		__getBufferData0 : function(bufferName, paramMap, callback, isComplete)
		{
			if(!isComplete) this.reloadDataFromLocalStorage(bufferName, qx.Bootstrap.bind(this.__getBufferData1, this, bufferName, paramMap, callback, isComplete));
			else this.__getBufferData1(bufferName, paramMap, callback, isComplete);
		},
		
		__getBufferData1 : function(bufferName, paramMap, callback, isComplete)
		{
			this.doGetBufferData(bufferName, paramMap, qx.Bootstrap.bind(this.__getBufferData2, this, bufferName, callback, isComplete));
		},
		
		__getBufferData2 : function(bufferName, callback, isComplete, ret)
		{
			callback(ret);
			this.isBufferComplete(bufferName, qx.Bootstrap.bind(this.__getBufferData3, this, bufferName, isComplete));
		},
		
		__getBufferData3 : function(bufferName, isComplete, isComplete2)
		{
			if(!isComplete&&isComplete2)
			{
				var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
				this.saveDataToLocalStorage(bufferName, storageObject, qx.Bootstrap.bind(this.__whatEver, this));
			}
		},
		
		__whatEver : function() {},
		
		_updateCurrentVersion : function(bufferName, callback)
		{
			if(callback) xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_UPDATE_BUFFER_VERSION, bufferName, qx.Bootstrap.bind(this.__updateCurrentVersion1, this, bufferName, callback));
			else
			{
				var version = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_UPDATE_BUFFER_VERSION, bufferName);
				this.__updateCurrentVersion2(bufferName, version);
				return version;
			}
		},
		
		__updateCurrentVersion1 : function(bufferName, callback, version)
		{
			this.__updateCurrentVersion2(bufferName, version);
			callback(version);
		},
		
		__updateCurrentVersion2 : function(bufferName, version)
		{
			var versionMap = xlsys.base.buffer.MXlsysBuffer.versionMap;
			var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
			var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
			var tempMap = versionMap.get(envId);
			if(tempMap==null)
			{
				tempMap = new xlsys.java.util.HashMap();
				versionMap.put(envId, tempMap);
			}
			tempMap.put(bufferName, version);
		},
		
		_getCurrentVersion : function(bufferName, callback)
		{
			if(xlsys.base.buffer.MXlsysBuffer.versionMap==null) xlsys.base.buffer.MXlsysBuffer.versionMap = new xlsys.java.util.HashMap();
			var versionMap = xlsys.base.buffer.MXlsysBuffer.versionMap;
			var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
			var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
			var tempMap = versionMap.get(envId);
			if(tempMap==null)
			{
				tempMap = new xlsys.java.util.HashMap();
				versionMap.put(envId, tempMap);
			}
			var version = tempMap.get(bufferName);
			if(callback)
			{
				if(version==-1||version==null) xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_GET_BUFFER_VERSION, bufferName, qx.Bootstrap.bind(this.__getCurrentVersion1, this, tempMap, bufferName, callback));
				else this.__getCurrentVersion1(tempMap, bufferName, callback, version);
			}
			else
			{
				if(version==-1||version==null) version = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_GET_BUFFER_VERSION, bufferName);
				tempMap.put(bufferName, version);
				return version;
			}
		},
		
		__getCurrentVersion1 : function(tempMap, bufferName, callback, version)
		{
			tempMap.put(bufferName, version);
			callback(version);
		},
		
		_reloadAllData : function(bufferName, forceLoad, callback)
		{
			if(forceLoad==null) forceLoad = false;
			if(callback) this.reloadDataFromLocalStorage(bufferName, qx.Bootstrap.bind(this.__reloadAllData1, this, bufferName, forceLoad, callback));
			else
			{
				if(!this.reloadDataFromLocalStorage(bufferName))
				{
					this.reloadDataDirectly(bufferName, null, forceLoad);
					if(this.isBufferComplete(bufferName))
					{
						var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
						this.saveDataToLocalStorage(bufferName, storageObject);
					}
				}
			}
		},
		
		__reloadAllData1 : function(bufferName, forceLoad, callback, success)
		{
			if(!success) this.reloadDataDirectly(bufferName, null, forceLoad, qx.Bootstrap.bind(this.__reloadData1, this, bufferName, callback));
			else callback();
		},
		
		_reloadData : function(bufferName, paramMap, forceLoad, callback)
		{
			if(forceLoad==null) forceLoad = false;
			if(callback)
			{
				if(paramMap==null) this.reloadAllData(bufferName, forceLoad, callback);
				else this.reloadDataDirectly(bufferName, paramMap, forceLoad, qx.Bootstrap.bind(this.__reloadData1, this, bufferName, callback));
			}
			else
			{
				if(paramMap==null) this.reloadAllData(bufferName, forceLoad);
				else
				{
					this.reloadDataDirectly(bufferName, paramMap, forceLoad);
					if(this.isBufferComplete(bufferName))
					{
						var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
						this.saveDataToLocalStorage(bufferName, storageObject);
					}
				}
			}
		},
		
		__reloadData1 : function(bufferName, callback)
		{
			callback();
			this.isBufferComplete(bufferName, qx.Bootstrap.bind(this.__reloadData2, this, bufferName));
		},
		
		__reloadData2 : function(bufferName, isComplete)
		{
			if(isComplete)
			{
				var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
				this.saveDataToLocalStorage(bufferName, storageObject, qx.Bootstrap.bind(this.__whatEver, this));
			}
		}
	}
});