/**
 * 不可存储的缓冲抽象类
 */
qx.Class.define("xlsys.base.buffer.UnstorageBuffer",
{
	type : "abstract",
	extend : xlsys.base.buffer.AbstractBuffer,
	
	members : 
	{
		getStorageObject : function(bufferName, mark)
		{
			return this.getBufferMap(bufferName);
		},

		isBufferComplete : function(bufferName, callback)
		{
			if(callback) callback(false);
			return false;
		},

		reloadDataDirectly : function(bufferName, paramMap, forceLoad, callback)
		{
			this.getBufferMap(bufferName).clear();
			if(callback) callback();
		},

		loadDataFromStorageObject : function(bufferName, storageObj, mark, callback)
		{
			if(callback) callback(false);
			else return false;
		},

		doGetBufferData : function(bufferName, paramMap, callback)
		{
			var bufferData = this.getBufferMap(bufferName);
			if(callback) callback(bufferData);
			else return bufferData;
		},
		
		saveDataToLocalStorage : function(bufferName, storageObject, callback)
		{
			if(callback) callback(false);
			else return false;
		},
		
		reloadDataFromLocalStorage : function(bufferName, callback)
		{
			if(callback) callback(false);
			else return false;
		},
		
		getLocalStorageVersion : function(bufferName, callback)
		{
			if(callback) callback(-1);
			else return -1;
		}
	}
});