/**
 * 标准缓冲对象接口
 */
qx.Interface.define("xlsys.base.buffer.XlsysBuffer",
{
	statics : 
	{
		MARK_ALL : "all"
	},
	
	members :
	{
		getStorageObject : function(bufferName, mark) {this.assertArgumentsCount(arguments, 2, 2);},
		
		isBufferComplete : function(bufferName, callback) {this.assertArgumentsCount(arguments, 1, 2);},
		
		reloadDataDirectly : function(bufferName, paramMap, forceLoad, callback) {this.assertArgumentsCount(arguments, 1, 4);},
		
		loadDataFromStorageObject : function(bufferName, storageObj, mark) {this.assertArgumentsCount(arguments, 3, 3);},
		
		doGetBufferData : function(bufferName, paramMap, callback) {this.assertArgumentsCount(arguments, 1, 3);},
		
		saveDataToLocalStorage : function(bufferName, storageObject, callback) {this.assertArgumentsCount(arguments, 2, 3);},
		
		reloadDataFromLocalStorage : function(bufferName, callback) {this.assertArgumentsCount(arguments, 1, 2);},
		
		getLocalStorageVersion : function(bufferName, callback) {this.assertArgumentsCount(arguments, 1, 2);},
		
		/**
		 * 在MXlsysBuffer中有默认实现
		 */
		getFinalStorageObject : function(bufferName, mark) {this.assertArgumentsCount(arguments, 2, 2);},
		
		/**
		 * 在MXlsysBuffer中有默认实现
		 */
		getBufferData : function(bufferName, paramMap, callback) {this.assertArgumentsCount(arguments, 1, 3);},
		
		/**
		 * 在MXlsysBuffer中有默认实现
		 */
		updateCurrentVersion : function(bufferName, callback) {this.assertArgumentsCount(arguments, 1, 2);},
		
		/**
		 * 在MXlsysBuffer中有默认实现
		 */
		getCurrentVersion : function(bufferName, callback) {this.assertArgumentsCount(arguments, 1, 2);},
		
		/**
		 * 在MXlsysBuffer中有默认实现
		 */
		reloadAllData : function(bufferName, forceLoad, callback) {this.assertArgumentsCount(arguments, 1, 3);},
		
		/**
		 * 在MXlsysBuffer中有默认实现
		 */
		reloadData : function(bufferName, paramMap, forceLoad, callback) {this.assertArgumentsCount(arguments, 1, 4);}
	}
});