/**
 * IClientDataBase接口
 */
qx.Interface.define("xlsys.base.database.IClientDataBase",
{
	extend : [xlsys.base.database.IDataBase],
	
	members:
	{
		getDataBaseId : function()
		{
			throw new xlsys.java.lang.Exception("UnsupportedOperation");
		},

		getEnvId : function() {},

		/**
		 * 需要重载以下方法
		 * getTableInfo(tableName);
		 * getTableInfo(tableName, callback);
		 */
		getTableInfo : function(tableName) {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需要重载以下方法
		 * getAllTableBaseInfo();
		 * getAllTableBaseInfo(callback);
		 */
		getAllTableBaseInfo : function() {this.assertArgumentsCount(arguments, 0, 1);},

		/**
		 * 需重载以下方法
		 * getResultCount(paramBean);
		 * getResultCount(paramBean, callback);
		 */
		getResultCount : function(paramBean) {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需要重载以下方法
		 * sqlSelectAsOneValue(selectSql);
		 * sqlSelectAsOneValue(paramBean);
		 * sqlSelectAsOneValue(selectSql, callback);
		 * sqlSelectAsOneValue(paramBean, callback);
		 */
		sqlSelectAsOneValue : function(sqlOrPb) {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需要重载以下方法
		 * sqlSelect(String selectSql);
		 * sqlSelect(String selectSql, callback);
		 * sqlSelect(ParamBean paramBean);
		 * sqlSelect(ParamBean paramBean, callback);
		 * sqlSelect(ParamBean paramBean, int beginRowNum, int endRowNum);
		 * sqlSelect(ParamBean paramBean, int beginRowNum, int endRowNum, callback);
		 * sqlSelect(ParamBean paramBean, Map<String, Integer> sortColMap, int beginRowNum, int endRowNum);
		 * sqlSelect(ParamBean paramBean, Map<String, Integer> sortColMap, int beginRowNum, int endRowNum, callback);
		 */
		sqlSelect : function() {this.assertArgumentsCount(arguments, 1, 5);},

		/**
		 * 需要重载以下方法
		 * sqlExecute(String executeSql);
		 * sqlExecute(String executeSql, callback);
		 * sqlExecute(ExecuteBean executeBean);
		 * sqlExecute(ExecuteBean executeBean, callback);
		 * sqlExecute(List<? extends ISqlBean> sqlBeanList);
		 * sqlExecute(List<? extends ISqlBean> sqlBeanList, callback);
		 * sqlExecute(ParamBean paramBean);
		 * sqlExecute(ParamBean paramBean, callback);
		 */
		sqlExecute : function() {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需要重载以下方法
		 * disableConstraint(tableName, constraintName);
		 * disableConstraint(tableName, constraintName, callback);
		 */
		disableConstraint : function(tableName, constraintName) {this.assertArgumentsCount(arguments, 2, 3);},

		/**
		 * 需要重载以下方法
		 * enableConstraint(tableName, constraintName);
		 * enableConstraint(tableName, constraintName, callback);
		 */
		enableConstraint : function(tableName, constraintName) {this.assertArgumentsCount(arguments, 2, 3);},

		/**
		 * 需要重载以下方法
		 * getLowerFunc(srcExp);
		 * getLowerFunc(srcExp, callback);
		 */
		getLowerFunc : function(srcExp) {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需要重载以下方法
		 * getUpperFunc(srcExp);
		 * getUpperFunc(srcExp, callback);
		 */
		getUpperFunc : function(srcExp) {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需要重载以下方法
		 * getByteLengthFunc(srcExp);
		 * getByteLengthFunc(srcExp, callback);
		 */
		getByteLengthFunc : function(srcExp) {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需重载以下方法
		 * getSubStringFunc(String srcExp, int begin);
		 * getSubStringFunc(String srcExp, int begin, callback);
		 * getSubStringFunc(String srcExp, int begin, int end);
		 * getSubStringFunc(String srcExp, int begin, int end, callback);
		 */
		getSubStringFunc : function() {this.assertArgumentsCount(arguments, 2, 4);},

		/**
		 * 需重载以下方法
		 * getToDateFunc(date);
		 * getToDateFunc(date, callback);
		 */
		getToDateFunc : function(date) {this.assertArgumentsCount(arguments, 1, 2);},

		/**
		 * 需重载以下方法
		 * commit();
		 * commit(callback);
		 */
		commit : function() {this.assertArgumentsCount(arguments, 0, 1);},

		rollback : function() {},

		/**
		 * 需重载以下方法
		 * setAutoCommit(autoCommit);
		 * setAutoCommit(autoCommit, callback);
		 */
		setAutoCommit : function(autoCommit) {this.assertArgumentsCount(arguments, 1, 2);},

		getAutoCommit : function() {},

		/**
		 * 需重载以下方法
		 * close();
		 * close(callback);
		 */
		close : function() {this.assertArgumentsCount(arguments, 0, 1);},

		isClose : function() {}
	}
});