/**
 * IDataBase接口
 */
qx.Interface.define("xlsys.base.database.IDataBase",
{
	statics : 
	{
		BUFFER_KEY_TABLE_NAME : "_BUFFER_KEY_TABLE_NAME"
	},
	
	members:
	{
		getDataBaseId : function() {},

		getTableInfo : function(tableName) {},

		getAllTableBaseInfo : function() {},

		getResultCount : function(paramBean) {},

		/**
		 * 需要重载以下方法
		 * sqlSelectAsOneValue(selectSql);
		 * sqlSelectAsOneValue(paramBean);
		 */
		sqlSelectAsOneValue : function(sqlOrPb) {},

		/**
		 * 需要重载以下方法
		 * sqlSelect(String selectSql);
		 * sqlSelect(ParamBean paramBean);
		 * sqlSelect(ParamBean paramBean, int beginRowNum, int endRowNum);
		 * sqlSelect(ParamBean paramBean, Map<String, Integer> sortColMap, int beginRowNum, int endRowNum);
		 */
		sqlSelect : function() {},

		/**
		 * 需要重载以下方法
		 * sqlExecute(String executeSql);
		 * sqlExecute(ExecuteBean executeBean);
		 * sqlExecute(List<? extends ISqlBean> sqlBeanList);
		 * sqlExecute(ParamBean paramBean);
		 */
		sqlExecute : function() {},
		
		getSplitedParamBean : function(paramBean, beginRowNum, endRowNum) {},

		disableConstraint : function(tableName, constraintName) {},

		enableConstraint : function(tableName, constraintName) {},

		getLowerFunc : function(srcExp) {},

		getUpperFunc : function(srcExp) {},

		getByteLengthFunc : function(srcExp) {},

		/**
		 * 需重载以下方法
		 * getSubStringFunc(String srcExp, int begin);
		 * getSubStringFunc(String srcExp, int begin, int end);
		 */
		getSubStringFunc : function() {},

		getToDateFunc : function(date) {},

		commit : function() {},

		rollback : function() {},

		setAutoCommit : function(autoCommit) {},

		getAutoCommit : function() {},

		close : function() {},

		isClose : function() {}
	}
});