/**
 * 表约束类
 */
qx.Class.define("xlsys.base.database.TableConstraint",
{
	extend : xlsys.java.io.Serializable,
	
	statics : 
	{
		CONSTRAINT_TYPE_UNKNOWN : 0,
		CONSTRAINT_TYPE_PK : 1,
		CONSTRAINT_TYPE_FK : 2,
		CONSTRAINT_TYPE_U : 3
	},
	
	construct : function(constraintName)
	{
		this.constraintName = constraintName;
		this.tableName = null;
		this.constraintType = null;
		this.refConstraintName = null;
		this.refTableName = null;
		this.columnNameSet = new xlsys.java.util.HashSet();
	},
	
	members :
	{
		constraintName : null,
		tableName : null,
		constraintType : null,
		refConstraintName : null,
		refTableName : null,
		columnNameSet : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("constraintName");
			arr.push("tableName");
			arr.push("constraintType");
			arr.push("refConstraintName");
			arr.push("refTableName");
			arr.push("columnNameSet");
			return arr;
		},
		
		addColumnName : function(columnName)
		{
			this.columnNameSet.add(this.columnName.toLowerCase());
		},

		getColumnNameSet : function()
		{
			return this.columnNameSet;
		},

		getConstraintName : function()
		{
			return this.constraintName;
		},

		setConstraintName : function(constraintName)
		{
			this.constraintName = constraintName.toLowerCase();
		},

		getTableName : function()
		{
			return this.tableName;
		},

		setTableName : function(tableName)
		{
			this.tableName = tableName.toLowerCase();
		},

		getConstraintType : function()
		{
			return this.constraintType;
		},

		setConstraintType : function(constraintType)
		{
			this.constraintType = constraintType;
		},

		getRefConstraintName : function()
		{
			return this.refConstraintName;
		},

		setRefConstraintName : function(refConstraintName)
		{
			this.refConstraintName = (refConstraintName==null?refConstraintName:refConstraintName.toLowerCase());
		},

		getRefTableName : function()
		{
			return this.refTableName;
		},

		setRefTableName : function(refTableName)
		{
			this.refTableName = (refTableName==null?refTableName:refTableName.toLowerCase());
		}
	}
});