/**
 * 表信息类
 */
qx.Class.define("xlsys.base.database.TableInfo",
{
	extend : xlsys.java.io.Serializable,
	
	construct : function(tableName)
	{
		this.tableName = tableName;
		this.tableComment = null;
		this.dataColumnMap = new xlsys.java.util.HashMap();
		this.columnCommentMap = new xlsys.java.util.HashMap();
		this.dataColumnList = new xlsys.java.util.ArrayList();
		this.pkColSet = new xlsys.java.util.LinkedHashSet();
		this.constraintMap = new xlsys.java.util.HashMap();
	},
	
	members :
	{
		tableName : null,
		tableComment : null,
		dataColumnMap : null,
		columnCommentMap : null,
		dataColumnList : null,
		pkColSet : null,
		constraintMap : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("tableName");
			arr.push("tableComment");
			arr.push("dataColumnMap");
			arr.push("columnCommentMap");
			arr.push("dataColumnList");
			arr.push("pkColSet");
			arr.push("constraintMap");
			return arr;
		},
		
		getTableComment : function()
		{
			return this.tableComment;
		},

		setTableComment : function(tableComment)
		{
			this.tableComment = tableComment;
		},

		addDataSetColumn : function(dsc)
		{
			if(!this.dataColumnList.contains(dsc))
			{
				this.dataColumnMap.put(dsc.getColumnName(), dsc);
				this.dataColumnList.add(dsc);
				if(this.pkColSet.contains(dsc.getColumnName()))
				{
					dsc.setPrimaryKey(true);
				}
				if(dsc.isPrimaryKey())
				{
					this.pkColSet.add(dsc.getColumnName());
				}
			}
		},

		addColumnComment : function(colName, comment)
		{
			this.columnCommentMap.put(colName.toLowerCase(), comment);
		},

		getColumnComment : function(colName)
		{
			return this.columnCommentMap.get(colName);
		},

		addPkCol : function(pkColName)
		{
			pkColName = pkColName.toLowerCase();
			this.pkColSet.add(pkColName);
			var size = this.dataColumnList.size();
			for(var i=0;i<size;++i)
			{
				var dsc = this.dataColumnList.get(i);
				if(dsc.getColumnName()==pkColName)
				{
					dsc.setPrimaryKey(true);
					break;
				}
			}
		},

		addConstraint : function(constraintName, constraint)
		{
			this.constraintMap.put(constraintName, constraint);
		},

		getConstraint : function(constraintName)
		{
			return this.constraintMap.get(constraintName);
		},

		getConstraintMap : function()
		{
			return this.constraintMap;
		},

		getDataSetColumn : function(colName)
		{
			var dsc = this.dataColumnMap.get(colName.toLowerCase());
			return dsc;
		},

		getTableName : function()
		{
			return this.tableName;
		},

		getDataColumnList : function()
		{
			return this.dataColumnList;
		},

		getPkColSet : function()
		{
			return this.pkColSet;
		}
	}
});