/**
 * ExecuteBean类
 */
qx.Class.define("xlsys.base.database.bean.ExecuteBean",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.base.database.bean.ISqlBean],
	
	statics : 
	{
		EXECUTE_TYPE_INSERT : 0,
		EXECUTE_TYPE_UPDATE : 1,
		EXECUTE_TYPE_DELETE : 2,
		EXECUTE_TYPE_OTHER : 9
	},
	
	construct : function()
	{
		this.executeSql = null;
		this.dataList = null;
		this.oldDataMaps = null;
		this.paramColSet = null;
		this.updateWhereColSet = null;
		this.executeType = -1;
		this.tableName = null;
		
		if(arguments.length==1)
		{
			this.executeSql = arguments[0];
			var lowcaseSql = qx.lang.String.trimLeft(this.executeSql.toLowerCase());
			if(qx.lang.String.startsWith(lowcaseSql, "update "))
			{
				this.executeType = this.self(arguments).EXECUTE_TYPE_UPDATE;
				lowcaseSql = lowcaseSql.substring(7).trim();
				var idx = lowcaseSql.indexOf(" ");
				if(idx!=-1) this.tableName = lowcaseSql.substring(0, idx);
			}
			else if(qx.lang.String.startsWith(lowcaseSql, "insert "))
			{
				this.executeType = this.self(arguments).EXECUTE_TYPE_INSERT;
				var idx = lowcaseSql.indexOf(" into ");
				lowcaseSql = lowcaseSql.substring(idx+6).trim();
				idx = lowcaseSql.indexOf(" ");
				if(idx!=-1) this.tableName = lowcaseSql.substring(0, idx);
				idx = this.tableName.indexOf("(");
				if(idx!=-1) this.tableName = this.tableName.substring(0, idx);
			}
			else if(qx.lang.String.startsWith(lowcaseSql, "delete "))
			{
				this.executeType = this.self(arguments).EXECUTE_TYPE_DELETE;
				var idx = lowcaseSql.indexOf(" from ");
				lowcaseSql = lowcaseSql.substring(idx+6).trim();
				idx = lowcaseSql.indexOf(" ");
				if(idx!=-1) this.tableName = lowcaseSql.substring(0, idx);
				else this.tableName = lowcaseSql;
			}
			else
			{
				this.executeType = this.self(arguments).EXECUTE_TYPE_OTHER;
			}
		}
		else if(arguments.length>=2)
		{
			this.executeType = arguments[0];
			this.tableName = arguments[1];
		}
	},
	
	members :
	{
		executeSql : null,
		dataList : null,
		oldDataMaps : null,
		paramColSet : null,
		updateWhereColSet : null,
		executeType : null,
		tableName : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("executeSql");
			arr.push("dataList");
			arr.push("oldDataMaps");
			arr.push("paramColSet");
			arr.push("updateWhereColSet");
			arr.push("executeType");
			arr.push("tableName");
			return arr;
		},
		
		/**
		 * 支持重载以下方法
		 * addData(dataMap);
		 * addData(dataMap, oldDataMap);
		 */
		addData : function()
		{
			if(arguments.length==1)
			{
				var dataMap = arguments[0];
				if(this.dataList==null) this.dataList = new xlsys.java.util.ArrayList();
				if(dataMap!=null) this.dataList.add(dataMap);
			}
			else if(arguments.length>=2)
			{
				var dataMap = arguments[0];
				var oldDataMap = arguments[1];
				if(this.dataList==null) this.dataList = new xlsys.java.util.ArrayList();
				if(oldDataMap!=null&&this.oldDataMaps==null) this.oldDataMaps = new xlsys.java.util.HashMap();
				if(dataMap!=null)
				{
					this.dataList.add(dataMap);
					if(oldDataMap!=null) this.oldDataMaps.put(dataMap, oldDataMap);
				}
			}
		},

		getExecuteType : function()
		{
			return this.executeType;
		},

		getTableName : function()
		{
			return this.tableName;
		},

		setExecuteSql : function(executeSql)
		{
			this.executeSql = executeSql;
		},

		getExecuteSql : function()
		{
			return this.executeSql;
		},

		getDataList : function()
		{
			return this.dataList;
		},

		setDataList : function(dataList)
		{
			this.dataList = dataList;
		},

		getOldDataMaps : function()
		{
			return this.oldDataMaps;
		},

		setOldDataMaps : function(oldDataMaps)
		{
			this.oldDataMaps = oldDataMaps;
		},

		getParamColSet : function()
		{
			return this.paramColSet;
		},

		setParamColSet : function(paramColSet)
		{
			this.paramColSet = paramColSet;
		},

		getUpdateWhereColSet : function()
		{
			return this.updateWhereColSet;
		},

		setUpdateWhereColSet : function(updateWhereColSet)
		{
			this.updateWhereColSet = updateWhereColSet;
		}
	}
});