/**
 * ParamBean类
 */
qx.Class.define("xlsys.base.database.bean.ParamBean",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.base.database.bean.ISqlBean],
	
	construct : function()
	{
		this.selectSql = null;
		this.cursor = -1;
		this.paramsList = null;
		
		if(arguments.length>=1)
		{
			this.selectSql = arguments[0];
		}
	},
	
	members :
	{
		selectSql : null,
		cursor : -1,
		paramsList : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("selectSql");
			arr.push("paramsList");
			return arr;
		},
		
		next : function()
		{
			return this.gotoRow(this.cursor+1);
		},

		previous : function()
		{
			return this.gotoRow(this.cursor-1);
		},

		first : function()
		{
			return this.gotoRow(0);
		},

		last : function()
		{
			if(this.paramsList!=null) return this.gotoRow(this.paramsList.size()-1);
			else return false;
		},

		gotoRow : function(rowIdx)
		{
			var success = false;
			if(this.paramsList!=null&&rowIdx>=0&&rowIdx<this.paramsList.size())
			{
				this.cursor = rowIdx;
				success = true;
			}
			return success;
		},

		getRowIdx : function()
		{
			return this.cursor;
		},

		addParamGroup : function()
		{
			if(this.paramsList==null) this.paramsList = new xlsys.java.util.ArrayList();
			this.paramsList.add(new xlsys.java.util.ArrayList());
			this.cursor = this.paramsList.size()-1;
		},

		setParam : function()
		{
			var idx = null;
			var value = null;
			var javaClass = null;
			if(arguments.length>=3) javaClass = arguments[2];
			if(arguments.length>=2)
			{
				idx = arguments[0];
				value = arguments[1];
				if(javaClass==null)
				{
					if(value!=null) javaClass = xlsys.base.util.ObjectUtil.className(value);
					else throw new xlsys.java.lang.Exception("Can not set param using this method when value is null, use setParam(int, Serializable, String) instead.");
				}
				this.__setParam(this.cursor, idx, value, javaClass);
			}
			else throw new xlsys.java.lang.Exception("Invalid parameter");
		},

		__setParam : function(rowIdx, colIdx, value, javaClass)
		{
			if(rowIdx<0||colIdx<1) throw new xlsys.java.lang.Exception("Invalid parameter : row : " + rowIdx + " col : " + colIdx);
			if(this.paramsList==null) this.paramsList = new xlsys.java.util.ArrayList();
			while(this.paramsList.size()<rowIdx+1)
			{
				this.paramsList.add(new xlsys.java.util.ArrayList());
			}
			var params = this.paramsList.get(rowIdx);
			while(params.size()<colIdx)
			{
				params.add(null);
			}
			var param = new xlsys.base.database.bean.Param(value, javaClass);
			params.set(colIdx-1, param);
		},

		getParam : function()
		{
			var rowIdx = null;
			var colIdx = null;
			if(arguments.length==1)
			{
				rowIdx = this.cursor;
				colIdx = arguments[0];
			}
			else if(arguments.length==2)
			{
				rowIdx = arguments[0];
				colIdx = arguments[1];
			}
			var value = null;
			if(this.paramsList!=null&&rowIdx>=0&&rowIdx<this.paramsList.size())
			{
				var params = this.paramsList.get(rowIdx);
				if(params!=null&&colIdx>=1&&colIdx<=params.size())
				{
					value = params.get(colIdx-1).value;
				}
			}
			return value;
		},

		setSelectSql : function(selectSql)
		{
			this.selectSql = selectSql;
		},

		getSelectSql : function()
		{
			return this.selectSql;
		},

		getParamsList : function()
		{
			return this.paramsList;
		},

		setParamsList : function(paramsList)
		{
			this.paramsList = paramsList;
		}
	}
});