/**
 * Sql工具类
 */
qx.Class.define("xlsys.base.database.util.SqlUtil",
{
	type : "static",
	
	statics :
	{
		isSelectSql : function(sql)
		{
			var success = false;
			if(sql!=null) success = qx.lang.String.startsWith(qx.lang.String.trimLeft(sql.toLowerCase()), "select ");
			return success;
		},
		
		createExpressionSql : function(left, rightValue, macroMap)
		{
			// 获取连接符号
			var connectToken = "=";
			var regexStr = "^(.*(%|_).*)$";
			var regex = new RegExp(regexStr);
			if(regex.test(rightValue)) connectToken = " like ";
			// 获取结果
			var sb = new xlsys.java.lang.StringBuilder();
			regex.compile("^(.*\\[.*\\].*)$");
			if(regex.test(rightValue))
			{
				// 包含公式
				var rightResult = this.replaceExpression(rightValue, macroMap);
				sb.append("(");
				for(var i=0;i<rightResult.length;++i)
				{
					sb.append(left).append(connectToken).append("\'").append(rightResult[i]).append("\'");
					if(i!=rightResult.length-1) sb.append(" or ");
				}
				sb.append(")");
			}
			else
			{
				sb.append(left).append(connectToken).append("\'").append(rightValue).append("\'");
			}
			return sb.toString();
		},
		
		replaceExpression : function(rightValue, macroMap)
		{
			// 先判断是否含有包含多个value的marcoKey
			var valueToken = xlsys.base.util.StringUtil.split(rightValue, "[", "]", true);
			var multiKey = null;
			var multiValue = null;
			for(var i=0;i<valueToken.length;++i)
			{
				var token = valueToken[i];
				if(qx.lang.String.startsWith(token, "[")&&qx.lang.String.endsWith(token, "]"))
				{
					var params = token.substring(1, token.length-1).split(",");
					if(macroMap.containsKey(params[0]))
					{
						if(macroMap.get(params[0]).indexOf(xlsys.base.XLSYS.KEY_CODE_SEPARATOR)!=-1)
						{
							multiValue = macroMap.get(params[0]).split(xlsys.base.XLSYS.KEY_CODE_SEPARATOR);
							multiKey = params[0];
							break;
						}
					}
				}
			}
			// 组装结果
			var result = null;
			var len = 1;
			if(multiValue!=null) len = multiValue.length;
			result = new Array();
			for(var n=0;n<len;++n)
			{
				result.push("");
				for(var i=0;i<valueToken.length;++i)
				{
					var token = valueToken[i];
					if(qx.lang.String.startsWith(token, "[")&&qx.lang.String.endsWith(token, "]"))
					{
						// 表达式
						var params = token.substring(1, token.length-1).split(",");
						if(macroMap.containsKey(params[0]))
						{
							var macroValue = macroMap.get(params[0]);
							if(params[0]==multiKey) macroValue = multiValue[n];
							if(params.length==1) result[n] += macroValue;
							else if(params.length==2)
							{
								var startIdx = parseInt(params[1]);
								result[n] += macroValue.substring(startIdx);
							}
							else if(params.length==3)
							{
								var startIdx = parseInt(params[1]);
								var endIdx = parseInt(params[2]);
								result[n] += macroValue.substring(startIdx, endIdx);
							}
						}
					}
					else result[n] += token;
				}
			}
			return result;
		},
		
		/**
		 * 去除sql中的注释
		 */
		removeComment : function(sql)
		{
			// 去除多行注释
			var splitArr = xlsys.base.util.StringUtil.split(sql, "/\\*", "\\*/", false);
			sql = splitArr.join("");
			// 去除单行注释
			var regex = new RegExp("\r\n|\n\r|\n|\r", "g");
			var splitArr = sql.split(regex);
			var sb = new xlsys.java.lang.StringBuilder();
			for(var i=0;i<splitArr.length;++i)
			{
				var pieces = splitArr[i];
				var idx = xlsys.base.util.StringUtil.indexOfIgnoreMark(pieces, "--", 0, pieces.length, "'");
				if(idx!=-1) sb.append(pieces.substring(0, idx)).append("\n");
				else sb.append(pieces);
			}
			return sb.toString();
		},
		
		getSplitedSql : function(sqlText)
		{
			sqlText = this.removeComment(sqlText);
			var ignoreArr = xlsys.base.util.StringUtil.getAllIndexOf(sqlText, "'", 0, sqlText.length);
			var curIdx = 0;
			var indexArr = new Array();
			while((curIdx=sqlText.indexOf(";", curIdx))!=-1)
			{
				if(xlsys.base.util.StringUtil.__isIndexBetweenMark(curIdx, ignoreArr))
				{
					curIdx += 1;
					continue;
				}
				indexArr.push(curIdx);
				curIdx += 1;
			}
			var arr = new Array();
			var lastIndex = -1;
			for(var i=0;i<indexArr.length;++i)
			{
				arr.push(sqlText.substring(lastIndex+1, indexArr[i]));
				lastIndex = indexArr[i];
			}
			if(lastIndex+1<sqlText.length) arr.push(sqlText.substring(lastIndex+1));
			return arr;
		}
	}
});