/**
 * 数据集行
 */
qx.Class.define("xlsys.base.dataset.DataSetRow",
{
	extend : xlsys.java.io.Serializable,
	
	statics :
	{
		STATUS_VIRTUAL : 0,
		STATUS_COMMON : 1,
		STATUS_FOR_NEW : 2,
		STATUS_REPLACE : 4
	},
	
	construct: function()
	{
		this.changed = false;
		this.changeStatus = null;
		this.oldChangeStatus = null;
		this.cells = new xlsys.java.util.ArrayList();
		this.properties = null;
		if(arguments.length==1&&arguments[0])
		{
			this.changeStatus = this.self(arguments).STATUS_VIRTUAL;
			this.oldChangeStatus = this.self(arguments).STATUS_VIRTUAL;
		}
		else
		{
			this.changeStatus = this.self(arguments).STATUS_COMMON;
			this.oldChangeStatus = this.self(arguments).STATUS_COMMON;
		}
	},
	
	members :
	{
		changed : null,
		changeStatus : null,
		oldChangeStatus : null,
		cells : null,
		properties : null,
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			/*arr.push("changed");
			arr.push("changeStatus");
			arr.push("oldChangeStatus");*/
			arr.push("cells");
			return arr;
		},
		
		addCell : function(cell)
		{
			this.cells.add(cell);
		},

		removeCell : function(cellIndex)
		{
			this.cells.removeAt(cellIndex);
		},

		getCell : function(index)
		{
			return this.cells.get(index);
		},

		setCell : function(index, cell)
		{
			this.cells.set(index, cell);
		},

		getCells : function()
		{
			return this.cells;
		},

		setCells : function(cells)
		{
			this.cells = cells;
		},

		isChanged : function()
		{
			return this.changed;
		},

		setChanged : function(changed)
		{
			this.changed = changed;
		},

		getChangeStatus : function()
		{
			return this.changeStatus;
		},

		setChangeStatus : function(changeStatus)
		{
			this.oldChangeStatus = this.changeStatus;
			this.changeStatus = changeStatus;
		},

		getOldChangeStatus : function()
		{
			return this.oldChangeStatus;
		},

		getProperties : function()
		{
			return this.properties;
		},

		putProperty : function(key, value)
		{
			if(this.properties==null) this.properties = new xlsys.java.util.HashMap();
			this.properties.put(key, value);
		},

		containsProperty : function(key)
		{
			var contains = false;
			if(this.properties!=null)
			{
				contains = this.properties.containsKey(key);
			}
			return contains;
		},

		removeProperty : function(key)
		{
			if(this.properties!=null)
			{
				this.properties.remove(key);
			}
		},

		getProperty : function(key)
		{
			var value = null;
			if(this.properties!=null)
			{
				value = this.properties.get(key);
			}
			return value;
		},

		cloneOf : function(anotherRow)
		{
			for(var i=0;i<anotherRow.cells.size();++i)
			{
				var cell = null;
				if(i>=this.cells.size())
				{
					cell = new xlsys.base.dataset.DataSetCell();
					this.cells.add(cell);
				}
				else cell = this.cells.get(i);
				cell.setContent(anotherRow.cells.get(i).getContent());
			}
			for(var i=this.cells.size()-1;i>=anotherRow.cells.size();--i) this.cells.removeAt(i);
			this.changed = anotherRow.changed;
			this.changeStatus = anotherRow.changeStatus;
			this.oldChangeStatus = anotherRow.oldChangeStatus;
		}
	}
});