/**
 * 支持树形结构的数据集接口
 */
qx.Interface.define("xlsys.base.dataset.ITreeDataSet",
{
	extend : [xlsys.base.dataset.IDataSet],
	
	members :
	{
		/**
		 * 需要重载以下方法:
		 * setTreeColumn(String columnName);
		 * setTreeColumn(String columnName, int sortType);
		 * setTreeColumn(int columnIdx);
		 * setTreeColumn(int columnIdx, int sortType);
		 */
		setTreeColumn : function(colNameOrIdx) {this.assertArgumentsCount(arguments, 1, 2);},
		
		setTreeColIdx : function(treeColIdx) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getTreeColumnName : function() {},
		
		getTreeColumn : function() {},
		
		getRootRows : function() {},
		
		getRootRowNums : function() {},
		
		getChildrenRows : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getChildrenRowNums : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getAllChildrenRows : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getAllChildrenRowNums : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getParentRow : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getParentRowNum : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);},
		
		getAllParent : function(rowOrRowAt) {this.assertArgumentsCount(arguments, 1, 1);}
	}
});