/**
 * 可存储数据集扩展监听实现
 */
qx.Class.define("xlsys.base.dataset.SdsExpandListener",
{
	extend : xlsys.base.dataset.StorableDataSetAdapter,
	
	members :
	{
		/**
		 * 需要重载以下方法
		 * expandRows(event);
		 * expandRows(event, callback);
		 */
		expandRows : function(event)
		{
			if(arguments.length==1) this._expandRows(event);
			else this._expandRowsWithCallback(event, arguments[1]);
		},

		_expandRows : function(event)
		{
			var sds = event.getDataSet();
			xlsys.base.log.LogUtil.printlnInfo("event.beginIdxOfExpand="+event.beginIdxOfExpand+" event.endIdxOfExpand="+event.endIdxOfExpand);
			var selectBean = sds.getSelectBean();
			if(selectBean!=null)
			{
				var dataBase = null;
				try
				{
					dataBase = sds.getDataBase();
					var tempDataSet = null;
					if(sds.isSorted())
					{
						tempDataSet = dataBase.sqlSelect(selectBean, sds.getSortColMap(), event.beginIdxOfExpand, event.endIdxOfExpand);
					}
					else tempDataSet = dataBase.sqlSelect(selectBean, event.beginIdxOfExpand, event.endIdxOfExpand);
					if(tempDataSet!=null)
					{
						var tempRows = tempDataSet.getRows();
						for(var i=0;i<tempRows.size();++i)
						{
							sds.getRows().get(i+event.beginIdxOfExpand).cloneOf(tempRows.get(i));
						}
					}
				}
				catch(err)
				{
					event.doit = false;
					event.errMsg = err;
					event.interrupt = true;
					var msgEvent = new xlsys.base.dataset.DataSetEvent(event.getDataSet(), event);
					msgEvent.logLevel = xlsys.base.log.Log.LOG_LEVEL_ERROR;
					sds.fireShowMessage(event);
				}
			}
		},

		_expandRowsWithCallback : function(event, callback)
		{
			var sds = event.getDataSet();
			xlsys.base.log.LogUtil.printlnInfo("event.beginIdxOfExpand="+event.beginIdxOfExpand+" event.endIdxOfExpand="+event.endIdxOfExpand);
			var selectBean = sds.getSelectBean();
			if(selectBean!=null)
			{
				var dataBase = sds.getDataBase();
				var tempCallback = qx.Bootstrap.bind(this._expandRowsWithCallback1, this, event, callback);
				if(sds.isSorted()) dataBase.sqlSelect(selectBean, sds.getSortColMap(), event.beginIdxOfExpand, event.endIdxOfExpand, tempCallback);
				else dataBase.sqlSelect(selectBean, event.beginIdxOfExpand, event.endIdxOfExpand, tempCallback);
			}
			else callback(event, "success");
		},

		_expandRowsWithCallback1 : function(event, callback, tempDataSet, status)
		{
			if(tempDataSet!=null)
			{
				var sds = event.getDataSet();
				var tempRows = tempDataSet.getRows();
				for(var i=0;i<tempRows.size();++i)
				{
					sds.getRows().get(i+event.beginIdxOfExpand).cloneOf(tempRows.get(i));
				}
			}
			callback(event, "success");
		}
	}
});