/**
 * 附件类
 */
qx.Class.define("xlsys.base.io.attachment.XlsysAttachment",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.base.model.IModel],
	
	statics : 
	{
		STYLE_FILE_SYSTEM : 1,
		STYLE_FTP : 2
	},
	
	construct : function(attachmentName, lastModified, style, attachmentData, compress)
	{
		this.setAttachmentName(attachmentName);
		this.lastModified = lastModified;
		this.style = style;
		this.setAttachmentData(attachmentData);
		this.compress = compress;
	},
	
	members : 
	{
		attachmentName : null,
		innerName : null,
		size : null,
		lastModified : null,
		type : null,
		style : null,
		compress : null,
		attachmentData : null,
		md5 : null,
		id : null,
		path : null,
		
		setAttachmentName : function(attachmentName)
		{
			this.attachmentName = attachmentName;
			if(attachmentName!=null)
			{
				var baseStr = attachmentName + (new Date()).getTime() + qx.core.ObjectRegistry.toHashCode(this);
				this.innerName = xlsys.base.util.StringUtil.getMD5String(baseStr);
			}
			else this.innerName = null;
		},

		getAttachmentName : function()
		{
			return this.attachmentName;
		},

		getInnerName : function()
		{
			return this.innerName;
		},

		getStyle : function()
		{
			return this.style;
		},

		setSize : function(size)
		{
			this.size = size;
		},

		getSize : function()
		{
			return this.size;
		},

		isCompress : function()
		{
			return this.compress;
		},

		getAttachmentData : function()
		{
			return this.attachmentData;
		},

		setAttachmentData : function(attachmentData)
		{
			this.attachmentData = attachmentData;
			if(attachmentData!=null)
			{
				this.size = attachmentData.length;
				this.setMd5(xlsys.base.util.StringUtil.getMD5String(attachmentData));
			}
		},
		
		getPath : function()
		{
			return this.path;
		},

		getLastModified : function()
		{
			return this.lastModified;
		},
		
		setType : function(type)
		{
			this.type = type;
		},
		
		getType : function()
		{
			return this.type;
		},

		setPath : function(path)
		{
			this.path = path;
		},

		getId : function()
		{
			return this.id;
		},

		setId : function(id)
		{
			this.id = id;
		},

		getMd5 : function()
		{
			return this.md5;
		},

		setMd5 : function(md5)
		{
			this.md5 = md5;
		},
		
		getSerializableMembers : function()
		{
			var ret = new Array();
			ret.push("attachmentName");
			ret.push("innerName");
			ret.push("size");
			ret.push("lastModified");
			ret.push("type");
			ret.push("style");
			ret.push("compress");
			ret.push("attachmentData");
			ret.push("md5");
			ret.push("id");
			ret.push("path");
			return ret;
		},
		
		getMemberDataType : function(memberName)
		{
			var type = null;
			if(memberName=="size"||memberName=="lastModified") type = xlsys.base.XLSYS.DATA_TYPE_LONG;
			else if(memberName=="style") type = xlsys.base.XLSYS.DATA_TYPE_INT;
			else if(memberName=="attachmentData") type = xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY;
			return type;
		}
	}
});