/**
 * 客户端传输类
 */
qx.Class.define("xlsys.base.io.transfer.client.ClientTransfer",
{
	type : "static",
	
	statics :
	{
		defaultPost : function(cmd, obj, callback, platform)
		{
			var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
			if(session==null) session = xlsys.base.session.SessionManager.getInstance().defaultSession;
			if(callback==null) return this.post(session, cmd, obj, false, callback, platform);
			else this.post(session, cmd, obj, false, callback, platform);
		},
		
		/**
		 * @lint environmentNonLiteralKey(xlsys.base.XLSYS.ENV_SERVLET_URL)
		 */
		post : function(session, cmd, obj, retPkg, callback, platform, wholeSession)
		{
			if(wholeSession==null) wholeSession = false;
			var srcSession = session;
			// 如果session不是默认id, 则发送增量
			if(!wholeSession&&session!=null&&session.getSessionId()!=xlsys.base.XLSYS.SESSION_DEFAULT_ID)
			{
				var cloneSession = new xlsys.base.session.Session(session.getSessionId());
				cloneSession.setSessionType(xlsys.base.session.Session.TYPE_INCREMENTAL);
				var changedKeys = session.getChangedEnvKeys().toArray();
				for(var i=0;i<changedKeys.length;++i)
				{
					cloneSession.setAttribute(changedKeys[i], session.getAttribute(changedKeys[i]));
				}
				session.getChangedEnvKeys().clear();
				session = cloneSession;
			}
			if(platform==null) platform = xlsys.base.XLSYS.PLATFORM_PURE_JSON;
			// if(platform==null) platform = xlsys.base.XLSYS.PLATFORM_WEB;
			var data = new Object();
			data.WEB_COMMAND = cmd;
			if(platform==xlsys.base.XLSYS.PLATFORM_PURE_JSON)
			{
				data.WEB_SESSION = xlsys.base.io.util.IOUtil.getCommonJSONFromObj(session);
				data.WEB_DATA = xlsys.base.io.util.IOUtil.getCommonJSONFromObj(obj);
			}
			else
			{
				data.WEB_SESSION = xlsys.base.io.util.IOUtil.getJSONStr(session);
				data.WEB_DATA = xlsys.base.io.util.IOUtil.getJSONStr(obj);
			}
			var req = new qx.io.request.Xhr();
			req.setUrl(qx.core.Environment.get(xlsys.base.XLSYS.ENV_SERVLET_URL));
			req.setMethod("POST");
			req.setRequestHeader(xlsys.base.XLSYS.PLATFORM, ""+platform);
			req.setRequestHeader("Content-type","application/x-www-form-urlencoded");
			var sb = new xlsys.java.lang.StringBuilder();
			var isFirst = true;
			for(var fieldName in data)
			{
				if(!isFirst) sb.append("&");
				else isFirst = false;
				sb.append(fieldName).append("=").append(encodeURIComponent(data[fieldName]));
			}
			req.setRequestData(sb.toString());
			var isAsync = (callback!=null);
			req.setAsync(isAsync);
			if(isAsync) req.addListener("success", qx.Bootstrap.bind(this.__onRequestSuccess, this, srcSession, cmd, obj, retPkg, callback, platform), this);
			req.send();
			if(!isAsync)
			{
				var retObj = null;
				if(platform==xlsys.base.XLSYS.PLATFORM_PURE_JSON) retObj = xlsys.base.io.util.IOUtil.getObjFromCommonJSON(req.getResponse());
				else retObj = xlsys.base.io.util.IOUtil.getObjFromJSON(req.getResponse());
				// 判断是否是服务端请求完整session
				if(retObj.getCommand()==xlsys.base.XLSYS.COMMAND_WHOLE_SESSION)
				{
					// 重新发送带完整session的请求给服务端
					return this.post(xlsys.base.session.SessionManager.getInstance().getCurrentSession(), cmd, obj, retPkg, callback, platform, true);
				}
				else
				{
					// 设置服务端发送过来的session增量到原始session中
					this.__setSessionIncremental(srcSession, retObj.getSession());
					if(!retPkg) retObj = retObj.getObj();
					return retObj;
				}
			}
		},
		
		__setSessionIncremental : function(srcSession, increSession)
		{
			if(srcSession==null||increSession==null) return;
			if(increSession.getSessionType()!=xlsys.base.session.Session.TYPE_INCREMENTAL) return;
			var keys = increSession.getEnvKeySet().toArray();
			for(var i=0;i<keys.length;++i)
			{
				srcSession.setAttribute(keys[i], increSession.getAttribute(keys[i]));
			}
			srcSession.getChangedEnvKeys().clear();
		},
		
		__onRequestSuccess : function(srcSession, cmd, obj, retPkg, callback, platform, event)
		{
			var req = event.getTarget();
			var retObj = null;
			if(platform==xlsys.base.XLSYS.PLATFORM_PURE_JSON) retObj = xlsys.base.io.util.IOUtil.getObjFromCommonJSON(req.getResponse());
			else retObj = xlsys.base.io.util.IOUtil.getObjFromJSON(req.getResponse());
			// 判断是否是服务端请求完整session
			if(retObj.getCommand()==xlsys.base.XLSYS.COMMAND_WHOLE_SESSION)
			{
				// 重新发送带完整session的请求给服务端
				this.post(xlsys.base.session.SessionManager.getInstance().getCurrentSession(), cmd, obj, retPkg, callback, platform, true);
			}
			else
			{
				this.__setSessionIncremental(srcSession, retObj.getSession());
				if(!retPkg) retObj = retObj.getObj();
				callback(retObj, "success");
			}
		}
	}
});