/**
 * 日志工具类
 */
qx.Class.define("xlsys.base.log.LogUtil",
{
	type : "static",
	
	statics :
	{
		__log : null,
		
		/**
		 * @lint environmentNonLiteralKey(xlsys.base.XLSYS.ENV_LOG_LEVEL)
		 * @lint environmentNonLiteralKey(xlsys.base.XLSYS.ENV_LOG_CLASS)
		 */
		println : function(level, content)
		{
			if(this.__log==null)
			{
				var logLevel = qx.core.Environment.get(xlsys.base.XLSYS.ENV_LOG_LEVEL);
				var logClass = qx.core.Environment.get(xlsys.base.XLSYS.ENV_LOG_CLASS);
				this.__log = xlsys.base.util.ReflectUtil.newInstance(logClass, [logLevel]);
			}
			this.__log.println(level, content);
			return true;
		},
		
		printlnDebug : function(content)
		{
			return this.println(xlsys.base.log.Log.LOG_LEVEL_DEBUG, content);
		},

		printlnInfo : function(content)
		{
			return this.println(xlsys.base.log.Log.LOG_LEVEL_INFO, content);
		},
		
		printlnWarn : function(content)
		{
			return this.println(xlsys.base.log.Log.LOG_LEVEL_WARN, content);
		},
		
		printlnError : function(content)
		{
			return this.println(xlsys.base.log.Log.LOG_LEVEL_ERROR, content);
		},
		
		printlnFatal : function(content)
		{
			return this.println(xlsys.base.log.Log.LOG_LEVEL_FATAL, content);
		}
	}
});