/**
 * 
 */
qx.Class.define("xlsys.base.model.ModelUtil",
{
	type : "static",
	
	statics : 
	{
		cloneModel : function(model)
		{
			if(model==null) return null;
			var cloneModel = xlsys.base.util.ReflectUtil.newInstance(xlsys.base.util.ObjectUtil.className(model));
			var fields = model.getSerializableMembers();
			for(var i=0;i<fields.length;++i)
			{
				cloneModel[fields[i]] = model[fields[i]];
			}
			return cloneModel;
		},
		
		modelListToDataSet : function(modelList)
		{
			if(modelList==null||modelList.isEmpty()) return null;
			var dataSet = new xlsys.base.dataset.DataSet();
			var firstModel = modelList.get(0);
			var fields = firstModel.getSerializableMembers();
			var colFieldList = new xlsys.java.util.ArrayList();
			for(var i=0;i<fields.length;++i)
			{
				var fieldName = fields[i];
				if(qx.lang.String.endsWith(fieldName, "List")) continue;
				colFieldList.add(fieldName);
				var dsc = dataSet.insertNewColumnAfterLast();
				dsc.setColumnName(fieldName);
			}
			dataSet.buildColumnMap();
			for(var i=0;i<modelList.size();++i)
			{
				var model = modelList.get(i);
				dataSet.insertNewRowAfterLast();
				for(var j=0;j<colFieldList.size();++j)
				{
					var fieldName = colFieldList.get(j);
					dataSet.setValue(fieldName, model[fieldName]);
				}
			}
			return dataSet;
		},
		
		listToTreeModel : function(sortedList, treeFieldName, root)
		{
			// 获取第一层元素
			var addedSet = new xlsys.java.util.HashSet();
			for(var i=0;i<sortedList.size();++i)
			{
				if(!addedSet.contains(i))
				{
					var childModel = root.addChildData(sortedList.get(i));
					this.__addChildrenToTreeModel(sortedList, treeFieldName, childModel, i, addedSet);
				}
			}
			return root;
		},
		
		__addChildrenToTreeModel : function(sortedList, treeFieldName, treeModel, index, addedSet)
		{
			var keyStr = xlsys.base.util.ObjectUtil.objectToString(treeModel.getData()[treeFieldName]);
			for(var i=index+1;i<sortedList.size();++i)
			{
				if(!addedSet.contains(i))
				{
					var temp = sortedList.get(i);
					var tempStr = xlsys.base.util.ObjectUtil.objectToString(temp[treeFieldName]);
					if(qx.lang.String.startsWith(tempStr, keyStr))
					{
						var childModel = treeModel.addChildData(temp);
						addedSet.add(i);
						this.__addChildrenToTreeModel(sortedList, treeFieldName, childModel, i, addedSet);
					}
				}
			}
		},
		
		dataSetToTreeModel : function(sortedDataSet, treeColumnName, root)
		{
			// 获取第一层元素
			var addedSet = new xlsys.java.util.HashSet();
			var rowList = sortedDataSet.getRows();
			for(var i=0;i<rowList.size();++i)
			{
				if(!addedSet.contains(i))
				{
					var childModel = root.addChildData(rowList.get(i));
					this.__addChildrenRowToTreeModel(sortedDataSet, treeColumnName, childModel, i, addedSet);
				}
			}
			return root;
		},
		
		__addChildrenRowToTreeModel : function(sortedDataSet, treeColumnName, treeModel, index, addedSet)
		{
			var keyStr = xlsys.base.util.ObjectUtil.objectToString(sortedDataSet.getValue(index, treeColumnName));
			var rowList = sortedDataSet.getRows();
			for(var i=index+1;i<rowList.size();++i)
			{
				if(!addedSet.contains(i))
				{
					var tempStr = xlsys.base.util.ObjectUtil.objectToString(sortedDataSet.getValue(i, treeColumnName));
					if(qx.lang.String.startsWith(tempStr, keyStr))
					{
						var childModel = treeModel.addChildData(sortedDataSet.getRow(i));
						addedSet.add(i);
						this.__addChildrenRowToTreeModel(sortedDataSet, treeColumnName, childModel, i, addedSet);
					}
				}
			}
		}
	}
});