/**
 * 系统工具类
 */
qx.Class.define("xlsys.base.util.SystemUtil",
{
	type : "static",
	
	statics :
	{
		getUserLanguage : function()
		{
			var language = null;
			var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
			if(session!=null) language = session.getAttribute(xlsys.base.XLSYS.SESSION_LANGUAGE);
			else language = qx.core.Environment.get("locale");
			return language;
		},
		
		/**
		 * @lint environmentNonLiteralKey(xlsys.base.XLSYS.ENV_APP_VERSION)
		 */
		getAppVersion : function()
		{
			return qx.core.Environment.get(xlsys.base.XLSYS.ENV_APP_VERSION);
		},
		
		/**
		 * @lint environmentNonLiteralKey(xlsys.base.XLSYS.ENV_LOG_LEVEL)
		 */
		isDebug : function()
		{
			var logLevel = qx.core.Environment.get(xlsys.base.XLSYS.ENV_LOG_LEVEL);
			return logLevel>=xlsys.base.log.Log.LOG_LEVEL_DEBUG;
		},
		
		getPlatform : function()
		{
			var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
			return session.getAttribute(xlsys.base.XLSYS.PLATFORM);
		},
		
		getOsName : function()
		{
			return qx.core.Environment.get("os.name");
		},
		
		getOsVersion : function()
		{
			return qx.core.Environment.get("os.version");
		},
		
		getDeviceType : function()
		{
			return qx.core.Environment.get("device.type");
		},
		
		getBrowserName : function()
		{
			return qx.core.Environment.get("browser.name");
		},
		
		getBrowserVersion : function()
		{
			return qx.core.Environment.get("browser.version");
		},
		
		getBrowserEngineName : function()
		{
			return qx.core.Environment.get("engine.name");
		},
		
		getBrowserEngineVersion : function()
		{
			return qx.core.Environment.get("engine.version");
		}
	}
});