/**
 * 可序列化接口
 */
qx.Class.define("xlsys.java.io.Serializable",
{
	type : "abstract",
	extend : qx.core.Object,
	
	members : 
	{
		toHashCode : function()
		{
			var seed = 0;
			seed = xlsys.base.util.ObjectUtil._hash_combine(seed, xlsys.base.util.ObjectUtil.className(this));
			var needMembers = this.getSerializableMembers();
			for(var x in needMembers)
			{
				seed = xlsys.base.util.ObjectUtil._hash_combine(seed, this[needMembers[x]]);
			}
			return seed;
		},
		
		getClassName : function()
		{
			var className = this.classname;
			return className;
		},
		
		/**
		 * 获取可序列化的成员
		 * @return {Array} 可序列化的成员名称
		 */
		getSerializableMembers : function() {},
		
		/**
		 * 获取可序列化成员的数据类型. 子类在成员中包含以下类型时需要定义该方法
		 * 因为整数类型无法区分byte,char,short,int,long. 所以整数类型需要手动定义dataType
		 * 因为数组类型无法区分数组内部的元素类型, 所以需要手动定义dataType, 如果不定义, 则一律视同为DATA_TYPE_OBJECT_ARRAY
		 */
		getMemberDataType : function(memberName) {}
	}
});