/**
 * Exception类
 */
qx.Class.define("xlsys.java.lang.Exception", 
{
	extend : xlsys.java.io.Serializable,
	
	members :
	{
		msg : null,
		stackTrace : null,
		cause : null,
		
		getMessage : function()
		{
			return this.msg;
		},
		
		getStackTrace : function()
		{
			return this.stackTrace;
		},
		
		setStackTrace : function(stackTrace)
		{
			this.stackTrace = stackTrace;
		},
		
		getCause : function()
		{
			return this.cause;
		},

		toString : function()
		{
			return this.msg;
		},
		
		getClassName : function()
		{
			return "java.lang.Exception";
		},
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("msg");
			arr.push("stackTrace");
			arr.push("cause");
			return arr;
		}
	},

	/**
	 * 支持以下方法:
	 * Exception(msg)
	 * Exception(msg, cause)
	 */
	construct: function()
	{
		this.msg = arguments[0];
		if(arguments.length>1) this.cause = arguments[1];
		this.stackTrace = qx.dev.StackTrace.getStackTrace();
	}
});