/**
 * ArrayList
 */
qx.Class.define("xlsys.java.util.ArrayList",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.java.util.List],
	
	construct: function()
	{
		this.__array = new Array();
	},
	
	members :
	{
		__array : null,
		
		getClassName : function()
		{
			return "java.util.ArrayList";
		},
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("__array");
			return arr;
		},
		
		add : function()
		{
			if(arguments.length==1) this.__array.push(arguments[0]);
			else if(arguments.length>=2) this.__array.splice(arguments[0], 0, arguments[1]);
		},

		addAll : function(collection)
		{
			var arr = collection.toArray();
			for(var i=0;i<arr.length;++i)
			{
				this.add(arr[i]);
			}
		},

		clear : function()
		{
			while(this.__array.pop()!=null);
		},

		contains : function(element)
		{
			return this.indexOf(element)!=-1;
		},

		remove : function(element)
		{
			var index = this.indexOf(element);
			if(index!=-1) this.removeAt(index);
		},

		size : function()
		{
			return this.__array.length;
		},

		toArray : function()
		{
			var tempArr = new Array();
			for(var i=0;i<this.__array.length;++i)
			{
				tempArr.push(this.__array[i]);
			}
			return tempArr;
		},

		get : function(index)
		{
			return this.__array[index];
		},

		indexOf : function(element)
		{
			return this.__array.indexOf(element);
		},

		isEmpty : function()
		{
			return this.size()==0;
		},

		removeAt : function(index)
		{
			this.__array.splice(index, 1);
		},

		set : function(index, element)
		{
			this.__array.splice(index, 1, element);
		}
	}
});