/**
 * HashSet
 */
qx.Class.define("xlsys.java.util.HashSet",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.java.util.Set],
	
	construct: function()
	{
		this.__map = new Object();
		this.__size = 0;
	},
	
	members :
	{
		__map : null,
		__size : null,
		
		_getHashKey : function(obj)
		{
			return xlsys.base.util.ObjectUtil._getHashKey(obj);
		},
		
		getClassName : function()
		{
			return "java.util.HashSet";
		},
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("__map");
			arr.push("__size");
			return arr;
		},
		
		add : function(element)
		{
			var hash = this._getHashKey(element);
			if(!this.__map[hash]) ++this.__size;
			this.__map[hash] = element;
		},

		addAll : function(collection)
		{
			var arr = collection.toArray();
			for(var i=0;i<arr.length;++i)
			{
				this.add(arr[i]);
			}
		},

		clear : function()
		{
			for(var fieldName in this.__map)
			{
				delete this.__map[fieldName];
			}
			this.__size = 0;
		},

		contains : function(element)
		{
			var hash = this._getHashKey(element);
			var contain = this.__map[hash]!=null;
			return contain;
		},

		remove : function(element)
		{
			var hash = this._getHashKey(element);
			if(delete this.__map[hash]) --this.__size;
		},

		size : function()
		{
			return this.__size;
		},

		isEmpty : function()
		{
			return this.__size==0;
		},
		
		toArray : function()
		{
			var tempArr = new Array();
			for(var fieldName in this.__map)
			{
				if(fieldName=="__hashcode"||fieldName=="$$hash") continue;
				tempArr.push(this.__map[fieldName]);
			}
			return tempArr;
		}
	}
});