/**
 * LinkedHashMap
 */
qx.Class.define("xlsys.java.util.LinkedHashMap",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.java.util.Map],
	
	construct: function()
	{
		this.__map = new Object();
		this.__keys = new Array();
	},
	
	members :
	{
		__map : null,
		__keys : null,
		
		_getHashKey : function(obj)
		{
			return xlsys.base.util.ObjectUtil._getHashKey(obj);
		},
		
		getClassName : function()
		{
			return "java.util.LinkedHashMap";
		},
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("__map");
			arr.push("__keys");
			return arr;
		},
		
		clear : function()
		{
			for(var fieldName in this.__map)
			{
				delete this.__map[fieldName];
			}
			while(this.__keys.pop()!=null);
		},

		containsKey : function(key)
		{
			var keyHash = this._getHashKey(key);
			return this.__map[keyHash]!=null;
		},

		containsValue : function(value)
		{
			var contains = false;
			for(var fieldName in this.__map)
			{
				if(this._getHashKey(this.__map[fieldName])==this._getHashKey(value))
				{
					contains = true;
					break;
				}
			}
			return contains;
		},

		get : function(key)
		{
			var keyHash = this._getHashKey(key);
			return this.__map[keyHash];
		},

		isEmpty : function()
		{
			return this.__keys.length==0;
		},

		put : function(key, value)
		{
			if(!this.containsKey(key)) this.__keys.push(key);
			var keyHash = this._getHashKey(key);
			this.__map[keyHash] = value;
		},

		putAll : function(m)
		{
			var keyArr = m.keys();
			for(var i=0;i<keyArr.length;++i)
			{
				this.put(keyArr[i], m.get(keyArr[i]));
			}
		},

		remove : function(key)
		{
			var keyHash = this._getHashKey(key);
			if(delete this.__map[keyHash])
			{
				for(var i=0;i<this.__keys.length;++i)
				{
					if(this._getHashKey(this.__keys[i])==keyHash)
					{
						this.__keys.splice(i, 1);
						break;
					}
				}
			}
		},

		size : function()
		{
			return this.__keys.length;
		},

		keys : function()
		{
			var tempArr = new Array();
			for(var i=0;i<this.__keys.length;++i)
			{
				tempArr.push(this.__keys[i]);
			}
			return tempArr;
		},

		values : function()
		{
			var tempArr = new Array();
			for(var i=0;i<this.__keys.length;++i)
			{
				var keyHash = this._getHashKey(this.__keys[i]);
				tempArr.push(this.__map[keyHash]);
			}
			return tempArr;
		},
		
		keySet : function()
		{
			var set = new xlsys.java.util.LinkedHashSet();
			for(var i=0;i<this.__keys.length;++i)
			{
				set.add(this.__keys[i]);
			}
			return set;
		},
		
		entrySet : function()
		{
			var set = new xlsys.java.util.LinkedHashSet();
			for(var i=0;i<this.__keys.length;++i)
			{
				var key = this.__keys[i];
				var keyHash = this._getHashKey(this.__keys[i]);
				var value = this.__map[keyHash];
				var entry = new xlsys.java.util.SimpleEntry(key, value);
				set.add(entry);
			}
			return set;
		}
	}
});