/**
 * LinkedHashSet
 */
qx.Class.define("xlsys.java.util.LinkedHashSet",
{
	extend : xlsys.java.io.Serializable,
	implement : [xlsys.java.util.Set],
	
	construct: function()
	{
		this.__array = new Array();
		this.__map = new Object();
	},
	
	members :
	{
		__array : null,
		__map : null,
		
		_getHashKey : function(obj)
		{
			return xlsys.base.util.ObjectUtil._getHashKey(obj);
		},
		
		getClassName : function()
		{
			return "java.util.LinkedHashSet";
		},
		
		getSerializableMembers : function()
		{
			var arr = new Array();
			arr.push("__array");
			arr.push("__map");
			return arr;
		},
		
		add : function(element)
		{
			if(!this.contains(element)) this.__array.push(element);
			var hash = this._getHashKey(element);
			this.__map[hash] = element;
		},

		addAll : function(collection)
		{
			var arr = collection.toArray();
			for(var i=0;i<arr.length;++i)
			{
				this.add(arr[i]);
			}
		},

		clear : function()
		{
			for(var fieldName in this._map)
			{
				delete this.__map[fieldName];
			}
			while(this.__array.pop()!=null);
		},

		contains : function(element)
		{
			var hash = this._getHashKey(element);
			var contain = this.__map[hash]!=null;
			return contain;
		},

		remove : function(element)
		{
			var hash = this._getHashKey(element);
			if(delete this.__map[hash])
			{
				for(var i=0;i<this.__array.length;++i)
				{
					if(this._getHashKey(this.__array[i])==hash)
					{
						this.__array.splice(i, 1);
						break;
					}
				}
			}
		},

		size : function()
		{
			return this.__array.length;
		},
		
		isEmpty : function()
		{
			return this.__array.length==0;
		},

		toArray : function()
		{
			var tempArr = new Array();
			for(var i=0;i<this.__array.length;++i)
			{
				tempArr.push(this.__array[i]);
			}
			return tempArr;
		}
	}
});