(function() {

    if (typeof console == "undefined") console = {};
    if (!console.log) console.log = function() {
        var out = java.lang.System.out;
        for (var i = 0; i < arguments.length; i++)
        out.print(arguments[i]);
        out.println();
    };

    if (!this.qxloadPrefixUrl) qxloadPrefixUrl = "";

    if (!this.window) window = this;

    if (!window.navigator) window.navigator = {
        userAgent: "Mozilla/5.0 (Macintosh; U; Intel Mac OS X 10_6_4; de-de) AppleWebKit/533.17.8 (KHTML, like Gecko) Version/5.0.1 Safari/533.17.8",
        product: "",
        cpuClass: "",
        language: "en-US"
    };

    if (!window.setTimeout && environment && environment["java.version"]) {
      // Emulate setTimeout/setInterval features in Rhino
      // http://stackoverflow.com/questions/2261705/how-to-run-a-javascript-function-asynchronously-without-using-settimeout
      var timer = new java.util.Timer();
      var counter = 1; 
      var ids = {};

      window.setTimeout = function (fn,delay) 
      {
        if (delay === 0) {
          delay = 1;
        }
        var id = counter++;
        ids[id] = new JavaAdapter(java.util.TimerTask,{run: fn});
        timer.schedule(ids[id],delay);
        return id;
      };

      window.clearTimeout = function (id) 
      {
        if (ids[id])
        {
          ids[id].cancel();
          timer.purge();
          delete ids[id];
        }
      };

      window.setInterval = function (fn,delay) 
      {
        if (delay === 0) {
          delay = 1;
        }
        var id = counter++; 
        ids[id] = new JavaAdapter(java.util.TimerTask,{run: fn});
        timer.schedule(ids[id],delay,delay);
        return id;
      };

      window.clearInterval = window.clearTimeout;
    }

    if (!window.qx) window.qx = {};

    if (!qx.$$environment) qx.$$environment = {};
    var envinfo = {"qx.application":"xlsys.Application","qx.aspects":false,"qx.debug":false,"qx.debug.databinding":false,"qx.debug.dispose":false,"qx.debug.io":false,"qx.debug.ui.queue":false,"qx.globalErrorHandling":false,"qx.optimization.basecalls":true,"qx.optimization.comments":true,"qx.revision":"","qx.theme":"qx.theme.Modern","qx.version":"5.0.2"};
    for (var k in envinfo) qx.$$environment[k] = envinfo[k];

    if (!qx.$$libraries) qx.$$libraries = {};
    var libinfo = {"__out__":{"sourceUri":"."},"qx":{"resourceUri":".","sourceUri":".","sourceViewUri":"https://github.com/qooxdoo/qooxdoo/blob/%{qxGitBranch}/framework/source/class/%{classFilePath}#L%{lineNumber}"},"xlsys":{"resourceUri":".","sourceUri":"."}};
    for (var k in libinfo) qx.$$libraries[k] = libinfo[k];

    var isDebug = qx.$$environment["qx.debug"],
        log = isDebug ? console.log : function() {},
        load = qx.$$environment["qx.load"] ? this[qx.$$environment["load"]] : this.load;

    qx.$$resources = {};
    qx.$$translations = {"C":null,"en":null,"zh":null};
    qx.$$locales = {"C":null,"en":null,"zh":null};
    qx.$$packageData = {};
    qx.$$loader = {
        parts: {"boot":[0]},
        packages: {"0":{"uris":["__out__:xlsys.808c5b05c569.js"]}},
        urisBefore: [],
        boot: "boot",
        closureParts: {},
        bootIsInline: true,

        decodeUris: function(compressedUris) {
            var libs = qx.$$libraries;
            var uris = [];
            for (var i = 0; i < compressedUris.length; i++) {
                var uri = compressedUris[i].split(":");
                var euri;
                if (uri.length == 2 && uri[0] in libs) {
                    var prefix = libs[uri[0]].sourceUri;
                    euri = prefix + "/" + uri[1];
                } else {
                    euri = compressedUris[i];
                }
                uris.push(qxloadPrefixUrl + euri);
            }
            return uris;
        },

        init: function() {
            var l = qx.$$loader;
            if (l.urisBefore.length > 0) this.loadScriptList(l.urisBefore);

            var bootPackageHash = l.parts[l.boot][0];
            if (!l.bootIsInline) this.loadScriptList(l.decodeUris(l.packages[l.parts[l.boot][0]].uris));
            l.importPackageData(qx.$$packageData[bootPackageHash] || {});
            l.signalStartup();
        },

        loadScriptList: function(uris) {
            var i, p, s;
            for (i = 0; i < uris.length; i++) {
                if (typeof process !== "undefined") { // Node
                  p = uris[i];
                  try {
                    require(p);
                  } catch (e) {
                    console.error("Unable to load uri: "+p);
                    throw e;
                  }
                } else if (typeof environment !== "undefined") { // Rhino
                  p = uris[i];
                  try {
                    load(p);
                  } catch (e) {
                    java.lang.System.err.println("Unable to load uri: "+p);
                    throw e;
                  }
                }
                //log("loaded uri " + p);
            }
        },

        signalStartup: function() {
            qx.$$loader.scriptLoaded = true;
            qx.core.BaseInit.ready();
            qx.$$loader.applicationHandlerReady = true;
        },

        importPackageData: function(dataMap, callback) {
            if (dataMap["resources"]) {
                var resMap = dataMap["resources"];
                for (var k in resMap)
                qx.$$resources[k] = resMap[k];
            }
            if (dataMap["locales"]) {
                var locMap = dataMap["locales"];
                var qxlocs = qx.$$locales;
                for (var lang in locMap) {
                    if (!qxlocs[lang]) qxlocs[lang] = locMap[lang];
                    else for (var k in locMap[lang])
                    qxlocs[lang][k] = locMap[lang][k];
                }
            }
            if (dataMap["translations"]) {
                var trMap = dataMap["translations"];
                var qxtrans = qx.$$translations;
                for (var lang in trMap) {
                    if (!qxtrans[lang]) qxtrans[lang] = trMap[lang];
                    else for (var k in trMap[lang])
                    qxtrans[lang][k] = trMap[lang][k];
                }
            }
            if (callback) {
                callback(dataMap);
            }
        }
    };

})();


qx.$$packageData['0']={"locales":{},"resources":{},"translations":{"C":{},"en":{}}};

if(!window.qx){

  window.qx = {
  };
};
qx.Bootstrap = {
  genericToString : function(){

    return "[Class " + this.classname + "]";
  },
  createNamespace : function(name, object){

    var splits = name.split(".");
    var part = splits[0];
    var parent = qx.$$namespaceRoot && qx.$$namespaceRoot[part] ? qx.$$namespaceRoot : window;
    for(var i = 0,len = splits.length - 1;i < len;i++,part = splits[i]){

      if(!parent[part]){

        parent = parent[part] = {
        };
      } else {

        parent = parent[part];
      };
    };
    parent[part] = object;
    return part;
  },
  setDisplayName : function(fcn, classname, name){

    fcn.displayName = classname + "." + name + "()";
  },
  setDisplayNames : function(functionMap, classname){

    for(var name in functionMap){

      var value = functionMap[name];
      if(value instanceof Function){

        value.displayName = classname + "." + name + "()";
      };
    };
  },
  base : function(args, varargs){

    if(qx.Bootstrap.DEBUG){

      if(!qx.Bootstrap.isFunction(args.callee.base)){

        throw new Error("Cannot call super class. Method is not derived: " + args.callee.displayName);
      };
    };
    if(arguments.length === 1){

      return args.callee.base.call(this);
    } else {

      return args.callee.base.apply(this, Array.prototype.slice.call(arguments, 1));
    };
  },
  define : function(name, config){

    if(!config){

      config = {
        statics : {
        }
      };
    };
    var clazz;
    var proto = null;
    qx.Bootstrap.setDisplayNames(config.statics, name);
    if(config.members || config.extend){

      qx.Bootstrap.setDisplayNames(config.members, name + ".prototype");
      clazz = config.construct || new Function;
      if(config.extend){

        this.extendClass(clazz, clazz, config.extend, name, basename);
      };
      var statics = config.statics || {
      };
      for(var i = 0,keys = qx.Bootstrap.keys(statics),l = keys.length;i < l;i++){

        var key = keys[i];
        clazz[key] = statics[key];
      };
      proto = clazz.prototype;
      proto.base = qx.Bootstrap.base;
      proto.name = proto.classname = name;
      var members = config.members || {
      };
      var key,member;
      for(var i = 0,keys = qx.Bootstrap.keys(members),l = keys.length;i < l;i++){

        key = keys[i];
        member = members[key];
        if(member instanceof Function && proto[key]){

          member.base = proto[key];
        };
        proto[key] = member;
      };
    } else {

      clazz = config.statics || {
      };
      if(qx.Bootstrap.$$registry && qx.Bootstrap.$$registry[name]){

        var formerClass = qx.Bootstrap.$$registry[name];
        if(this.keys(clazz).length !== 0){

          if(config.defer){

            config.defer(clazz, proto);
          };
          for(var curProp in clazz){

            formerClass[curProp] = clazz[curProp];
          };
          return formerClass;
        };
      };
    };
    clazz.$$type = "Class";
    if(!clazz.hasOwnProperty("toString")){

      clazz.toString = this.genericToString;
    };
    var basename = name ? this.createNamespace(name, clazz) : "";
    clazz.name = clazz.classname = name;
    clazz.basename = basename;
    clazz.$$events = config.events;
    if(config.defer){

      config.defer(clazz, proto);
    };
    if(name != null){

      qx.Bootstrap.$$registry[name] = clazz;
    };
    return clazz;
  }
};
qx.Bootstrap.define("qx.Bootstrap", {
  statics : {
    LOADSTART : qx.$$start || new Date(),
    DEBUG : (function(){

      var debug = true;
      if(qx.$$environment && qx.$$environment["qx.debug"] === false){

        debug = false;
      };
      return debug;
    })(),
    getEnvironmentSetting : function(key){

      if(qx.$$environment){

        return qx.$$environment[key];
      };
    },
    setEnvironmentSetting : function(key, value){

      if(!qx.$$environment){

        qx.$$environment = {
        };
      };
      if(qx.$$environment[key] === undefined){

        qx.$$environment[key] = value;
      };
    },
    createNamespace : qx.Bootstrap.createNamespace,
    setRoot : function(root){

      qx.$$namespaceRoot = root;
    },
    base : qx.Bootstrap.base,
    define : qx.Bootstrap.define,
    setDisplayName : qx.Bootstrap.setDisplayName,
    setDisplayNames : qx.Bootstrap.setDisplayNames,
    genericToString : qx.Bootstrap.genericToString,
    extendClass : function(clazz, construct, superClass, name, basename){

      var superproto = superClass.prototype;
      var helper = new Function();
      helper.prototype = superproto;
      var proto = new helper();
      clazz.prototype = proto;
      proto.name = proto.classname = name;
      proto.basename = basename;
      construct.base = superClass;
      clazz.superclass = superClass;
      construct.self = clazz.constructor = proto.constructor = clazz;
    },
    getByName : function(name){

      return qx.Bootstrap.$$registry[name];
    },
    $$registry : {
    },
    objectGetLength : function(map){

      return qx.Bootstrap.keys(map).length;
    },
    objectMergeWith : function(target, source, overwrite){

      if(overwrite === undefined){

        overwrite = true;
      };
      for(var key in source){

        if(overwrite || target[key] === undefined){

          target[key] = source[key];
        };
      };
      return target;
    },
    __shadowedKeys : ["isPrototypeOf", "hasOwnProperty", "toLocaleString", "toString", "valueOf", "propertyIsEnumerable", "constructor"],
    keys : ({
      "ES5" : Object.keys,
      "BROKEN_IE" : function(map){

        if(map === null || (typeof map != "object" && typeof map != "function")){

          throw new TypeError("Object.keys requires an object as argument.");
        };
        var arr = [];
        var hasOwnProperty = Object.prototype.hasOwnProperty;
        for(var key in map){

          if(hasOwnProperty.call(map, key)){

            arr.push(key);
          };
        };
        var shadowedKeys = qx.Bootstrap.__shadowedKeys;
        for(var i = 0,a = shadowedKeys,l = a.length;i < l;i++){

          if(hasOwnProperty.call(map, a[i])){

            arr.push(a[i]);
          };
        };
        return arr;
      },
      "default" : function(map){

        if(map === null || (typeof map != "object" && typeof map != "function")){

          throw new TypeError("Object.keys requires an object as argument.");
        };
        var arr = [];
        var hasOwnProperty = Object.prototype.hasOwnProperty;
        for(var key in map){

          if(hasOwnProperty.call(map, key)){

            arr.push(key);
          };
        };
        return arr;
      }
    })[typeof (Object.keys) == "function" ? "ES5" : (function(){

      for(var key in {
        toString : 1
      }){

        return key;
      };
    })() !== "toString" ? "BROKEN_IE" : "default"],
    __classToTypeMap : {
      "[object String]" : "String",
      "[object Array]" : "Array",
      "[object Object]" : "Object",
      "[object RegExp]" : "RegExp",
      "[object Number]" : "Number",
      "[object Boolean]" : "Boolean",
      "[object Date]" : "Date",
      "[object Function]" : "Function",
      "[object Error]" : "Error"
    },
    bind : function(func, self, varargs){

      var fixedArgs = Array.prototype.slice.call(arguments, 2, arguments.length);
      return function(){

        var args = Array.prototype.slice.call(arguments, 0, arguments.length);
        return func.apply(self, fixedArgs.concat(args));
      };
    },
    firstUp : function(str){

      return str.charAt(0).toUpperCase() + str.substr(1);
    },
    firstLow : function(str){

      return str.charAt(0).toLowerCase() + str.substr(1);
    },
    getClass : function(value){

      if(value === undefined){

        return "Undefined";
      } else if(value === null){

        return "Null";
      };
      var classString = Object.prototype.toString.call(value);
      return (qx.Bootstrap.__classToTypeMap[classString] || classString.slice(8, -1));
    },
    isString : function(value){

      return (value !== null && (typeof value === "string" || qx.Bootstrap.getClass(value) == "String" || value instanceof String || (!!value && !!value.$$isString)));
    },
    isArray : function(value){

      return (value !== null && (value instanceof Array || (value && qx.data && qx.data.IListData && qx.util.OOUtil.hasInterface(value.constructor, qx.data.IListData)) || qx.Bootstrap.getClass(value) == "Array" || (!!value && !!value.$$isArray)));
    },
    isObject : function(value){

      return (value !== undefined && value !== null && qx.Bootstrap.getClass(value) == "Object");
    },
    isFunction : function(value){

      return qx.Bootstrap.getClass(value) == "Function";
    },
    $$logs : [],
    debug : function(object, message){

      qx.Bootstrap.$$logs.push(["debug", arguments]);
    },
    info : function(object, message){

      qx.Bootstrap.$$logs.push(["info", arguments]);
    },
    warn : function(object, message){

      qx.Bootstrap.$$logs.push(["warn", arguments]);
    },
    error : function(object, message){

      qx.Bootstrap.$$logs.push(["error", arguments]);
    },
    trace : function(object){
    }
  }
});
qx.Bootstrap.define("qx.util.OOUtil", {
  statics : {
    classIsDefined : function(name){

      return qx.Bootstrap.getByName(name) !== undefined;
    },
    getPropertyDefinition : function(clazz, name){

      while(clazz){

        if(clazz.$$properties && clazz.$$properties[name]){

          return clazz.$$properties[name];
        };
        clazz = clazz.superclass;
      };
      return null;
    },
    hasProperty : function(clazz, name){

      return !!qx.util.OOUtil.getPropertyDefinition(clazz, name);
    },
    getEventType : function(clazz, name){

      var clazz = clazz.constructor;
      while(clazz.superclass){

        if(clazz.$$events && clazz.$$events[name] !== undefined){

          return clazz.$$events[name];
        };
        clazz = clazz.superclass;
      };
      return null;
    },
    supportsEvent : function(clazz, name){

      return !!qx.util.OOUtil.getEventType(clazz, name);
    },
    getByInterface : function(clazz, iface){

      var list,i,l;
      while(clazz){

        if(clazz.$$implements){

          list = clazz.$$flatImplements;
          for(i = 0,l = list.length;i < l;i++){

            if(list[i] === iface){

              return clazz;
            };
          };
        };
        clazz = clazz.superclass;
      };
      return null;
    },
    hasInterface : function(clazz, iface){

      return !!qx.util.OOUtil.getByInterface(clazz, iface);
    },
    getMixins : function(clazz){

      var list = [];
      while(clazz){

        if(clazz.$$includes){

          list.push.apply(list, clazz.$$flatIncludes);
        };
        clazz = clazz.superclass;
      };
      return list;
    }
  }
});
qx.Bootstrap.define("qx.core.Environment", {
  statics : {
    _checks : {
    },
    _asyncChecks : {
    },
    __cache : {
    },
    _checksMap : {
    },
    _defaults : {
      "true" : true,
      "qx.allowUrlSettings" : false,
      "qx.allowUrlVariants" : false,
      "qx.debug.property.level" : 0,
      "qx.debug" : true,
      "qx.debug.ui.queue" : true,
      "qx.aspects" : false,
      "qx.dynlocale" : true,
      "qx.dyntheme" : true,
      "qx.blankpage" : "qx/static/blank.html",
      "qx.debug.databinding" : false,
      "qx.debug.dispose" : false,
      "qx.optimization.basecalls" : false,
      "qx.optimization.comments" : false,
      "qx.optimization.privates" : false,
      "qx.optimization.strings" : false,
      "qx.optimization.variables" : false,
      "qx.optimization.variants" : false,
      "module.databinding" : true,
      "module.logger" : true,
      "module.property" : true,
      "module.events" : true,
      "qx.nativeScrollBars" : false
    },
    get : function(key){

      if(this.__cache[key] != undefined){

        return this.__cache[key];
      };
      var check = this._checks[key];
      if(check){

        var value = check();
        this.__cache[key] = value;
        return value;
      };
      var classAndMethod = this._getClassNameFromEnvKey(key);
      if(classAndMethod[0] != undefined){

        var clazz = classAndMethod[0];
        var method = classAndMethod[1];
        var value = clazz[method]();
        this.__cache[key] = value;
        return value;
      };
      if(qx.Bootstrap.DEBUG){

        qx.Bootstrap.warn(key + " is not a valid key. Please see the API-doc of " + "qx.core.Environment for a list of predefined keys.");
        qx.Bootstrap.trace(this);
      };
    },
    _getClassNameFromEnvKey : function(key){

      var envmappings = this._checksMap;
      if(envmappings[key] != undefined){

        var implementation = envmappings[key];
        var lastdot = implementation.lastIndexOf(".");
        if(lastdot > -1){

          var classname = implementation.slice(0, lastdot);
          var methodname = implementation.slice(lastdot + 1);
          var clazz = qx.Bootstrap.getByName(classname);
          if(clazz != undefined){

            return [clazz, methodname];
          };
        };
      };
      return [undefined, undefined];
    },
    getAsync : function(key, callback, self){

      var env = this;
      if(this.__cache[key] != undefined){

        window.setTimeout(function(){

          callback.call(self, env.__cache[key]);
        }, 0);
        return;
      };
      var check = this._asyncChecks[key];
      if(check){

        check(function(result){

          env.__cache[key] = result;
          callback.call(self, result);
        });
        return;
      };
      var classAndMethod = this._getClassNameFromEnvKey(key);
      if(classAndMethod[0] != undefined){

        var clazz = classAndMethod[0];
        var method = classAndMethod[1];
        clazz[method](function(result){

          env.__cache[key] = result;
          callback.call(self, result);
        });
        return;
      };
      if(qx.Bootstrap.DEBUG){

        qx.Bootstrap.warn(key + " is not a valid key. Please see the API-doc of " + "qx.core.Environment for a list of predefined keys.");
        qx.Bootstrap.trace(this);
      };
    },
    select : function(key, values){

      return this.__pickFromValues(this.get(key), values);
    },
    selectAsync : function(key, values, self){

      this.getAsync(key, function(result){

        var value = this.__pickFromValues(key, values);
        value.call(self, result);
      }, this);
    },
    __pickFromValues : function(key, values){

      var value = values[key];
      if(values.hasOwnProperty(key)){

        return value;
      };
      for(var id in values){

        if(id.indexOf("|") != -1){

          var ids = id.split("|");
          for(var i = 0;i < ids.length;i++){

            if(ids[i] == key){

              return values[id];
            };
          };
        };
      };
      if(values["default"] !== undefined){

        return values["default"];
      };
      if(qx.Bootstrap.DEBUG){

        throw new Error('No match for variant "' + key + '" (' + (typeof key) + ' type)' + ' in variants [' + qx.Bootstrap.keys(values) + '] found, and no default ("default") given');
      };
    },
    filter : function(map){

      var returnArray = [];
      for(var check in map){

        if(this.get(check)){

          returnArray.push(map[check]);
        };
      };
      return returnArray;
    },
    invalidateCacheKey : function(key){

      delete this.__cache[key];
    },
    add : function(key, check){

      if(this._checks[key] == undefined){

        if(check instanceof Function){

          if(!this._checksMap[key] && check.displayName){

            this._checksMap[key] = check.displayName.substr(0, check.displayName.length - 2);
          };
          this._checks[key] = check;
        } else {

          this._checks[key] = this.__createCheck(check);
        };
      };
    },
    addAsync : function(key, check){

      if(this._checks[key] == undefined){

        this._asyncChecks[key] = check;
      };
    },
    getChecks : function(){

      return this._checks;
    },
    getAsyncChecks : function(){

      return this._asyncChecks;
    },
    _initDefaultQxValues : function(){

      var createFuncReturning = function(val){

        return function(){

          return val;
        };
      };
      for(var prop in this._defaults){

        this.add(prop, createFuncReturning(this._defaults[prop]));
      };
    },
    __importFromGenerator : function(){

      if(qx && qx.$$environment){

        for(var key in qx.$$environment){

          var value = qx.$$environment[key];
          this._checks[key] = this.__createCheck(value);
        };
      };
    },
    __importFromUrl : function(){

      if(window.document && window.document.location){

        var urlChecks = window.document.location.search.slice(1).split("&");
        for(var i = 0;i < urlChecks.length;i++){

          var check = urlChecks[i].split(":");
          if(check.length != 3 || check[0] != "qxenv"){

            continue;
          };
          var key = check[1];
          var value = decodeURIComponent(check[2]);
          if(value == "true"){

            value = true;
          } else if(value == "false"){

            value = false;
          } else if(/^(\d|\.)+$/.test(value)){

            value = parseFloat(value);
          };;
          this._checks[key] = this.__createCheck(value);
        };
      };
    },
    __createCheck : function(value){

      return qx.Bootstrap.bind(function(value){

        return value;
      }, null, value);
    }
  },
  defer : function(statics){

    statics._initDefaultQxValues();
    statics.__importFromGenerator();
    if(statics.get("qx.allowUrlSettings") === true){

      statics.__importFromUrl();
    };
  }
});
qx.Bootstrap.define("qx.bom.client.EcmaScript", {
  statics : {
    getStackTrace : function(){

      var propName;
      var e = new Error("e");
      propName = e.stack ? "stack" : e.stacktrace ? "stacktrace" : null;
      if(!propName){

        try{

          throw e;
        } catch(ex) {

          e = ex;
        };
      };
      return e.stacktrace ? "stacktrace" : e.stack ? "stack" : null;
    },
    getArrayIndexOf : function(){

      return !!Array.prototype.indexOf;
    },
    getArrayLastIndexOf : function(){

      return !!Array.prototype.lastIndexOf;
    },
    getArrayForEach : function(){

      return !!Array.prototype.forEach;
    },
    getArrayFilter : function(){

      return !!Array.prototype.filter;
    },
    getArrayMap : function(){

      return !!Array.prototype.map;
    },
    getArraySome : function(){

      return !!Array.prototype.some;
    },
    getArrayEvery : function(){

      return !!Array.prototype.every;
    },
    getArrayReduce : function(){

      return !!Array.prototype.reduce;
    },
    getArrayReduceRight : function(){

      return !!Array.prototype.reduceRight;
    },
    getErrorToString : function(){

      return typeof Error.prototype.toString == "function" && Error.prototype.toString() !== "[object Error]";
    },
    getFunctionBind : function(){

      return typeof Function.prototype.bind === "function";
    },
    getObjectKeys : function(){

      return !!Object.keys;
    },
    getDateNow : function(){

      return !!Date.now;
    },
    getStringTrim : function(){

      return typeof String.prototype.trim === "function";
    }
  },
  defer : function(statics){

    qx.core.Environment.add("ecmascript.array.indexof", statics.getArrayIndexOf);
    qx.core.Environment.add("ecmascript.array.lastindexof", statics.getArrayLastIndexOf);
    qx.core.Environment.add("ecmascript.array.foreach", statics.getArrayForEach);
    qx.core.Environment.add("ecmascript.array.filter", statics.getArrayFilter);
    qx.core.Environment.add("ecmascript.array.map", statics.getArrayMap);
    qx.core.Environment.add("ecmascript.array.some", statics.getArraySome);
    qx.core.Environment.add("ecmascript.array.every", statics.getArrayEvery);
    qx.core.Environment.add("ecmascript.array.reduce", statics.getArrayReduce);
    qx.core.Environment.add("ecmascript.array.reduceright", statics.getArrayReduceRight);
    qx.core.Environment.add("ecmascript.date.now", statics.getDateNow);
    qx.core.Environment.add("ecmascript.error.toString", statics.getErrorToString);
    qx.core.Environment.add("ecmascript.error.stacktrace", statics.getStackTrace);
    qx.core.Environment.add("ecmascript.function.bind", statics.getFunctionBind);
    qx.core.Environment.add("ecmascript.object.keys", statics.getObjectKeys);
    qx.core.Environment.add("ecmascript.string.trim", statics.getStringTrim);
  }
});
qx.Bootstrap.define("qx.lang.normalize.Function", {
  statics : {
    bind : function(that){

      var slice = Array.prototype.slice;
      var target = this;
      if(typeof target != "function"){

        throw new TypeError("Function.prototype.bind called on incompatible " + target);
      };
      var args = slice.call(arguments, 1);
      var bound = function(){

        if(this instanceof bound){

          var F = function(){
          };
          F.prototype = target.prototype;
          var self = new F;
          var result = target.apply(self, args.concat(slice.call(arguments)));
          if(Object(result) === result){

            return result;
          };
          return self;
        } else {

          return target.apply(that, args.concat(slice.call(arguments)));
        };
      };
      return bound;
    }
  },
  defer : function(statics){

    if(!qx.core.Environment.get("ecmascript.function.bind")){

      Function.prototype.bind = statics.bind;
    };
  }
});
qx.Bootstrap.define("qx.lang.normalize.Array", {
  statics : {
    indexOf : function(searchElement, fromIndex){

      if(fromIndex == null){

        fromIndex = 0;
      } else if(fromIndex < 0){

        fromIndex = Math.max(0, this.length + fromIndex);
      };
      for(var i = fromIndex;i < this.length;i++){

        if(this[i] === searchElement){

          return i;
        };
      };
      return -1;
    },
    lastIndexOf : function(searchElement, fromIndex){

      if(fromIndex == null){

        fromIndex = this.length - 1;
      } else if(fromIndex < 0){

        fromIndex = Math.max(0, this.length + fromIndex);
      };
      for(var i = fromIndex;i >= 0;i--){

        if(this[i] === searchElement){

          return i;
        };
      };
      return -1;
    },
    forEach : function(callback, obj){

      var l = this.length;
      for(var i = 0;i < l;i++){

        var value = this[i];
        if(value !== undefined){

          callback.call(obj || window, value, i, this);
        };
      };
    },
    filter : function(callback, obj){

      var res = [];
      var l = this.length;
      for(var i = 0;i < l;i++){

        var value = this[i];
        if(value !== undefined){

          if(callback.call(obj || window, value, i, this)){

            res.push(this[i]);
          };
        };
      };
      return res;
    },
    map : function(callback, obj){

      var res = [];
      var l = this.length;
      for(var i = 0;i < l;i++){

        var value = this[i];
        if(value !== undefined){

          res[i] = callback.call(obj || window, value, i, this);
        };
      };
      return res;
    },
    some : function(callback, obj){

      var l = this.length;
      for(var i = 0;i < l;i++){

        var value = this[i];
        if(value !== undefined){

          if(callback.call(obj || window, value, i, this)){

            return true;
          };
        };
      };
      return false;
    },
    every : function(callback, obj){

      var l = this.length;
      for(var i = 0;i < l;i++){

        var value = this[i];
        if(value !== undefined){

          if(!callback.call(obj || window, value, i, this)){

            return false;
          };
        };
      };
      return true;
    },
    reduce : function(callback, init){

      if(typeof callback !== "function"){

        throw new TypeError("First argument is not callable");
      };
      if(init === undefined && this.length === 0){

        throw new TypeError("Length is 0 and no second argument given");
      };
      var ret = init === undefined ? this[0] : init;
      for(var i = init === undefined ? 1 : 0;i < this.length;i++){

        if(i in this){

          ret = callback.call(undefined, ret, this[i], i, this);
        };
      };
      return ret;
    },
    reduceRight : function(callback, init){

      if(typeof callback !== "function"){

        throw new TypeError("First argument is not callable");
      };
      if(init === undefined && this.length === 0){

        throw new TypeError("Length is 0 and no second argument given");
      };
      var ret = init === undefined ? this[this.length - 1] : init;
      for(var i = init === undefined ? this.length - 2 : this.length - 1;i >= 0;i--){

        if(i in this){

          ret = callback.call(undefined, ret, this[i], i, this);
        };
      };
      return ret;
    }
  },
  defer : function(statics){

    if(!qx.core.Environment.get("ecmascript.array.indexof")){

      Array.prototype.indexOf = statics.indexOf;
    };
    if(!qx.core.Environment.get("ecmascript.array.lastindexof")){

      Array.prototype.lastIndexOf = statics.lastIndexOf;
    };
    if(!qx.core.Environment.get("ecmascript.array.foreach")){

      Array.prototype.forEach = statics.forEach;
    };
    if(!qx.core.Environment.get("ecmascript.array.filter")){

      Array.prototype.filter = statics.filter;
    };
    if(!qx.core.Environment.get("ecmascript.array.map")){

      Array.prototype.map = statics.map;
    };
    if(!qx.core.Environment.get("ecmascript.array.some")){

      Array.prototype.some = statics.some;
    };
    if(!qx.core.Environment.get("ecmascript.array.every")){

      Array.prototype.every = statics.every;
    };
    if(!qx.core.Environment.get("ecmascript.array.reduce")){

      Array.prototype.reduce = statics.reduce;
    };
    if(!qx.core.Environment.get("ecmascript.array.reduceright")){

      Array.prototype.reduceRight = statics.reduceRight;
    };
  }
});
qx.Bootstrap.define("qx.Mixin", {
  statics : {
    define : function(name, config){

      if(config){

        if(config.include && !(qx.Bootstrap.getClass(config.include) === "Array")){

          config.include = [config.include];
        };
        if(qx.core.Environment.get("qx.debug")){

          this.__validateConfig(name, config);
        };
        var mixin = config.statics ? config.statics : {
        };
        qx.Bootstrap.setDisplayNames(mixin, name);
        for(var key in mixin){

          if(mixin[key] instanceof Function){

            mixin[key].$$mixin = mixin;
          };
        };
        if(config.construct){

          mixin.$$constructor = config.construct;
          qx.Bootstrap.setDisplayName(config.construct, name, "constructor");
        };
        if(config.include){

          mixin.$$includes = config.include;
        };
        if(config.properties){

          mixin.$$properties = config.properties;
        };
        if(config.members){

          mixin.$$members = config.members;
          qx.Bootstrap.setDisplayNames(config.members, name + ".prototype");
        };
        for(var key in mixin.$$members){

          if(mixin.$$members[key] instanceof Function){

            mixin.$$members[key].$$mixin = mixin;
          };
        };
        if(config.events){

          mixin.$$events = config.events;
        };
        if(config.destruct){

          mixin.$$destructor = config.destruct;
          qx.Bootstrap.setDisplayName(config.destruct, name, "destruct");
        };
      } else {

        var mixin = {
        };
      };
      mixin.$$type = "Mixin";
      mixin.name = name;
      mixin.toString = this.genericToString;
      mixin.basename = qx.Bootstrap.createNamespace(name, mixin);
      this.$$registry[name] = mixin;
      return mixin;
    },
    checkCompatibility : function(mixins){

      var list = this.flatten(mixins);
      var len = list.length;
      if(len < 2){

        return true;
      };
      var properties = {
      };
      var members = {
      };
      var events = {
      };
      var mixin;
      for(var i = 0;i < len;i++){

        mixin = list[i];
        for(var key in mixin.events){

          if(events[key]){

            throw new Error('Conflict between mixin "' + mixin.name + '" and "' + events[key] + '" in member "' + key + '"!');
          };
          events[key] = mixin.name;
        };
        for(var key in mixin.properties){

          if(properties[key]){

            throw new Error('Conflict between mixin "' + mixin.name + '" and "' + properties[key] + '" in property "' + key + '"!');
          };
          properties[key] = mixin.name;
        };
        for(var key in mixin.members){

          if(members[key]){

            throw new Error('Conflict between mixin "' + mixin.name + '" and "' + members[key] + '" in member "' + key + '"!');
          };
          members[key] = mixin.name;
        };
      };
      return true;
    },
    isCompatible : function(mixin, clazz){

      var list = qx.util.OOUtil.getMixins(clazz);
      list.push(mixin);
      return qx.Mixin.checkCompatibility(list);
    },
    getByName : function(name){

      return this.$$registry[name];
    },
    isDefined : function(name){

      return this.getByName(name) !== undefined;
    },
    getTotalNumber : function(){

      return qx.Bootstrap.objectGetLength(this.$$registry);
    },
    flatten : function(mixins){

      if(!mixins){

        return [];
      };
      var list = mixins.concat();
      for(var i = 0,l = mixins.length;i < l;i++){

        if(mixins[i].$$includes){

          list.push.apply(list, this.flatten(mixins[i].$$includes));
        };
      };
      return list;
    },
    genericToString : function(){

      return "[Mixin " + this.name + "]";
    },
    $$registry : {
    },
    __allowedKeys : qx.core.Environment.select("qx.debug", {
      "true" : {
        "include" : "object",
        "statics" : "object",
        "members" : "object",
        "properties" : "object",
        "events" : "object",
        "destruct" : "function",
        "construct" : "function"
      },
      "default" : null
    }),
    __validateConfig : qx.core.Environment.select("qx.debug", {
      "true" : function(name, config){

        var allowed = this.__allowedKeys;
        for(var key in config){

          if(!allowed[key]){

            throw new Error('The configuration key "' + key + '" in mixin "' + name + '" is not allowed!');
          };
          if(config[key] == null){

            throw new Error('Invalid key "' + key + '" in mixin "' + name + '"! The value is undefined/null!');
          };
          if(allowed[key] !== null && typeof config[key] !== allowed[key]){

            throw new Error('Invalid type of key "' + key + '" in mixin "' + name + '"! The type of the key must be "' + allowed[key] + '"!');
          };
        };
        var maps = ["statics", "members", "properties", "events"];
        for(var i = 0,l = maps.length;i < l;i++){

          var key = maps[i];
          if(config[key] !== undefined && (["Array", "RegExp", "Date"].indexOf(qx.Bootstrap.getClass(config[key])) != -1 || config[key].classname !== undefined)){

            throw new Error('Invalid key "' + key + '" in mixin "' + name + '"! The value needs to be a map!');
          };
        };
        if(config.include){

          for(var i = 0,a = config.include,l = a.length;i < l;i++){

            if(a[i] == null){

              throw new Error("Includes of mixins must be mixins. The include number '" + (i + 1) + "' in mixin '" + name + "'is undefined/null!");
            };
            if(a[i].$$type !== "Mixin"){

              throw new Error("Includes of mixins must be mixins. The include number '" + (i + 1) + "' in mixin '" + name + "'is not a mixin!");
            };
          };
          this.checkCompatibility(config.include);
        };
      },
      "default" : function(name, config){
      }
    })
  }
});
qx.Bootstrap.define("qx.core.Aspect", {
  statics : {
    __registry : [],
    wrap : function(fullName, fcn, type){

      var before = [];
      var after = [];
      var reg = this.__registry;
      var entry;
      for(var i = 0;i < reg.length;i++){

        entry = reg[i];
        if((entry.type == null || type == entry.type || entry.type == "*") && (entry.name == null || fullName.match(entry.name))){

          entry.pos == -1 ? before.push(entry.fcn) : after.push(entry.fcn);
        };
      };
      if(before.length === 0 && after.length === 0){

        return fcn;
      };
      var wrapper = function(){

        for(var i = 0;i < before.length;i++){

          before[i].call(this, fullName, fcn, type, arguments);
        };
        var ret = fcn.apply(this, arguments);
        for(var i = 0;i < after.length;i++){

          after[i].call(this, fullName, fcn, type, arguments, ret);
        };
        return ret;
      };
      if(type !== "static"){

        wrapper.self = fcn.self;
        wrapper.base = fcn.base;
      };
      fcn.wrapper = wrapper;
      wrapper.original = fcn;
      return wrapper;
    },
    addAdvice : function(fcn, position, type, name){

      this.__registry.push({
        fcn : fcn,
        pos : position === "before" ? -1 : 1,
        type : type,
        name : name
      });
    }
  }
});
qx.Bootstrap.define("qx.lang.normalize.String", {
  statics : {
    trim : function(){

      return this.replace(/^\s+|\s+$/g, '');
    }
  },
  defer : function(statics){

    if(!qx.core.Environment.get("ecmascript.string.trim")){

      String.prototype.trim = statics.trim;
    };
  }
});
qx.Bootstrap.define("qx.lang.normalize.Object", {
  statics : {
    keys : qx.Bootstrap.keys
  },
  defer : function(statics){

    if(!qx.core.Environment.get("ecmascript.object.keys")){

      Object.keys = statics.keys;
    };
  }
});
qx.Bootstrap.define("qx.Interface", {
  statics : {
    define : function(name, config){

      if(config){

        if(config.extend && !(qx.Bootstrap.getClass(config.extend) === "Array")){

          config.extend = [config.extend];
        };
        if(qx.core.Environment.get("qx.debug")){

          this.__validateConfig(name, config);
        };
        var iface = config.statics ? config.statics : {
        };
        if(config.extend){

          iface.$$extends = config.extend;
        };
        if(config.properties){

          iface.$$properties = config.properties;
        };
        if(config.members){

          iface.$$members = config.members;
        };
        if(config.events){

          iface.$$events = config.events;
        };
      } else {

        var iface = {
        };
      };
      iface.$$type = "Interface";
      iface.name = name;
      iface.toString = this.genericToString;
      iface.basename = qx.Bootstrap.createNamespace(name, iface);
      qx.Interface.$$registry[name] = iface;
      return iface;
    },
    getByName : function(name){

      return this.$$registry[name];
    },
    isDefined : function(name){

      return this.getByName(name) !== undefined;
    },
    getTotalNumber : function(){

      return qx.Bootstrap.objectGetLength(this.$$registry);
    },
    flatten : function(ifaces){

      if(!ifaces){

        return [];
      };
      var list = ifaces.concat();
      for(var i = 0,l = ifaces.length;i < l;i++){

        if(ifaces[i].$$extends){

          list.push.apply(list, this.flatten(ifaces[i].$$extends));
        };
      };
      return list;
    },
    __checkMembers : function(object, clazz, iface, wrap, shouldThrow){

      var members = iface.$$members;
      if(members){

        for(var key in members){

          if(qx.Bootstrap.isFunction(members[key])){

            var isPropertyMethod = this.__isPropertyMethod(clazz, key);
            var hasMemberFunction = isPropertyMethod || qx.Bootstrap.isFunction(object[key]);
            if(!hasMemberFunction){

              if(shouldThrow){

                throw new Error('Implementation of method "' + key + '" is missing in class "' + clazz.classname + '" required by interface "' + iface.name + '"');
              } else {

                return false;
              };
            };
            var shouldWrapFunction = wrap === true && !isPropertyMethod && !qx.util.OOUtil.hasInterface(clazz, iface);
            if(shouldWrapFunction){

              object[key] = this.__wrapInterfaceMember(iface, object[key], key, members[key]);
            };
          } else {

            if(typeof object[key] === undefined){

              if(typeof object[key] !== "function"){

                if(shouldThrow){

                  throw new Error('Implementation of member "' + key + '" is missing in class "' + clazz.classname + '" required by interface "' + iface.name + '"');
                } else {

                  return false;
                };
              };
            };
          };
        };
      };
      if(!shouldThrow){

        return true;
      };
    },
    __isPropertyMethod : function(clazz, methodName){

      var match = methodName.match(/^(is|toggle|get|set|reset)(.*)$/);
      if(!match){

        return false;
      };
      var propertyName = qx.Bootstrap.firstLow(match[2]);
      var isPropertyMethod = qx.util.OOUtil.getPropertyDefinition(clazz, propertyName);
      if(!isPropertyMethod){

        return false;
      };
      var isBoolean = match[0] == "is" || match[0] == "toggle";
      if(isBoolean){

        return qx.util.OOUtil.getPropertyDefinition(clazz, propertyName).check == "Boolean";
      };
      return true;
    },
    __checkProperties : function(clazz, iface, shouldThrow){

      if(iface.$$properties){

        for(var key in iface.$$properties){

          if(!qx.util.OOUtil.getPropertyDefinition(clazz, key)){

            if(shouldThrow){

              throw new Error('The property "' + key + '" is not supported by Class "' + clazz.classname + '"!');
            } else {

              return false;
            };
          };
        };
      };
      if(!shouldThrow){

        return true;
      };
    },
    __checkEvents : function(clazz, iface, shouldThrow){

      if(iface.$$events){

        for(var key in iface.$$events){

          if(!qx.util.OOUtil.supportsEvent(clazz, key)){

            if(shouldThrow){

              throw new Error('The event "' + key + '" is not supported by Class "' + clazz.classname + '"!');
            } else {

              return false;
            };
          };
        };
      };
      if(!shouldThrow){

        return true;
      };
    },
    assertObject : function(object, iface){

      var clazz = object.constructor;
      this.__checkMembers(object, clazz, iface, false, true);
      this.__checkProperties(clazz, iface, true);
      this.__checkEvents(clazz, iface, true);
      var extend = iface.$$extends;
      if(extend){

        for(var i = 0,l = extend.length;i < l;i++){

          this.assertObject(object, extend[i]);
        };
      };
    },
    assert : function(clazz, iface, wrap){

      this.__checkMembers(clazz.prototype, clazz, iface, wrap, true);
      this.__checkProperties(clazz, iface, true);
      this.__checkEvents(clazz, iface, true);
      var extend = iface.$$extends;
      if(extend){

        for(var i = 0,l = extend.length;i < l;i++){

          this.assert(clazz, extend[i], wrap);
        };
      };
    },
    objectImplements : function(object, iface){

      var clazz = object.constructor;
      if(!this.__checkMembers(object, clazz, iface) || !this.__checkProperties(clazz, iface) || !this.__checkEvents(clazz, iface)){

        return false;
      };
      var extend = iface.$$extends;
      if(extend){

        for(var i = 0,l = extend.length;i < l;i++){

          if(!this.objectImplements(object, extend[i])){

            return false;
          };
        };
      };
      return true;
    },
    classImplements : function(clazz, iface){

      if(!this.__checkMembers(clazz.prototype, clazz, iface) || !this.__checkProperties(clazz, iface) || !this.__checkEvents(clazz, iface)){

        return false;
      };
      var extend = iface.$$extends;
      if(extend){

        for(var i = 0,l = extend.length;i < l;i++){

          if(!this.has(clazz, extend[i])){

            return false;
          };
        };
      };
      return true;
    },
    genericToString : function(){

      return "[Interface " + this.name + "]";
    },
    $$registry : {
    },
    __wrapInterfaceMember : qx.core.Environment.select("qx.debug", {
      "true" : function(iface, origFunction, functionName, preCondition){

        function wrappedFunction(){

          preCondition.apply(this, arguments);
          return origFunction.apply(this, arguments);
        };
        origFunction.wrapper = wrappedFunction;
        return wrappedFunction;
      },
      "default" : function(iface, origFunction, functionName, preCondition){
      }
    }),
    __allowedKeys : qx.core.Environment.select("qx.debug", {
      "true" : {
        "extend" : "object",
        "statics" : "object",
        "members" : "object",
        "properties" : "object",
        "events" : "object"
      },
      "default" : null
    }),
    __validateConfig : qx.core.Environment.select("qx.debug", {
      "true" : function(name, config){

        if(qx.core.Environment.get("qx.debug")){

          var allowed = this.__allowedKeys;
          for(var key in config){

            if(allowed[key] === undefined){

              throw new Error('The configuration key "' + key + '" in class "' + name + '" is not allowed!');
            };
            if(config[key] == null){

              throw new Error("Invalid key '" + key + "' in interface '" + name + "'! The value is undefined/null!");
            };
            if(allowed[key] !== null && typeof config[key] !== allowed[key]){

              throw new Error('Invalid type of key "' + key + '" in interface "' + name + '"! The type of the key must be "' + allowed[key] + '"!');
            };
          };
          var maps = ["statics", "members", "properties", "events"];
          for(var i = 0,l = maps.length;i < l;i++){

            var key = maps[i];
            if(config[key] !== undefined && (["Array", "RegExp", "Date"].indexOf(qx.Bootstrap.getClass(config[key])) != -1 || config[key].classname !== undefined)){

              throw new Error('Invalid key "' + key + '" in interface "' + name + '"! The value needs to be a map!');
            };
          };
          if(config.extend){

            for(var i = 0,a = config.extend,l = a.length;i < l;i++){

              if(a[i] == null){

                throw new Error("Extends of interfaces must be interfaces. The extend number '" + i + 1 + "' in interface '" + name + "' is undefined/null!");
              };
              if(a[i].$$type !== "Interface"){

                throw new Error("Extends of interfaces must be interfaces. The extend number '" + i + 1 + "' in interface '" + name + "' is not an interface!");
              };
            };
          };
          if(config.statics){

            for(var key in config.statics){

              if(key.toUpperCase() !== key){

                throw new Error('Invalid key "' + key + '" in interface "' + name + '"! Static constants must be all uppercase.');
              };
              switch(typeof config.statics[key]){case "boolean":case "string":case "number":
              break;default:
              throw new Error('Invalid key "' + key + '" in interface "' + name + '"! Static constants must be all of a primitive type.');};
            };
          };
        };
      },
      "default" : function(name, config){
      }
    })
  }
});
qx.Bootstrap.define("qx.lang.normalize.Error", {
  statics : {
    toString : function(){

      var name = this.name || "Error";
      var message = this.message || "";
      if(name === "" && message === ""){

        return "Error";
      };
      if(name === ""){

        return message;
      };
      if(message === ""){

        return name;
      };
      return name + ": " + message;
    }
  },
  defer : function(statics){

    if(!qx.core.Environment.get("ecmascript.error.toString")){

      Error.prototype.toString = statics.toString;
    };
  }
});
qx.Bootstrap.define("qx.lang.normalize.Date", {
  statics : {
    now : function(){

      return +new Date();
    }
  },
  defer : function(statics){

    if(!qx.core.Environment.get("ecmascript.date.now")){

      Date.now = statics.now;
    };
  }
});
qx.Bootstrap.define("qx.core.Property", {
  statics : {
    __gatherDependency : function(){

      if(qx.core.Environment.get("module.events")){

        qx.event.type.Data;
        qx.event.dispatch.Direct;
      };
    },
    __checks : {
      "Boolean" : 'qx.core.Assert.assertBoolean(value, msg) || true',
      "String" : 'qx.core.Assert.assertString(value, msg) || true',
      "Number" : 'qx.core.Assert.assertNumber(value, msg) || true',
      "Integer" : 'qx.core.Assert.assertInteger(value, msg) || true',
      "PositiveNumber" : 'qx.core.Assert.assertPositiveNumber(value, msg) || true',
      "PositiveInteger" : 'qx.core.Assert.assertPositiveInteger(value, msg) || true',
      "Error" : 'qx.core.Assert.assertInstance(value, Error, msg) || true',
      "RegExp" : 'qx.core.Assert.assertInstance(value, RegExp, msg) || true',
      "Object" : 'qx.core.Assert.assertObject(value, msg) || true',
      "Array" : 'qx.core.Assert.assertArray(value, msg) || true',
      "Map" : 'qx.core.Assert.assertMap(value, msg) || true',
      "Function" : 'qx.core.Assert.assertFunction(value, msg) || true',
      "Date" : 'qx.core.Assert.assertInstance(value, Date, msg) || true',
      "Node" : 'value !== null && value.nodeType !== undefined',
      "Element" : 'value !== null && value.nodeType === 1 && value.attributes',
      "Document" : 'value !== null && value.nodeType === 9 && value.documentElement',
      "Window" : 'value !== null && value.document',
      "Event" : 'value !== null && value.type !== undefined',
      "Class" : 'value !== null && value.$$type === "Class"',
      "Mixin" : 'value !== null && value.$$type === "Mixin"',
      "Interface" : 'value !== null && value.$$type === "Interface"',
      "Theme" : 'value !== null && value.$$type === "Theme"',
      "Color" : 'qx.lang.Type.isString(value) && qx.util.ColorUtil.isValidPropertyValue(value)',
      "Decorator" : 'value !== null && qx.theme.manager.Decoration.getInstance().isValidPropertyValue(value)',
      "Font" : 'value !== null && qx.theme.manager.Font.getInstance().isDynamic(value)'
    },
    __dereference : {
      "Node" : true,
      "Element" : true,
      "Document" : true,
      "Window" : true,
      "Event" : true
    },
    $$inherit : "inherit",
    $$store : {
      runtime : {
      },
      user : {
      },
      theme : {
      },
      inherit : {
      },
      init : {
      },
      useinit : {
      }
    },
    $$method : {
      get : {
      },
      set : {
      },
      reset : {
      },
      init : {
      },
      refresh : {
      },
      setRuntime : {
      },
      resetRuntime : {
      },
      setThemed : {
      },
      resetThemed : {
      }
    },
    $$allowedKeys : {
      name : "string",
      dereference : "boolean",
      inheritable : "boolean",
      nullable : "boolean",
      themeable : "boolean",
      refine : "boolean",
      init : null,
      apply : "string",
      event : "string",
      check : null,
      transform : "string",
      deferredInit : "boolean",
      validate : null
    },
    $$allowedGroupKeys : {
      name : "string",
      group : "object",
      mode : "string",
      themeable : "boolean"
    },
    $$inheritable : {
    },
    __executeOptimizedRefresh : function(clazz){

      var inheritables = this.__getInheritablesOfClass(clazz);
      if(!inheritables.length){

        var refresher = function(){
        };
      } else {

        refresher = this.__createRefresher(inheritables);
      };
      clazz.prototype.$$refreshInheritables = refresher;
    },
    __getInheritablesOfClass : function(clazz){

      var inheritable = [];
      while(clazz){

        var properties = clazz.$$properties;
        if(properties){

          for(var name in this.$$inheritable){

            if(properties[name] && properties[name].inheritable){

              inheritable.push(name);
            };
          };
        };
        clazz = clazz.superclass;
      };
      return inheritable;
    },
    __createRefresher : function(inheritables){

      var inherit = this.$$store.inherit;
      var init = this.$$store.init;
      var refresh = this.$$method.refresh;
      var code = ["var parent = this.getLayoutParent();", "if (!parent) return;"];
      for(var i = 0,l = inheritables.length;i < l;i++){

        var name = inheritables[i];
        code.push("var value = parent.", inherit[name], ";", "if (value===undefined) value = parent.", init[name], ";", "this.", refresh[name], "(value);");
      };
      return new Function(code.join(""));
    },
    attachRefreshInheritables : function(clazz){

      clazz.prototype.$$refreshInheritables = function(){

        qx.core.Property.__executeOptimizedRefresh(clazz);
        return this.$$refreshInheritables();
      };
    },
    attachMethods : function(clazz, name, config){

      config.group ? this.__attachGroupMethods(clazz, config, name) : this.__attachPropertyMethods(clazz, config, name);
    },
    __attachGroupMethods : function(clazz, config, name){

      var upname = qx.Bootstrap.firstUp(name);
      var members = clazz.prototype;
      var themeable = config.themeable === true;
      if(qx.core.Environment.get("qx.debug")){

        if(qx.core.Environment.get("qx.debug.property.level") > 1){

          qx.Bootstrap.debug("Generating property group: " + name);
        };
      };
      var setter = [];
      var resetter = [];
      if(themeable){

        var styler = [];
        var unstyler = [];
      };
      var argHandler = "var a=arguments[0] instanceof Array?arguments[0]:arguments;";
      setter.push(argHandler);
      if(themeable){

        styler.push(argHandler);
      };
      if(config.mode == "shorthand"){

        var shorthand = "a=qx.lang.Array.fromShortHand(qx.lang.Array.fromArguments(a));";
        setter.push(shorthand);
        if(themeable){

          styler.push(shorthand);
        };
      };
      for(var i = 0,a = config.group,l = a.length;i < l;i++){

        if(qx.core.Environment.get("qx.debug")){

          if(!this.$$method.set[a[i]] || !this.$$method.reset[a[i]]){

            throw new Error("Cannot create property group '" + name + "' including non-existing property '" + a[i] + "'!");
          };
        };
        setter.push("this.", this.$$method.set[a[i]], "(a[", i, "]);");
        resetter.push("this.", this.$$method.reset[a[i]], "();");
        if(themeable){

          if(qx.core.Environment.get("qx.debug")){

            if(!this.$$method.setThemed[a[i]]){

              throw new Error("Cannot add the non themable property '" + a[i] + "' to the themable property group '" + name + "'");
            };
          };
          styler.push("this.", this.$$method.setThemed[a[i]], "(a[", i, "]);");
          unstyler.push("this.", this.$$method.resetThemed[a[i]], "();");
        };
      };
      this.$$method.set[name] = "set" + upname;
      members[this.$$method.set[name]] = new Function(setter.join(""));
      this.$$method.reset[name] = "reset" + upname;
      members[this.$$method.reset[name]] = new Function(resetter.join(""));
      if(themeable){

        this.$$method.setThemed[name] = "setThemed" + upname;
        members[this.$$method.setThemed[name]] = new Function(styler.join(""));
        this.$$method.resetThemed[name] = "resetThemed" + upname;
        members[this.$$method.resetThemed[name]] = new Function(unstyler.join(""));
      };
    },
    __attachPropertyMethods : function(clazz, config, name){

      var upname = qx.Bootstrap.firstUp(name);
      var members = clazz.prototype;
      if(qx.core.Environment.get("qx.debug")){

        if(qx.core.Environment.get("qx.debug.property.level") > 1){

          qx.Bootstrap.debug("Generating property wrappers: " + name);
        };
      };
      if(config.dereference === undefined && typeof config.check === "string"){

        config.dereference = this.__shouldBeDereferenced(config.check);
      };
      var method = this.$$method;
      var store = this.$$store;
      store.runtime[name] = "$$runtime_" + name;
      store.user[name] = "$$user_" + name;
      store.theme[name] = "$$theme_" + name;
      store.init[name] = "$$init_" + name;
      store.inherit[name] = "$$inherit_" + name;
      store.useinit[name] = "$$useinit_" + name;
      method.get[name] = "get" + upname;
      members[method.get[name]] = function(){

        return qx.core.Property.executeOptimizedGetter(this, clazz, name, "get");
      };
      method.set[name] = "set" + upname;
      members[method.set[name]] = function(value){

        return qx.core.Property.executeOptimizedSetter(this, clazz, name, "set", arguments);
      };
      method.reset[name] = "reset" + upname;
      members[method.reset[name]] = function(){

        return qx.core.Property.executeOptimizedSetter(this, clazz, name, "reset");
      };
      if(config.inheritable || config.apply || config.event || config.deferredInit){

        method.init[name] = "init" + upname;
        members[method.init[name]] = function(value){

          return qx.core.Property.executeOptimizedSetter(this, clazz, name, "init", arguments);
        };
        if(qx.core.Environment.get("qx.debug")){

          members[method.init[name]].$$propertyMethod = true;
        };
      };
      if(config.inheritable){

        method.refresh[name] = "refresh" + upname;
        members[method.refresh[name]] = function(value){

          return qx.core.Property.executeOptimizedSetter(this, clazz, name, "refresh", arguments);
        };
        if(qx.core.Environment.get("qx.debug")){

          members[method.refresh[name]].$$propertyMethod = true;
        };
      };
      method.setRuntime[name] = "setRuntime" + upname;
      members[method.setRuntime[name]] = function(value){

        return qx.core.Property.executeOptimizedSetter(this, clazz, name, "setRuntime", arguments);
      };
      method.resetRuntime[name] = "resetRuntime" + upname;
      members[method.resetRuntime[name]] = function(){

        return qx.core.Property.executeOptimizedSetter(this, clazz, name, "resetRuntime");
      };
      if(config.themeable){

        method.setThemed[name] = "setThemed" + upname;
        members[method.setThemed[name]] = function(value){

          return qx.core.Property.executeOptimizedSetter(this, clazz, name, "setThemed", arguments);
        };
        method.resetThemed[name] = "resetThemed" + upname;
        members[method.resetThemed[name]] = function(){

          return qx.core.Property.executeOptimizedSetter(this, clazz, name, "resetThemed");
        };
        if(qx.core.Environment.get("qx.debug")){

          members[method.setThemed[name]].$$propertyMethod = true;
          members[method.resetThemed[name]].$$propertyMethod = true;
        };
      };
      if(config.check === "Boolean"){

        members["toggle" + upname] = new Function("return this." + method.set[name] + "(!this." + method.get[name] + "())");
        members["is" + upname] = new Function("return this." + method.get[name] + "()");
        if(qx.core.Environment.get("qx.debug")){

          members["toggle" + upname].$$propertyMethod = true;
          members["is" + upname].$$propertyMethod = true;
        };
      };
      if(qx.core.Environment.get("qx.debug")){

        members[method.get[name]].$$propertyMethod = true;
        members[method.set[name]].$$propertyMethod = true;
        members[method.reset[name]].$$propertyMethod = true;
        members[method.setRuntime[name]].$$propertyMethod = true;
        members[method.resetRuntime[name]].$$propertyMethod = true;
      };
    },
    __shouldBeDereferenced : function(check){

      return !!this.__dereference[check];
    },
    __errors : {
      '0' : 'Could not change or apply init value after constructing phase!',
      '1' : 'Requires exactly one argument!',
      '2' : 'Undefined value is not allowed!',
      '3' : 'Does not allow any arguments!',
      '4' : 'Null value is not allowed!',
      '5' : 'Is invalid!'
    },
    error : function(obj, id, property, variant, value){

      var classname = obj.constructor.classname;
      var msg = "Error in property " + property + " of class " + classname + " in method " + this.$$method[variant][property] + " with incoming value '" + value + "': ";
      throw new Error(msg + (this.__errors[id] || "Unknown reason: " + id));
    },
    __unwrapFunctionFromCode : function(instance, members, name, variant, code, args){

      var store = this.$$method[variant][name];
      if(qx.core.Environment.get("qx.debug")){

        if(qx.core.Environment.get("qx.debug.property.level") > 1){

          qx.Bootstrap.debug("Code[" + this.$$method[variant][name] + "]: " + code.join(""));
        };
        try{

          members[store] = new Function("value", code.join(""));
        } catch(ex) {

          throw new Error("Malformed generated code to unwrap method: " + this.$$method[variant][name] + "\n" + code.join(""));
        };
      } else {

        members[store] = new Function("value", code.join(""));
      };
      if(qx.core.Environment.get("qx.aspects")){

        members[store] = qx.core.Aspect.wrap(instance.classname + "." + store, members[store], "property");
      };
      qx.Bootstrap.setDisplayName(members[store], instance.classname + ".prototype", store);
      if(args === undefined){

        return instance[store]();
      } else if(qx.core.Environment.get("qx.debug")){

        return instance[store].apply(instance, args);
      } else {

        return instance[store](args[0]);
      };
    },
    executeOptimizedGetter : function(instance, clazz, name, variant){

      var config = clazz.$$properties[name];
      var members = clazz.prototype;
      var code = [];
      var store = this.$$store;
      code.push('if(this.', store.runtime[name], '!==undefined)');
      code.push('return this.', store.runtime[name], ';');
      if(config.inheritable){

        code.push('else if(this.', store.inherit[name], '!==undefined)');
        code.push('return this.', store.inherit[name], ';');
        code.push('else ');
      };
      code.push('if(this.', store.user[name], '!==undefined)');
      code.push('return this.', store.user[name], ';');
      if(config.themeable){

        code.push('else if(this.', store.theme[name], '!==undefined)');
        code.push('return this.', store.theme[name], ';');
      };
      if(config.deferredInit && config.init === undefined){

        code.push('else if(this.', store.init[name], '!==undefined)');
        code.push('return this.', store.init[name], ';');
      };
      code.push('else ');
      if(config.init !== undefined){

        if(config.inheritable){

          code.push('var init=this.', store.init[name], ';');
          if(config.nullable){

            code.push('if(init==qx.core.Property.$$inherit)init=null;');
          };
          code.push('return init;');
        } else {

          code.push('return this.', store.init[name], ';');
        };
      } else if(config.inheritable || config.nullable){

        code.push('return null;');
      } else {

        code.push('throw new Error("Property ', name, ' of an instance of ', clazz.classname, ' is not (yet) ready!");');
      };
      return this.__unwrapFunctionFromCode(instance, members, name, variant, code);
    },
    executeOptimizedSetter : function(instance, clazz, name, variant, args){

      var config = clazz.$$properties[name];
      var members = clazz.prototype;
      var code = [];
      var incomingValue = variant === "set" || variant === "setThemed" || variant === "setRuntime" || (variant === "init" && config.init === undefined);
      var hasCallback = config.apply || config.event || config.inheritable;
      var store = this.__getStore(variant, name);
      this.__emitSetterPreConditions(code, config, name, variant, incomingValue);
      if(incomingValue){

        this.__emitIncomingValueTransformation(code, clazz, config, name);
      };
      if(hasCallback){

        this.__emitOldNewComparison(code, incomingValue, store, variant);
      };
      if(config.inheritable){

        code.push('var inherit=prop.$$inherit;');
      };
      if(qx.core.Environment.get("qx.debug")){

        if(incomingValue){

          this.__emitIncomingValueValidation(code, config, clazz, name, variant);
        };
      };
      if(!hasCallback){

        this.__emitStoreValue(code, name, variant, incomingValue);
      } else {

        this.__emitStoreComputedAndOldValue(code, config, name, variant, incomingValue);
      };
      if(config.inheritable){

        this.__emitStoreInheritedPropertyValue(code, config, name, variant);
      } else if(hasCallback){

        this.__emitNormalizeUndefinedValues(code, config, name, variant);
      };
      if(hasCallback){

        this.__emitCallCallback(code, config, name, variant);
        if(config.inheritable && members._getChildren){

          this.__emitRefreshChildrenValue(code, name);
        };
      };
      if(incomingValue){

        code.push('return value;');
      };
      return this.__unwrapFunctionFromCode(instance, members, name, variant, code, args);
    },
    __getStore : function(variant, name){

      if(variant === "setRuntime" || variant === "resetRuntime"){

        var store = this.$$store.runtime[name];
      } else if(variant === "setThemed" || variant === "resetThemed"){

        store = this.$$store.theme[name];
      } else if(variant === "init"){

        store = this.$$store.init[name];
      } else {

        store = this.$$store.user[name];
      };;
      return store;
    },
    __emitSetterPreConditions : function(code, config, name, variant, incomingValue){

      if(qx.core.Environment.get("qx.debug")){

        code.push('var prop=qx.core.Property;');
        if(variant === "init"){

          code.push('if(this.$$initialized)prop.error(this,0,"', name, '","', variant, '",value);');
        };
        if(variant === "refresh"){
        } else if(incomingValue){

          code.push('if(arguments.length!==1)prop.error(this,1,"', name, '","', variant, '",value);');
          code.push('if(value===undefined)prop.error(this,2,"', name, '","', variant, '",value);');
        } else {

          code.push('if(arguments.length!==0)prop.error(this,3,"', name, '","', variant, '",value);');
        };
      } else {

        if(!config.nullable || config.check || config.inheritable){

          code.push('var prop=qx.core.Property;');
        };
        if(variant === "set"){

          code.push('if(value===undefined)prop.error(this,2,"', name, '","', variant, '",value);');
        };
      };
    },
    __emitIncomingValueTransformation : function(code, clazz, config, name){

      if(config.transform){

        code.push('value=this.', config.transform, '(value);');
      };
      if(config.validate){

        if(typeof config.validate === "string"){

          code.push('this.', config.validate, '(value);');
        } else if(config.validate instanceof Function){

          code.push(clazz.classname, '.$$properties.', name);
          code.push('.validate.call(this, value);');
        };
      };
    },
    __emitOldNewComparison : function(code, incomingValue, store, variant){

      var resetValue = (variant === "reset" || variant === "resetThemed" || variant === "resetRuntime");
      if(incomingValue){

        code.push('if(this.', store, '===value)return value;');
      } else if(resetValue){

        code.push('if(this.', store, '===undefined)return;');
      };
    },
    __emitIncomingValueValidation : qx.core.Environment.select("qx.debug", {
      "true" : function(code, config, clazz, name, variant){

        if(!config.nullable){

          code.push('if(value===null)prop.error(this,4,"', name, '","', variant, '",value);');
        };
        if(config.check !== undefined){

          code.push('var msg = "Invalid incoming value for property \'' + name + '\' of class \'' + clazz.classname + '\'";');
          if(config.nullable){

            code.push('if(value!==null)');
          };
          if(config.inheritable){

            code.push('if(value!==inherit)');
          };
          code.push('if(');
          if(this.__checks[config.check] !== undefined){

            code.push('!(', this.__checks[config.check], ')');
          } else if(qx.Class.isDefined(config.check)){

            code.push('qx.core.Assert.assertInstance(value, qx.Class.getByName("', config.check, '"), msg)');
          } else if(qx.Interface && qx.Interface.isDefined(config.check)){

            code.push('qx.core.Assert.assertInterface(value, qx.Interface.getByName("', config.check, '"), msg)');
          } else if(typeof config.check === "function"){

            code.push('!', clazz.classname, '.$$properties.', name);
            code.push('.check.call(this, value)');
          } else if(typeof config.check === "string"){

            code.push('!(', config.check, ')');
          } else if(config.check instanceof Array){

            code.push('qx.core.Assert.assertInArray(value, ', clazz.classname, '.$$properties.', name, '.check, msg)');
          } else {

            throw new Error("Could not add check to property " + name + " of class " + clazz.classname);
          };;;;;
          code.push(')prop.error(this,5,"', name, '","', variant, '",value);');
        };
      },
      "false" : undefined
    }),
    __emitStoreValue : function(code, name, variant, incomingValue){

      if(variant === "setRuntime"){

        code.push('this.', this.$$store.runtime[name], '=value;');
      } else if(variant === "resetRuntime"){

        code.push('if(this.', this.$$store.runtime[name], '!==undefined)');
        code.push('delete this.', this.$$store.runtime[name], ';');
      } else if(variant === "set"){

        code.push('this.', this.$$store.user[name], '=value;');
      } else if(variant === "reset"){

        code.push('if(this.', this.$$store.user[name], '!==undefined)');
        code.push('delete this.', this.$$store.user[name], ';');
      } else if(variant === "setThemed"){

        code.push('this.', this.$$store.theme[name], '=value;');
      } else if(variant === "resetThemed"){

        code.push('if(this.', this.$$store.theme[name], '!==undefined)');
        code.push('delete this.', this.$$store.theme[name], ';');
      } else if(variant === "init" && incomingValue){

        code.push('this.', this.$$store.init[name], '=value;');
      };;;;;;
    },
    __emitStoreComputedAndOldValue : function(code, config, name, variant, incomingValue){

      if(config.inheritable){

        code.push('var computed, old=this.', this.$$store.inherit[name], ';');
      } else {

        code.push('var computed, old;');
      };
      code.push('if(this.', this.$$store.runtime[name], '!==undefined){');
      if(variant === "setRuntime"){

        code.push('computed=this.', this.$$store.runtime[name], '=value;');
      } else if(variant === "resetRuntime"){

        code.push('delete this.', this.$$store.runtime[name], ';');
        code.push('if(this.', this.$$store.user[name], '!==undefined)');
        code.push('computed=this.', this.$$store.user[name], ';');
        code.push('else if(this.', this.$$store.theme[name], '!==undefined)');
        code.push('computed=this.', this.$$store.theme[name], ';');
        code.push('else if(this.', this.$$store.init[name], '!==undefined){');
        code.push('computed=this.', this.$$store.init[name], ';');
        code.push('this.', this.$$store.useinit[name], '=true;');
        code.push('}');
      } else {

        code.push('old=computed=this.', this.$$store.runtime[name], ';');
        if(variant === "set"){

          code.push('this.', this.$$store.user[name], '=value;');
        } else if(variant === "reset"){

          code.push('delete this.', this.$$store.user[name], ';');
        } else if(variant === "setThemed"){

          code.push('this.', this.$$store.theme[name], '=value;');
        } else if(variant === "resetThemed"){

          code.push('delete this.', this.$$store.theme[name], ';');
        } else if(variant === "init" && incomingValue){

          code.push('this.', this.$$store.init[name], '=value;');
        };;;;
      };
      code.push('}');
      code.push('else if(this.', this.$$store.user[name], '!==undefined){');
      if(variant === "set"){

        if(!config.inheritable){

          code.push('old=this.', this.$$store.user[name], ';');
        };
        code.push('computed=this.', this.$$store.user[name], '=value;');
      } else if(variant === "reset"){

        if(!config.inheritable){

          code.push('old=this.', this.$$store.user[name], ';');
        };
        code.push('delete this.', this.$$store.user[name], ';');
        code.push('if(this.', this.$$store.runtime[name], '!==undefined)');
        code.push('computed=this.', this.$$store.runtime[name], ';');
        code.push('if(this.', this.$$store.theme[name], '!==undefined)');
        code.push('computed=this.', this.$$store.theme[name], ';');
        code.push('else if(this.', this.$$store.init[name], '!==undefined){');
        code.push('computed=this.', this.$$store.init[name], ';');
        code.push('this.', this.$$store.useinit[name], '=true;');
        code.push('}');
      } else {

        if(variant === "setRuntime"){

          code.push('computed=this.', this.$$store.runtime[name], '=value;');
        } else if(config.inheritable){

          code.push('computed=this.', this.$$store.user[name], ';');
        } else {

          code.push('old=computed=this.', this.$$store.user[name], ';');
        };
        if(variant === "setThemed"){

          code.push('this.', this.$$store.theme[name], '=value;');
        } else if(variant === "resetThemed"){

          code.push('delete this.', this.$$store.theme[name], ';');
        } else if(variant === "init" && incomingValue){

          code.push('this.', this.$$store.init[name], '=value;');
        };;
      };
      code.push('}');
      if(config.themeable){

        code.push('else if(this.', this.$$store.theme[name], '!==undefined){');
        if(!config.inheritable){

          code.push('old=this.', this.$$store.theme[name], ';');
        };
        if(variant === "setRuntime"){

          code.push('computed=this.', this.$$store.runtime[name], '=value;');
        } else if(variant === "set"){

          code.push('computed=this.', this.$$store.user[name], '=value;');
        } else if(variant === "setThemed"){

          code.push('computed=this.', this.$$store.theme[name], '=value;');
        } else if(variant === "resetThemed"){

          code.push('delete this.', this.$$store.theme[name], ';');
          code.push('if(this.', this.$$store.init[name], '!==undefined){');
          code.push('computed=this.', this.$$store.init[name], ';');
          code.push('this.', this.$$store.useinit[name], '=true;');
          code.push('}');
        } else if(variant === "init"){

          if(incomingValue){

            code.push('this.', this.$$store.init[name], '=value;');
          };
          code.push('computed=this.', this.$$store.theme[name], ';');
        } else if(variant === "refresh"){

          code.push('computed=this.', this.$$store.theme[name], ';');
        };;;;;
        code.push('}');
      };
      code.push('else if(this.', this.$$store.useinit[name], '){');
      if(!config.inheritable){

        code.push('old=this.', this.$$store.init[name], ';');
      };
      if(variant === "init"){

        if(incomingValue){

          code.push('computed=this.', this.$$store.init[name], '=value;');
        } else {

          code.push('computed=this.', this.$$store.init[name], ';');
        };
      } else if(variant === "set" || variant === "setRuntime" || variant === "setThemed" || variant === "refresh"){

        code.push('delete this.', this.$$store.useinit[name], ';');
        if(variant === "setRuntime"){

          code.push('computed=this.', this.$$store.runtime[name], '=value;');
        } else if(variant === "set"){

          code.push('computed=this.', this.$$store.user[name], '=value;');
        } else if(variant === "setThemed"){

          code.push('computed=this.', this.$$store.theme[name], '=value;');
        } else if(variant === "refresh"){

          code.push('computed=this.', this.$$store.init[name], ';');
        };;;
      };
      code.push('}');
      if(variant === "set" || variant === "setRuntime" || variant === "setThemed" || variant === "init"){

        code.push('else{');
        if(variant === "setRuntime"){

          code.push('computed=this.', this.$$store.runtime[name], '=value;');
        } else if(variant === "set"){

          code.push('computed=this.', this.$$store.user[name], '=value;');
        } else if(variant === "setThemed"){

          code.push('computed=this.', this.$$store.theme[name], '=value;');
        } else if(variant === "init"){

          if(incomingValue){

            code.push('computed=this.', this.$$store.init[name], '=value;');
          } else {

            code.push('computed=this.', this.$$store.init[name], ';');
          };
          code.push('this.', this.$$store.useinit[name], '=true;');
        };;;
        code.push('}');
      };
    },
    __emitStoreInheritedPropertyValue : function(code, config, name, variant){

      code.push('if(computed===undefined||computed===inherit){');
      if(variant === "refresh"){

        code.push('computed=value;');
      } else {

        code.push('var pa=this.getLayoutParent();if(pa)computed=pa.', this.$$store.inherit[name], ';');
      };
      code.push('if((computed===undefined||computed===inherit)&&');
      code.push('this.', this.$$store.init[name], '!==undefined&&');
      code.push('this.', this.$$store.init[name], '!==inherit){');
      code.push('computed=this.', this.$$store.init[name], ';');
      code.push('this.', this.$$store.useinit[name], '=true;');
      code.push('}else{');
      code.push('delete this.', this.$$store.useinit[name], ';}');
      code.push('}');
      code.push('if(old===computed)return value;');
      code.push('if(computed===inherit){');
      code.push('computed=undefined;delete this.', this.$$store.inherit[name], ';');
      code.push('}');
      code.push('else if(computed===undefined)');
      code.push('delete this.', this.$$store.inherit[name], ';');
      code.push('else this.', this.$$store.inherit[name], '=computed;');
      code.push('var backup=computed;');
      if(config.init !== undefined && variant !== "init"){

        code.push('if(old===undefined)old=this.', this.$$store.init[name], ";");
      } else {

        code.push('if(old===undefined)old=null;');
      };
      code.push('if(computed===undefined||computed==inherit)computed=null;');
    },
    __emitNormalizeUndefinedValues : function(code, config, name, variant){

      if(variant !== "set" && variant !== "setRuntime" && variant !== "setThemed"){

        code.push('if(computed===undefined)computed=null;');
      };
      code.push('if(old===computed)return value;');
      if(config.init !== undefined && variant !== "init"){

        code.push('if(old===undefined)old=this.', this.$$store.init[name], ";");
      } else {

        code.push('if(old===undefined)old=null;');
      };
    },
    __emitCallCallback : function(code, config, name, variant){

      if(config.apply){

        code.push('this.', config.apply, '(computed, old, "', name, '", "', variant, '");');
      };
      if(config.event){

        code.push("var reg=qx.event.Registration;", "if(reg.hasListener(this, '", config.event, "')){", "reg.fireEvent(this, '", config.event, "', qx.event.type.Data, [computed, old]", ")}");
      };
    },
    __emitRefreshChildrenValue : function(code, name){

      code.push('var a=this._getChildren();if(a)for(var i=0,l=a.length;i<l;i++){');
      code.push('if(a[i].', this.$$method.refresh[name], ')a[i].', this.$$method.refresh[name], '(backup);');
      code.push('}');
    }
  }
});
qx.Bootstrap.define("qx.Class", {
  statics : {
    __Property : qx.core.Environment.get("module.property") ? qx.core.Property : null,
    define : function(name, config){

      if(!config){

        config = {
        };
      };
      if(config.include && !(qx.Bootstrap.getClass(config.include) === "Array")){

        config.include = [config.include];
      };
      if(config.implement && !(qx.Bootstrap.getClass(config.implement) === "Array")){

        config.implement = [config.implement];
      };
      var implicitType = false;
      if(!config.hasOwnProperty("extend") && !config.type){

        config.type = "static";
        implicitType = true;
      };
      if(qx.core.Environment.get("qx.debug")){

        try{

          this.__validateConfig(name, config);
        } catch(ex) {

          if(implicitType){

            ex.message = 'Assumed static class because no "extend" key was found. ' + ex.message;
          };
          throw ex;
        };
      };
      var clazz = this.__createClass(name, config.type, config.extend, config.statics, config.construct, config.destruct, config.include);
      if(config.extend){

        if(config.properties){

          this.__addProperties(clazz, config.properties, true);
        };
        if(config.members){

          this.__addMembers(clazz, config.members, true, true, false);
        };
        if(config.events){

          this.__addEvents(clazz, config.events, true);
        };
        if(config.include){

          for(var i = 0,l = config.include.length;i < l;i++){

            this.__addMixin(clazz, config.include[i], false);
          };
        };
      } else if(config.hasOwnProperty('extend') && qx.core.Environment.get("qx.debug")){

        throw new Error('"extend" parameter is null or undefined');
      };
      if(config.environment){

        for(var key in config.environment){

          qx.core.Environment.add(key, config.environment[key]);
        };
      };
      if(config.implement){

        for(var i = 0,l = config.implement.length;i < l;i++){

          this.__addInterface(clazz, config.implement[i]);
        };
      };
      if(qx.core.Environment.get("qx.debug")){

        this.__validateAbstractInterfaces(clazz);
      };
      if(config.defer){

        config.defer.self = clazz;
        config.defer(clazz, clazz.prototype, {
          add : function(name, config){

            var properties = {
            };
            properties[name] = config;
            qx.Class.__addProperties(clazz, properties, true);
          }
        });
      };
      return clazz;
    },
    undefine : function(name){

      delete this.$$registry[name];
      var ns = name.split(".");
      var objects = [window];
      for(var i = 0;i < ns.length;i++){

        objects.push(objects[i][ns[i]]);
      };
      for(var i = objects.length - 1;i >= 1;i--){

        var last = objects[i];
        var parent = objects[i - 1];
        if(qx.Bootstrap.isFunction(last) || qx.Bootstrap.objectGetLength(last) === 0){

          delete parent[ns[i - 1]];
        } else {

          break;
        };
      };
    },
    isDefined : qx.util.OOUtil.classIsDefined,
    getTotalNumber : function(){

      return qx.Bootstrap.objectGetLength(this.$$registry);
    },
    getByName : qx.Bootstrap.getByName,
    include : function(clazz, mixin){

      if(qx.core.Environment.get("qx.debug")){

        if(!mixin){

          throw new Error("The mixin to include into class '" + clazz.classname + "' is undefined/null!");
        };
        qx.Mixin.isCompatible(mixin, clazz);
      };
      qx.Class.__addMixin(clazz, mixin, false);
    },
    patch : function(clazz, mixin){

      if(qx.core.Environment.get("qx.debug")){

        if(!mixin){

          throw new Error("The mixin to patch class '" + clazz.classname + "' is undefined/null!");
        };
        qx.Mixin.isCompatible(mixin, clazz);
      };
      qx.Class.__addMixin(clazz, mixin, true);
    },
    isSubClassOf : function(clazz, superClass){

      if(!clazz){

        return false;
      };
      if(clazz == superClass){

        return true;
      };
      if(clazz.prototype instanceof superClass){

        return true;
      };
      return false;
    },
    getPropertyDefinition : qx.util.OOUtil.getPropertyDefinition,
    getProperties : function(clazz){

      var list = [];
      while(clazz){

        if(clazz.$$properties){

          list.push.apply(list, Object.keys(clazz.$$properties));
        };
        clazz = clazz.superclass;
      };
      return list;
    },
    getByProperty : function(clazz, name){

      while(clazz){

        if(clazz.$$properties && clazz.$$properties[name]){

          return clazz;
        };
        clazz = clazz.superclass;
      };
      return null;
    },
    hasProperty : qx.util.OOUtil.hasProperty,
    getEventType : qx.util.OOUtil.getEventType,
    supportsEvent : qx.util.OOUtil.supportsEvent,
    hasOwnMixin : function(clazz, mixin){

      return clazz.$$includes && clazz.$$includes.indexOf(mixin) !== -1;
    },
    getByMixin : function(clazz, mixin){

      var list,i,l;
      while(clazz){

        if(clazz.$$includes){

          list = clazz.$$flatIncludes;
          for(i = 0,l = list.length;i < l;i++){

            if(list[i] === mixin){

              return clazz;
            };
          };
        };
        clazz = clazz.superclass;
      };
      return null;
    },
    getMixins : qx.util.OOUtil.getMixins,
    hasMixin : function(clazz, mixin){

      return !!this.getByMixin(clazz, mixin);
    },
    hasOwnInterface : function(clazz, iface){

      return clazz.$$implements && clazz.$$implements.indexOf(iface) !== -1;
    },
    getByInterface : qx.util.OOUtil.getByInterface,
    getInterfaces : function(clazz){

      var list = [];
      while(clazz){

        if(clazz.$$implements){

          list.push.apply(list, clazz.$$flatImplements);
        };
        clazz = clazz.superclass;
      };
      return list;
    },
    hasInterface : qx.util.OOUtil.hasInterface,
    implementsInterface : function(obj, iface){

      var clazz = obj.constructor;
      if(this.hasInterface(clazz, iface)){

        return true;
      };
      if(qx.Interface.objectImplements(obj, iface)){

        return true;
      };
      if(qx.Interface.classImplements(clazz, iface)){

        return true;
      };
      return false;
    },
    getInstance : function(){

      if(!this.$$instance){

        this.$$allowconstruct = true;
        this.$$instance = new this();
        delete this.$$allowconstruct;
      };
      return this.$$instance;
    },
    genericToString : function(){

      return "[Class " + this.classname + "]";
    },
    $$registry : qx.Bootstrap.$$registry,
    __allowedKeys : qx.core.Environment.select("qx.debug", {
      "true" : {
        "type" : "string",
        "extend" : "function",
        "implement" : "object",
        "include" : "object",
        "construct" : "function",
        "statics" : "object",
        "properties" : "object",
        "members" : "object",
        "environment" : "object",
        "events" : "object",
        "defer" : "function",
        "destruct" : "function"
      },
      "default" : null
    }),
    __staticAllowedKeys : qx.core.Environment.select("qx.debug", {
      "true" : {
        "type" : "string",
        "statics" : "object",
        "environment" : "object",
        "defer" : "function"
      },
      "default" : null
    }),
    __validateConfig : qx.core.Environment.select("qx.debug", {
      "true" : function(name, config){

        if(config.type && !(config.type === "static" || config.type === "abstract" || config.type === "singleton")){

          throw new Error('Invalid type "' + config.type + '" definition for class "' + name + '"!');
        };
        if(config.type && config.type !== "static" && !config.extend){

          throw new Error('Invalid config in class "' + name + '"! Every non-static class has to extend at least the "qx.core.Object" class.');
        };
        var allowed = config.type === "static" ? this.__staticAllowedKeys : this.__allowedKeys;
        for(var key in config){

          if(!allowed[key]){

            throw new Error('The configuration key "' + key + '" in class "' + name + '" is not allowed!');
          };
          if(config[key] == null){

            throw new Error('Invalid key "' + key + '" in class "' + name + '"! The value is undefined/null!');
          };
          if(typeof config[key] !== allowed[key]){

            throw new Error('Invalid type of key "' + key + '" in class "' + name + '"! The type of the key must be "' + allowed[key] + '"!');
          };
        };
        var maps = ["statics", "properties", "members", "environment", "settings", "variants", "events"];
        for(var i = 0,l = maps.length;i < l;i++){

          var key = maps[i];
          if(config[key] !== undefined && (config[key].$$hash !== undefined || !qx.Bootstrap.isObject(config[key]))){

            throw new Error('Invalid key "' + key + '" in class "' + name + '"! The value needs to be a map!');
          };
        };
        if(config.include){

          if(qx.Bootstrap.getClass(config.include) === "Array"){

            for(var i = 0,a = config.include,l = a.length;i < l;i++){

              if(a[i] == null || a[i].$$type !== "Mixin"){

                throw new Error('The include definition in class "' + name + '" contains an invalid mixin at position ' + i + ': ' + a[i]);
              };
            };
          } else {

            throw new Error('Invalid include definition in class "' + name + '"! Only mixins and arrays of mixins are allowed!');
          };
        };
        if(config.implement){

          if(qx.Bootstrap.getClass(config.implement) === "Array"){

            for(var i = 0,a = config.implement,l = a.length;i < l;i++){

              if(a[i] == null || a[i].$$type !== "Interface"){

                throw new Error('The implement definition in class "' + name + '" contains an invalid interface at position ' + i + ': ' + a[i]);
              };
            };
          } else {

            throw new Error('Invalid implement definition in class "' + name + '"! Only interfaces and arrays of interfaces are allowed!');
          };
        };
        if(config.include){

          try{

            qx.Mixin.checkCompatibility(config.include);
          } catch(ex) {

            throw new Error('Error in include definition of class "' + name + '"! ' + ex.message);
          };
        };
        if(config.environment){

          for(var key in config.environment){

            if(key.substr(0, key.indexOf(".")) != name.substr(0, name.indexOf("."))){

              throw new Error('Forbidden environment setting "' + key + '" found in "' + name + '". It is forbidden to define a ' + 'environment setting for an external namespace!');
            };
          };
        };
        if(config.settings){

          for(var key in config.settings){

            if(key.substr(0, key.indexOf(".")) != name.substr(0, name.indexOf("."))){

              throw new Error('Forbidden setting "' + key + '" found in "' + name + '". It is forbidden to define a default setting for an external namespace!');
            };
          };
        };
        if(config.variants){

          for(var key in config.variants){

            if(key.substr(0, key.indexOf(".")) != name.substr(0, name.indexOf("."))){

              throw new Error('Forbidden variant "' + key + '" found in "' + name + '". It is forbidden to define a variant for an external namespace!');
            };
          };
        };
      },
      "default" : function(name, config){
      }
    }),
    __validateAbstractInterfaces : qx.core.Environment.select("qx.debug", {
      "true" : function(clazz){

        var superclass = clazz.superclass;
        while(superclass){

          if(superclass.$$classtype !== "abstract"){

            break;
          };
          var interfaces = superclass.$$implements;
          if(interfaces){

            for(var i = 0;i < interfaces.length;i++){

              qx.Interface.assert(clazz, interfaces[i], true);
            };
          };
          superclass = superclass.superclass;
        };
      },
      "default" : function(clazz){
      }
    }),
    __createClass : function(name, type, extend, statics, construct, destruct, mixins){

      var clazz;
      if(!extend && qx.core.Environment.get("qx.aspects") == false){

        clazz = statics || {
        };
        qx.Bootstrap.setDisplayNames(clazz, name);
      } else {

        clazz = {
        };
        if(extend){

          if(!construct){

            construct = this.__createDefaultConstructor();
          };
          if(this.__needsConstructorWrapper(extend, mixins)){

            clazz = this.__wrapConstructor(construct, name, type);
          } else {

            clazz = construct;
          };
          if(type === "singleton"){

            clazz.getInstance = this.getInstance;
          };
          qx.Bootstrap.setDisplayName(construct, name, "constructor");
        };
        if(statics){

          qx.Bootstrap.setDisplayNames(statics, name);
          var key;
          for(var i = 0,a = Object.keys(statics),l = a.length;i < l;i++){

            key = a[i];
            var staticValue = statics[key];
            if(qx.core.Environment.get("qx.aspects")){

              if(staticValue instanceof Function){

                staticValue = qx.core.Aspect.wrap(name + "." + key, staticValue, "static");
              };
              clazz[key] = staticValue;
            } else {

              clazz[key] = staticValue;
            };
          };
        };
      };
      var basename = name ? qx.Bootstrap.createNamespace(name, clazz) : "";
      clazz.name = clazz.classname = name;
      clazz.basename = basename;
      clazz.$$type = "Class";
      if(type){

        clazz.$$classtype = type;
      };
      if(!clazz.hasOwnProperty("toString")){

        clazz.toString = this.genericToString;
      };
      if(extend){

        qx.Bootstrap.extendClass(clazz, construct, extend, name, basename);
        if(destruct){

          if(qx.core.Environment.get("qx.aspects")){

            destruct = qx.core.Aspect.wrap(name, destruct, "destructor");
          };
          clazz.$$destructor = destruct;
          qx.Bootstrap.setDisplayName(destruct, name, "destruct");
        };
      };
      this.$$registry[name] = clazz;
      return clazz;
    },
    __addEvents : function(clazz, events, patch){

      if(qx.core.Environment.get("qx.debug")){

        if(typeof events !== "object" || qx.Bootstrap.getClass(events) === "Array"){

          throw new Error(clazz.classname + ": the events must be defined as map!");
        };
        for(var key in events){

          if(typeof events[key] !== "string"){

            throw new Error(clazz.classname + "/" + key + ": the event value needs to be a string with the class name of the event object which will be fired.");
          };
        };
        if(clazz.$$events && patch !== true){

          for(var key in events){

            if(clazz.$$events[key] !== undefined && clazz.$$events[key] !== events[key]){

              throw new Error(clazz.classname + "/" + key + ": the event value/type cannot be changed from " + clazz.$$events[key] + " to " + events[key]);
            };
          };
        };
      };
      if(clazz.$$events){

        for(var key in events){

          clazz.$$events[key] = events[key];
        };
      } else {

        clazz.$$events = events;
      };
    },
    __addProperties : function(clazz, properties, patch){

      if(!qx.core.Environment.get("module.property")){

        throw new Error("Property module disabled.");
      };
      var config;
      if(patch === undefined){

        patch = false;
      };
      var proto = clazz.prototype;
      for(var name in properties){

        config = properties[name];
        if(qx.core.Environment.get("qx.debug")){

          this.__validateProperty(clazz, name, config, patch);
        };
        config.name = name;
        if(!config.refine){

          if(clazz.$$properties === undefined){

            clazz.$$properties = {
            };
          };
          clazz.$$properties[name] = config;
        };
        if(config.init !== undefined){

          clazz.prototype["$$init_" + name] = config.init;
        };
        if(config.event !== undefined){

          if(!qx.core.Environment.get("module.events")){

            throw new Error("Events module not enabled.");
          };
          var event = {
          };
          event[config.event] = "qx.event.type.Data";
          this.__addEvents(clazz, event, patch);
        };
        if(config.inheritable){

          this.__Property.$$inheritable[name] = true;
          if(!proto.$$refreshInheritables){

            this.__Property.attachRefreshInheritables(clazz);
          };
        };
        if(!config.refine){

          this.__Property.attachMethods(clazz, name, config);
        };
      };
    },
    __validateProperty : qx.core.Environment.select("qx.debug", {
      "true" : function(clazz, name, config, patch){

        if(!qx.core.Environment.get("module.property")){

          throw new Error("Property module disabled.");
        };
        var has = this.hasProperty(clazz, name);
        if(has){

          var existingProperty = this.getPropertyDefinition(clazz, name);
          if(config.refine && existingProperty.init === undefined){

            throw new Error("Could not refine an init value if there was previously no init value defined. Property '" + name + "' of class '" + clazz.classname + "'.");
          };
        };
        if(!has && config.refine){

          throw new Error("Could not refine non-existent property: '" + name + "' of class: '" + clazz.classname + "'!");
        };
        if(has && !patch){

          throw new Error("Class " + clazz.classname + " already has a property: " + name + "!");
        };
        if(has && patch){

          if(!config.refine){

            throw new Error('Could not refine property "' + name + '" without a "refine" flag in the property definition! This class: ' + clazz.classname + ', original class: ' + this.getByProperty(clazz, name).classname + '.');
          };
          for(var key in config){

            if(key !== "init" && key !== "refine"){

              throw new Error("Class " + clazz.classname + " could not refine property: " + name + "! Key: " + key + " could not be refined!");
            };
          };
        };
        var allowed = config.group ? this.__Property.$$allowedGroupKeys : this.__Property.$$allowedKeys;
        for(var key in config){

          if(allowed[key] === undefined){

            throw new Error('The configuration key "' + key + '" of property "' + name + '" in class "' + clazz.classname + '" is not allowed!');
          };
          if(config[key] === undefined){

            throw new Error('Invalid key "' + key + '" of property "' + name + '" in class "' + clazz.classname + '"! The value is undefined: ' + config[key]);
          };
          if(allowed[key] !== null && typeof config[key] !== allowed[key]){

            throw new Error('Invalid type of key "' + key + '" of property "' + name + '" in class "' + clazz.classname + '"! The type of the key must be "' + allowed[key] + '"!');
          };
        };
        if(config.transform != null){

          if(!(typeof config.transform == "string")){

            throw new Error('Invalid transform definition of property "' + name + '" in class "' + clazz.classname + '"! Needs to be a String.');
          };
        };
        if(config.check != null){

          if(!qx.Bootstrap.isString(config.check) && !qx.Bootstrap.isArray(config.check) && !qx.Bootstrap.isFunction(config.check)){

            throw new Error('Invalid check definition of property "' + name + '" in class "' + clazz.classname + '"! Needs to be a String, Array or Function.');
          };
        };
      },
      "default" : null
    }),
    __addMembers : function(clazz, members, patch, base, wrap){

      var proto = clazz.prototype;
      var key,member;
      qx.Bootstrap.setDisplayNames(members, clazz.classname + ".prototype");
      for(var i = 0,a = Object.keys(members),l = a.length;i < l;i++){

        key = a[i];
        member = members[key];
        if(qx.core.Environment.get("qx.debug")){

          if(proto[key] !== undefined && key.charAt(0) == "_" && key.charAt(1) == "_"){

            throw new Error('Overwriting private member "' + key + '" of Class "' + clazz.classname + '" is not allowed!');
          };
          if(patch !== true && proto.hasOwnProperty(key)){

            throw new Error('Overwriting member "' + key + '" of Class "' + clazz.classname + '" is not allowed!');
          };
          if(proto[key] != undefined && proto[key].$$propertyMethod){

            throw new Error('Overwriting generated property method "' + key + '" of Class "' + clazz.classname + '" is not allowed!');
          };
        };
        if(base !== false && member instanceof Function && member.$$type == null){

          if(wrap == true){

            member = this.__mixinMemberWrapper(member, proto[key]);
          } else {

            if(proto[key]){

              member.base = proto[key];
            };
            member.self = clazz;
          };
          if(qx.core.Environment.get("qx.aspects")){

            member = qx.core.Aspect.wrap(clazz.classname + "." + key, member, "member");
          };
        };
        proto[key] = member;
      };
    },
    __mixinMemberWrapper : function(member, base){

      if(base){

        return function(){

          var oldBase = member.base;
          member.base = base;
          var retval = member.apply(this, arguments);
          member.base = oldBase;
          return retval;
        };
      } else {

        return member;
      };
    },
    __addInterface : function(clazz, iface){

      if(qx.core.Environment.get("qx.debug")){

        if(!clazz || !iface){

          throw new Error("Incomplete parameters!");
        };
        if(this.hasOwnInterface(clazz, iface)){

          throw new Error('Interface "' + iface.name + '" is already used by Class "' + clazz.classname + '!');
        };
        if(clazz.$$classtype !== "abstract"){

          qx.Interface.assert(clazz, iface, true);
        };
      };
      var list = qx.Interface.flatten([iface]);
      if(clazz.$$implements){

        clazz.$$implements.push(iface);
        clazz.$$flatImplements.push.apply(clazz.$$flatImplements, list);
      } else {

        clazz.$$implements = [iface];
        clazz.$$flatImplements = list;
      };
    },
    __retrospectWrapConstruct : function(clazz){

      var name = clazz.classname;
      var wrapper = this.__wrapConstructor(clazz, name, clazz.$$classtype);
      for(var i = 0,a = Object.keys(clazz),l = a.length;i < l;i++){

        key = a[i];
        wrapper[key] = clazz[key];
      };
      wrapper.prototype = clazz.prototype;
      var members = clazz.prototype;
      for(var i = 0,a = Object.keys(members),l = a.length;i < l;i++){

        key = a[i];
        var method = members[key];
        if(method && method.self == clazz){

          method.self = wrapper;
        };
      };
      for(var key in this.$$registry){

        var construct = this.$$registry[key];
        if(!construct){

          continue;
        };
        if(construct.base == clazz){

          construct.base = wrapper;
        };
        if(construct.superclass == clazz){

          construct.superclass = wrapper;
        };
        if(construct.$$original){

          if(construct.$$original.base == clazz){

            construct.$$original.base = wrapper;
          };
          if(construct.$$original.superclass == clazz){

            construct.$$original.superclass = wrapper;
          };
        };
      };
      qx.Bootstrap.createNamespace(name, wrapper);
      this.$$registry[name] = wrapper;
      return wrapper;
    },
    __addMixin : function(clazz, mixin, patch){

      if(qx.core.Environment.get("qx.debug")){

        if(!clazz || !mixin){

          throw new Error("Incomplete parameters!");
        };
      };
      if(this.hasMixin(clazz, mixin)){

        return;
      };
      var isConstructorWrapped = clazz.$$original;
      if(mixin.$$constructor && !isConstructorWrapped){

        clazz = this.__retrospectWrapConstruct(clazz);
      };
      var list = qx.Mixin.flatten([mixin]);
      var entry;
      for(var i = 0,l = list.length;i < l;i++){

        entry = list[i];
        if(entry.$$events){

          this.__addEvents(clazz, entry.$$events, patch);
        };
        if(entry.$$properties){

          this.__addProperties(clazz, entry.$$properties, patch);
        };
        if(entry.$$members){

          this.__addMembers(clazz, entry.$$members, patch, patch, patch);
        };
      };
      if(clazz.$$includes){

        clazz.$$includes.push(mixin);
        clazz.$$flatIncludes.push.apply(clazz.$$flatIncludes, list);
      } else {

        clazz.$$includes = [mixin];
        clazz.$$flatIncludes = list;
      };
    },
    __createDefaultConstructor : function(){

      function defaultConstructor(){

        defaultConstructor.base.apply(this, arguments);
      };
      return defaultConstructor;
    },
    __needsConstructorWrapper : function(base, mixins){

      if(qx.core.Environment.get("qx.debug")){

        return true;
      };
      if(base && base.$$includes){

        var baseMixins = base.$$flatIncludes;
        for(var i = 0,l = baseMixins.length;i < l;i++){

          if(baseMixins[i].$$constructor){

            return true;
          };
        };
      };
      if(mixins){

        var flatMixins = qx.Mixin.flatten(mixins);
        for(var i = 0,l = flatMixins.length;i < l;i++){

          if(flatMixins[i].$$constructor){

            return true;
          };
        };
      };
      return false;
    },
    __wrapConstructor : function(construct, name, type){

      var wrapper = function(){

        var clazz = wrapper;
        if(qx.core.Environment.get("qx.debug")){

          if(!(this instanceof clazz)){

            throw new Error("Please initialize '" + name + "' objects using the new keyword!");
          };
          if(type === "abstract"){

            if(this.classname === name){

              throw new Error("The class '," + name + "' is abstract! It is not possible to instantiate it.");
            };
          } else if(type === "singleton"){

            if(!clazz.$$allowconstruct){

              throw new Error("The class '" + name + "' is a singleton! It is not possible to instantiate it directly. Use the static getInstance() method instead.");
            };
          };
        };
        var retval = clazz.$$original.apply(this, arguments);
        if(clazz.$$includes){

          var mixins = clazz.$$flatIncludes;
          for(var i = 0,l = mixins.length;i < l;i++){

            if(mixins[i].$$constructor){

              mixins[i].$$constructor.apply(this, arguments);
            };
          };
        };
        if(qx.core.Environment.get("qx.debug")){

          if(this.classname === name){

            this.$$initialized = true;
          };
        };
        return retval;
      };
      if(qx.core.Environment.get("qx.aspects")){

        var aspectWrapper = qx.core.Aspect.wrap(name, wrapper, "constructor");
        wrapper.$$original = construct;
        wrapper.constructor = aspectWrapper;
        wrapper = aspectWrapper;
      };
      wrapper.$$original = construct;
      construct.wrapper = wrapper;
      return wrapper;
    }
  },
  defer : function(){

    if(qx.core.Environment.get("qx.aspects")){

      for(var classname in qx.Bootstrap.$$registry){

        var statics = qx.Bootstrap.$$registry[classname];
        for(var key in statics){

          if(statics[key] instanceof Function){

            statics[key] = qx.core.Aspect.wrap(classname + "." + key, statics[key], "static");
          };
        };
      };
    };
  }
});
qx.Mixin.define("qx.data.MBinding", {
  construct : function(){

    this.__objectHash = this.toHashCode();
  },
  members : {
    __objectHash : null,
    bind : function(sourcePropertyChain, targetObject, targetProperty, options){

      return qx.data.SingleValueBinding.bind(this, sourcePropertyChain, targetObject, targetProperty, options);
    },
    removeBinding : function(id){

      qx.data.SingleValueBinding.removeBindingFromObject(this, id);
    },
    removeRelatedBindings : function(relatedObject){

      qx.data.SingleValueBinding.removeRelatedBindings(this, relatedObject);
    },
    removeAllBindings : function(){

      qx.data.SingleValueBinding.removeAllBindingsForObject(this);
    },
    getBindings : function(){

      return qx.data.SingleValueBinding.getAllBindingsForObject(this);
    }
  },
  destruct : function(){

    this.$$hash = this.__objectHash;
    this.removeAllBindings();
    delete this.$$hash;
  }
});
qx.Class.define("qx.data.SingleValueBinding", {
  statics : {
    __bindings : {
    },
    __bindingsByTarget : {
    },
    bind : function(sourceObject, sourcePropertyChain, targetObject, targetPropertyChain, options){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertObject(sourceObject, "sourceObject");
        qx.core.Assert.assertString(sourcePropertyChain, "sourcePropertyChain");
        qx.core.Assert.assertObject(targetObject, "targetObject");
        qx.core.Assert.assertString(targetPropertyChain, "targetPropertyChain");
      };
      var targetListenerMap = this.__setUpTargetBinding(sourceObject, sourcePropertyChain, targetObject, targetPropertyChain, options);
      var propertyNames = sourcePropertyChain.split(".");
      var arrayIndexValues = this.__checkForArrayInPropertyChain(propertyNames);
      var sources = [];
      var listeners = [];
      var listenerIds = [];
      var eventNames = [];
      var source = sourceObject;
      try{

        for(var i = 0;i < propertyNames.length;i++){

          if(arrayIndexValues[i] !== ""){

            eventNames.push("change");
          } else {

            var eventName = this.__getEventNameForProperty(source, propertyNames[i]);
            if(!eventName){

              if(i == 0){

                throw new qx.core.AssertionError("Binding property " + propertyNames[i] + " of object " + source + " not possible: No event available. ");
              };
              this.__setInitialValue(undefined, targetObject, targetPropertyChain, options, sourceObject);
              break;
            };
            eventNames.push(eventName);
          };
          sources[i] = source;
          if(i == propertyNames.length - 1){

            if(arrayIndexValues[i] !== ""){

              var itemIndex = arrayIndexValues[i] === "last" ? source.length - 1 : arrayIndexValues[i];
              var currentValue = source.getItem(itemIndex);
              this.__setInitialValue(currentValue, targetObject, targetPropertyChain, options, sourceObject);
              listenerIds[i] = this.__bindEventToProperty(source, eventNames[i], targetObject, targetPropertyChain, options, arrayIndexValues[i]);
            } else {

              if(propertyNames[i] != null && source["get" + qx.lang.String.firstUp(propertyNames[i])] != null){

                var currentValue = source["get" + qx.lang.String.firstUp(propertyNames[i])]();
                this.__setInitialValue(currentValue, targetObject, targetPropertyChain, options, sourceObject);
              };
              listenerIds[i] = this.__bindEventToProperty(source, eventNames[i], targetObject, targetPropertyChain, options);
            };
          } else {

            var context = {
              index : i,
              propertyNames : propertyNames,
              sources : sources,
              listenerIds : listenerIds,
              arrayIndexValues : arrayIndexValues,
              targetObject : targetObject,
              targetPropertyChain : targetPropertyChain,
              options : options,
              listeners : listeners
            };
            var listener = qx.lang.Function.bind(this.__chainListener, this, context);
            listeners.push(listener);
            listenerIds[i] = source.addListener(eventNames[i], listener);
          };
          if(source["get" + qx.lang.String.firstUp(propertyNames[i])] == null){

            source = undefined;
          } else if(arrayIndexValues[i] !== ""){

            var itemIndex = arrayIndexValues[i] === "last" ? source.length - 1 : arrayIndexValues[i];
            source = source["get" + qx.lang.String.firstUp(propertyNames[i])](itemIndex);
          } else {

            source = source["get" + qx.lang.String.firstUp(propertyNames[i])]();
            if(source === null && (propertyNames.length - 1) != i){

              source = undefined;
            };
          };
          if(!source){

            this.__setInitialValue(source, targetObject, targetPropertyChain, options, sourceObject);
            break;
          };
        };
      } catch(ex) {

        for(var i = 0;i < sources.length;i++){

          if(sources[i] && listenerIds[i]){

            sources[i].removeListenerById(listenerIds[i]);
          };
        };
        var targets = targetListenerMap.targets;
        var targetIds = targetListenerMap.listenerIds;
        for(var i = 0;i < targets.length;i++){

          if(targets[i] && targetIds[i]){

            targets[i].removeListenerById(targetIds[i]);
          };
        };
        throw ex;
      };
      var id = {
        type : "deepBinding",
        listenerIds : listenerIds,
        sources : sources,
        targetListenerIds : targetListenerMap.listenerIds,
        targets : targetListenerMap.targets
      };
      this.__storeBinding(id, sourceObject, sourcePropertyChain, targetObject, targetPropertyChain);
      return id;
    },
    __chainListener : function(context){

      if(context.options && context.options.onUpdate){

        context.options.onUpdate(context.sources[context.index], context.targetObject);
      };
      for(var j = context.index + 1;j < context.propertyNames.length;j++){

        var source = context.sources[j];
        context.sources[j] = null;
        if(!source){

          continue;
        };
        source.removeListenerById(context.listenerIds[j]);
      };
      var source = context.sources[context.index];
      for(var j = context.index + 1;j < context.propertyNames.length;j++){

        if(context.arrayIndexValues[j - 1] !== ""){

          source = source["get" + qx.lang.String.firstUp(context.propertyNames[j - 1])](context.arrayIndexValues[j - 1]);
        } else {

          source = source["get" + qx.lang.String.firstUp(context.propertyNames[j - 1])]();
        };
        context.sources[j] = source;
        if(!source){

          if(context.options && context.options.converter){

            var ignoreConverter = false;
            if(context.options.ignoreConverter){

              var currentSourceChain = context.propertyNames.slice(0, j).join(".");
              var match = currentSourceChain.match(new RegExp("^" + context.options.ignoreConverter));
              ignoreConverter = match ? match.length > 0 : false;
            };
            if(!ignoreConverter){

              this.__setTargetValue(context.targetObject, context.targetPropertyChain, context.options.converter());
            } else {

              this.__resetTargetValue(context.targetObject, context.targetPropertyChain);
            };
          } else {

            this.__resetTargetValue(context.targetObject, context.targetPropertyChain);
          };
          break;
        };
        if(j == context.propertyNames.length - 1){

          if(qx.Class.implementsInterface(source, qx.data.IListData)){

            var itemIndex = context.arrayIndexValues[j] === "last" ? source.length - 1 : context.arrayIndexValues[j];
            var currentValue = source.getItem(itemIndex);
            this.__setInitialValue(currentValue, context.targetObject, context.targetPropertyChain, context.options, context.sources[context.index]);
            context.listenerIds[j] = this.__bindEventToProperty(source, "change", context.targetObject, context.targetPropertyChain, context.options, context.arrayIndexValues[j]);
          } else {

            if(context.propertyNames[j] != null && source["get" + qx.lang.String.firstUp(context.propertyNames[j])] != null){

              var currentValue = source["get" + qx.lang.String.firstUp(context.propertyNames[j])]();
              this.__setInitialValue(currentValue, context.targetObject, context.targetPropertyChain, context.options, context.sources[context.index]);
            };
            var eventName = this.__getEventNameForProperty(source, context.propertyNames[j]);
            if(!eventName){

              this.__resetTargetValue(context.targetObject, context.targetPropertyChain);
              break;
            };
            context.listenerIds[j] = this.__bindEventToProperty(source, eventName, context.targetObject, context.targetPropertyChain, context.options);
          };
        } else {

          if(context.listeners[j] == null){

            var listener = qx.lang.Function.bind(this.__chainListener, this, context);
            context.listeners.push(listener);
          };
          if(qx.Class.implementsInterface(source, qx.data.IListData)){

            var eventName = "change";
          } else {

            var eventName = this.__getEventNameForProperty(source, context.propertyNames[j]);
          };
          if(!eventName){

            this.__resetTargetValue(context.targetObject, context.targetPropertyChain);
            return;
          };
          context.listenerIds[j] = source.addListener(eventName, context.listeners[j]);
        };
      };
    },
    __setUpTargetBinding : function(sourceObject, sourcePropertyChain, targetObject, targetPropertyChain, options){

      var propertyNames = targetPropertyChain.split(".");
      var arrayIndexValues = this.__checkForArrayInPropertyChain(propertyNames);
      var targets = [];
      var listeners = [];
      var listenerIds = [];
      var eventNames = [];
      var target = targetObject;
      for(var i = 0;i < propertyNames.length - 1;i++){

        if(arrayIndexValues[i] !== ""){

          eventNames.push("change");
        } else {

          var eventName = this.__getEventNameForProperty(target, propertyNames[i]);
          if(!eventName){

            break;
          };
          eventNames.push(eventName);
        };
        targets[i] = target;
        var listener = function(){

          for(var j = i + 1;j < propertyNames.length - 1;j++){

            var target = targets[j];
            targets[j] = null;
            if(!target){

              continue;
            };
            target.removeListenerById(listenerIds[j]);
          };
          var target = targets[i];
          for(var j = i + 1;j < propertyNames.length - 1;j++){

            var firstUpPropName = qx.lang.String.firstUp(propertyNames[j - 1]);
            if(arrayIndexValues[j - 1] !== ""){

              var currentIndex = arrayIndexValues[j - 1] === "last" ? target.getLength() - 1 : arrayIndexValues[j - 1];
              target = target["get" + firstUpPropName](currentIndex);
            } else {

              target = target["get" + firstUpPropName]();
            };
            targets[j] = target;
            if(listeners[j] == null){

              listeners.push(listener);
            };
            if(qx.Class.implementsInterface(target, qx.data.IListData)){

              var eventName = "change";
            } else {

              var eventName = qx.data.SingleValueBinding.__getEventNameForProperty(target, propertyNames[j]);
              if(!eventName){

                break;
              };
            };
            listenerIds[j] = target.addListener(eventName, listeners[j]);
          };
          qx.data.SingleValueBinding.updateTarget(sourceObject, sourcePropertyChain, targetObject, targetPropertyChain, options);
        };
        listeners.push(listener);
        listenerIds[i] = target.addListener(eventNames[i], listener);
        var firstUpPropName = qx.lang.String.firstUp(propertyNames[i]);
        if(target["get" + firstUpPropName] == null){

          target = null;
        } else if(arrayIndexValues[i] !== ""){

          target = target["get" + firstUpPropName](arrayIndexValues[i]);
        } else {

          target = target["get" + firstUpPropName]();
        };
        if(!target){

          break;
        };
      };
      return {
        listenerIds : listenerIds,
        targets : targets
      };
    },
    updateTarget : function(sourceObject, sourcePropertyChain, targetObject, targetPropertyChain, options){

      var value = this.resolvePropertyChain(sourceObject, sourcePropertyChain);
      value = qx.data.SingleValueBinding.__convertValue(value, targetObject, targetPropertyChain, options, sourceObject);
      this.__setTargetValue(targetObject, targetPropertyChain, value);
    },
    resolvePropertyChain : function(o, propertyChain){

      var properties = this.__getPropertyChainArray(propertyChain);
      return this.__getTargetFromChain(o, properties, properties.length);
    },
    __getEventNameForProperty : function(source, propertyName){

      var eventName = this.__getEventForProperty(source, propertyName);
      if(eventName == null){

        if(qx.Class.supportsEvent(source.constructor, propertyName)){

          eventName = propertyName;
        } else if(qx.Class.supportsEvent(source.constructor, "change" + qx.lang.String.firstUp(propertyName))){

          eventName = "change" + qx.lang.String.firstUp(propertyName);
        } else {

          return null;
        };
      };
      return eventName;
    },
    __resetTargetValue : function(targetObject, targetPropertyChain){

      var properties = this.__getPropertyChainArray(targetPropertyChain);
      var target = this.__getTargetFromChain(targetObject, properties);
      if(target != null){

        var lastProperty = properties[properties.length - 1];
        var index = this.__getArrayIndex(lastProperty);
        if(index){

          this.__setTargetValue(targetObject, targetPropertyChain, null);
          return;
        };
        if(target["reset" + qx.lang.String.firstUp(lastProperty)] != undefined){

          target["reset" + qx.lang.String.firstUp(lastProperty)]();
        } else {

          target["set" + qx.lang.String.firstUp(lastProperty)](null);
        };
      };
    },
    __setTargetValue : function(targetObject, targetPropertyChain, value){

      var properties = this.__getPropertyChainArray(targetPropertyChain);
      var target = this.__getTargetFromChain(targetObject, properties);
      if(target){

        var lastProperty = properties[properties.length - 1];
        var index = this.__getArrayIndex(lastProperty);
        if(index){

          if(index === "last"){

            index = target.length - 1;
          };
          target.setItem(index, value);
        } else {

          target["set" + qx.lang.String.firstUp(lastProperty)](value);
        };
      };
    },
    __getArrayIndex : function(propertyName){

      var arrayExp = /^\[(\d+|last)\]$/;
      var arrayMatch = propertyName.match(arrayExp);
      if(arrayMatch){

        return arrayMatch[1];
      };
      return null;
    },
    __getPropertyChainArray : function(targetPropertyChain){

      return targetPropertyChain.replace(/\[/g, ".[").split(".").filter(function(prop){

        return prop !== "";
      });
    },
    __getTargetFromChain : function(targetObject, targetProperties, index){

      index = index || targetProperties.length - 1;
      var target = targetObject;
      for(var i = 0;i < index;i++){

        try{

          var property = targetProperties[i];
          var arrIndex = this.__getArrayIndex(property);
          if(arrIndex){

            if(arrIndex === "last"){

              arrIndex = target.length - 1;
            };
            target = target.getItem(arrIndex);
          } else {

            target = target["get" + qx.lang.String.firstUp(property)]();
          };
        } catch(ex) {

          return null;
        };
      };
      return target;
    },
    __setInitialValue : function(value, targetObject, targetPropertyChain, options, sourceObject){

      value = this.__convertValue(value, targetObject, targetPropertyChain, options, sourceObject);
      if(value === undefined){

        this.__resetTargetValue(targetObject, targetPropertyChain);
      };
      if(value !== undefined){

        try{

          this.__setTargetValue(targetObject, targetPropertyChain, value);
          if(options && options.onUpdate){

            options.onUpdate(sourceObject, targetObject, value);
          };
        } catch(e) {

          if(!(e instanceof qx.core.ValidationError)){

            throw e;
          };
          if(options && options.onSetFail){

            options.onSetFail(e);
          } else {

            qx.log.Logger.warn("Failed so set value " + value + " on " + targetObject + ". Error message: " + e);
          };
        };
      };
    },
    __checkForArrayInPropertyChain : function(propertyNames){

      var arrayIndexValues = [];
      for(var i = 0;i < propertyNames.length;i++){

        var name = propertyNames[i];
        if(qx.lang.String.endsWith(name, "]")){

          var arrayIndex = name.substring(name.indexOf("[") + 1, name.indexOf("]"));
          if(name.indexOf("]") != name.length - 1){

            throw new Error("Please use only one array at a time: " + name + " does not work.");
          };
          if(arrayIndex !== "last"){

            if(arrayIndex == "" || isNaN(parseInt(arrayIndex, 10))){

              throw new Error("No number or 'last' value hast been given" + " in an array binding: " + name + " does not work.");
            };
          };
          if(name.indexOf("[") != 0){

            propertyNames[i] = name.substring(0, name.indexOf("["));
            arrayIndexValues[i] = "";
            arrayIndexValues[i + 1] = arrayIndex;
            propertyNames.splice(i + 1, 0, "item");
            i++;
          } else {

            arrayIndexValues[i] = arrayIndex;
            propertyNames.splice(i, 1, "item");
          };
        } else {

          arrayIndexValues[i] = "";
        };
      };
      return arrayIndexValues;
    },
    __bindEventToProperty : function(sourceObject, sourceEvent, targetObject, targetProperty, options, arrayIndex){

      if(qx.core.Environment.get("qx.debug")){

        var eventType = qx.Class.getEventType(sourceObject.constructor, sourceEvent);
        qx.core.Assert.assertEquals("qx.event.type.Data", eventType, sourceEvent + " is not an data (qx.event.type.Data) event on " + sourceObject + ".");
      };
      var bindListener = function(arrayIndex, e){

        if(arrayIndex !== ""){

          if(arrayIndex === "last"){

            arrayIndex = sourceObject.length - 1;
          };
          var data = sourceObject.getItem(arrayIndex);
          if(data === undefined){

            qx.data.SingleValueBinding.__resetTargetValue(targetObject, targetProperty);
          };
          var start = e.getData().start;
          var end = e.getData().end;
          if(arrayIndex < start || arrayIndex > end){

            return;
          };
        } else {

          var data = e.getData();
        };
        if(qx.core.Environment.get("qx.debug.databinding")){

          qx.log.Logger.debug("Binding executed from " + sourceObject + " by " + sourceEvent + " to " + targetObject + " (" + targetProperty + ")");
          qx.log.Logger.debug("Data before conversion: " + data);
        };
        data = qx.data.SingleValueBinding.__convertValue(data, targetObject, targetProperty, options, sourceObject);
        if(qx.core.Environment.get("qx.debug.databinding")){

          qx.log.Logger.debug("Data after conversion: " + data);
        };
        try{

          if(data !== undefined){

            qx.data.SingleValueBinding.__setTargetValue(targetObject, targetProperty, data);
          } else {

            qx.data.SingleValueBinding.__resetTargetValue(targetObject, targetProperty);
          };
          if(options && options.onUpdate){

            options.onUpdate(sourceObject, targetObject, data);
          };
        } catch(ex) {

          if(!(ex instanceof qx.core.ValidationError)){

            throw ex;
          };
          if(options && options.onSetFail){

            options.onSetFail(ex);
          } else {

            qx.log.Logger.warn("Failed so set value " + data + " on " + targetObject + ". Error message: " + ex);
          };
        };
      };
      if(!arrayIndex){

        arrayIndex = "";
      };
      bindListener = qx.lang.Function.bind(bindListener, sourceObject, arrayIndex);
      var id = sourceObject.addListener(sourceEvent, bindListener);
      return id;
    },
    __storeBinding : function(id, sourceObject, sourceEvent, targetObject, targetProperty){

      var hash;
      hash = sourceObject.toHashCode();
      if(this.__bindings[hash] === undefined){

        this.__bindings[hash] = [];
      };
      var binding = [id, sourceObject, sourceEvent, targetObject, targetProperty];
      this.__bindings[hash].push(binding);
      hash = targetObject.toHashCode();
      if(this.__bindingsByTarget[hash] === undefined){

        this.__bindingsByTarget[hash] = [];
      };
      this.__bindingsByTarget[hash].push(binding);
    },
    __convertValue : function(value, targetObject, targetPropertyChain, options, sourceObject){

      if(options && options.converter){

        var model;
        if(targetObject.getModel){

          model = targetObject.getModel();
        };
        return options.converter(value, model, sourceObject, targetObject);
      } else {

        var properties = this.__getPropertyChainArray(targetPropertyChain);
        var target = this.__getTargetFromChain(targetObject, properties);
        var lastProperty = targetPropertyChain.substring(targetPropertyChain.lastIndexOf(".") + 1, targetPropertyChain.length);
        if(target == null){

          return value;
        };
        var propertieDefinition = qx.Class.getPropertyDefinition(target.constructor, lastProperty);
        var check = propertieDefinition == null ? "" : propertieDefinition.check;
        return this.__defaultConversion(value, check);
      };
    },
    __getEventForProperty : function(sourceObject, sourceProperty){

      var propertieDefinition = qx.Class.getPropertyDefinition(sourceObject.constructor, sourceProperty);
      if(propertieDefinition == null){

        return null;
      };
      return propertieDefinition.event;
    },
    __defaultConversion : function(data, targetCheck){

      var dataType = qx.lang.Type.getClass(data);
      if((dataType == "Number" || dataType == "String") && (targetCheck == "Integer" || targetCheck == "PositiveInteger")){

        data = parseInt(data, 10);
      };
      if((dataType == "Boolean" || dataType == "Number" || dataType == "Date") && targetCheck == "String"){

        data = data + "";
      };
      if((dataType == "Number" || dataType == "String") && (targetCheck == "Number" || targetCheck == "PositiveNumber")){

        data = parseFloat(data);
      };
      return data;
    },
    removeBindingFromObject : function(sourceObject, id){

      if(id.type == "deepBinding"){

        for(var i = 0;i < id.sources.length;i++){

          if(id.sources[i]){

            id.sources[i].removeListenerById(id.listenerIds[i]);
          };
        };
        for(var i = 0;i < id.targets.length;i++){

          if(id.targets[i]){

            id.targets[i].removeListenerById(id.targetListenerIds[i]);
          };
        };
      } else {

        sourceObject.removeListenerById(id);
      };
      var bindings = this.getAllBindingsForObject(sourceObject);
      if(bindings != undefined){

        for(var i = 0;i < bindings.length;i++){

          if(bindings[i][0] == id){

            var target = bindings[i][3];
            if(this.__bindingsByTarget[target.toHashCode()]){

              qx.lang.Array.remove(this.__bindingsByTarget[target.toHashCode()], bindings[i]);
            };
            var source = bindings[i][1];
            if(this.__bindings[source.toHashCode()]){

              qx.lang.Array.remove(this.__bindings[source.toHashCode()], bindings[i]);
            };
            return;
          };
        };
      };
      throw new Error("Binding could not be found!");
    },
    removeAllBindingsForObject : function(object){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertNotNull(object, "Can not remove the bindings for null object!");
      };
      var bindings = this.getAllBindingsForObject(object);
      if(bindings != undefined){

        for(var i = bindings.length - 1;i >= 0;i--){

          this.removeBindingFromObject(object, bindings[i][0]);
        };
      };
    },
    removeRelatedBindings : function(object, relatedObject){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertNotNull(object, "Can not remove the bindings for null object!");
        qx.core.Assert.assertNotNull(relatedObject, "Can not remove the bindings for null object!");
      };
      var bindings = this.getAllBindingsForObject(object);
      if(bindings != undefined){

        for(var i = bindings.length - 1;i >= 0;i--){

          var source = bindings[i][1];
          var target = bindings[i][3];
          if(source === relatedObject || target === relatedObject){

            this.removeBindingFromObject(object, bindings[i][0]);
          };
        };
      };
    },
    getAllBindingsForObject : function(object){

      var hash = object.toHashCode();
      if(this.__bindings[hash] === undefined){

        this.__bindings[hash] = [];
      };
      var sourceBindings = this.__bindings[hash];
      var targetBindings = this.__bindingsByTarget[hash] ? this.__bindingsByTarget[hash] : [];
      return qx.lang.Array.unique(sourceBindings.concat(targetBindings));
    },
    removeAllBindings : function(){

      for(var hash in this.__bindings){

        var object = qx.core.ObjectRegistry.fromHashCode(hash);
        if(object == null){

          delete this.__bindings[hash];
          continue;
        };
        this.removeAllBindingsForObject(object);
      };
      this.__bindings = {
      };
    },
    getAllBindings : function(){

      return this.__bindings;
    },
    showBindingInLog : function(object, id){

      var binding;
      for(var i = 0;i < this.__bindings[object.toHashCode()].length;i++){

        if(this.__bindings[object.toHashCode()][i][0] == id){

          binding = this.__bindings[object.toHashCode()][i];
          break;
        };
      };
      if(binding === undefined){

        var message = "Binding does not exist!";
      } else {

        var message = "Binding from '" + binding[1] + "' (" + binding[2] + ") to the object '" + binding[3] + "' (" + binding[4] + ").";
      };
      qx.log.Logger.debug(message);
    },
    showAllBindingsInLog : function(){

      for(var hash in this.__bindings){

        var object = qx.core.ObjectRegistry.fromHashCode(hash);
        for(var i = 0;i < this.__bindings[hash].length;i++){

          this.showBindingInLog(object, this.__bindings[hash][i][0]);
        };
      };
    }
  }
});
qx.Bootstrap.define("qx.lang.Type", {
  statics : {
    getClass : qx.Bootstrap.getClass,
    isString : qx.Bootstrap.isString,
    isArray : qx.Bootstrap.isArray,
    isObject : qx.Bootstrap.isObject,
    isFunction : qx.Bootstrap.isFunction,
    isRegExp : function(value){

      return this.getClass(value) == "RegExp";
    },
    isNumber : function(value){

      return (value !== null && (this.getClass(value) == "Number" || value instanceof Number));
    },
    isBoolean : function(value){

      return (value !== null && (this.getClass(value) == "Boolean" || value instanceof Boolean));
    },
    isDate : function(value){

      return (value !== null && (this.getClass(value) == "Date" || value instanceof Date));
    },
    isError : function(value){

      return (value !== null && (this.getClass(value) == "Error" || value instanceof Error));
    }
  }
});
qx.Bootstrap.define("qx.core.Assert", {
  statics : {
    __logError : true,
    __fail : function(comment, msgvarargs){

      var msg = "";
      for(var i = 1,l = arguments.length;i < l;i++){

        msg = msg + this.__toString(arguments[i] === undefined ? "'undefined'" : arguments[i]);
      };
      var fullComment = "";
      if(msg){

        fullComment = comment + ": " + msg;
      } else {

        fullComment = comment;
      };
      var errorMsg = "Assertion error! " + fullComment;
      if(qx.Class && qx.Class.isDefined("qx.core.AssertionError")){

        var err = new qx.core.AssertionError(comment, msg);
        if(this.__logError){

          qx.Bootstrap.error(errorMsg + "\n Stack trace: \n" + err.getStackTrace());
        };
        throw err;
      } else {

        if(this.__logError){

          qx.Bootstrap.error(errorMsg);
        };
        throw new Error(errorMsg);
      };
    },
    __toString : function(value){

      var stringValue;
      if(value === null){

        stringValue = "null";
      } else if(qx.lang.Type.isArray(value) && value.length > 10){

        stringValue = "Array[" + value.length + "]";
      } else if((value instanceof Object) && (value.toString == null)){

        stringValue = qx.lang.Json.stringify(value, null, 2);
      } else {

        try{

          stringValue = value.toString();
        } catch(e) {

          stringValue = "";
        };
      };;
      return stringValue;
    },
    assert : function(condition, msg){

      condition == true || this.__fail(msg || "", "Called assert with 'false'");
    },
    fail : function(msg, compact){

      var msgvarargs = compact ? "" : "Called fail().";
      this.__fail(msg || "", msgvarargs);
    },
    assertTrue : function(value, msg){

      (value === true) || this.__fail(msg || "", "Called assertTrue with '", value, "'");
    },
    assertFalse : function(value, msg){

      (value === false) || this.__fail(msg || "", "Called assertFalse with '", value, "'");
    },
    assertEquals : function(expected, found, msg){

      expected == found || this.__fail(msg || "", "Expected '", expected, "' but found '", found, "'!");
    },
    assertNotEquals : function(expected, found, msg){

      expected != found || this.__fail(msg || "", "Expected '", expected, "' to be not equal with '", found, "'!");
    },
    assertIdentical : function(expected, found, msg){

      expected === found || this.__fail(msg || "", "Expected '", expected, "' (identical) but found '", found, "'!");
    },
    assertNotIdentical : function(expected, found, msg){

      expected !== found || this.__fail(msg || "", "Expected '", expected, "' to be not identical with '", found, "'!");
    },
    assertNotUndefined : function(value, msg){

      value !== undefined || this.__fail(msg || "", "Expected value not to be undefined but found undefined!");
    },
    assertUndefined : function(value, msg){

      value === undefined || this.__fail(msg || "", "Expected value to be undefined but found ", value, "!");
    },
    assertNotNull : function(value, msg){

      value !== null || this.__fail(msg || "", "Expected value not to be null but found null!");
    },
    assertNull : function(value, msg){

      value === null || this.__fail(msg || "", "Expected value to be null but found ", value, "!");
    },
    assertJsonEquals : function(expected, found, msg){

      this.assertEquals(qx.lang.Json.stringify(expected), qx.lang.Json.stringify(found), msg);
    },
    assertMatch : function(str, re, msg){

      this.assertString(str);
      this.assert(qx.lang.Type.isRegExp(re) || qx.lang.Type.isString(re), "The parameter 're' must be a string or a regular expression.");
      str.search(re) >= 0 || this.__fail(msg || "", "The String '", str, "' does not match the regular expression '", re.toString(), "'!");
    },
    assertArgumentsCount : function(args, minCount, maxCount, msg){

      var argCount = args.length;
      (argCount >= minCount && argCount <= maxCount) || this.__fail(msg || "", "Wrong number of arguments given. Expected '", minCount, "' to '", maxCount, "' arguments but found '", argCount, "' arguments.");
    },
    assertEventFired : function(obj, event, invokeFunc, listenerFunc, msg){

      var called = false;
      var listener = function(e){

        if(listenerFunc){

          listenerFunc.call(obj, e);
        };
        called = true;
      };
      var id;
      try{

        id = obj.addListener(event, listener, obj);
        invokeFunc.call(obj);
      } catch(ex) {

        throw ex;
      }finally{

        try{

          obj.removeListenerById(id);
        } catch(ex) {
        };
      };
      called === true || this.__fail(msg || "", "Event (", event, ") not fired.");
    },
    assertEventNotFired : function(obj, event, invokeFunc, msg){

      var called = false;
      var listener = function(e){

        called = true;
      };
      var id = obj.addListener(event, listener, obj);
      invokeFunc.call();
      called === false || this.__fail(msg || "", "Event (", event, ") was fired.");
      obj.removeListenerById(id);
    },
    assertException : function(callback, exception, re, msg){

      var exception = exception || Error;
      var error;
      try{

        this.__logError = false;
        callback();
      } catch(ex) {

        error = ex;
      }finally{

        this.__logError = true;
      };
      if(error == null){

        this.__fail(msg || "", "The function did not raise an exception!");
      };
      error instanceof exception || this.__fail(msg || "", "The raised exception does not have the expected type! ", exception, " != ", error);
      if(re){

        this.assertMatch(error.toString(), re, msg);
      };
    },
    assertInArray : function(value, array, msg){

      array.indexOf(value) !== -1 || this.__fail(msg || "", "The value '", value, "' must have any of the values defined in the array '", array, "'");
    },
    assertArrayEquals : function(expected, found, msg){

      this.assertArray(expected, msg);
      this.assertArray(found, msg);
      msg = msg || "Expected [" + expected.join(", ") + "], but found [" + found.join(", ") + "]";
      if(expected.length !== found.length){

        this.fail(msg, true);
      };
      for(var i = 0;i < expected.length;i++){

        if(expected[i] !== found[i]){

          this.fail(msg, true);
        };
      };
    },
    assertKeyInMap : function(value, map, msg){

      map[value] !== undefined || this.__fail(msg || "", "The value '", value, "' must must be a key of the map '", map, "'");
    },
    assertFunction : function(value, msg){

      qx.lang.Type.isFunction(value) || this.__fail(msg || "", "Expected value to be typeof function but found ", value, "!");
    },
    assertString : function(value, msg){

      qx.lang.Type.isString(value) || this.__fail(msg || "", "Expected value to be a string but found ", value, "!");
    },
    assertBoolean : function(value, msg){

      qx.lang.Type.isBoolean(value) || this.__fail(msg || "", "Expected value to be a boolean but found ", value, "!");
    },
    assertNumber : function(value, msg){

      (qx.lang.Type.isNumber(value) && isFinite(value)) || this.__fail(msg || "", "Expected value to be a number but found ", value, "!");
    },
    assertPositiveNumber : function(value, msg){

      (qx.lang.Type.isNumber(value) && isFinite(value) && value >= 0) || this.__fail(msg || "", "Expected value to be a number >= 0 but found ", value, "!");
    },
    assertInteger : function(value, msg){

      (qx.lang.Type.isNumber(value) && isFinite(value) && value % 1 === 0) || this.__fail(msg || "", "Expected value to be an integer but found ", value, "!");
    },
    assertPositiveInteger : function(value, msg){

      var condition = (qx.lang.Type.isNumber(value) && isFinite(value) && value % 1 === 0 && value >= 0);
      condition || this.__fail(msg || "", "Expected value to be an integer >= 0 but found ", value, "!");
    },
    assertInRange : function(value, min, max, msg){

      (value >= min && value <= max) || this.__fail(msg || "", qx.lang.String.format("Expected value '%1' to be in the range '%2'..'%3'!", [value, min, max]));
    },
    assertObject : function(value, msg){

      var condition = value !== null && (qx.lang.Type.isObject(value) || typeof value === "object");
      condition || this.__fail(msg || "", "Expected value to be typeof object but found ", (value), "!");
    },
    assertArray : function(value, msg){

      qx.lang.Type.isArray(value) || this.__fail(msg || "", "Expected value to be an array but found ", value, "!");
    },
    assertMap : function(value, msg){

      qx.lang.Type.isObject(value) || this.__fail(msg || "", "Expected value to be a map but found ", value, "!");
    },
    assertRegExp : function(value, msg){

      qx.lang.Type.isRegExp(value) || this.__fail(msg || "", "Expected value to be a regular expression but found ", value, "!");
    },
    assertType : function(value, type, msg){

      this.assertString(type, "Invalid argument 'type'");
      typeof (value) === type || this.__fail(msg || "", "Expected value to be typeof '", type, "' but found ", value, "!");
    },
    assertInstance : function(value, clazz, msg){

      var className = clazz.classname || clazz + "";
      value instanceof clazz || this.__fail(msg || "", "Expected value to be instanceof '", className, "' but found ", value, "!");
    },
    assertInterface : function(value, iface, msg){

      qx.Class && qx.Class.implementsInterface(value, iface) || this.__fail(msg || "", "Expected object '", value, "' to implement the interface '", iface, "'!");
    },
    assertCssColor : function(expected, value, msg){

      var ColorUtil = qx.Class ? qx.Class.getByName("qx.util.ColorUtil") : null;
      if(!ColorUtil){

        throw new Error("qx.util.ColorUtil not available! Your code must have a dependency on 'qx.util.ColorUtil'");
      };
      var expectedRgb = ColorUtil.stringToRgb(expected);
      try{

        var valueRgb = ColorUtil.stringToRgb(value);
      } catch(ex) {

        this.__fail(msg || "", "Expected value to be the CSS color '", expected, "' (rgb(", expectedRgb.join(","), ")), but found value '", value, "', which cannot be converted to a CSS color!");
      };
      var condition = expectedRgb[0] == valueRgb[0] && expectedRgb[1] == valueRgb[1] && expectedRgb[2] == valueRgb[2];
      condition || this.__fail(msg || "", "Expected value to be the CSS color '", expectedRgb, "' (rgb(", expectedRgb.join(","), ")), but found value '", value, "' (rgb(", valueRgb.join(","), "))!");
    },
    assertElement : function(value, msg){

      !!(value && value.nodeType === 1) || this.__fail(msg || "", "Expected value to be a DOM element but found  '", value, "'!");
    },
    assertQxObject : function(value, msg){

      this.__isQxInstance(value, "qx.core.Object") || this.__fail(msg || "", "Expected value to be a qooxdoo object but found ", value, "!");
    },
    assertQxWidget : function(value, msg){

      this.__isQxInstance(value, "qx.ui.core.Widget") || this.__fail(msg || "", "Expected value to be a qooxdoo widget but found ", value, "!");
    },
    __isQxInstance : function(object, classname){

      if(!object){

        return false;
      };
      var clazz = object.constructor;
      while(clazz){

        if(clazz.classname === classname){

          return true;
        };
        clazz = clazz.superclass;
      };
      return false;
    }
  }
});
qx.Bootstrap.define("qx.type.BaseError", {
  extend : Error,
  construct : function(comment, failMessage){

    var inst = Error.call(this, failMessage);
    if(inst.stack){

      this.stack = inst.stack;
    };
    if(inst.stacktrace){

      this.stacktrace = inst.stacktrace;
    };
    this.__comment = comment || "";
    this.message = failMessage || qx.type.BaseError.DEFAULTMESSAGE;
  },
  statics : {
    DEFAULTMESSAGE : "error"
  },
  members : {
    __sTrace : null,
    __comment : null,
    message : null,
    getComment : function(){

      return this.__comment;
    },
    toString : function(){

      return this.__comment + (this.message ? ": " + this.message : "");
    }
  }
});
qx.Bootstrap.define("qx.core.AssertionError", {
  extend : qx.type.BaseError,
  construct : function(comment, failMessage){

    qx.type.BaseError.call(this, comment, failMessage);
    this.__trace = qx.dev.StackTrace.getStackTrace();
  },
  members : {
    __trace : null,
    getStackTrace : function(){

      return this.__trace;
    }
  }
});
qx.Bootstrap.define("qx.dev.StackTrace", {
  statics : {
    FILENAME_TO_CLASSNAME : null,
    FORMAT_STACKTRACE : null,
    getStackTrace : function(){

      var trace = [];
      try{

        throw new Error();
      } catch(ex) {

        if(qx.dev.StackTrace.hasEnvironmentCheck && qx.core.Environment.get("ecmascript.error.stacktrace")){

          var errorTrace = qx.dev.StackTrace.getStackTraceFromError(ex);
          var callerTrace = qx.dev.StackTrace.getStackTraceFromCaller(arguments);
          qx.lang.Array.removeAt(errorTrace, 0);
          trace = callerTrace.length > errorTrace.length ? callerTrace : errorTrace;
          for(var i = 0;i < Math.min(callerTrace.length, errorTrace.length);i++){

            var callerCall = callerTrace[i];
            if(callerCall.indexOf("anonymous") >= 0){

              continue;
            };
            var methodName = null;
            var callerArr = callerCall.split(".");
            var mO = /(.*?)\(/.exec(callerArr[callerArr.length - 1]);
            if(mO && mO.length == 2){

              methodName = mO[1];
              callerArr.pop();
            };
            if(callerArr[callerArr.length - 1] == "prototype"){

              callerArr.pop();
            };
            var callerClassName = callerArr.join(".");
            var errorCall = errorTrace[i];
            var errorArr = errorCall.split(":");
            var errorClassName = errorArr[0];
            var lineNumber = errorArr[1];
            var columnNumber;
            if(errorArr[2]){

              columnNumber = errorArr[2];
            };
            var className = null;
            if(qx.Class && qx.Class.getByName(errorClassName)){

              className = errorClassName;
            } else {

              className = callerClassName;
            };
            var line = className;
            if(methodName){

              line += "." + methodName;
            };
            line += ":" + lineNumber;
            if(columnNumber){

              line += ":" + columnNumber;
            };
            trace[i] = line;
          };
        } else {

          trace = this.getStackTraceFromCaller(arguments);
        };
      };
      return trace;
    },
    getStackTraceFromCaller : function(args){

      var trace = [];
      var fcn = qx.lang.Function.getCaller(args);
      var knownFunction = {
      };
      while(fcn){

        var fcnName = qx.lang.Function.getName(fcn);
        trace.push(fcnName);
        try{

          fcn = fcn.caller;
        } catch(ex) {

          break;
        };
        if(!fcn){

          break;
        };
        var hash = qx.core.ObjectRegistry.toHashCode(fcn);
        if(knownFunction[hash]){

          trace.push("...");
          break;
        };
        knownFunction[hash] = fcn;
      };
      return trace;
    },
    getStackTraceFromError : function(error){

      var trace = [];
      var lineRe,hit,className,lineNumber,columnNumber,fileName,url;
      var traceProp = qx.dev.StackTrace.hasEnvironmentCheck ? qx.core.Environment.get("ecmascript.error.stacktrace") : null;
      if(traceProp === "stack"){

        if(!error.stack){

          return trace;
        };
        lineRe = /@(.+):(\d+)$/gm;
        while((hit = lineRe.exec(error.stack)) != null){

          url = hit[1];
          lineNumber = hit[2];
          className = this.__fileNameToClassName(url);
          trace.push(className + ":" + lineNumber);
        };
        if(trace.length > 0){

          return this.__formatStackTrace(trace);
        };
        lineRe = /at (.*)/gm;
        var fileReParens = /\((.*?)(:[^\/].*)\)/;
        var fileRe = /(.*?)(:[^\/].*)/;
        while((hit = lineRe.exec(error.stack)) != null){

          var fileMatch = fileReParens.exec(hit[1]);
          if(!fileMatch){

            fileMatch = fileRe.exec(hit[1]);
          };
          if(fileMatch){

            className = this.__fileNameToClassName(fileMatch[1]);
            trace.push(className + fileMatch[2]);
          } else {

            trace.push(hit[1]);
          };
        };
      } else if(traceProp === "stacktrace"){

        var stacktrace = error.stacktrace;
        if(!stacktrace){

          return trace;
        };
        if(stacktrace.indexOf("Error created at") >= 0){

          stacktrace = stacktrace.split("Error created at")[0];
        };
        lineRe = /line\ (\d+?),\ column\ (\d+?)\ in\ (?:.*?)\ in\ (.*?):[^\/]/gm;
        while((hit = lineRe.exec(stacktrace)) != null){

          lineNumber = hit[1];
          columnNumber = hit[2];
          url = hit[3];
          className = this.__fileNameToClassName(url);
          trace.push(className + ":" + lineNumber + ":" + columnNumber);
        };
        if(trace.length > 0){

          return this.__formatStackTrace(trace);
        };
        lineRe = /Line\ (\d+?)\ of\ linked\ script\ (.*?)$/gm;
        while((hit = lineRe.exec(stacktrace)) != null){

          lineNumber = hit[1];
          url = hit[2];
          className = this.__fileNameToClassName(url);
          trace.push(className + ":" + lineNumber);
        };
      } else if(error.message && error.message.indexOf("Backtrace:") >= 0){

        var traceString = error.message.split("Backtrace:")[1].trim();
        var lines = traceString.split("\n");
        for(var i = 0;i < lines.length;i++){

          var reResult = lines[i].match(/\s*Line ([0-9]+) of.* (\S.*)/);
          if(reResult && reResult.length >= 2){

            lineNumber = reResult[1];
            fileName = this.__fileNameToClassName(reResult[2]);
            trace.push(fileName + ":" + lineNumber);
          };
        };
      } else if(error.sourceURL && error.line){

        trace.push(this.__fileNameToClassName(error.sourceURL) + ":" + error.line);
      };;;
      return this.__formatStackTrace(trace);
    },
    __fileNameToClassName : function(fileName){

      if(typeof qx.dev.StackTrace.FILENAME_TO_CLASSNAME == "function"){

        var convertedName = qx.dev.StackTrace.FILENAME_TO_CLASSNAME(fileName);
        if(qx.core.Environment.get("qx.debug") && !qx.lang.Type.isString(convertedName)){

          throw new Error("FILENAME_TO_CLASSNAME must return a string!");
        };
        return convertedName;
      };
      return qx.dev.StackTrace.__fileNameToClassNameDefault(fileName);
    },
    __fileNameToClassNameDefault : function(fileName){

      var scriptDir = "/source/class/";
      var jsPos = fileName.indexOf(scriptDir);
      var paramPos = fileName.indexOf("?");
      if(paramPos >= 0){

        fileName = fileName.substring(0, paramPos);
      };
      var className = (jsPos == -1) ? fileName : fileName.substring(jsPos + scriptDir.length).replace(/\//g, ".").replace(/\.js$/, "");
      return className;
    },
    __formatStackTrace : function(trace){

      if(typeof qx.dev.StackTrace.FORMAT_STACKTRACE == "function"){

        trace = qx.dev.StackTrace.FORMAT_STACKTRACE(trace);
        if(qx.core.Environment.get("qx.debug") && !qx.lang.Type.isArray(trace)){

          throw new Error("FORMAT_STACKTRACE must return an array of strings!");
        };
      };
      return trace;
    }
  },
  defer : function(statics){

    statics.hasEnvironmentCheck = qx.bom && qx.bom.client && qx.bom.client.EcmaScript && qx.bom.client.EcmaScript.getStackTrace;
  }
});
qx.Bootstrap.define("qx.lang.Array", {
  statics : {
    cast : function(object, constructor, offset){

      if(object.constructor === constructor){

        return object;
      };
      if(qx.data && qx.data.IListData){

        if(qx.Class && qx.Class.hasInterface(object, qx.data.IListData)){

          var object = object.toArray();
        };
      };
      var ret = new constructor;
      if((qx.core.Environment.get("engine.name") == "mshtml")){

        if(object.item){

          for(var i = offset || 0,l = object.length;i < l;i++){

            ret.push(object[i]);
          };
          return ret;
        };
      };
      if(Object.prototype.toString.call(object) === "[object Array]" && offset == null){

        ret.push.apply(ret, object);
      } else {

        ret.push.apply(ret, Array.prototype.slice.call(object, offset || 0));
      };
      return ret;
    },
    fromArguments : function(args, offset){

      return Array.prototype.slice.call(args, offset || 0);
    },
    fromCollection : function(coll){

      if((qx.core.Environment.get("engine.name") == "mshtml")){

        if(coll.item){

          var arr = [];
          for(var i = 0,l = coll.length;i < l;i++){

            arr[i] = coll[i];
          };
          return arr;
        };
      };
      return Array.prototype.slice.call(coll, 0);
    },
    fromShortHand : function(input){

      var len = input.length;
      var result = qx.lang.Array.clone(input);
      switch(len){case 1:
      result[1] = result[2] = result[3] = result[0];
      break;case 2:
      result[2] = result[0];case 3:
      result[3] = result[1];};
      return result;
    },
    clone : function(arr){

      return arr.concat();
    },
    insertAt : function(arr, obj, i){

      arr.splice(i, 0, obj);
      return arr;
    },
    insertBefore : function(arr, obj, obj2){

      var i = arr.indexOf(obj2);
      if(i == -1){

        arr.push(obj);
      } else {

        arr.splice(i, 0, obj);
      };
      return arr;
    },
    insertAfter : function(arr, obj, obj2){

      var i = arr.indexOf(obj2);
      if(i == -1 || i == (arr.length - 1)){

        arr.push(obj);
      } else {

        arr.splice(i + 1, 0, obj);
      };
      return arr;
    },
    removeAt : function(arr, i){

      return arr.splice(i, 1)[0];
    },
    removeAll : function(arr){

      arr.length = 0;
      return this;
    },
    append : function(arr1, arr2){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertArray(arr1, "The first parameter must be an array.");
        qx.core.Assert && qx.core.Assert.assertArray(arr2, "The second parameter must be an array.");
      };
      Array.prototype.push.apply(arr1, arr2);
      return arr1;
    },
    exclude : function(arr1, arr2){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertArray(arr1, "The first parameter must be an array.");
        qx.core.Assert && qx.core.Assert.assertArray(arr2, "The second parameter must be an array.");
      };
      for(var i = 0,il = arr2.length,index;i < il;i++){

        index = arr1.indexOf(arr2[i]);
        if(index != -1){

          arr1.splice(index, 1);
        };
      };
      return arr1;
    },
    remove : function(arr, obj){

      var i = arr.indexOf(obj);
      if(i != -1){

        arr.splice(i, 1);
        return obj;
      };
    },
    contains : function(arr, obj){

      return arr.indexOf(obj) !== -1;
    },
    equals : function(arr1, arr2){

      var length = arr1.length;
      if(length !== arr2.length){

        return false;
      };
      for(var i = 0;i < length;i++){

        if(arr1[i] !== arr2[i]){

          return false;
        };
      };
      return true;
    },
    sum : function(arr){

      var result = 0;
      for(var i = 0,l = arr.length;i < l;i++){

        if(arr[i] != undefined){

          result += arr[i];
        };
      };
      return result;
    },
    max : function(arr){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertArray(arr, "Parameter must be an array.");
      };
      var i,len = arr.length,result = arr[0];
      for(i = 1;i < len;i++){

        if(arr[i] > result){

          result = arr[i];
        };
      };
      return result === undefined ? null : result;
    },
    min : function(arr){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertArray(arr, "Parameter must be an array.");
      };
      var i,len = arr.length,result = arr[0];
      for(i = 1;i < len;i++){

        if(arr[i] < result){

          result = arr[i];
        };
      };
      return result === undefined ? null : result;
    },
    unique : function(arr){

      var ret = [],doneStrings = {
      },doneNumbers = {
      },doneObjects = {
      };
      var value,count = 0;
      var key = "qx" + Date.now();
      var hasNull = false,hasFalse = false,hasTrue = false;
      for(var i = 0,len = arr.length;i < len;i++){

        value = arr[i];
        if(value === null){

          if(!hasNull){

            hasNull = true;
            ret.push(value);
          };
        } else if(value === undefined){
        } else if(value === false){

          if(!hasFalse){

            hasFalse = true;
            ret.push(value);
          };
        } else if(value === true){

          if(!hasTrue){

            hasTrue = true;
            ret.push(value);
          };
        } else if(typeof value === "string"){

          if(!doneStrings[value]){

            doneStrings[value] = 1;
            ret.push(value);
          };
        } else if(typeof value === "number"){

          if(!doneNumbers[value]){

            doneNumbers[value] = 1;
            ret.push(value);
          };
        } else {

          var hash = value[key];
          if(hash == null){

            hash = value[key] = count++;
          };
          if(!doneObjects[hash]){

            doneObjects[hash] = value;
            ret.push(value);
          };
        };;;;;
      };
      for(var hash in doneObjects){

        try{

          delete doneObjects[hash][key];
        } catch(ex) {

          try{

            doneObjects[hash][key] = null;
          } catch(ex1) {

            throw new Error("Cannot clean-up map entry doneObjects[" + hash + "][" + key + "]");
          };
        };
      };
      return ret;
    },
    range : function(start, stop, step){

      if(arguments.length <= 1){

        stop = start || 0;
        start = 0;
      };
      step = arguments[2] || 1;
      var length = Math.max(Math.ceil((stop - start) / step), 0);
      var idx = 0;
      var range = Array(length);
      while(idx < length){

        range[idx++] = start;
        start += step;
      };
      return range;
    }
  }
});
qx.Bootstrap.define("qx.bom.client.Engine", {
  statics : {
    getVersion : function(){

      var agent = window.navigator.userAgent;
      var version = "";
      if(qx.bom.client.Engine.__isMshtml()){

        var isTrident = /Trident\/([^\);]+)(\)|;)/.test(agent);
        if(/MSIE\s+([^\);]+)(\)|;)/.test(agent)){

          version = RegExp.$1;
          if(version < 8 && isTrident){

            if(RegExp.$1 == "4.0"){

              version = "8.0";
            } else if(RegExp.$1 == "5.0"){

              version = "9.0";
            };
          };
        } else if(isTrident){

          var match = /\brv\:(\d+?\.\d+?)\b/.exec(agent);
          if(match){

            version = match[1];
          };
        };
      } else if(qx.bom.client.Engine.__isOpera()){

        if(/Opera[\s\/]([0-9]+)\.([0-9])([0-9]*)/.test(agent)){

          if(agent.indexOf("Version/") != -1){

            var match = agent.match(/Version\/(\d+)\.(\d+)/);
            version = match[1] + "." + match[2].charAt(0) + "." + match[2].substring(1, match[2].length);
          } else {

            version = RegExp.$1 + "." + RegExp.$2;
            if(RegExp.$3 != ""){

              version += "." + RegExp.$3;
            };
          };
        };
      } else if(qx.bom.client.Engine.__isWebkit()){

        if(/AppleWebKit\/([^ ]+)/.test(agent)){

          version = RegExp.$1;
          var invalidCharacter = RegExp("[^\\.0-9]").exec(version);
          if(invalidCharacter){

            version = version.slice(0, invalidCharacter.index);
          };
        };
      } else if(qx.bom.client.Engine.__isGecko() || qx.bom.client.Engine.__isMaple()){

        if(/rv\:([^\);]+)(\)|;)/.test(agent)){

          version = RegExp.$1;
        };
      } else {

        var failFunction = window.qxFail;
        if(failFunction && typeof failFunction === "function"){

          version = failFunction().FULLVERSION;
        } else {

          version = "1.9.0.0";
          qx.Bootstrap.warn("Unsupported client: " + agent + "! Assumed gecko version 1.9.0.0 (Firefox 3.0).");
        };
      };;;
      return version;
    },
    getName : function(){

      var name;
      if(qx.bom.client.Engine.__isMshtml()){

        name = "mshtml";
      } else if(qx.bom.client.Engine.__isOpera()){

        name = "opera";
      } else if(qx.bom.client.Engine.__isWebkit()){

        name = "webkit";
      } else if(qx.bom.client.Engine.__isGecko() || qx.bom.client.Engine.__isMaple()){

        name = "gecko";
      } else {

        var failFunction = window.qxFail;
        if(failFunction && typeof failFunction === "function"){

          name = failFunction().NAME;
        } else {

          name = "gecko";
          qx.Bootstrap.warn("Unsupported client: " + window.navigator.userAgent + "! Assumed gecko version 1.9.0.0 (Firefox 3.0).");
        };
      };;;
      return name;
    },
    __isOpera : function(){

      return window.opera && Object.prototype.toString.call(window.opera) == "[object Opera]";
    },
    __isWebkit : function(){

      return window.navigator.userAgent.indexOf("AppleWebKit/") != -1;
    },
    __isMaple : function(){

      return window.navigator.userAgent.indexOf("Maple") != -1;
    },
    __isGecko : function(){

      return (window.navigator.mozApps || window.navigator.buildID) && window.navigator.product === "Gecko" && window.navigator.userAgent.indexOf("Maple") == -1 && window.navigator.userAgent.indexOf("Trident") == -1;
    },
    __isMshtml : function(){

      if(window.navigator.cpuClass && (/MSIE\s+([^\);]+)(\)|;)/.test(window.navigator.userAgent) || /Trident\/\d+?\.\d+?/.test(window.navigator.userAgent))){

        return true;
      };
      if(qx.bom.client.Engine.__isWindowsPhone()){

        return true;
      };
      return false;
    },
    __isWindowsPhone : function(){

      return window.navigator.userAgent.indexOf("Windows Phone") > -1;
    }
  },
  defer : function(statics){

    qx.core.Environment.add("engine.version", statics.getVersion);
    qx.core.Environment.add("engine.name", statics.getName);
  }
});
qx.Bootstrap.define("qx.lang.Function", {
  statics : {
    getCaller : function(args){

      return args.caller ? args.caller.callee : args.callee.caller;
    },
    getName : function(fcn){

      if(fcn.displayName){

        return fcn.displayName;
      };
      if(fcn.$$original || fcn.wrapper || fcn.classname){

        return fcn.classname + ".constructor()";
      };
      if(fcn.$$mixin){

        for(var key in fcn.$$mixin.$$members){

          if(fcn.$$mixin.$$members[key] == fcn){

            return fcn.$$mixin.name + ".prototype." + key + "()";
          };
        };
        for(var key in fcn.$$mixin){

          if(fcn.$$mixin[key] == fcn){

            return fcn.$$mixin.name + "." + key + "()";
          };
        };
      };
      if(fcn.self){

        var clazz = fcn.self.constructor;
        if(clazz){

          for(var key in clazz.prototype){

            if(clazz.prototype[key] == fcn){

              return clazz.classname + ".prototype." + key + "()";
            };
          };
          for(var key in clazz){

            if(clazz[key] == fcn){

              return clazz.classname + "." + key + "()";
            };
          };
        };
      };
      var fcnReResult = fcn.toString().match(/function\s*(\w*)\s*\(.*/);
      if(fcnReResult && fcnReResult.length >= 1 && fcnReResult[1]){

        return fcnReResult[1] + "()";
      };
      return 'anonymous()';
    },
    globalEval : function(data){

      if(window.execScript){

        return window.execScript(data);
      } else {

        return eval.call(window, data);
      };
    },
    create : function(func, options){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertFunction(func, "Invalid parameter 'func'.");
      };
      if(!options){

        return func;
      };
      if(!(options.self || options.args || options.delay != null || options.periodical != null || options.attempt)){

        return func;
      };
      return function(event){

        if(qx.core.Environment.get("qx.debug")){

          if(qx.core.Object && options.self && qx.Bootstrap.isObject(options.self) && options.self.isDisposed && qx.Bootstrap.isFunction(options.self.isDisposed)){

            qx.core.Assert && qx.core.Assert.assertFalse(options.self.isDisposed(), "Trying to call a bound function with a disposed object as context: " + options.self.toString() + " :: " + qx.lang.Function.getName(func));
          };
        };
        var args = qx.lang.Array.fromArguments(arguments);
        if(options.args){

          args = options.args.concat(args);
        };
        if(options.delay || options.periodical){

          var returns = function(){

            return func.apply(options.self || this, args);
          };
          if(qx.core.Environment.get("qx.globalErrorHandling")){

            returns = qx.event.GlobalError.observeMethod(returns);
          };
          if(options.delay){

            return window.setTimeout(returns, options.delay);
          };
          if(options.periodical){

            return window.setInterval(returns, options.periodical);
          };
        } else if(options.attempt){

          var ret = false;
          try{

            ret = func.apply(options.self || this, args);
          } catch(ex) {
          };
          return ret;
        } else {

          return func.apply(options.self || this, args);
        };
      };
    },
    bind : function(func, self, varargs){

      return this.create(func, {
        self : self,
        args : arguments.length > 2 ? qx.lang.Array.fromArguments(arguments, 2) : null
      });
    },
    curry : function(func, varargs){

      return this.create(func, {
        args : arguments.length > 1 ? qx.lang.Array.fromArguments(arguments, 1) : null
      });
    },
    listener : function(func, self, varargs){

      if(arguments.length < 3){

        return function(event){

          return func.call(self || this, event || window.event);
        };
      } else {

        var optargs = qx.lang.Array.fromArguments(arguments, 2);
        return function(event){

          var args = [event || window.event];
          args.push.apply(args, optargs);
          func.apply(self || this, args);
        };
      };
    },
    attempt : function(func, self, varargs){

      return this.create(func, {
        self : self,
        attempt : true,
        args : arguments.length > 2 ? qx.lang.Array.fromArguments(arguments, 2) : null
      })();
    },
    delay : function(func, delay, self, varargs){

      return this.create(func, {
        delay : delay,
        self : self,
        args : arguments.length > 3 ? qx.lang.Array.fromArguments(arguments, 3) : null
      })();
    },
    periodical : function(func, interval, self, varargs){

      return this.create(func, {
        periodical : interval,
        self : self,
        args : arguments.length > 3 ? qx.lang.Array.fromArguments(arguments, 3) : null
      })();
    }
  }
});
qx.Bootstrap.define("qx.core.ObjectRegistry", {
  statics : {
    inShutDown : false,
    __registry : {
    },
    __nextHash : 0,
    __freeHashes : [],
    __postId : "",
    __stackTraces : {
    },
    register : function(obj){

      var registry = this.__registry;
      if(!registry){

        return;
      };
      var hash = obj.$$hash;
      if(hash == null){

        var cache = this.__freeHashes;
        if(cache.length > 0 && !qx.core.Environment.get("qx.debug.dispose")){

          hash = cache.pop();
        } else {

          hash = (this.__nextHash++) + this.__postId;
        };
        obj.$$hash = hash;
        if(qx.core.Environment.get("qx.debug.dispose")){

          if(qx.dev && qx.dev.Debug && qx.dev.Debug.disposeProfilingActive){

            this.__stackTraces[hash] = qx.dev.StackTrace.getStackTrace();
          };
        };
      };
      if(qx.core.Environment.get("qx.debug")){

        if(!obj.dispose){

          throw new Error("Invalid object: " + obj);
        };
      };
      registry[hash] = obj;
    },
    unregister : function(obj){

      var hash = obj.$$hash;
      if(hash == null){

        return;
      };
      var registry = this.__registry;
      if(registry && registry[hash]){

        delete registry[hash];
        this.__freeHashes.push(hash);
      };
      try{

        delete obj.$$hash;
      } catch(ex) {

        if(obj.removeAttribute){

          obj.removeAttribute("$$hash");
        };
      };
    },
    toHashCode : function(obj){

      if(qx.core.Environment.get("qx.debug")){

        if(obj == null){

          throw new Error("Invalid object: " + obj);
        };
      };
      var hash = obj.$$hash;
      if(hash != null){

        return hash;
      };
      var cache = this.__freeHashes;
      if(cache.length > 0){

        hash = cache.pop();
      } else {

        hash = (this.__nextHash++) + this.__postId;
      };
      return obj.$$hash = hash;
    },
    clearHashCode : function(obj){

      if(qx.core.Environment.get("qx.debug")){

        if(obj == null){

          throw new Error("Invalid object: " + obj);
        };
      };
      var hash = obj.$$hash;
      if(hash != null){

        this.__freeHashes.push(hash);
        try{

          delete obj.$$hash;
        } catch(ex) {

          if(obj.removeAttribute){

            obj.removeAttribute("$$hash");
          };
        };
      };
    },
    fromHashCode : function(hash){

      return this.__registry[hash] || null;
    },
    shutdown : function(){

      this.inShutDown = true;
      var registry = this.__registry;
      var hashes = [];
      for(var hash in registry){

        hashes.push(hash);
      };
      hashes.sort(function(a, b){

        return parseInt(b, 10) - parseInt(a, 10);
      });
      var obj,i = 0,l = hashes.length;
      while(true){

        try{

          for(;i < l;i++){

            hash = hashes[i];
            obj = registry[hash];
            if(obj && obj.dispose){

              obj.dispose();
            };
          };
        } catch(ex) {

          qx.Bootstrap.error(this, "Could not dispose object " + obj.toString() + ": " + ex, ex);
          if(i !== l){

            i++;
            continue;
          };
        };
        break;
      };
      qx.Bootstrap.debug(this, "Disposed " + l + " objects");
      delete this.__registry;
    },
    getRegistry : function(){

      return this.__registry;
    },
    getNextHash : function(){

      return this.__nextHash;
    },
    getPostId : function(){

      return this.__postId;
    },
    getStackTraces : function(){

      return this.__stackTraces;
    }
  },
  defer : function(statics){

    if(window && window.top){

      var frames = window.top.frames;
      for(var i = 0;i < frames.length;i++){

        if(frames[i] === window){

          statics.__postId = "-" + (i + 1);
          return;
        };
      };
    };
    statics.__postId = "-0";
  }
});
qx.Bootstrap.define("qx.lang.Json", {
  statics : {
    stringify : null,
    parse : null
  }
});
(function(){

  var JSON3;
  var exports;
  var define;
  (function(window){

    var getClass = {
    }.toString,isProperty,forEach,undef;
    var isLoader = typeof define === "function" && define.amd,JSON3 = typeof exports == "object" && exports;
    if(JSON3 || isLoader){

      if(typeof JSON == "object" && JSON){

        if(JSON3){

          JSON3.stringify = JSON.stringify;
          JSON3.parse = JSON.parse;
        } else {

          JSON3 = JSON;
        };
      } else if(isLoader){

        JSON3 = window.JSON = {
        };
      };
    } else {

      JSON3 = window.JSON || (window.JSON = {
      });
    };
    var isExtended = new Date(-3509827334573292);
    try{

      isExtended = isExtended.getUTCFullYear() == -109252 && isExtended.getUTCMonth() === 0 && isExtended.getUTCDate() === 1 && isExtended.getUTCHours() == 10 && isExtended.getUTCMinutes() == 37 && isExtended.getUTCSeconds() == 6 && isExtended.getUTCMilliseconds() == 708;
    } catch(exception) {
    };
    function has(name){

      if(name == "bug-string-char-index"){

        return "a"[0] != "a";
      };
      var value,serialized = '{"a":[1,true,false,null,"\\u0000\\b\\n\\f\\r\\t"]}',isAll = name == "json";
      if(isAll || name == "json-stringify" || name == "json-parse"){

        if(name == "json-stringify" || isAll){

          var stringify = JSON3.stringify,stringifySupported = typeof stringify == "function" && isExtended;
          if(stringifySupported){

            (value = function(){

              return 1;
            }).toJSON = value;
            try{

              stringifySupported = stringify(0) === "0" && stringify(new Number()) === "0" && stringify(new String()) == '""' && stringify(getClass) === undef && stringify(undef) === undef && stringify() === undef && stringify(value) === "1" && stringify([value]) == "[1]" && stringify([undef]) == "[null]" && stringify(null) == "null" && stringify([undef, getClass, null]) == "[null,null,null]" && stringify({
                "a" : [value, true, false, null, "\x00\b\n\f\r\t"]
              }) == serialized && stringify(null, value) === "1" && stringify([1, 2], null, 1) == "[\n 1,\n 2\n]" && stringify(new Date(-8.64e15)) == '"-271821-04-20T00:00:00.000Z"' && stringify(new Date(8.64e15)) == '"+275760-09-13T00:00:00.000Z"' && stringify(new Date(-621987552e5)) == '"-000001-01-01T00:00:00.000Z"' && stringify(new Date(-1)) == '"1969-12-31T23:59:59.999Z"';
            } catch(exception) {

              stringifySupported = false;
            };
          };
          if(!isAll){

            return stringifySupported;
          };
        };
        if(name == "json-parse" || isAll){

          var parse = JSON3.parse;
          if(typeof parse == "function"){

            try{

              if(parse("0") === 0 && !parse(false)){

                value = parse(serialized);
                var parseSupported = value["a"].length == 5 && value["a"][0] === 1;
                if(parseSupported){

                  try{

                    parseSupported = !parse('"\t"');
                  } catch(exception) {
                  };
                  if(parseSupported){

                    try{

                      parseSupported = parse("01") !== 1;
                    } catch(exception) {
                    };
                  };
                };
              };
            } catch(exception) {

              parseSupported = false;
            };
          };
          if(!isAll){

            return parseSupported;
          };
        };
        return stringifySupported && parseSupported;
      };
    };
    if(!has("json")){

      var functionClass = "[object Function]";
      var dateClass = "[object Date]";
      var numberClass = "[object Number]";
      var stringClass = "[object String]";
      var arrayClass = "[object Array]";
      var booleanClass = "[object Boolean]";
      var charIndexBuggy = has("bug-string-char-index");
      if(!isExtended){

        var floor = Math.floor;
        var Months = [0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 334];
        var getDay = function(year, month){

          return Months[month] + 365 * (year - 1970) + floor((year - 1969 + (month = +(month > 1))) / 4) - floor((year - 1901 + month) / 100) + floor((year - 1601 + month) / 400);
        };
      };
      if(!(isProperty = {
      }.hasOwnProperty)){

        isProperty = function(property){

          var members = {
          },constructor;
          if((members.__proto__ = null, members.__proto__ = {
            "toString" : 1
          }, members).toString != getClass){

            isProperty = function(property){

              var original = this.__proto__,result = property in (this.__proto__ = null, this);
              this.__proto__ = original;
              return result;
            };
          } else {

            constructor = members.constructor;
            isProperty = function(property){

              var parent = (this.constructor || constructor).prototype;
              return property in this && !(property in parent && this[property] === parent[property]);
            };
          };
          members = null;
          return isProperty.call(this, property);
        };
      };
      var PrimitiveTypes = {
        'boolean' : 1,
        'number' : 1,
        'string' : 1,
        'undefined' : 1
      };
      var isHostType = function(object, property){

        var type = typeof object[property];
        return type == 'object' ? !!object[property] : !PrimitiveTypes[type];
      };
      forEach = function(object, callback){

        var size = 0,Properties,members,property,forEach;
        (Properties = function(){

          this.valueOf = 0;
        }).prototype.valueOf = 0;
        members = new Properties();
        for(property in members){

          if(isProperty.call(members, property)){

            size++;
          };
        };
        Properties = members = null;
        if(!size){

          members = ["valueOf", "toString", "toLocaleString", "propertyIsEnumerable", "isPrototypeOf", "hasOwnProperty", "constructor"];
          forEach = function(object, callback){

            var isFunction = getClass.call(object) == functionClass,property,length;
            var hasProperty = !isFunction && typeof object.constructor != 'function' && isHostType(object, 'hasOwnProperty') ? object.hasOwnProperty : isProperty;
            for(property in object){

              if(!(isFunction && property == "prototype") && hasProperty.call(object, property)){

                callback(property);
              };
            };
            for(length = members.length;property = members[--length];hasProperty.call(object, property) && callback(property));
          };
        } else if(size == 2){

          forEach = function(object, callback){

            var members = {
            },isFunction = getClass.call(object) == functionClass,property;
            for(property in object){

              if(!(isFunction && property == "prototype") && !isProperty.call(members, property) && (members[property] = 1) && isProperty.call(object, property)){

                callback(property);
              };
            };
          };
        } else {

          forEach = function(object, callback){

            var isFunction = getClass.call(object) == functionClass,property,isConstructor;
            for(property in object){

              if(!(isFunction && property == "prototype") && isProperty.call(object, property) && !(isConstructor = property === "constructor")){

                callback(property);
              };
            };
            if(isConstructor || isProperty.call(object, (property = "constructor"))){

              callback(property);
            };
          };
        };
        return forEach(object, callback);
      };
      if(!has("json-stringify")){

        var Escapes = {
          '92' : "\\\\",
          '34' : '\\"',
          '8' : "\\b",
          '12' : "\\f",
          '10' : "\\n",
          '13' : "\\r",
          '9' : "\\t"
        };
        var leadingZeroes = "000000";
        var toPaddedString = function(width, value){

          return (leadingZeroes + (value || 0)).slice(-width);
        };
        var unicodePrefix = "\\u00";
        var quote = function(value){

          var result = '"',index = 0,length = value.length,isLarge = length > 10 && charIndexBuggy,symbols;
          if(isLarge){

            symbols = value.split("");
          };
          for(;index < length;index++){

            var charCode = value.charCodeAt(index);
            switch(charCode){case 8:case 9:case 10:case 12:case 13:case 34:case 92:
            result += Escapes[charCode];
            break;default:
            if(charCode < 32){

              result += unicodePrefix + toPaddedString(2, charCode.toString(16));
              break;
            };
            result += isLarge ? symbols[index] : charIndexBuggy ? value.charAt(index) : value[index];};
          };
          return result + '"';
        };
        var serialize = function(property, object, callback, properties, whitespace, indentation, stack){

          var value = object[property],className,year,month,date,time,hours,minutes,seconds,milliseconds,results,element,index,length,prefix,hasMembers,result;
          try{

            value = object[property];
          } catch(exception) {
          };
          if(typeof value == "object" && value){

            className = getClass.call(value);
            if(className == dateClass && !isProperty.call(value, "toJSON")){

              if(value > -1 / 0 && value < 1 / 0){

                if(getDay){

                  date = floor(value / 864e5);
                  for(year = floor(date / 365.2425) + 1970 - 1;getDay(year + 1, 0) <= date;year++);
                  for(month = floor((date - getDay(year, 0)) / 30.42);getDay(year, month + 1) <= date;month++);
                  date = 1 + date - getDay(year, month);
                  time = (value % 864e5 + 864e5) % 864e5;
                  hours = floor(time / 36e5) % 24;
                  minutes = floor(time / 6e4) % 60;
                  seconds = floor(time / 1e3) % 60;
                  milliseconds = time % 1e3;
                } else {

                  year = value.getUTCFullYear();
                  month = value.getUTCMonth();
                  date = value.getUTCDate();
                  hours = value.getUTCHours();
                  minutes = value.getUTCMinutes();
                  seconds = value.getUTCSeconds();
                  milliseconds = value.getUTCMilliseconds();
                };
                value = (year <= 0 || year >= 1e4 ? (year < 0 ? "-" : "+") + toPaddedString(6, year < 0 ? -year : year) : toPaddedString(4, year)) + "-" + toPaddedString(2, month + 1) + "-" + toPaddedString(2, date) + "T" + toPaddedString(2, hours) + ":" + toPaddedString(2, minutes) + ":" + toPaddedString(2, seconds) + "." + toPaddedString(3, milliseconds) + "Z";
              } else {

                value = null;
              };
            } else if(typeof value.toJSON == "function" && ((className != numberClass && className != stringClass && className != arrayClass) || isProperty.call(value, "toJSON"))){

              value = value.toJSON(property);
            };
          };
          if(callback){

            value = callback.call(object, property, value);
          };
          if(value === null){

            return "null";
          };
          className = getClass.call(value);
          if(className == booleanClass){

            return "" + value;
          } else if(className == numberClass){

            return value > -1 / 0 && value < 1 / 0 ? "" + value : "null";
          } else if(className == stringClass){

            return quote("" + value);
          };;
          if(typeof value == "object"){

            for(length = stack.length;length--;){

              if(stack[length] === value){

                throw TypeError();
              };
            };
            stack.push(value);
            results = [];
            prefix = indentation;
            indentation += whitespace;
            if(className == arrayClass){

              for(index = 0,length = value.length;index < length;hasMembers || (hasMembers = true),index++){

                element = serialize(index, value, callback, properties, whitespace, indentation, stack);
                results.push(element === undef ? "null" : element);
              };
              result = hasMembers ? (whitespace ? "[\n" + indentation + results.join(",\n" + indentation) + "\n" + prefix + "]" : ("[" + results.join(",") + "]")) : "[]";
            } else {

              forEach(properties || value, function(property){

                var element = serialize(property, value, callback, properties, whitespace, indentation, stack);
                if(element !== undef){

                  results.push(quote(property) + ":" + (whitespace ? " " : "") + element);
                };
                hasMembers || (hasMembers = true);
              });
              result = hasMembers ? (whitespace ? "{\n" + indentation + results.join(",\n" + indentation) + "\n" + prefix + "}" : ("{" + results.join(",") + "}")) : "{}";
            };
            stack.pop();
            return result;
          };
        };
        JSON3.stringify = function(source, filter, width){

          var whitespace,callback,properties;
          if(typeof filter == "function" || typeof filter == "object" && filter){

            if(getClass.call(filter) == functionClass){

              callback = filter;
            } else if(getClass.call(filter) == arrayClass){

              properties = {
              };
              for(var index = 0,length = filter.length,value;index < length;value = filter[index++],((getClass.call(value) == stringClass || getClass.call(value) == numberClass) && (properties[value] = 1)));
            };
          };
          if(width){

            if(getClass.call(width) == numberClass){

              if((width -= width % 1) > 0){

                for(whitespace = "",width > 10 && (width = 10);whitespace.length < width;whitespace += " ");
              };
            } else if(getClass.call(width) == stringClass){

              whitespace = width.length <= 10 ? width : width.slice(0, 10);
            };
          };
          return serialize("", (value = {
          }, value[""] = source, value), callback, properties, whitespace, "", []);
        };
      };
      if(!has("json-parse")){

        var fromCharCode = String.fromCharCode;
        var Unescapes = {
          '92' : "\\",
          '34' : '"',
          '47' : "/",
          '98' : "\b",
          '116' : "\t",
          '110' : "\n",
          '102' : "\f",
          '114' : "\r"
        };
        var Index,Source;
        var abort = function(){

          Index = Source = null;
          throw SyntaxError();
        };
        var lex = function(){

          var source = Source,length = source.length,value,begin,position,isSigned,charCode;
          while(Index < length){

            charCode = source.charCodeAt(Index);
            switch(charCode){case 9:case 10:case 13:case 32:
            Index++;
            break;case 123:case 125:case 91:case 93:case 58:case 44:
            value = charIndexBuggy ? source.charAt(Index) : source[Index];
            Index++;
            return value;case 34:
            for(value = "@",Index++;Index < length;){

              charCode = source.charCodeAt(Index);
              if(charCode < 32){

                abort();
              } else if(charCode == 92){

                charCode = source.charCodeAt(++Index);
                switch(charCode){case 92:case 34:case 47:case 98:case 116:case 110:case 102:case 114:
                value += Unescapes[charCode];
                Index++;
                break;case 117:
                begin = ++Index;
                for(position = Index + 4;Index < position;Index++){

                  charCode = source.charCodeAt(Index);
                  if(!(charCode >= 48 && charCode <= 57 || charCode >= 97 && charCode <= 102 || charCode >= 65 && charCode <= 70)){

                    abort();
                  };
                };
                value += fromCharCode("0x" + source.slice(begin, Index));
                break;default:
                abort();};
              } else {

                if(charCode == 34){

                  break;
                };
                charCode = source.charCodeAt(Index);
                begin = Index;
                while(charCode >= 32 && charCode != 92 && charCode != 34){

                  charCode = source.charCodeAt(++Index);
                };
                value += source.slice(begin, Index);
              };
            };
            if(source.charCodeAt(Index) == 34){

              Index++;
              return value;
            };
            abort();default:
            begin = Index;
            if(charCode == 45){

              isSigned = true;
              charCode = source.charCodeAt(++Index);
            };
            if(charCode >= 48 && charCode <= 57){

              if(charCode == 48 && ((charCode = source.charCodeAt(Index + 1)), charCode >= 48 && charCode <= 57)){

                abort();
              };
              isSigned = false;
              for(;Index < length && ((charCode = source.charCodeAt(Index)), charCode >= 48 && charCode <= 57);Index++);
              if(source.charCodeAt(Index) == 46){

                position = ++Index;
                for(;position < length && ((charCode = source.charCodeAt(position)), charCode >= 48 && charCode <= 57);position++);
                if(position == Index){

                  abort();
                };
                Index = position;
              };
              charCode = source.charCodeAt(Index);
              if(charCode == 101 || charCode == 69){

                charCode = source.charCodeAt(++Index);
                if(charCode == 43 || charCode == 45){

                  Index++;
                };
                for(position = Index;position < length && ((charCode = source.charCodeAt(position)), charCode >= 48 && charCode <= 57);position++);
                if(position == Index){

                  abort();
                };
                Index = position;
              };
              return +source.slice(begin, Index);
            };
            if(isSigned){

              abort();
            };
            if(source.slice(Index, Index + 4) == "true"){

              Index += 4;
              return true;
            } else if(source.slice(Index, Index + 5) == "false"){

              Index += 5;
              return false;
            } else if(source.slice(Index, Index + 4) == "null"){

              Index += 4;
              return null;
            };;
            abort();};
          };
          return "$";
        };
        var get = function(value){

          var results,hasMembers;
          if(value == "$"){

            abort();
          };
          if(typeof value == "string"){

            if((charIndexBuggy ? value.charAt(0) : value[0]) == "@"){

              return value.slice(1);
            };
            if(value == "["){

              results = [];
              for(;;hasMembers || (hasMembers = true)){

                value = lex();
                if(value == "]"){

                  break;
                };
                if(hasMembers){

                  if(value == ","){

                    value = lex();
                    if(value == "]"){

                      abort();
                    };
                  } else {

                    abort();
                  };
                };
                if(value == ","){

                  abort();
                };
                results.push(get(value));
              };
              return results;
            } else if(value == "{"){

              results = {
              };
              for(;;hasMembers || (hasMembers = true)){

                value = lex();
                if(value == "}"){

                  break;
                };
                if(hasMembers){

                  if(value == ","){

                    value = lex();
                    if(value == "}"){

                      abort();
                    };
                  } else {

                    abort();
                  };
                };
                if(value == "," || typeof value != "string" || (charIndexBuggy ? value.charAt(0) : value[0]) != "@" || lex() != ":"){

                  abort();
                };
                results[value.slice(1)] = get(lex());
              };
              return results;
            };
            abort();
          };
          return value;
        };
        var update = function(source, property, callback){

          var element = walk(source, property, callback);
          if(element === undef){

            delete source[property];
          } else {

            source[property] = element;
          };
        };
        var walk = function(source, property, callback){

          var value = source[property],length;
          if(typeof value == "object" && value){

            if(getClass.call(value) == arrayClass){

              for(length = value.length;length--;){

                update(value, length, callback);
              };
            } else {

              forEach(value, function(property){

                update(value, property, callback);
              });
            };
          };
          return callback.call(source, property, value);
        };
        JSON3.parse = function(source, callback){

          var result,value;
          Index = 0;
          Source = "" + source;
          result = get(lex());
          if(lex() != "$"){

            abort();
          };
          Index = Source = null;
          return callback && getClass.call(callback) == functionClass ? walk((value = {
          }, value[""] = result, value), "", callback) : result;
        };
      };
    };
    if(isLoader){

      define(function(){

        return JSON3;
      });
    };
  }(this));
}());
qx.lang.Json.stringify = window.JSON.stringify;
qx.lang.Json.parse = window.JSON.parse;
qx.Bootstrap.define("qx.lang.String", {
  statics : {
    __unicodeLetters : "0041-005A0061-007A00AA00B500BA00C0-00D600D8-00F600F8-02C102C6-02D102E0-02E402EC02EE0370-037403760377037A-037D03860388-038A038C038E-03A103A3-03F503F7-0481048A-05250531-055605590561-058705D0-05EA05F0-05F20621-064A066E066F0671-06D306D506E506E606EE06EF06FA-06FC06FF07100712-072F074D-07A507B107CA-07EA07F407F507FA0800-0815081A082408280904-0939093D09500958-0961097109720979-097F0985-098C098F09900993-09A809AA-09B009B209B6-09B909BD09CE09DC09DD09DF-09E109F009F10A05-0A0A0A0F0A100A13-0A280A2A-0A300A320A330A350A360A380A390A59-0A5C0A5E0A72-0A740A85-0A8D0A8F-0A910A93-0AA80AAA-0AB00AB20AB30AB5-0AB90ABD0AD00AE00AE10B05-0B0C0B0F0B100B13-0B280B2A-0B300B320B330B35-0B390B3D0B5C0B5D0B5F-0B610B710B830B85-0B8A0B8E-0B900B92-0B950B990B9A0B9C0B9E0B9F0BA30BA40BA8-0BAA0BAE-0BB90BD00C05-0C0C0C0E-0C100C12-0C280C2A-0C330C35-0C390C3D0C580C590C600C610C85-0C8C0C8E-0C900C92-0CA80CAA-0CB30CB5-0CB90CBD0CDE0CE00CE10D05-0D0C0D0E-0D100D12-0D280D2A-0D390D3D0D600D610D7A-0D7F0D85-0D960D9A-0DB10DB3-0DBB0DBD0DC0-0DC60E01-0E300E320E330E40-0E460E810E820E840E870E880E8A0E8D0E94-0E970E99-0E9F0EA1-0EA30EA50EA70EAA0EAB0EAD-0EB00EB20EB30EBD0EC0-0EC40EC60EDC0EDD0F000F40-0F470F49-0F6C0F88-0F8B1000-102A103F1050-1055105A-105D106110651066106E-10701075-1081108E10A0-10C510D0-10FA10FC1100-1248124A-124D1250-12561258125A-125D1260-1288128A-128D1290-12B012B2-12B512B8-12BE12C012C2-12C512C8-12D612D8-13101312-13151318-135A1380-138F13A0-13F41401-166C166F-167F1681-169A16A0-16EA1700-170C170E-17111720-17311740-17511760-176C176E-17701780-17B317D717DC1820-18771880-18A818AA18B0-18F51900-191C1950-196D1970-19741980-19AB19C1-19C71A00-1A161A20-1A541AA71B05-1B331B45-1B4B1B83-1BA01BAE1BAF1C00-1C231C4D-1C4F1C5A-1C7D1CE9-1CEC1CEE-1CF11D00-1DBF1E00-1F151F18-1F1D1F20-1F451F48-1F4D1F50-1F571F591F5B1F5D1F5F-1F7D1F80-1FB41FB6-1FBC1FBE1FC2-1FC41FC6-1FCC1FD0-1FD31FD6-1FDB1FE0-1FEC1FF2-1FF41FF6-1FFC2071207F2090-209421022107210A-211321152119-211D212421262128212A-212D212F-2139213C-213F2145-2149214E218321842C00-2C2E2C30-2C5E2C60-2CE42CEB-2CEE2D00-2D252D30-2D652D6F2D80-2D962DA0-2DA62DA8-2DAE2DB0-2DB62DB8-2DBE2DC0-2DC62DC8-2DCE2DD0-2DD62DD8-2DDE2E2F300530063031-3035303B303C3041-3096309D-309F30A1-30FA30FC-30FF3105-312D3131-318E31A0-31B731F0-31FF3400-4DB54E00-9FCBA000-A48CA4D0-A4FDA500-A60CA610-A61FA62AA62BA640-A65FA662-A66EA67F-A697A6A0-A6E5A717-A71FA722-A788A78BA78CA7FB-A801A803-A805A807-A80AA80C-A822A840-A873A882-A8B3A8F2-A8F7A8FBA90A-A925A930-A946A960-A97CA984-A9B2A9CFAA00-AA28AA40-AA42AA44-AA4BAA60-AA76AA7AAA80-AAAFAAB1AAB5AAB6AAB9-AABDAAC0AAC2AADB-AADDABC0-ABE2AC00-D7A3D7B0-D7C6D7CB-D7FBF900-FA2DFA30-FA6DFA70-FAD9FB00-FB06FB13-FB17FB1DFB1F-FB28FB2A-FB36FB38-FB3CFB3EFB40FB41FB43FB44FB46-FBB1FBD3-FD3DFD50-FD8FFD92-FDC7FDF0-FDFBFE70-FE74FE76-FEFCFF21-FF3AFF41-FF5AFF66-FFBEFFC2-FFC7FFCA-FFCFFFD2-FFD7FFDA-FFDC",
    __unicodeFirstLetterInWordRegexp : null,
    __stringsMap : {
    },
    camelCase : function(str){

      var result = this.__stringsMap[str];
      if(!result){

        result = str.replace(/\-([a-z])/g, function(match, chr){

          return chr.toUpperCase();
        });
        if(str.indexOf("-") >= 0){

          this.__stringsMap[str] = result;
        };
      };
      return result;
    },
    hyphenate : function(str){

      var result = this.__stringsMap[str];
      if(!result){

        result = str.replace(/[A-Z]/g, function(match){

          return ('-' + match.charAt(0).toLowerCase());
        });
        if(str.indexOf("-") == -1){

          this.__stringsMap[str] = result;
        };
      };
      return result;
    },
    capitalize : function(str){

      if(this.__unicodeFirstLetterInWordRegexp === null){

        var unicodeEscapePrefix = '\\u';
        this.__unicodeFirstLetterInWordRegexp = new RegExp("(^|[^" + this.__unicodeLetters.replace(/[0-9A-F]{4}/g, function(match){

          return unicodeEscapePrefix + match;
        }) + "])[" + this.__unicodeLetters.replace(/[0-9A-F]{4}/g, function(match){

          return unicodeEscapePrefix + match;
        }) + "]", "g");
      };
      return str.replace(this.__unicodeFirstLetterInWordRegexp, function(match){

        return match.toUpperCase();
      });
    },
    clean : function(str){

      return str.replace(/\s+/g, ' ').trim();
    },
    trimLeft : function(str){

      return str.replace(/^\s+/, "");
    },
    trimRight : function(str){

      return str.replace(/\s+$/, "");
    },
    startsWith : function(fullstr, substr){

      return fullstr.indexOf(substr) === 0;
    },
    endsWith : function(fullstr, substr){

      return fullstr.substring(fullstr.length - substr.length, fullstr.length) === substr;
    },
    repeat : function(str, times){

      return str.length > 0 ? new Array(times + 1).join(str) : "";
    },
    pad : function(str, length, ch){

      var padLength = length - str.length;
      if(padLength > 0){

        if(typeof ch === "undefined"){

          ch = "0";
        };
        return this.repeat(ch, padLength) + str;
      } else {

        return str;
      };
    },
    firstUp : qx.Bootstrap.firstUp,
    firstLow : qx.Bootstrap.firstLow,
    contains : function(str, substring){

      return str.indexOf(substring) != -1;
    },
    format : function(pattern, args){

      var str = pattern;
      var i = args.length;
      while(i--){

        str = str.replace(new RegExp("%" + (i + 1), "g"), function(){

          return args[i] + "";
        });
      };
      return str;
    },
    escapeRegexpChars : function(str){

      return str.replace(/([.*+?^${}()|[\]\/\\])/g, '\\$1');
    },
    toArray : function(str){

      return str.split(/\B|\b/g);
    },
    stripTags : function(str){

      return str.replace(/<\/?[^>]+>/gi, "");
    },
    stripScripts : function(str, exec){

      var scripts = "";
      var text = str.replace(/<script[^>]*>([\s\S]*?)<\/script>/gi, function(){

        scripts += arguments[1] + '\n';
        return "";
      });
      if(exec === true){

        qx.lang.Function.globalEval(scripts);
      };
      return text;
    },
    quote : function(str){

      return '"' + str.replace(/\\/g, "\\\\").replace(/\"/g, "\\\"") + '"';
    }
  }
});
qx.Interface.define("qx.data.IListData", {
  events : {
    "change" : "qx.event.type.Data",
    "changeLength" : "qx.event.type.Event"
  },
  members : {
    getItem : function(index){
    },
    setItem : function(index, item){
    },
    splice : function(startIndex, amount, varargs){
    },
    contains : function(item){
    },
    getLength : function(){
    },
    toArray : function(){
    }
  }
});
qx.Class.define("qx.core.ValidationError", {
  extend : qx.type.BaseError
});
qx.Bootstrap.define("qx.util.RingBuffer", {
  extend : Object,
  construct : function(maxEntries){

    this.setMaxEntries(maxEntries || 50);
  },
  members : {
    __nextIndexToStoreTo : 0,
    __entriesStored : 0,
    __isMarkActive : false,
    __entriesStoredSinceMark : 0,
    __entries : null,
    __maxEntries : null,
    setMaxEntries : function(maxEntries){

      this.__maxEntries = maxEntries;
      this.clear();
    },
    getMaxEntries : function(){

      return this.__maxEntries;
    },
    addEntry : function(entry){

      this.__entries[this.__nextIndexToStoreTo] = entry;
      this.__nextIndexToStoreTo = this.__addToIndex(this.__nextIndexToStoreTo, 1);
      var max = this.getMaxEntries();
      if(this.__entriesStored < max){

        this.__entriesStored++;
      };
      if(this.__isMarkActive && (this.__entriesStoredSinceMark < max)){

        this.__entriesStoredSinceMark++;
      };
    },
    mark : function(){

      this.__isMarkActive = true;
      this.__entriesStoredSinceMark = 0;
    },
    clearMark : function(){

      this.__isMarkActive = false;
    },
    getAllEntries : function(){

      return this.getEntries(this.getMaxEntries(), false);
    },
    getEntries : function(count, startingFromMark){

      if(count > this.__entriesStored){

        count = this.__entriesStored;
      };
      if(startingFromMark && this.__isMarkActive && (count > this.__entriesStoredSinceMark)){

        count = this.__entriesStoredSinceMark;
      };
      if(count > 0){

        var indexOfYoungestElementInHistory = this.__addToIndex(this.__nextIndexToStoreTo, -1);
        var startIndex = this.__addToIndex(indexOfYoungestElementInHistory, -count + 1);
        var result;
        if(startIndex <= indexOfYoungestElementInHistory){

          result = this.__entries.slice(startIndex, indexOfYoungestElementInHistory + 1);
        } else {

          result = this.__entries.slice(startIndex, this.__entriesStored).concat(this.__entries.slice(0, indexOfYoungestElementInHistory + 1));
        };
      } else {

        result = [];
      };
      return result;
    },
    clear : function(){

      this.__entries = new Array(this.getMaxEntries());
      this.__entriesStored = 0;
      this.__entriesStoredSinceMark = 0;
      this.__nextIndexToStoreTo = 0;
    },
    __addToIndex : function(idx, addMe){

      var max = this.getMaxEntries();
      var result = (idx + addMe) % max;
      if(result < 0){

        result += max;
      };
      return result;
    }
  }
});
qx.Bootstrap.define("qx.log.appender.RingBuffer", {
  extend : qx.util.RingBuffer,
  construct : function(maxMessages){

    this.setMaxMessages(maxMessages || 50);
  },
  members : {
    setMaxMessages : function(maxMessages){

      this.setMaxEntries(maxMessages);
    },
    getMaxMessages : function(){

      return this.getMaxEntries();
    },
    process : function(entry){

      this.addEntry(entry);
    },
    getAllLogEvents : function(){

      return this.getAllEntries();
    },
    retrieveLogEvents : function(count, startingFromMark){

      return this.getEntries(count, startingFromMark);
    },
    clearHistory : function(){

      this.clear();
    }
  }
});
qx.Bootstrap.define("qx.log.Logger", {
  statics : {
    __level : "debug",
    setLevel : function(value){

      this.__level = value;
    },
    getLevel : function(){

      return this.__level;
    },
    setTreshold : function(value){

      this.__buffer.setMaxMessages(value);
    },
    getTreshold : function(){

      return this.__buffer.getMaxMessages();
    },
    __appender : {
    },
    __id : 0,
    register : function(appender){

      if(appender.$$id){

        return;
      };
      var id = this.__id++;
      this.__appender[id] = appender;
      appender.$$id = id;
      var levels = this.__levels;
      var entries = this.__buffer.getAllLogEvents();
      for(var i = 0,l = entries.length;i < l;i++){

        if(levels[entries[i].level] >= levels[this.__level]){

          appender.process(entries[i]);
        };
      };
    },
    unregister : function(appender){

      var id = appender.$$id;
      if(id == null){

        return;
      };
      delete this.__appender[id];
      delete appender.$$id;
    },
    debug : function(object, message){

      qx.log.Logger.__log("debug", arguments);
    },
    info : function(object, message){

      qx.log.Logger.__log("info", arguments);
    },
    warn : function(object, message){

      qx.log.Logger.__log("warn", arguments);
    },
    error : function(object, message){

      qx.log.Logger.__log("error", arguments);
    },
    trace : function(object){

      var trace = qx.dev.StackTrace.getStackTrace();
      qx.log.Logger.__log("info", [(typeof object !== "undefined" ? [object].concat(trace) : trace).join("\n")]);
    },
    deprecatedMethodWarning : function(fcn, msg){

      if(qx.core.Environment.get("qx.debug")){

        var functionName = qx.lang.Function.getName(fcn);
        this.warn("The method '" + functionName + "' is deprecated: " + (msg || "Please consult the API documentation of this method for alternatives."));
        this.trace();
      };
    },
    deprecatedClassWarning : function(clazz, msg){

      if(qx.core.Environment.get("qx.debug")){

        var className = clazz.classname || "unknown";
        this.warn("The class '" + className + "' is deprecated: " + (msg || "Please consult the API documentation of this class for alternatives."));
        this.trace();
      };
    },
    deprecatedEventWarning : function(clazz, event, msg){

      if(qx.core.Environment.get("qx.debug")){

        var className = clazz.self ? clazz.self.classname : "unknown";
        this.warn("The event '" + (event || "unknown") + "' from class '" + className + "' is deprecated: " + (msg || "Please consult the API documentation of this class for alternatives."));
        this.trace();
      };
    },
    deprecatedMixinWarning : function(clazz, msg){

      if(qx.core.Environment.get("qx.debug")){

        var mixinName = clazz ? clazz.name : "unknown";
        this.warn("The mixin '" + mixinName + "' is deprecated: " + (msg || "Please consult the API documentation of this class for alternatives."));
        this.trace();
      };
    },
    deprecatedConstantWarning : function(clazz, constant, msg){

      if(qx.core.Environment.get("qx.debug")){

        if(clazz.__defineGetter__){

          var self = this;
          var constantValue = clazz[constant];
          clazz.__defineGetter__(constant, function(){

            self.warn("The constant '" + constant + "' is deprecated: " + (msg || "Please consult the API documentation for alternatives."));
            self.trace();
            return constantValue;
          });
        };
      };
    },
    deprecateMethodOverriding : function(object, baseclass, methodName, msg){

      if(qx.core.Environment.get("qx.debug")){

        var clazz = object.constructor;
        while(clazz.classname !== baseclass.classname){

          if(clazz.prototype.hasOwnProperty(methodName)){

            this.warn("The method '" + qx.lang.Function.getName(object[methodName]) + "' overrides a deprecated method: " + (msg || "Please consult the API documentation for alternatives."));
            this.trace();
            break;
          };
          clazz = clazz.superclass;
        };
      };
    },
    clear : function(){

      this.__buffer.clearHistory();
    },
    __buffer : new qx.log.appender.RingBuffer(50),
    __levels : {
      debug : 0,
      info : 1,
      warn : 2,
      error : 3
    },
    __log : function(level, args){

      var levels = this.__levels;
      if(levels[level] < levels[this.__level]){

        return;
      };
      var object = args.length < 2 ? null : args[0];
      var start = object ? 1 : 0;
      var items = [];
      for(var i = start,l = args.length;i < l;i++){

        items.push(this.__serialize(args[i], true));
      };
      var time = new Date;
      var entry = {
        time : time,
        offset : time - qx.Bootstrap.LOADSTART,
        level : level,
        items : items,
        win : window
      };
      if(object){

        if(object.$$hash !== undefined){

          entry.object = object.$$hash;
        } else if(object.$$type){

          entry.clazz = object;
        } else if(object.constructor){

          entry.clazz = object.constructor;
        };;
      };
      this.__buffer.process(entry);
      var appender = this.__appender;
      for(var id in appender){

        appender[id].process(entry);
      };
    },
    __detect : function(value){

      if(value === undefined){

        return "undefined";
      } else if(value === null){

        return "null";
      };
      if(value.$$type){

        return "class";
      };
      var type = typeof value;
      if(type === "function" || type == "string" || type === "number" || type === "boolean"){

        return type;
      } else if(type === "object"){

        if(value.nodeType){

          return "node";
        } else if(value instanceof Error || (value.name && value.message)){

          return "error";
        } else if(value.classname){

          return "instance";
        } else if(value instanceof Array){

          return "array";
        } else if(value instanceof Date){

          return "date";
        } else {

          return "map";
        };;;;
      };
      if(value.toString){

        return "stringify";
      };
      return "unknown";
    },
    __serialize : function(value, deep){

      var type = this.__detect(value);
      var text = "unknown";
      var trace = [];
      switch(type){case "null":case "undefined":
      text = type;
      break;case "string":case "number":case "boolean":case "date":
      text = value;
      break;case "node":
      if(value.nodeType === 9){

        text = "document";
      } else if(value.nodeType === 3){

        text = "text[" + value.nodeValue + "]";
      } else if(value.nodeType === 1){

        text = value.nodeName.toLowerCase();
        if(value.id){

          text += "#" + value.id;
        };
      } else {

        text = "node";
      };;
      break;case "function":
      text = qx.lang.Function.getName(value) || type;
      break;case "instance":
      text = value.basename + "[" + value.$$hash + "]";
      break;case "class":case "stringify":
      text = value.toString();
      break;case "error":
      trace = qx.dev.StackTrace.getStackTraceFromError(value);
      text = (value.basename ? value.basename + ": " : "") + value.toString();
      break;case "array":
      if(deep){

        text = [];
        for(var i = 0,l = value.length;i < l;i++){

          if(text.length > 20){

            text.push("...(+" + (l - i) + ")");
            break;
          };
          text.push(this.__serialize(value[i], false));
        };
      } else {

        text = "[...(" + value.length + ")]";
      };
      break;case "map":
      if(deep){

        var temp;
        var sorted = [];
        for(var key in value){

          sorted.push(key);
        };
        sorted.sort();
        text = [];
        for(var i = 0,l = sorted.length;i < l;i++){

          if(text.length > 20){

            text.push("...(+" + (l - i) + ")");
            break;
          };
          key = sorted[i];
          temp = this.__serialize(value[key], false);
          temp.key = key;
          text.push(temp);
        };
      } else {

        var number = 0;
        for(var key in value){

          number++;
        };
        text = "{...(" + number + ")}";
      };
      break;};
      return {
        type : type,
        text : text,
        trace : trace
      };
    }
  },
  defer : function(statics){

    var logs = qx.Bootstrap.$$logs;
    for(var i = 0;i < logs.length;i++){

      statics.__log(logs[i][0], logs[i][1]);
    };
    qx.Bootstrap.debug = statics.debug;
    qx.Bootstrap.info = statics.info;
    qx.Bootstrap.warn = statics.warn;
    qx.Bootstrap.error = statics.error;
    qx.Bootstrap.trace = statics.trace;
  }
});
qx.Mixin.define("qx.core.MLogging", {
  members : {
    __Logger : qx.log.Logger,
    debug : function(varargs){

      this.__logMessage("debug", arguments);
    },
    info : function(varargs){

      this.__logMessage("info", arguments);
    },
    warn : function(varargs){

      this.__logMessage("warn", arguments);
    },
    error : function(varargs){

      this.__logMessage("error", arguments);
    },
    trace : function(){

      this.__Logger.trace(this);
    },
    __logMessage : function(level, varargs){

      var argumentsArray = qx.lang.Array.fromArguments(varargs);
      argumentsArray.unshift(this);
      this.__Logger[level].apply(this.__Logger, argumentsArray);
    }
  }
});
qx.Bootstrap.define("qx.dom.Node", {
  statics : {
    ELEMENT : 1,
    ATTRIBUTE : 2,
    TEXT : 3,
    CDATA_SECTION : 4,
    ENTITY_REFERENCE : 5,
    ENTITY : 6,
    PROCESSING_INSTRUCTION : 7,
    COMMENT : 8,
    DOCUMENT : 9,
    DOCUMENT_TYPE : 10,
    DOCUMENT_FRAGMENT : 11,
    NOTATION : 12,
    getDocument : function(node){

      return node.nodeType === this.DOCUMENT ? node : node.ownerDocument || node.document;
    },
    getWindow : function(node){

      if(node.nodeType == null){

        return node;
      };
      if(node.nodeType !== this.DOCUMENT){

        node = node.ownerDocument;
      };
      return node.defaultView || node.parentWindow;
    },
    getDocumentElement : function(node){

      return this.getDocument(node).documentElement;
    },
    getBodyElement : function(node){

      return this.getDocument(node).body;
    },
    isNode : function(node){

      return !!(node && node.nodeType != null);
    },
    isElement : function(node){

      return !!(node && node.nodeType === this.ELEMENT);
    },
    isDocument : function(node){

      return !!(node && node.nodeType === this.DOCUMENT);
    },
    isDocumentFragment : function(node){

      return !!(node && node.nodeType === this.DOCUMENT_FRAGMENT);
    },
    isText : function(node){

      return !!(node && node.nodeType === this.TEXT);
    },
    isWindow : function(obj){

      return !!(obj && obj.history && obj.location && obj.document);
    },
    isNodeName : function(node, nodeName){

      if(!nodeName || !node || !node.nodeName){

        return false;
      };
      return nodeName.toLowerCase() == qx.dom.Node.getName(node);
    },
    getName : function(node){

      if(!node || !node.nodeName){

        return null;
      };
      return node.nodeName.toLowerCase();
    },
    getText : function(node){

      if(!node || !node.nodeType){

        return null;
      };
      switch(node.nodeType){case 1:
      var i,a = [],nodes = node.childNodes,length = nodes.length;
      for(i = 0;i < length;i++){

        a[i] = this.getText(nodes[i]);
      };
      return a.join("");case 2:case 3:case 4:
      return node.nodeValue;};
      return null;
    },
    isBlockNode : function(node){

      if(!qx.dom.Node.isElement(node)){

        return false;
      };
      node = qx.dom.Node.getName(node);
      return /^(body|form|textarea|fieldset|ul|ol|dl|dt|dd|li|div|hr|p|h[1-6]|quote|pre|table|thead|tbody|tfoot|tr|td|th|iframe|address|blockquote)$/.test(node);
    }
  }
});
qx.Bootstrap.define("qx.bom.Event", {
  statics : {
    addNativeListener : function(target, type, listener, useCapture){

      if(target.addEventListener){

        target.addEventListener(type, listener, !!useCapture);
      } else if(target.attachEvent){

        target.attachEvent("on" + type, listener);
      } else if(typeof target["on" + type] != "undefined"){

        target["on" + type] = listener;
      } else {

        if(qx.core.Environment.get("qx.debug")){

          qx.log.Logger.warn("No method available to add native listener to " + target);
        };
      };;
    },
    removeNativeListener : function(target, type, listener, useCapture){

      if(target.removeEventListener){

        target.removeEventListener(type, listener, !!useCapture);
      } else if(target.detachEvent){

        try{

          target.detachEvent("on" + type, listener);
        } catch(e) {

          if(e.number !== -2146828218){

            throw e;
          };
        };
      } else if(typeof target["on" + type] != "undefined"){

        target["on" + type] = null;
      } else {

        if(qx.core.Environment.get("qx.debug")){

          qx.log.Logger.warn("No method available to remove native listener from " + target);
        };
      };;
    },
    getTarget : function(e){

      return e.target || e.srcElement;
    },
    getRelatedTarget : function(e){

      if(e.relatedTarget !== undefined){

        if((qx.core.Environment.get("engine.name") == "gecko")){

          try{

            e.relatedTarget && e.relatedTarget.nodeType;
          } catch(ex) {

            return null;
          };
        };
        return e.relatedTarget;
      } else if(e.fromElement !== undefined && (e.type === "mouseover" || e.type === "pointerover")){

        return e.fromElement;
      } else if(e.toElement !== undefined){

        return e.toElement;
      } else {

        return null;
      };;
    },
    preventDefault : function(e){

      if(e.preventDefault){

        e.preventDefault();
      } else {

        try{

          e.keyCode = 0;
        } catch(ex) {
        };
        e.returnValue = false;
      };
    },
    stopPropagation : function(e){

      if(e.stopPropagation){

        e.stopPropagation();
      } else {

        e.cancelBubble = true;
      };
    },
    fire : function(target, type){

      if(document.createEvent){

        var evt = document.createEvent("HTMLEvents");
        evt.initEvent(type, true, true);
        return !target.dispatchEvent(evt);
      } else {

        var evt = document.createEventObject();
        return target.fireEvent("on" + type, evt);
      };
    },
    supportsEvent : function(target, type){

      var browserName = qx.core.Environment.get("browser.name");
      var engineName = qx.core.Environment.get("engine.name");
      if(type.toLowerCase().indexOf("transitionend") != -1 && engineName === "mshtml" && qx.core.Environment.get("browser.documentmode") > 9){

        return true;
      };
      var safariBrowserNames = ["mobile safari", "safari"];
      if(engineName === "webkit" && safariBrowserNames.indexOf(browserName) > -1){

        var supportedEvents = ['loadeddata', 'progress', 'timeupdate', 'seeked', 'canplay', 'play', 'playing', 'pause', 'loadedmetadata', 'ended', 'volumechange'];
        if(supportedEvents.indexOf(type.toLowerCase()) > -1){

          return true;
        };
      };
      if(target != window && type.toLowerCase().indexOf("transitionend") != -1){

        var transitionSupport = qx.core.Environment.get("css.transition");
        return (transitionSupport && transitionSupport["end-event"] == type);
      };
      var eventName = "on" + type.toLowerCase();
      var supportsEvent = (eventName in target);
      if(!supportsEvent){

        supportsEvent = typeof target[eventName] == "function";
        if(!supportsEvent && target.setAttribute){

          target.setAttribute(eventName, "return;");
          supportsEvent = typeof target[eventName] == "function";
          target.removeAttribute(eventName);
        };
      };
      return supportsEvent;
    },
    getEventName : function(target, type){

      var pref = [""].concat(qx.bom.Style.VENDOR_PREFIXES);
      for(var i = 0,l = pref.length;i < l;i++){

        var prefix = pref[i].toLowerCase();
        if(qx.bom.Event.supportsEvent(target, prefix + type)){

          return prefix ? prefix + qx.lang.String.firstUp(type) : type;
        };
      };
      return null;
    }
  }
});
qx.Bootstrap.define("qx.bom.Style", {
  statics : {
    VENDOR_PREFIXES : ["Webkit", "Moz", "O", "ms", "Khtml"],
    __cssName : {
    },
    __supports : null,
    getPropertyName : function(propertyName){

      var style = document.documentElement.style;
      if(style[propertyName] !== undefined){

        return propertyName;
      };
      for(var i = 0,l = this.VENDOR_PREFIXES.length;i < l;i++){

        var prefixedProp = this.VENDOR_PREFIXES[i] + qx.lang.String.firstUp(propertyName);
        if(style[prefixedProp] !== undefined){

          return prefixedProp;
        };
      };
      return null;
    },
    getCssName : function(propertyName){

      var cssName = this.__cssName[propertyName];
      if(!cssName){

        cssName = propertyName.replace(/[A-Z]/g, function(match){

          return ('-' + match.charAt(0).toLowerCase());
        });
        if((/^ms/.test(cssName))){

          cssName = "-" + cssName;
        };
        this.__cssName[propertyName] = cssName;
      };
      return cssName;
    },
    getAppliedStyle : function(element, propertyName, value, prefixed){

      var cssProperty = qx.bom.Style.getCssName(propertyName);
      var win = qx.dom.Node.getWindow(element);
      var vendorPrefixes = (prefixed !== false) ? [null].concat(this.VENDOR_PREFIXES) : [null];
      for(var i = 0,l = vendorPrefixes.length;i < l;i++){

        var supported = false;
        var prefixedVal = vendorPrefixes[i] ? "-" + vendorPrefixes[i].toLowerCase() + "-" + value : value;
        if(qx.bom.Style.__supports){

          supported = qx.bom.Style.__supports.call(win, cssProperty, prefixedVal);
        } else {

          element.style.cssText += cssProperty + ":" + prefixedVal + ";";
          supported = (typeof element.style[propertyName] == "string" && element.style[propertyName] !== "");
        };
        if(supported){

          return prefixedVal;
        };
      };
      return null;
    }
  },
  defer : function(statics){

    if(window.CSS && window.CSS.supports){

      qx.bom.Style.__supports = window.CSS.supports.bind(window.CSS);
    } else if(window.supportsCSS){

      qx.bom.Style.__supports = window.supportsCSS.bind(window);
    };
  }
});
qx.Bootstrap.define("qx.bom.client.OperatingSystem", {
  statics : {
    getName : function(){

      if(!navigator){

        return "";
      };
      var input = navigator.platform || "";
      var agent = navigator.userAgent || "";
      if(input.indexOf("Windows") != -1 || input.indexOf("Win32") != -1 || input.indexOf("Win64") != -1 || agent.indexOf("Windows Phone") != -1){

        return "win";
      } else if(input.indexOf("Macintosh") != -1 || input.indexOf("MacPPC") != -1 || input.indexOf("MacIntel") != -1 || input.indexOf("Mac OS X") != -1){

        return "osx";
      } else if(agent.indexOf("RIM Tablet OS") != -1){

        return "rim_tabletos";
      } else if(agent.indexOf("webOS") != -1){

        return "webos";
      } else if(input.indexOf("iPod") != -1 || input.indexOf("iPhone") != -1 || input.indexOf("iPad") != -1){

        return "ios";
      } else if(agent.indexOf("Android") != -1){

        return "android";
      } else if(input.indexOf("Linux") != -1){

        return "linux";
      } else if(input.indexOf("X11") != -1 || input.indexOf("BSD") != -1 || input.indexOf("Darwin") != -1){

        return "unix";
      } else if(input.indexOf("SymbianOS") != -1){

        return "symbian";
      } else if(input.indexOf("BlackBerry") != -1){

        return "blackberry";
      };;;;;;;;;
      return "";
    },
    __ids : {
      "Windows NT 10.0" : "10",
      "Windows NT 6.3" : "8.1",
      "Windows NT 6.2" : "8",
      "Windows NT 6.1" : "7",
      "Windows NT 6.0" : "vista",
      "Windows NT 5.2" : "2003",
      "Windows NT 5.1" : "xp",
      "Windows NT 5.0" : "2000",
      "Windows 2000" : "2000",
      "Windows NT 4.0" : "nt4",
      "Win 9x 4.90" : "me",
      "Windows CE" : "ce",
      "Windows 98" : "98",
      "Win98" : "98",
      "Windows 95" : "95",
      "Win95" : "95",
      "Mac OS X 10_12" : "10.12",
      "Mac OS X 10.12" : "10.12",
      "Mac OS X 10_11" : "10.11",
      "Mac OS X 10.11" : "10.11",
      "Mac OS X 10_10" : "10.10",
      "Mac OS X 10.10" : "10.10",
      "Mac OS X 10_9" : "10.9",
      "Mac OS X 10.9" : "10.9",
      "Mac OS X 10_8" : "10.8",
      "Mac OS X 10.8" : "10.8",
      "Mac OS X 10_7" : "10.7",
      "Mac OS X 10.7" : "10.7",
      "Mac OS X 10_6" : "10.6",
      "Mac OS X 10.6" : "10.6",
      "Mac OS X 10_5" : "10.5",
      "Mac OS X 10.5" : "10.5",
      "Mac OS X 10_4" : "10.4",
      "Mac OS X 10.4" : "10.4",
      "Mac OS X 10_3" : "10.3",
      "Mac OS X 10.3" : "10.3",
      "Mac OS X 10_2" : "10.2",
      "Mac OS X 10.2" : "10.2",
      "Mac OS X 10_1" : "10.1",
      "Mac OS X 10.1" : "10.1",
      "Mac OS X 10_0" : "10.0",
      "Mac OS X 10.0" : "10.0"
    },
    getVersion : function(){

      var version = qx.bom.client.OperatingSystem.__getVersionForDesktopOs(navigator.userAgent);
      if(version == null){

        version = qx.bom.client.OperatingSystem.__getVersionForMobileOs(navigator.userAgent);
      };
      if(version != null){

        return version;
      } else {

        return "";
      };
    },
    __getVersionForDesktopOs : function(userAgent){

      var str = [];
      for(var key in qx.bom.client.OperatingSystem.__ids){

        str.push(key);
      };
      var reg = new RegExp("(" + str.join("|").replace(/\./g, "\.") + ")", "g");
      var match = reg.exec(userAgent);
      if(match && match[1]){

        return qx.bom.client.OperatingSystem.__ids[match[1]];
      };
      return null;
    },
    __getVersionForMobileOs : function(userAgent){

      var windows = userAgent.indexOf("Windows Phone") != -1;
      var android = userAgent.indexOf("Android") != -1;
      var iOs = userAgent.match(/(iPad|iPhone|iPod)/i) ? true : false;
      if(windows){

        var windowsVersionRegExp = new RegExp(/Windows Phone (\d+(?:\.\d+)+)/i);
        var windowsMatch = windowsVersionRegExp.exec(userAgent);
        if(windowsMatch && windowsMatch[1]){

          return windowsMatch[1];
        };
      } else if(android){

        var androidVersionRegExp = new RegExp(/ Android (\d+(?:\.\d+)+)/i);
        var androidMatch = androidVersionRegExp.exec(userAgent);
        if(androidMatch && androidMatch[1]){

          return androidMatch[1];
        };
      } else if(iOs){

        var iOsVersionRegExp = new RegExp(/(CPU|iPhone|iPod) OS (\d+)_(\d+)(?:_(\d+))*\s+/);
        var iOsMatch = iOsVersionRegExp.exec(userAgent);
        if(iOsMatch && iOsMatch[2] && iOsMatch[3]){

          if(iOsMatch[4]){

            return iOsMatch[2] + "." + iOsMatch[3] + "." + iOsMatch[4];
          } else {

            return iOsMatch[2] + "." + iOsMatch[3];
          };
        };
      };;
      return null;
    }
  },
  defer : function(statics){

    qx.core.Environment.add("os.name", statics.getName);
    qx.core.Environment.add("os.version", statics.getVersion);
  }
});
qx.Bootstrap.define("qx.bom.client.Browser", {
  statics : {
    getName : function(){

      var agent = navigator.userAgent;
      var reg = new RegExp("(" + qx.bom.client.Browser.__agents + ")(/|)?([0-9]+\.[0-9])?");
      var match = agent.match(reg);
      if(!match){

        return "";
      };
      var name = match[1].toLowerCase();
      var engine = qx.bom.client.Engine.getName();
      if(engine === "webkit"){

        if(agent.match(/Edge\/\d+\.\d+/)){

          name = "edge";
        } else if(name === "android"){

          name = "mobile chrome";
        } else if(agent.indexOf("Mobile Safari") !== -1 || agent.indexOf("Mobile/") !== -1){

          name = "mobile safari";
        } else if(agent.indexOf(" OPR/") != -1){

          name = "opera";
        };;;
      } else if(engine === "mshtml"){

        if(name === "msie" || name === "trident"){

          name = "ie";
          if(qx.bom.client.OperatingSystem.getVersion() === "ce"){

            name = "iemobile";
          };
          var reg = new RegExp("IEMobile");
          if(agent.match(reg)){

            name = "iemobile";
          };
        };
      } else if(engine === "opera"){

        if(name === "opera mobi"){

          name = "operamobile";
        } else if(name === "opera mini"){

          name = "operamini";
        };
      } else if(engine === "gecko"){

        if(agent.indexOf("Maple") !== -1){

          name = "maple";
        };
      };;;
      return name;
    },
    getVersion : function(){

      var agent = navigator.userAgent;
      var reg = new RegExp("(" + qx.bom.client.Browser.__agents + ")(/| )([0-9]+\.[0-9])");
      var match = agent.match(reg);
      if(!match){

        return "";
      };
      var name = match[1].toLowerCase();
      var version = match[3];
      if(agent.match(/Version(\/| )([0-9]+\.[0-9])/)){

        version = RegExp.$2;
      };
      if(qx.bom.client.Engine.getName() == "mshtml"){

        version = qx.bom.client.Engine.getVersion();
        if(name === "msie" && qx.bom.client.OperatingSystem.getVersion() == "ce"){

          version = "5.0";
        };
      };
      if(qx.bom.client.Browser.getName() == "maple"){

        reg = new RegExp("(Maple )([0-9]+\.[0-9]+\.[0-9]*)");
        match = agent.match(reg);
        if(!match){

          return "";
        };
        version = match[2];
      };
      if(qx.bom.client.Engine.getName() == "webkit" || qx.bom.client.Browser.getName() == "opera"){

        if(agent.match(/OPR(\/| )([0-9]+\.[0-9])/)){

          version = RegExp.$2;
        };
        if(agent.match(/Edge\/([\d+\.*]+)/)){

          version = RegExp.$1;
        };
      };
      return version;
    },
    getDocumentMode : function(){

      if(document.documentMode){

        return document.documentMode;
      };
      return 0;
    },
    getQuirksMode : function(){

      if(qx.bom.client.Engine.getName() == "mshtml" && parseFloat(qx.bom.client.Engine.getVersion()) >= 8){

        return qx.bom.client.Engine.DOCUMENT_MODE === 5;
      } else {

        return document.compatMode !== "CSS1Compat";
      };
    },
    __agents : {
      "webkit" : "AdobeAIR|Titanium|Fluid|Chrome|Android|Epiphany|Konqueror|iCab|iPad|iPhone|OmniWeb|Maxthon|Pre|PhantomJS|Mobile Safari|Safari",
      "gecko" : "prism|Fennec|Camino|Kmeleon|Galeon|Netscape|SeaMonkey|Namoroka|Firefox",
      "mshtml" : "IEMobile|Maxthon|MSIE|Trident",
      "opera" : "Opera Mini|Opera Mobi|Opera"
    }[qx.bom.client.Engine.getName()]
  },
  defer : function(statics){

    qx.core.Environment.add("browser.name", statics.getName);
    qx.core.Environment.add("browser.version", statics.getVersion);
    qx.core.Environment.add("browser.documentmode", statics.getDocumentMode);
    qx.core.Environment.add("browser.quirksmode", statics.getQuirksMode);
  }
});
qx.Bootstrap.define("qx.bom.client.CssTransition", {
  statics : {
    getTransitionName : function(){

      return qx.bom.Style.getPropertyName("transition");
    },
    getSupport : function(){

      var name = qx.bom.client.CssTransition.getTransitionName();
      if(!name){

        return null;
      };
      var eventName = qx.bom.Event.getEventName(window, "transitionEnd");
      eventName = eventName == "transitionEnd" ? eventName.toLowerCase() : eventName;
      if(!eventName){

        eventName = name + (name.indexOf("Trans") > 0 ? "E" : "e") + "nd";
      };
      return {
        name : name,
        "end-event" : eventName
      };
    }
  },
  defer : function(statics){

    qx.core.Environment.add("css.transition", statics.getSupport);
  }
});
qx.Class.define("qx.event.Manager", {
  extend : Object,
  construct : function(win, registration){

    this.__window = win;
    this.__windowId = qx.core.ObjectRegistry.toHashCode(win);
    this.__registration = registration;
    if(win.qx !== qx){

      var self = this;
      var method = function(){

        qx.bom.Event.removeNativeListener(win, "unload", arguments.callee);
        self.dispose();
      };
      if(qx.core.Environment.get("qx.globalErrorHandling")){

        qx.bom.Event.addNativeListener(win, "unload", qx.event.GlobalError.observeMethod(method));
      } else {

        qx.bom.Event.addNativeListener(win, "unload", method);
      };
    };
    this.__listeners = {
    };
    this.__handlers = {
    };
    this.__dispatchers = {
    };
    this.__handlerCache = {
    };
  },
  statics : {
    __lastUnique : 0,
    getNextUniqueId : function(){

      return (this.__lastUnique++) + "";
    }
  },
  members : {
    __registration : null,
    __listeners : null,
    __dispatchers : null,
    __disposeWrapper : null,
    __handlers : null,
    __handlerCache : null,
    __window : null,
    __windowId : null,
    getWindow : function(){

      return this.__window;
    },
    getWindowId : function(){

      return this.__windowId;
    },
    getHandler : function(clazz){

      var handler = this.__handlers[clazz.classname];
      if(handler){

        return handler;
      };
      return this.__handlers[clazz.classname] = new clazz(this);
    },
    getDispatcher : function(clazz){

      var dispatcher = this.__dispatchers[clazz.classname];
      if(dispatcher){

        return dispatcher;
      };
      return this.__dispatchers[clazz.classname] = new clazz(this, this.__registration);
    },
    getListeners : function(target, type, capture){

      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      if(!targetMap){

        return null;
      };
      var entryKey = type + (capture ? "|capture" : "|bubble");
      var entryList = targetMap[entryKey];
      return entryList ? entryList.concat() : null;
    },
    getAllListeners : function(){

      return this.__listeners;
    },
    serializeListeners : function(target){

      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      var result = [];
      if(targetMap){

        var indexOf,type,capture,entryList,entry;
        for(var entryKey in targetMap){

          indexOf = entryKey.indexOf("|");
          type = entryKey.substring(0, indexOf);
          capture = entryKey.charAt(indexOf + 1) == "c";
          entryList = targetMap[entryKey];
          for(var i = 0,l = entryList.length;i < l;i++){

            entry = entryList[i];
            result.push({
              self : entry.context,
              handler : entry.handler,
              type : type,
              capture : capture
            });
          };
        };
      };
      return result;
    },
    toggleAttachedEvents : function(target, enable){

      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      if(targetMap){

        var indexOf,type,capture,entryList;
        for(var entryKey in targetMap){

          indexOf = entryKey.indexOf("|");
          type = entryKey.substring(0, indexOf);
          capture = entryKey.charCodeAt(indexOf + 1) === 99;
          entryList = targetMap[entryKey];
          if(enable){

            this.__registerAtHandler(target, type, capture);
          } else {

            this.__unregisterAtHandler(target, type, capture);
          };
        };
      };
    },
    hasListener : function(target, type, capture){

      if(qx.core.Environment.get("qx.debug")){

        if(target == null){

          qx.log.Logger.trace(this);
          throw new Error("Invalid object: " + target);
        };
      };
      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      if(!targetMap){

        return false;
      };
      var entryKey = type + (capture ? "|capture" : "|bubble");
      var entryList = targetMap[entryKey];
      return !!(entryList && entryList.length > 0);
    },
    importListeners : function(target, list){

      if(qx.core.Environment.get("qx.debug")){

        if(target == null){

          qx.log.Logger.trace(this);
          throw new Error("Invalid object: " + target);
        };
      };
      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey] = {
      };
      var clazz = qx.event.Manager;
      for(var listKey in list){

        var item = list[listKey];
        var entryKey = item.type + (item.capture ? "|capture" : "|bubble");
        var entryList = targetMap[entryKey];
        if(!entryList){

          entryList = targetMap[entryKey] = [];
          this.__registerAtHandler(target, item.type, item.capture);
        };
        entryList.push({
          handler : item.listener,
          context : item.self,
          unique : item.unique || (clazz.__lastUnique++) + ""
        });
      };
    },
    addListener : function(target, type, listener, self, capture){

      if(qx.core.Environment.get("qx.debug")){

        var msg = "Failed to add event listener for type '" + type + "'" + " to the target '" + target.classname + "': ";
        qx.core.Assert.assertObject(target, msg + "Invalid Target.");
        qx.core.Assert.assertString(type, msg + "Invalid event type.");
        qx.core.Assert.assertFunction(listener, msg + "Invalid callback function");
        if(capture !== undefined){

          qx.core.Assert.assertBoolean(capture, "Invalid capture flag.");
        };
      };
      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      if(!targetMap){

        targetMap = this.__listeners[targetKey] = {
        };
      };
      var entryKey = type + (capture ? "|capture" : "|bubble");
      var entryList = targetMap[entryKey];
      if(!entryList){

        entryList = targetMap[entryKey] = [];
      };
      if(entryList.length === 0){

        this.__registerAtHandler(target, type, capture);
      };
      var unique = (qx.event.Manager.__lastUnique++) + "";
      var entry = {
        handler : listener,
        context : self,
        unique : unique
      };
      entryList.push(entry);
      return entryKey + "|" + unique;
    },
    findHandler : function(target, type){

      var isDomNode = false,isWindow = false,isObject = false,isDocument = false;
      var key;
      if(target.nodeType === 1){

        isDomNode = true;
        key = "DOM_" + target.tagName.toLowerCase() + "_" + type;
      } else if(target.nodeType === 9){

        isDocument = true;
        key = "DOCUMENT_" + type;
      } else if(target == this.__window){

        isWindow = true;
        key = "WIN_" + type;
      } else if(target.classname){

        isObject = true;
        key = "QX_" + target.classname + "_" + type;
      } else {

        key = "UNKNOWN_" + target + "_" + type;
      };;;
      var cache = this.__handlerCache;
      if(cache[key]){

        return cache[key];
      };
      var classes = this.__registration.getHandlers();
      var IEventHandler = qx.event.IEventHandler;
      var clazz,instance,supportedTypes,targetCheck;
      for(var i = 0,l = classes.length;i < l;i++){

        clazz = classes[i];
        supportedTypes = clazz.SUPPORTED_TYPES;
        if(supportedTypes && !supportedTypes[type]){

          continue;
        };
        targetCheck = clazz.TARGET_CHECK;
        if(targetCheck){

          var found = false;
          if(isDomNode && ((targetCheck & IEventHandler.TARGET_DOMNODE) != 0)){

            found = true;
          } else if(isWindow && ((targetCheck & IEventHandler.TARGET_WINDOW) != 0)){

            found = true;
          } else if(isObject && ((targetCheck & IEventHandler.TARGET_OBJECT) != 0)){

            found = true;
          } else if(isDocument && ((targetCheck & IEventHandler.TARGET_DOCUMENT) != 0)){

            found = true;
          };;;
          if(!found){

            continue;
          };
        };
        instance = this.getHandler(classes[i]);
        if(clazz.IGNORE_CAN_HANDLE || instance.canHandleEvent(target, type)){

          cache[key] = instance;
          return instance;
        };
      };
      return null;
    },
    __registerAtHandler : function(target, type, capture){

      var handler = this.findHandler(target, type);
      if(handler){

        handler.registerEvent(target, type, capture);
        return;
      };
      if(qx.core.Environment.get("qx.debug")){

        qx.log.Logger.warn(this, "There is no event handler for the event '" + type + "' on target '" + target + "'!");
      };
    },
    removeListener : function(target, type, listener, self, capture){

      if(qx.core.Environment.get("qx.debug")){

        var msg = "Failed to remove event listener for type '" + type + "'" + " from the target '" + target.classname + "': ";
        qx.core.Assert.assertObject(target, msg + "Invalid Target.");
        qx.core.Assert.assertString(type, msg + "Invalid event type.");
        qx.core.Assert.assertFunction(listener, msg + "Invalid callback function");
        if(self !== undefined){

          qx.core.Assert.assertObject(self, "Invalid context for callback.");
        };
        if(capture !== undefined){

          qx.core.Assert.assertBoolean(capture, "Invalid capture flag.");
        };
      };
      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      if(!targetMap){

        return false;
      };
      var entryKey = type + (capture ? "|capture" : "|bubble");
      var entryList = targetMap[entryKey];
      if(!entryList){

        return false;
      };
      var entry;
      for(var i = 0,l = entryList.length;i < l;i++){

        entry = entryList[i];
        if(entry.handler === listener && entry.context === self){

          qx.lang.Array.removeAt(entryList, i);
          if(entryList.length == 0){

            this.__unregisterAtHandler(target, type, capture);
          };
          return true;
        };
      };
      return false;
    },
    removeListenerById : function(target, id){

      if(qx.core.Environment.get("qx.debug")){

        var msg = "Failed to remove event listener for id '" + id + "'" + " from the target '" + target.classname + "': ";
        qx.core.Assert.assertObject(target, msg + "Invalid Target.");
        qx.core.Assert.assertString(id, msg + "Invalid id type.");
      };
      var split = id.split("|");
      var type = split[0];
      var capture = split[1].charCodeAt(0) == 99;
      var unique = split[2];
      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      if(!targetMap){

        return false;
      };
      var entryKey = type + (capture ? "|capture" : "|bubble");
      var entryList = targetMap[entryKey];
      if(!entryList){

        return false;
      };
      var entry;
      for(var i = 0,l = entryList.length;i < l;i++){

        entry = entryList[i];
        if(entry.unique === unique){

          qx.lang.Array.removeAt(entryList, i);
          if(entryList.length == 0){

            this.__unregisterAtHandler(target, type, capture);
          };
          return true;
        };
      };
      return false;
    },
    removeAllListeners : function(target){

      var targetKey = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var targetMap = this.__listeners[targetKey];
      if(!targetMap){

        return false;
      };
      var split,type,capture;
      for(var entryKey in targetMap){

        if(targetMap[entryKey].length > 0){

          split = entryKey.split("|");
          type = split[0];
          capture = split[1] === "capture";
          this.__unregisterAtHandler(target, type, capture);
        };
      };
      delete this.__listeners[targetKey];
      return true;
    },
    deleteAllListeners : function(targetKey){

      delete this.__listeners[targetKey];
    },
    __unregisterAtHandler : function(target, type, capture){

      var handler = this.findHandler(target, type);
      if(handler){

        handler.unregisterEvent(target, type, capture);
        return;
      };
      if(qx.core.Environment.get("qx.debug")){

        qx.log.Logger.warn(this, "There is no event handler for the event '" + type + "' on target '" + target + "'!");
      };
    },
    dispatchEvent : function(target, event){

      if(qx.core.Environment.get("qx.debug")){

        var msg = "Could not dispatch event '" + event + "' on target '" + target.classname + "': ";
        qx.core.Assert.assertNotUndefined(target, msg + "Invalid event target.");
        qx.core.Assert.assertNotNull(target, msg + "Invalid event target.");
        qx.core.Assert.assertInstance(event, qx.event.type.Event, msg + "Invalid event object.");
      };
      var type = event.getType();
      if(!event.getBubbles() && !this.hasListener(target, type)){

        qx.event.Pool.getInstance().poolObject(event);
        return true;
      };
      if(!event.getTarget()){

        event.setTarget(target);
      };
      var classes = this.__registration.getDispatchers();
      var instance;
      var dispatched = false;
      for(var i = 0,l = classes.length;i < l;i++){

        instance = this.getDispatcher(classes[i]);
        if(instance.canDispatchEvent(target, event, type)){

          instance.dispatchEvent(target, event, type);
          dispatched = true;
          break;
        };
      };
      if(!dispatched){

        if(qx.core.Environment.get("qx.debug")){

          qx.log.Logger.error(this, "No dispatcher can handle event of type " + type + " on " + target);
        };
        return true;
      };
      var preventDefault = event.getDefaultPrevented();
      qx.event.Pool.getInstance().poolObject(event);
      return !preventDefault;
    },
    dispose : function(){

      this.__registration.removeManager(this);
      qx.util.DisposeUtil.disposeMap(this, "__handlers");
      qx.util.DisposeUtil.disposeMap(this, "__dispatchers");
      this.__listeners = this.__window = this.__disposeWrapper = null;
      this.__registration = this.__handlerCache = null;
    }
  }
});
qx.Interface.define("qx.event.IEventHandler", {
  statics : {
    TARGET_DOMNODE : 1,
    TARGET_WINDOW : 2,
    TARGET_OBJECT : 4,
    TARGET_DOCUMENT : 8
  },
  members : {
    canHandleEvent : function(target, type){
    },
    registerEvent : function(target, type, capture){
    },
    unregisterEvent : function(target, type, capture){
    }
  }
});
qx.Class.define("qx.event.Registration", {
  statics : {
    __managers : {
    },
    getManager : function(target){

      if(target == null){

        if(qx.core.Environment.get("qx.debug")){

          qx.log.Logger.error("qx.event.Registration.getManager(null) was called!");
          qx.log.Logger.trace(this);
        };
        target = window;
      } else if(target.nodeType){

        target = qx.dom.Node.getWindow(target);
      } else if(!qx.dom.Node.isWindow(target)){

        target = window;
      };;
      var hash = target.$$hash || qx.core.ObjectRegistry.toHashCode(target);
      var manager = this.__managers[hash];
      if(!manager){

        manager = new qx.event.Manager(target, this);
        this.__managers[hash] = manager;
      };
      return manager;
    },
    removeManager : function(mgr){

      var id = mgr.getWindowId();
      delete this.__managers[id];
    },
    addListener : function(target, type, listener, self, capture){

      return this.getManager(target).addListener(target, type, listener, self, capture);
    },
    removeListener : function(target, type, listener, self, capture){

      return this.getManager(target).removeListener(target, type, listener, self, capture);
    },
    removeListenerById : function(target, id){

      return this.getManager(target).removeListenerById(target, id);
    },
    removeAllListeners : function(target){

      return this.getManager(target).removeAllListeners(target);
    },
    deleteAllListeners : function(target){

      var targetKey = target.$$hash;
      if(targetKey){

        this.getManager(target).deleteAllListeners(targetKey);
      };
    },
    hasListener : function(target, type, capture){

      return this.getManager(target).hasListener(target, type, capture);
    },
    serializeListeners : function(target){

      return this.getManager(target).serializeListeners(target);
    },
    createEvent : function(type, clazz, args){

      if(qx.core.Environment.get("qx.debug")){

        if(arguments.length > 1 && clazz === undefined){

          throw new Error("Create event of type " + type + " with undefined class. Please use null to explicit fallback to default event type!");
        };
      };
      if(clazz == null){

        clazz = qx.event.type.Event;
      };
      var obj = qx.event.Pool.getInstance().getObject(clazz);
      args ? obj.init.apply(obj, args) : obj.init();
      if(type){

        obj.setType(type);
      };
      return obj;
    },
    dispatchEvent : function(target, event){

      return this.getManager(target).dispatchEvent(target, event);
    },
    fireEvent : function(target, type, clazz, args){

      if(qx.core.Environment.get("qx.debug")){

        if(arguments.length > 2 && clazz === undefined && args !== undefined){

          throw new Error("Create event of type " + type + " with undefined class. Please use null to explicit fallback to default event type!");
        };
        var msg = "Could not fire event '" + type + "' on target '" + (target ? target.classname : "undefined") + "': ";
        qx.core.Assert.assertNotUndefined(target, msg + "Invalid event target.");
        qx.core.Assert.assertNotNull(target, msg + "Invalid event target.");
      };
      var evt = this.createEvent(type, clazz || null, args);
      return this.getManager(target).dispatchEvent(target, evt);
    },
    fireNonBubblingEvent : function(target, type, clazz, args){

      if(qx.core.Environment.get("qx.debug")){

        if(arguments.length > 2 && clazz === undefined && args !== undefined){

          throw new Error("Create event of type " + type + " with undefined class. Please use null to explicit fallback to default event type!");
        };
      };
      var mgr = this.getManager(target);
      if(!mgr.hasListener(target, type, false)){

        return true;
      };
      var evt = this.createEvent(type, clazz || null, args);
      return mgr.dispatchEvent(target, evt);
    },
    PRIORITY_FIRST : -32000,
    PRIORITY_NORMAL : 0,
    PRIORITY_LAST : 32000,
    __handlers : [],
    addHandler : function(handler){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertInterface(handler, qx.event.IEventHandler, "Invalid event handler.");
      };
      this.__handlers.push(handler);
      this.__handlers.sort(function(a, b){

        return a.PRIORITY - b.PRIORITY;
      });
    },
    getHandlers : function(){

      return this.__handlers;
    },
    __dispatchers : [],
    addDispatcher : function(dispatcher, priority){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertInterface(dispatcher, qx.event.IEventDispatcher, "Invalid event dispatcher!");
      };
      this.__dispatchers.push(dispatcher);
      this.__dispatchers.sort(function(a, b){

        return a.PRIORITY - b.PRIORITY;
      });
    },
    getDispatchers : function(){

      return this.__dispatchers;
    }
  }
});
qx.Mixin.define("qx.core.MEvent", {
  members : {
    __Registration : qx.event.Registration,
    addListener : function(type, listener, self, capture){

      if(!this.$$disposed){

        return this.__Registration.addListener(this, type, listener, self, capture);
      };
      return null;
    },
    addListenerOnce : function(type, listener, self, capture){

      var callback = function(e){

        this.removeListener(type, listener, this, capture);
        listener.call(self || this, e);
      };
      if(!listener.$$wrapped_callback){

        listener.$$wrapped_callback = {
        };
      };
      listener.$$wrapped_callback[type + this.$$hash] = callback;
      return this.addListener(type, callback, this, capture);
    },
    removeListener : function(type, listener, self, capture){

      if(!this.$$disposed){

        if(listener.$$wrapped_callback && listener.$$wrapped_callback[type + this.$$hash]){

          var callback = listener.$$wrapped_callback[type + this.$$hash];
          delete listener.$$wrapped_callback[type + this.$$hash];
          listener = callback;
        };
        return this.__Registration.removeListener(this, type, listener, self, capture);
      };
      return false;
    },
    removeListenerById : function(id){

      if(!this.$$disposed){

        return this.__Registration.removeListenerById(this, id);
      };
      return false;
    },
    hasListener : function(type, capture){

      return this.__Registration.hasListener(this, type, capture);
    },
    dispatchEvent : function(evt){

      if(!this.$$disposed){

        return this.__Registration.dispatchEvent(this, evt);
      };
      return true;
    },
    fireEvent : function(type, clazz, args){

      if(!this.$$disposed){

        return this.__Registration.fireEvent(this, type, clazz, args);
      };
      return true;
    },
    fireNonBubblingEvent : function(type, clazz, args){

      if(!this.$$disposed){

        return this.__Registration.fireNonBubblingEvent(this, type, clazz, args);
      };
      return true;
    },
    fireDataEvent : function(type, data, oldData, cancelable){

      if(!this.$$disposed){

        if(oldData === undefined){

          oldData = null;
        };
        return this.__Registration.fireNonBubblingEvent(this, type, qx.event.type.Data, [data, oldData, !!cancelable]);
      };
      return true;
    }
  }
});
qx.Interface.define("qx.event.IEventDispatcher", {
  members : {
    canDispatchEvent : function(target, event, type){

      this.assertInstance(event, qx.event.type.Event);
      this.assertString(type);
    },
    dispatchEvent : function(target, event, type){

      this.assertInstance(event, qx.event.type.Event);
      this.assertString(type);
    }
  }
});
qx.Mixin.define("qx.core.MProperty", {
  members : {
    set : function(data, value){

      var setter = qx.core.Property.$$method.set;
      if(qx.Bootstrap.isString(data)){

        if(!this[setter[data]]){

          if(this["set" + qx.Bootstrap.firstUp(data)] != undefined){

            this["set" + qx.Bootstrap.firstUp(data)](value);
            return this;
          };
          throw new Error("No such property: " + data);
        };
        return this[setter[data]](value);
      } else {

        for(var prop in data){

          if(!this[setter[prop]]){

            if(this["set" + qx.Bootstrap.firstUp(prop)] != undefined){

              this["set" + qx.Bootstrap.firstUp(prop)](data[prop]);
              continue;
            };
            throw new Error("No such property: " + prop);
          };
          this[setter[prop]](data[prop]);
        };
        return this;
      };
    },
    get : function(prop){

      var getter = qx.core.Property.$$method.get;
      if(!this[getter[prop]]){

        if(this["get" + qx.Bootstrap.firstUp(prop)] != undefined){

          return this["get" + qx.Bootstrap.firstUp(prop)]();
        };
        throw new Error("No such property: " + prop);
      };
      return this[getter[prop]]();
    },
    reset : function(prop){

      var resetter = qx.core.Property.$$method.reset;
      if(!this[resetter[prop]]){

        if(this["reset" + qx.Bootstrap.firstUp(prop)] != undefined){

          this["reset" + qx.Bootstrap.firstUp(prop)]();
          return;
        };
        throw new Error("No such property: " + prop);
      };
      this[resetter[prop]]();
    }
  }
});
qx.Mixin.define("qx.core.MAssert", {
  members : {
    assert : function(condition, msg){

      qx.core.Assert.assert(condition, msg);
    },
    fail : function(msg, compact){

      qx.core.Assert.fail(msg, compact);
    },
    assertTrue : function(value, msg){

      qx.core.Assert.assertTrue(value, msg);
    },
    assertFalse : function(value, msg){

      qx.core.Assert.assertFalse(value, msg);
    },
    assertEquals : function(expected, found, msg){

      qx.core.Assert.assertEquals(expected, found, msg);
    },
    assertNotEquals : function(expected, found, msg){

      qx.core.Assert.assertNotEquals(expected, found, msg);
    },
    assertIdentical : function(expected, found, msg){

      qx.core.Assert.assertIdentical(expected, found, msg);
    },
    assertNotIdentical : function(expected, found, msg){

      qx.core.Assert.assertNotIdentical(expected, found, msg);
    },
    assertNotUndefined : function(value, msg){

      qx.core.Assert.assertNotUndefined(value, msg);
    },
    assertUndefined : function(value, msg){

      qx.core.Assert.assertUndefined(value, msg);
    },
    assertNotNull : function(value, msg){

      qx.core.Assert.assertNotNull(value, msg);
    },
    assertNull : function(value, msg){

      qx.core.Assert.assertNull(value, msg);
    },
    assertJsonEquals : function(expected, found, msg){

      qx.core.Assert.assertJsonEquals(expected, found, msg);
    },
    assertMatch : function(str, re, msg){

      qx.core.Assert.assertMatch(str, re, msg);
    },
    assertArgumentsCount : function(args, minCount, maxCount, msg){

      qx.core.Assert.assertArgumentsCount(args, minCount, maxCount, msg);
    },
    assertEventFired : function(obj, event, invokeFunc, listener, msg){

      qx.core.Assert.assertEventFired(obj, event, invokeFunc, listener, msg);
    },
    assertEventNotFired : function(obj, event, invokeFunc, msg){

      qx.core.Assert.assertEventNotFired(obj, event, invokeFunc, msg);
    },
    assertException : function(callback, exception, re, msg){

      qx.core.Assert.assertException(callback, exception, re, msg);
    },
    assertInArray : function(value, array, msg){

      qx.core.Assert.assertInArray(value, array, msg);
    },
    assertArrayEquals : function(expected, found, msg){

      qx.core.Assert.assertArrayEquals(expected, found, msg);
    },
    assertKeyInMap : function(value, map, msg){

      qx.core.Assert.assertKeyInMap(value, map, msg);
    },
    assertFunction : function(value, msg){

      qx.core.Assert.assertFunction(value, msg);
    },
    assertString : function(value, msg){

      qx.core.Assert.assertString(value, msg);
    },
    assertBoolean : function(value, msg){

      qx.core.Assert.assertBoolean(value, msg);
    },
    assertNumber : function(value, msg){

      qx.core.Assert.assertNumber(value, msg);
    },
    assertPositiveNumber : function(value, msg){

      qx.core.Assert.assertPositiveNumber(value, msg);
    },
    assertInteger : function(value, msg){

      qx.core.Assert.assertInteger(value, msg);
    },
    assertPositiveInteger : function(value, msg){

      qx.core.Assert.assertPositiveInteger(value, msg);
    },
    assertInRange : function(value, min, max, msg){

      qx.core.Assert.assertInRange(value, min, max, msg);
    },
    assertObject : function(value, msg){

      qx.core.Assert.assertObject(value, msg);
    },
    assertArray : function(value, msg){

      qx.core.Assert.assertArray(value, msg);
    },
    assertMap : function(value, msg){

      qx.core.Assert.assertMap(value, msg);
    },
    assertRegExp : function(value, msg){

      qx.core.Assert.assertRegExp(value, msg);
    },
    assertType : function(value, type, msg){

      qx.core.Assert.assertType(value, type, msg);
    },
    assertInstance : function(value, clazz, msg){

      qx.core.Assert.assertInstance(value, clazz, msg);
    },
    assertInterface : function(value, iface, msg){

      qx.core.Assert.assertInterface(value, iface, msg);
    },
    assertCssColor : function(expected, value, msg){

      qx.core.Assert.assertCssColor(expected, value, msg);
    },
    assertElement : function(value, msg){

      qx.core.Assert.assertElement(value, msg);
    },
    assertQxObject : function(value, msg){

      qx.core.Assert.assertQxObject(value, msg);
    },
    assertQxWidget : function(value, msg){

      qx.core.Assert.assertQxWidget(value, msg);
    }
  }
});
qx.Class.define("qx.core.Object", {
  extend : Object,
  include : qx.core.Environment.filter({
    "module.databinding" : qx.data.MBinding,
    "module.logger" : qx.core.MLogging,
    "module.events" : qx.core.MEvent,
    "module.property" : qx.core.MProperty,
    "qx.debug" : qx.core.MAssert
  }),
  construct : function(){

    qx.core.ObjectRegistry.register(this);
  },
  statics : {
    $$type : "Object"
  },
  members : {
    __Property : qx.core.Environment.get("module.property") ? qx.core.Property : null,
    toHashCode : function(){

      return this.$$hash;
    },
    toString : function(){

      return this.classname + "[" + this.$$hash + "]";
    },
    base : function(args, varargs){

      if(qx.core.Environment.get("qx.debug")){

        if(!qx.Bootstrap.isFunction(args.callee.base)){

          throw new Error("Cannot call super class. Method is not derived: " + args.callee.displayName);
        };
      };
      if(arguments.length === 1){

        return args.callee.base.call(this);
      } else {

        return args.callee.base.apply(this, Array.prototype.slice.call(arguments, 1));
      };
    },
    self : function(args){

      return args.callee.self;
    },
    clone : function(){

      if(!qx.core.Environment.get("module.property")){

        throw new Error("Cloning only possible with properties.");
      };
      var clazz = this.constructor;
      var clone = new clazz;
      var props = qx.Class.getProperties(clazz);
      var user = this.__Property.$$store.user;
      var setter = this.__Property.$$method.set;
      var name;
      for(var i = 0,l = props.length;i < l;i++){

        name = props[i];
        if(this.hasOwnProperty(user[name])){

          clone[setter[name]](this[user[name]]);
        };
      };
      return clone;
    },
    __userData : null,
    setUserData : function(key, value){

      if(!this.__userData){

        this.__userData = {
        };
      };
      this.__userData[key] = value;
    },
    getUserData : function(key){

      if(!this.__userData){

        return null;
      };
      var data = this.__userData[key];
      return data === undefined ? null : data;
    },
    isDisposed : function(){

      return this.$$disposed || false;
    },
    dispose : function(){

      if(this.$$disposed){

        return;
      };
      this.$$disposed = true;
      this.$$instance = null;
      this.$$allowconstruct = null;
      if(qx.core.Environment.get("qx.debug")){

        if(qx.core.Environment.get("qx.debug.dispose.level") > 2){

          qx.Bootstrap.debug(this, "Disposing " + this.classname + "[" + this.toHashCode() + "]");
        };
      };
      var clazz = this.constructor;
      var mixins;
      while(clazz.superclass){

        if(clazz.$$destructor){

          clazz.$$destructor.call(this);
        };
        if(clazz.$$includes){

          mixins = clazz.$$flatIncludes;
          for(var i = 0,l = mixins.length;i < l;i++){

            if(mixins[i].$$destructor){

              mixins[i].$$destructor.call(this);
            };
          };
        };
        clazz = clazz.superclass;
      };
      if(qx.core.Environment.get("qx.debug")){

        if(qx.core.Environment.get("qx.debug.dispose.level") > 0){

          var key,value;
          for(key in this){

            value = this[key];
            if(value !== null && typeof value === "object" && !(qx.Bootstrap.isString(value))){

              if(this.constructor.prototype[key] != null){

                continue;
              };
              if(qx.core.Environment.get("qx.debug.dispose.level") > 1){

                qx.Bootstrap.warn(this, "Missing destruct definition for '" + key + "' in " + this.classname + "[" + this.toHashCode() + "]: " + value);
                delete this[key];
              };
            };
          };
        };
      };
    },
    _disposeObjects : function(varargs){

      qx.util.DisposeUtil.disposeObjects(this, arguments);
    },
    _disposeSingletonObjects : function(varargs){

      qx.util.DisposeUtil.disposeObjects(this, arguments, true);
    },
    _disposeArray : function(field){

      qx.util.DisposeUtil.disposeArray(this, field);
    },
    _disposeMap : function(field){

      qx.util.DisposeUtil.disposeMap(this, field);
    }
  },
  environment : {
    "qx.debug.dispose.level" : 0
  },
  destruct : function(){

    if(qx.core.Environment.get("module.events")){

      if(!qx.core.ObjectRegistry.inShutDown){

        qx.event.Registration.removeAllListeners(this);
      } else {

        qx.event.Registration.deleteAllListeners(this);
      };
    };
    qx.core.ObjectRegistry.unregister(this);
    this.__userData = null;
    if(qx.core.Environment.get("module.property")){

      var clazz = this.constructor;
      var properties;
      var store = this.__Property.$$store;
      var storeUser = store.user;
      var storeTheme = store.theme;
      var storeInherit = store.inherit;
      var storeUseinit = store.useinit;
      var storeInit = store.init;
      while(clazz){

        properties = clazz.$$properties;
        if(properties){

          for(var name in properties){

            if(properties[name].dereference){

              this[storeUser[name]] = this[storeTheme[name]] = this[storeInherit[name]] = this[storeUseinit[name]] = this[storeInit[name]] = undefined;
            };
          };
        };
        clazz = clazz.superclass;
      };
    };
  }
});
qx.Class.define("qx.util.DisposeUtil", {
  statics : {
    disposeObjects : function(obj, arr, disposeSingletons){

      var name;
      for(var i = 0,l = arr.length;i < l;i++){

        name = arr[i];
        if(obj[name] == null || !obj.hasOwnProperty(name)){

          continue;
        };
        if(!qx.core.ObjectRegistry.inShutDown){

          if(obj[name].dispose){

            if(!disposeSingletons && obj[name].constructor.$$instance){

              throw new Error("The object stored in key " + name + " is a singleton! Please use disposeSingleton instead.");
            } else {

              obj[name].dispose();
            };
          } else {

            throw new Error("Has no disposable object under key: " + name + "!");
          };
        };
        obj[name] = null;
      };
    },
    disposeArray : function(obj, field){

      var data = obj[field];
      if(!data){

        return;
      };
      if(qx.core.ObjectRegistry.inShutDown){

        obj[field] = null;
        return;
      };
      try{

        var entry;
        for(var i = data.length - 1;i >= 0;i--){

          entry = data[i];
          if(entry){

            entry.dispose();
          };
        };
      } catch(ex) {

        throw new Error("The array field: " + field + " of object: " + obj + " has non disposable entries: " + ex);
      };
      data.length = 0;
      obj[field] = null;
    },
    disposeMap : function(obj, field){

      var data = obj[field];
      if(!data){

        return;
      };
      if(qx.core.ObjectRegistry.inShutDown){

        obj[field] = null;
        return;
      };
      try{

        var entry;
        for(var key in data){

          entry = data[key];
          if(data.hasOwnProperty(key) && entry){

            entry.dispose();
          };
        };
      } catch(ex) {

        throw new Error("The map field: " + field + " of object: " + obj + " has non disposable entries: " + ex);
      };
      obj[field] = null;
    },
    disposeTriggeredBy : function(disposeMe, trigger){

      var triggerDispose = trigger.dispose;
      trigger.dispose = function(){

        triggerDispose.call(trigger);
        disposeMe.dispose();
      };
    },
    destroyContainer : function(container){

      if(qx.core.Environment.get("qx.debug")){

        if(qx.ui.mobile && container instanceof qx.ui.mobile.core.Widget){

          qx.core.Assert.assertTrue(this.__isChildrenContainer(container), "Container must be an instance of qx.ui.mobile.container.Composite.");
        } else {

          qx.core.Assert.assertQxWidget(container, "First argument must be a container widget!");
          qx.core.Assert.assertTrue(this.__isChildrenContainer(container), "Container must be an instance of qx.ui.container.Composite or " + "qx.ui.container.Scroll or qx.ui.container.Resizer or " + "qx.ui.container.SlideBar or qx.ui.container.Stack!");
        };
      };
      var arr = [];
      this._collectContainerChildren(container, arr);
      var len = arr.length;
      for(var i = len - 1;i >= 0;i--){

        arr[i].destroy();
      };
      container.destroy();
    },
    _collectContainerChildren : function(container, arr){

      var children = container.getChildren();
      for(var i = 0;i < children.length;i++){

        var item = children[i];
        arr.push(item);
        if(this.__isChildrenContainer(item)){

          this._collectContainerChildren(item, arr);
        };
      };
    },
    __isChildrenContainer : function(obj){

      var classes = [];
      if(qx.ui.mobile && obj instanceof qx.ui.mobile.core.Widget){

        classes = [qx.ui.mobile.container.Composite];
      } else {

        classes = [qx.ui.container.Composite, qx.ui.container.Scroll, qx.ui.container.SlideBar, qx.ui.container.Stack];
      };
      for(var i = 0,l = classes.length;i < l;i++){

        if(typeof classes[i] !== "undefined" && qx.Class.isSubClassOf(obj.constructor, classes[i])){

          return true;
        };
      };
      return false;
    }
  }
});
qx.Class.define("qx.event.type.Event", {
  extend : qx.core.Object,
  statics : {
    CAPTURING_PHASE : 1,
    AT_TARGET : 2,
    BUBBLING_PHASE : 3
  },
  members : {
    init : function(canBubble, cancelable){

      if(qx.core.Environment.get("qx.debug")){

        if(canBubble !== undefined){

          qx.core.Assert.assertBoolean(canBubble, "Invalid argument value 'canBubble'.");
        };
        if(cancelable !== undefined){

          qx.core.Assert.assertBoolean(cancelable, "Invalid argument value 'cancelable'.");
        };
      };
      this._type = null;
      this._target = null;
      this._currentTarget = null;
      this._relatedTarget = null;
      this._originalTarget = null;
      this._stopPropagation = false;
      this._preventDefault = false;
      this._bubbles = !!canBubble;
      this._cancelable = !!cancelable;
      this._timeStamp = (new Date()).getTime();
      this._eventPhase = null;
      return this;
    },
    clone : function(embryo){

      if(embryo){

        var clone = embryo;
      } else {

        var clone = qx.event.Pool.getInstance().getObject(this.constructor);
      };
      clone._type = this._type;
      clone._target = this._target;
      clone._currentTarget = this._currentTarget;
      clone._relatedTarget = this._relatedTarget;
      clone._originalTarget = this._originalTarget;
      clone._stopPropagation = this._stopPropagation;
      clone._bubbles = this._bubbles;
      clone._preventDefault = this._preventDefault;
      clone._cancelable = this._cancelable;
      return clone;
    },
    stop : function(){

      if(this._bubbles){

        this.stopPropagation();
      };
      if(this._cancelable){

        this.preventDefault();
      };
    },
    stopPropagation : function(){

      if(qx.core.Environment.get("qx.debug")){

        this.assertTrue(this._bubbles, "Cannot stop propagation on a non bubbling event: " + this.getType());
      };
      this._stopPropagation = true;
    },
    getPropagationStopped : function(){

      return !!this._stopPropagation;
    },
    preventDefault : function(){

      if(qx.core.Environment.get("qx.debug")){

        this.assertTrue(this._cancelable, "Cannot prevent default action on a non cancelable event: " + this.getType());
      };
      this._preventDefault = true;
    },
    getDefaultPrevented : function(){

      return !!this._preventDefault;
    },
    getType : function(){

      return this._type;
    },
    setType : function(type){

      this._type = type;
    },
    getEventPhase : function(){

      return this._eventPhase;
    },
    setEventPhase : function(eventPhase){

      this._eventPhase = eventPhase;
    },
    getTimeStamp : function(){

      return this._timeStamp;
    },
    getTarget : function(){

      return this._target;
    },
    setTarget : function(target){

      this._target = target;
    },
    getCurrentTarget : function(){

      return this._currentTarget || this._target;
    },
    setCurrentTarget : function(currentTarget){

      this._currentTarget = currentTarget;
    },
    getRelatedTarget : function(){

      return this._relatedTarget;
    },
    setRelatedTarget : function(relatedTarget){

      this._relatedTarget = relatedTarget;
    },
    getOriginalTarget : function(){

      return this._originalTarget;
    },
    setOriginalTarget : function(originalTarget){

      this._originalTarget = originalTarget;
    },
    getBubbles : function(){

      return this._bubbles;
    },
    setBubbles : function(bubbles){

      this._bubbles = bubbles;
    },
    isCancelable : function(){

      return this._cancelable;
    },
    setCancelable : function(cancelable){

      this._cancelable = cancelable;
    }
  },
  destruct : function(){

    this._target = this._currentTarget = this._relatedTarget = this._originalTarget = null;
  }
});
qx.Class.define("qx.util.ObjectPool", {
  extend : qx.core.Object,
  construct : function(size){

    qx.core.Object.call(this);
    this.__pool = {
    };
    if(size != null){

      this.setSize(size);
    };
  },
  properties : {
    size : {
      check : "Integer",
      init : Infinity
    }
  },
  members : {
    __pool : null,
    getObject : function(clazz){

      if(this.$$disposed){

        return new clazz;
      };
      if(!clazz){

        throw new Error("Class needs to be defined!");
      };
      var obj = null;
      var pool = this.__pool[clazz.classname];
      if(pool){

        obj = pool.pop();
      };
      if(obj){

        obj.$$pooled = false;
      } else {

        obj = new clazz;
      };
      return obj;
    },
    poolObject : function(obj){

      if(!this.__pool){

        return;
      };
      var classname = obj.classname;
      var pool = this.__pool[classname];
      if(obj.$$pooled){

        throw new Error("Object is already pooled: " + obj);
      };
      if(!pool){

        this.__pool[classname] = pool = [];
      };
      if(pool.length > this.getSize()){

        if(obj.destroy){

          obj.destroy();
        } else {

          obj.dispose();
        };
        return;
      };
      obj.$$pooled = true;
      pool.push(obj);
    }
  },
  destruct : function(){

    var pool = this.__pool;
    var classname,list,i,l;
    for(classname in pool){

      list = pool[classname];
      for(i = 0,l = list.length;i < l;i++){

        list[i].dispose();
      };
    };
    delete this.__pool;
  }
});
qx.Class.define("qx.event.Pool", {
  extend : qx.util.ObjectPool,
  type : "singleton",
  construct : function(){

    qx.util.ObjectPool.call(this, 30);
  }
});
qx.Class.define("qx.event.dispatch.Direct", {
  extend : qx.core.Object,
  implement : qx.event.IEventDispatcher,
  construct : function(manager){

    this._manager = manager;
  },
  statics : {
    PRIORITY : qx.event.Registration.PRIORITY_LAST
  },
  members : {
    canDispatchEvent : function(target, event, type){

      return !event.getBubbles();
    },
    dispatchEvent : function(target, event, type){

      if(qx.core.Environment.get("qx.debug")){

        if(target instanceof qx.core.Object){

          var expectedEventClassName = qx.Class.getEventType(target.constructor, type);
          var expectedEventClass = qx.Class.getByName(expectedEventClassName);
          if(!expectedEventClass){

            this.error("The event type '" + type + "' declared in the class '" + target.constructor + " is not an available class': " + expectedEventClassName);
          } else if(!(event instanceof expectedEventClass)){

            this.error("Expected event type to be instanceof '" + expectedEventClassName + "' but found '" + event.classname + "'");
          };
        };
      };
      event.setEventPhase(qx.event.type.Event.AT_TARGET);
      var listeners = this._manager.getListeners(target, type, false);
      if(listeners){

        for(var i = 0,l = listeners.length;i < l;i++){

          var context = listeners[i].context || target;
          if(qx.core.Environment.get("qx.debug")){

            if(context && context.isDisposed && context.isDisposed()){

              this.warn("The context object '" + context + "' for the event '" + type + "' of '" + target + "'is already disposed.");
            };
          };
          listeners[i].handler.call(context, event);
        };
      };
    }
  },
  defer : function(statics){

    qx.event.Registration.addDispatcher(statics);
  }
});
qx.Class.define("qx.event.handler.Object", {
  extend : qx.core.Object,
  implement : qx.event.IEventHandler,
  statics : {
    PRIORITY : qx.event.Registration.PRIORITY_LAST,
    SUPPORTED_TYPES : null,
    TARGET_CHECK : qx.event.IEventHandler.TARGET_OBJECT,
    IGNORE_CAN_HANDLE : false
  },
  members : {
    canHandleEvent : function(target, type){

      return qx.Class.supportsEvent(target.constructor, type);
    },
    registerEvent : function(target, type, capture){
    },
    unregisterEvent : function(target, type, capture){
    }
  },
  defer : function(statics){

    qx.event.Registration.addHandler(statics);
  }
});
qx.Class.define("qx.event.type.Data", {
  extend : qx.event.type.Event,
  members : {
    __data : null,
    __old : null,
    init : function(data, old, cancelable){

      qx.event.type.Event.prototype.init.call(this, false, cancelable);
      this.__data = data;
      this.__old = old;
      return this;
    },
    clone : function(embryo){

      var clone = qx.event.type.Event.prototype.clone.call(this, embryo);
      clone.__data = this.__data;
      clone.__old = this.__old;
      return clone;
    },
    getData : function(){

      return this.__data;
    },
    getOldData : function(){

      return this.__old;
    }
  },
  destruct : function(){

    this.__data = this.__old = null;
  }
});
qx.Class.define("qx.core.BaseInit", {
  statics : {
    __application : null,
    getApplication : function(){

      return this.__application || null;
    },
    ready : function(){

      if(this.__application){

        return;
      };
      if(qx.core.Environment.get("engine.name") == ""){

        qx.log.Logger.warn("Could not detect engine!");
      };
      if(qx.core.Environment.get("engine.version") == ""){

        qx.log.Logger.warn("Could not detect the version of the engine!");
      };
      if(qx.core.Environment.get("os.name") == ""){

        qx.log.Logger.warn("Could not detect operating system!");
      };
      qx.log.Logger.debug(this, "Load runtime: " + (new Date - qx.Bootstrap.LOADSTART) + "ms");
      var app = qx.core.Environment.get("qx.application");
      var clazz = qx.Class.getByName(app);
      if(clazz){

        this.__application = new clazz;
        var start = new Date;
        this.__application.main();
        qx.log.Logger.debug(this, "Main runtime: " + (new Date - start) + "ms");
        var start = new Date;
        this.__application.finalize();
        qx.log.Logger.debug(this, "Finalize runtime: " + (new Date - start) + "ms");
      } else {

        qx.log.Logger.warn("Missing application class: " + app);
      };
    },
    __close : function(e){

      var app = this.__application;
      if(app){

        app.close();
      };
    },
    __shutdown : function(){

      var app = this.__application;
      if(app){

        app.terminate();
      };
      qx.core.ObjectRegistry.shutdown();
    }
  }
});
qx.Interface.define("qx.application.IApplication", {
  members : {
    main : function(){
    },
    finalize : function(){
    },
    close : function(){
    },
    terminate : function(){
    }
  }
});
qx.Class.define("qx.application.Basic", {
  extend : qx.core.Object,
  implement : [qx.application.IApplication],
  members : {
    main : function(){
    },
    finalize : function(){
    },
    close : function(){
    },
    terminate : function(){
    }
  }
});
qx.Class.define("xlsys.Application", {
  extend : qx.application.Basic,
  members : {
    main : function(){

      if(qx.core.Environment.get("runtime.name") == "rhino"){

        qx.log.Logger.register(qx.log.appender.RhinoConsole);
      } else if(qx.core.Environment.get("runtime.name") == "node.js"){

        qx.log.Logger.register(qx.log.appender.NodeConsole);
      };
      if(window.arguments){

        try{

          this._argumentsToSettings(window.arguments);
        } catch(ex) {

          this.error(ex.toString());
          return;
        };
      };
      qx.$$xlsys = xlsys;
      this.info("Hello World!");
    },
    _argumentsToSettings : function(args){

      var opts;
      for(var i = 0,l = args.length;i < l;i++){

        if(args[i].indexOf("settings=") == 0){

          opts = args[i].substr(9);
          break;
        } else if(args[i].indexOf("'settings=") == 0){

          opts = /'settings\=(.*?)'/.exec(args[i])[1];
          break;
        };
      };
      if(opts){

        opts = opts.replace(/\\\{/g, "{").replace(/\\\}/g, "}");
        opts = qx.lang.Json.parse(opts);
        for(var prop in opts){

          var value = opts[prop];
          if(typeof value == "string"){

            value = value.replace(/\$/g, " ");
          };
          try{

            qx.core.Environment.add(prop, value);
          } catch(ex) {

            this.error("Unable to define command-line setting " + prop + ": " + ex);
          };
        };
      };
    }
  }
});
qx.Class.define("qx.log.appender.RhinoConsole", {
  statics : {
    __OUT : null,
    __ERR : null,
    log : function(logMessage, level){

      if(level == "error"){

        this.__ERR.println(logMessage);
      } else {

        this.__OUT.println(logMessage);
      };
    },
    debug : function(logMessage){

      this.log(logMessage, "debug");
    },
    info : function(logMessage){

      this.log(logMessage, "info");
    },
    warn : function(logMessage){

      this.log(logMessage, "warn");
    },
    error : function(logMessage){

      this.log(logMessage, "error");
    },
    process : function(entry){

      var level = entry.level || "info";
      for(var prop in entry){

        if(prop == "items"){

          var items = entry[prop];
          for(var p = 0,l = items.length;p < l;p++){

            var item = items[p];
            this[level](item.text);
          };
        };
      };
    }
  },
  defer : function(){

    if(typeof (java) !== "undefined" && typeof (java.lang) !== "undefined"){

      qx.log.appender.RhinoConsole.__OUT = java.lang.System.out;
      qx.log.appender.RhinoConsole.__ERR = java.lang.System.err;
    };
  }
});
qx.Class.define("qx.log.appender.NodeConsole", {
  statics : {
    __OUT : null,
    __ERR : null,
    log : function(logMessage, level){

      if(level == "error"){

        this.__ERR.write(logMessage + '\n');
      } else {

        this.__OUT.write(logMessage + '\n');
      };
    },
    debug : function(logMessage){

      this.log(logMessage, "debug");
    },
    info : function(logMessage){

      this.log(logMessage, "info");
    },
    warn : function(logMessage){

      this.log(logMessage, "warn");
    },
    error : function(logMessage){

      this.log(logMessage, "error");
    },
    process : function(entry){

      var level = entry.level || "info";
      for(var prop in entry){

        if(prop == "items"){

          var items = entry[prop];
          for(var p = 0;p < items.length;p++){

            var item = items[p];
            this[level](item.text);
          };
        };
      };
    }
  },
  defer : function(statics){

    if(typeof (process) !== "undefined"){

      statics.__OUT = process.stdout;
      statics.__ERR = process.stderr;
    };
  }
});
qx.Bootstrap.define("qx.bom.client.Runtime", {
  statics : {
    getName : function(){

      var name = "";
      if(typeof environment !== "undefined"){

        name = "rhino";
      } else if(typeof process !== "undefined"){

        name = "node.js";
      } else if(typeof Titanium !== "undefined" && typeof Titanium.userAgent !== "undefined"){

        name = "titanium";
      } else {

        name = qx.bom.client.Browser.getName();
      };;
      return name;
    }
  },
  defer : function(statics){

    qx.core.Environment.add("runtime.name", statics.getName);
  }
});
qx.Class.define("xlsys.java.io.Serializable", {
  type : "abstract",
  extend : qx.core.Object,
  members : {
    toHashCode : function(){

      var seed = 0;
      seed = xlsys.base.util.ObjectUtil._hash_combine(seed, xlsys.base.util.ObjectUtil.className(this));
      var needMembers = this.getSerializableMembers();
      for(var x in needMembers){

        seed = xlsys.base.util.ObjectUtil._hash_combine(seed, this[needMembers[x]]);
      };
      return seed;
    },
    getClassName : function(){

      var className = this.classname;
      return className;
    },
    getSerializableMembers : function(){
    },
    getMemberDataType : function(memberName){
    }
  }
});
qx.Class.define("xlsys.base.util.ObjectUtil", {
  type : "static",
  statics : {
    __obj_id : 0,
    _getHashKey : function(obj){

      var hashKey = null;
      if(obj == undefined || obj == null)hashKey = "_undefined_"; else if(qx.lang.Type.isBoolean(obj))hashKey = "_boolean_" + obj.toString(); else if(qx.lang.Type.isNumber(obj))hashKey = "_number_" + obj.toString(); else if(qx.lang.Type.isString(obj))hashKey = "_string_" + obj; else hashKey = "" + qx.core.ObjectRegistry.toHashCode(obj);;;;
      return hashKey;
    },
    __longToInt : function(longValue){

      if(longValue > 0x7fffffff || longValue < -0x80000000)longValue &= 0xFFFFFFFF;
      return longValue;
    },
    __strHashcode : function(str){

      var hash = 0;
      for(var i = 0;i < str.length;++i){

        hash = hash * 31 + str.charCodeAt(i);
        hash = this.__longToInt(hash);
      };
      return hash;
    },
    _hash_combine : function(seed, obj){

      seed = seed * 31 + this.hashcode(obj);
      seed = this.__longToInt(seed);
      return seed;
    },
    hashcode : function(obj){

      var hash = 0;
      if(obj == undefined || obj == null){

        hash = this.__strHashcode("_undefined_");
      } else if(qx.lang.Type.isArray(obj)){

        hash = this._hash_combine(hash, "_array_");
        for(var i = 0;i < obj.length;++i){

          hash = this._hash_combine(hash, obj[i]);
        };
      } else if(qx.lang.Type.isBoolean(obj)){

        hash = this.__strHashcode("_boolean_" + obj.toString());
      } else if(qx.lang.Type.isDate(obj)){

        hash = this.__strHashcode("_date_" + obj.toString());
      } else if(qx.lang.Type.isNumber(obj)){

        hash = this.__strHashcode("_number_" + obj.toString());
      } else if(qx.lang.Type.isString(obj)){

        hash = this.__strHashcode("_string_" + obj);
      } else if(qx.lang.Type.isRegExp(obj)){

        hash = this.__strHashcode("_regexp_" + obj.source);
      } else if(qx.lang.Type.isFunction(obj)){

        hash = this.__strHashcode("_function_" + obj.toString());
      } else if(qx.lang.Type.isError(obj)){

        hash = this.__strHashcode("_error_" + obj.toString());
      } else if(qx.lang.Type.isObject(obj)){

        if(obj instanceof qx.core.Object){

          hash = obj.toHashCode();
        } else {

          if(!obj.__hashcode){

            ++this.__obj_id;
            var uniqueObjStr = "_object_" + location.href + this.__obj_id;
            hash = this.__strHashcode(uniqueObjStr);
            obj.__hashcode = hash;
          } else hash = obj.__hashcode;
        };
      };;;;;;;;;
      return hash;
    },
    className : function(obj){

      var name = null;
      if(obj == undefined || obj == null){

        name = "undefined";
      } else if(qx.lang.Type.isArray(obj)){

        name = "[B";
      } else if(qx.lang.Type.isBoolean(obj)){

        name = "java.lang.Boolean";
      } else if(qx.lang.Type.isDate(obj)){

        name = "java.util.Date";
      } else if(qx.lang.Type.isNumber(obj)){

        name = "java.math.BigDecimal";
      } else if(qx.lang.Type.isString(obj)){

        name = "java.lang.String";
      } else if(qx.lang.Type.isRegExp(obj)){

        throw new Error("Unsupport!");
      } else if(qx.lang.Type.isFunction(obj)){

        throw new Error("Unsupport!");
      } else if(qx.lang.Type.isObject(obj)){

        if(obj instanceof xlsys.java.io.Serializable){

          name = obj.getClassName();
        } else if(obj instanceof qx.core.Object){

          name = obj.classname;
        } else {

          name = "java.lang.Object";
        };
      };;;;;;;;
      return name;
    },
    getClass : function(obj){

      if(obj == null || obj.classname == null)return null;
      return this.getClassByName(obj.classname);
    },
    getClassByName : function(className){

      var objClass = qx.Bootstrap.getByName(className);
      if(objClass == null)objClass = qx.Interface.getByName(className);
      return objClass;
    },
    hasMixin : function(obj, mixin){

      var has = false;
      var objClass = this.getClass(obj);
      if(objClass != null)has = qx.Class.hasMixin(objClass, mixin);
      return has;
    },
    hasBitProp : function(prop, bitProp){

      return (prop & bitProp) == bitProp;
    },
    objectToString : function(obj){

      var str = null;
      if(obj == undefined || obj == null){

        str = null;
      } else if(qx.lang.Type.isArray(obj)){

        try{

          str = xlsys.base.util.StringUtil.bytesToString(obj);
        } catch(err) {

          var sb = new xlsys.java.lang.StringBuilder();
          sb.append("[");
          for(var i = 0;i < obj.length;++i){

            sb.append(this.objectToString(obj[i]));
            if(i != obj.length - 1)sb.append(",");
          };
          sb.append("]");
          str = sb.toString();
        };
      } else if(qx.lang.Type.isBoolean(obj)){

        str = "" + obj;
      } else if(qx.lang.Type.isDate(obj)){

        var year = obj.getFullYear() + "";
        var month = obj.getMonth() + 1 + "";
        if(month.length < 2)month = "0" + month;
        var day = obj.getDate() + "";
        if(day.length < 2)day = "0" + day;
        var hour = obj.getHours() + "";
        if(hour.length < 2)hour = "0" + hour;
        var minute = obj.getMinutes() + "";
        if(minute.length < 2)minute = "0" + minute;
        var second = obj.getSeconds() + "";
        if(second.length < 2)second = "0" + second;
        str = month + "/" + day + "/" + year + " " + hour + ":" + minute + ":" + second;
      } else if(qx.lang.Type.isNumber(obj)){

        str = "" + obj;
      } else if(qx.lang.Type.isString(obj)){

        str = obj;
      } else if(qx.lang.Type.isRegExp(obj)){

        str = obj.source;
      } else if(qx.lang.Type.isFunction(obj)){

        str = obj.toString();
      } else if(qx.lang.Type.isError(obj)){

        var sb = new xlsys.java.lang.StringBuilder();
        sb.append(obj.name + " : " + obj.message).append("\n");
        var stackTrace = qx.dev.StackTrace.getStackTraceFromError(obj);
        for(var i = 0;i < stackTrace.length;++i){

          sb.append(stackTrace[i]);
          if(i != stackTrace.length - 1)sb.append("\n");
        };
        str = sb.toString();
      } else if(obj instanceof xlsys.java.lang.Exception){

        var stackTrace = obj.getStackTrace();
        var sb = new xlsys.java.lang.StringBuilder();
        sb.append(obj.getMessage()).append("\n");
        for(var i = 0;i < stackTrace.length;++i){

          sb.append(stackTrace[i]);
          if(i != stackTrace.length - 1)sb.append("\n");
        };
        str = sb.toString();
      } else if(qx.lang.Type.isObject(obj)){

        str = obj.toString();
      };;;;;;;;;;
      return str;
    },
    objectToNumber : function(obj){

      if(obj == null)return null;
      return Number(obj);
    },
    objectToInt : function(obj){

      if(obj == null)return null;
      return parseInt(this.objectToString(obj));
    },
    objectToBoolean : function(obj){

      if(obj == null)return false; else if(qx.lang.Type.isBoolean(obj))return obj; else if(qx.lang.Type.isNumber(obj)){

        if(this.objectToInt(obj) == 0)return false; else return true;
      } else {

        var objStr = this.objectToString(obj);
        if(objStr.toLowerCase() == "true")return true; else return false;
      };;
    },
    objectToDate : function(obj){

      if(obj == null)return null; else if(qx.lang.Type.isDate(obj))return obj; else {

        var objStr = this.objectToString(obj);
        var time = Date.parse(objStr);
        var date = new Date();
        date.setTime(time);
        return date;
      };
    },
    objectToBlob : function(obj){

      if(qx.lang.Type.isString(obj)){

        return xlsys.base.util.StringUtil.stringToBytes(obj);
      } else return obj;
    },
    tryInitObj : function(className){

      var obj = null;
      var invokeSb = new xlsys.java.lang.StringBuilder();
      invokeSb.append("new ");
      if(qx.lang.String.startsWith(className, "["))invokeSb.append("Array"); else if(qx.lang.String.endsWith(className, "Exception"))invokeSb.append("xlsys.java.lang.Exception"); else if(qx.lang.String.startsWith(className, "java."))invokeSb.append("xlsys.").append(className); else invokeSb.append(className);;;
      invokeSb.append("(");
      if(arguments.length > 1){

        for(var i = 1;i < arguments.length;++i){

          invokeSb.append(arguments[i]);
          if(i != arguments.length - 1)invokeSb.append(",");
        };
      };
      invokeSb.append(");");
      obj = eval(invokeSb.toString());
      return obj;
    }
  }
});
qx.Class.define("xlsys.base.util.StringUtil", {
  type : "static",
  statics : {
    stringToBytes : function(str){

      var bytes = new Array();
      for(var i = 0;i < str.length;++i){

        var code = str.charCodeAt(i);
        if(code > 0x0 && code <= 0x7f){

          bytes.push(code);
        } else if(code >= 0x80 && code <= 0x7ff){

          bytes.push(0xc0 | ((code >> 6) & 0x1f), 0x80 | (code & 0x3f));
        } else if(code >= 0x800 && code <= 0xffff){

          bytes.push(0xe0 | ((code >> 12) & 0xf), 0x80 | ((code >> 6) & 0x3f), 0x80 | (code & 0x3f));
        };;
      };
      return bytes;
    },
    bytesToString : function(bytes){

      var sb = new xlsys.java.lang.StringBuilder();
      for(var i = 0;i < bytes.length;++i){

        var codes = new Array();
        codes.push(bytes[i]);
        if(((codes[0] >> 7) & 0xff) == 0x0){

          sb.append(String.fromCharCode(bytes[i]));
        } else if(((codes[0] >> 5) & 0xff) == 0x6){

          codes.push(bytes[++i]);
          var temp = new Array();
          temp.push(codes[0] & 0x1f);
          temp.push(codes[1] & 0x3f);
          sb.append(String.fromCharCode((temp[0] << 6) | temp[1]));
        } else if(((codes[0] >> 4) & 0xff) == 0xe){

          codes.push(bytes[++i]);
          codes.push(bytes[++i]);
          var temp = new Array();
          temp.push((codes[0] << 4) | ((codes[1] >> 2) & 0xf));
          temp.push(((codes[1] & 0x3) << 6) | (codes[2] & 0x3f));
          sb.append(String.fromCharCode((temp[0] << 8) | temp[1]));
        };;
      };
      return sb.toString();
    },
    split : function(str, beginRegexStr, endRegexStr, reserve){

      var regex = null;
      if(beginRegexStr == endRegexStr)regex = new RegExp(beginRegexStr, "g"); else regex = new RegExp("(" + beginRegexStr + "|" + endRegexStr + ")", "g");
      var resultArr = new Array();
      var result = null;
      while((result = regex.exec(str)) != null){

        resultArr.push(result);
      };
      var arr = new Array();
      if(resultArr.length == 0)arr.push(str); else {

        var lastEnd = new Array();
        lastEnd.push("");
        lastEnd.index = 0;
        for(var i = 0;i < resultArr.length;i += 2){

          var begin = resultArr[i];
          var end = null;
          if(i + 1 < resultArr.length)end = resultArr[i + 1];
          arr.push(str.substring(lastEnd.index + lastEnd[0].length, begin.index));
          var startStr = begin[0];
          var startIndex = begin.index + startStr.length;
          if(end != null){

            lastEnd = end;
            var endIndex = end.index;
            if(reserve)arr.push(str.substring(startIndex, endIndex));
          } else {

            lastEnd = null;
            arr.push(str.substring(startIndex));
          };
        };
        if(lastEnd != null)arr.push(str.substring(end.index + end[0].length));
      };
      return arr;
    },
    getAllIndexOf : function(srcStr, findStr, start, end){

      if(srcStr.length > end)srcStr = srcStr.substring(0, end);
      var arr = new Array();
      if(srcStr.length > start){

        var curIdx = start;
        while((curIdx = srcStr.indexOf(findStr, curIdx)) != -1){

          arr.push(curIdx);
          curIdx += findStr.length;
        };
      };
      return arr;
    },
    __isIndexBetweenMark : function(idx, arr){

      var isBetween = false;
      for(var i = 0;i < arr.length;i += 2){

        if(i != arr.length - 1){

          var start = arr[i];
          var end = arr[i + 1];
          if(idx > start && idx < end){

            isBetween = true;
            break;
          };
        };
      };
      return isBetween;
    },
    indexOfIgnoreMark : function(srcStr, findStr, start, end, ignoreStrBetweenThisMark){

      var index = -1;
      if(srcStr.length > end)srcStr = srcStr.substring(0, end);
      var ignoreArr = this.getAllIndexOf(srcStr, ignoreStrBetweenThisMark, start, end);
      var curIdx = start;
      while((curIdx = srcStr.indexOf(findStr, curIdx)) != -1){

        if(!this.__isIndexBetweenMark(curIdx, ignoreArr)){

          index = curIdx;
          break;
        };
        curIdx += findStr.length;
      };
      return index;
    },
    getMD5String : function(obj){

      var string = null;
      if(qx.lang.Type.isString(obj))string = obj; else string = this.bytesToString(obj);
      function RotateLeft(lValue, iShiftBits){

        return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits));
      };
      function AddUnsigned(lX, lY){

        var lX4,lY4,lX8,lY8,lResult;
        lX8 = (lX & 0x80000000);
        lY8 = (lY & 0x80000000);
        lX4 = (lX & 0x40000000);
        lY4 = (lY & 0x40000000);
        lResult = (lX & 0x3FFFFFFF) + (lY & 0x3FFFFFFF);
        if(lX4 & lY4){

          return (lResult ^ 0x80000000 ^ lX8 ^ lY8);
        };
        if(lX4 | lY4){

          if(lResult & 0x40000000){

            return (lResult ^ 0xC0000000 ^ lX8 ^ lY8);
          } else {

            return (lResult ^ 0x40000000 ^ lX8 ^ lY8);
          };
        } else {

          return (lResult ^ lX8 ^ lY8);
        };
      };
      function F(x, y, z){

        return (x & y) | ((~x) & z);
      };
      function G(x, y, z){

        return (x & z) | (y & (~z));
      };
      function H(x, y, z){

        return (x ^ y ^ z);
      };
      function I(x, y, z){

        return (y ^ (x | (~z)));
      };
      function FF(a, b, c, d, x, s, ac){

        a = AddUnsigned(a, AddUnsigned(AddUnsigned(F(b, c, d), x), ac));
        return AddUnsigned(RotateLeft(a, s), b);
      };
      function GG(a, b, c, d, x, s, ac){

        a = AddUnsigned(a, AddUnsigned(AddUnsigned(G(b, c, d), x), ac));
        return AddUnsigned(RotateLeft(a, s), b);
      };
      function HH(a, b, c, d, x, s, ac){

        a = AddUnsigned(a, AddUnsigned(AddUnsigned(H(b, c, d), x), ac));
        return AddUnsigned(RotateLeft(a, s), b);
      };
      function II(a, b, c, d, x, s, ac){

        a = AddUnsigned(a, AddUnsigned(AddUnsigned(I(b, c, d), x), ac));
        return AddUnsigned(RotateLeft(a, s), b);
      };
      function ConvertToWordArray(string){

        var lWordCount;
        var lMessageLength = string.length;
        var lNumberOfWords_temp1 = lMessageLength + 8;
        var lNumberOfWords_temp2 = (lNumberOfWords_temp1 - (lNumberOfWords_temp1 % 64)) / 64;
        var lNumberOfWords = (lNumberOfWords_temp2 + 1) * 16;
        var lWordArray = Array(lNumberOfWords - 1);
        var lBytePosition = 0;
        var lByteCount = 0;
        while(lByteCount < lMessageLength){

          lWordCount = (lByteCount - (lByteCount % 4)) / 4;
          lBytePosition = (lByteCount % 4) * 8;
          lWordArray[lWordCount] = (lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition));
          lByteCount++;
        };
        lWordCount = (lByteCount - (lByteCount % 4)) / 4;
        lBytePosition = (lByteCount % 4) * 8;
        lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition);
        lWordArray[lNumberOfWords - 2] = lMessageLength << 3;
        lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29;
        return lWordArray;
      };
      function WordToHex(lValue){

        var WordToHexValue = "",WordToHexValue_temp = "",lByte,lCount;
        for(lCount = 0;lCount <= 3;lCount++){

          lByte = (lValue >>> (lCount * 8)) & 255;
          WordToHexValue_temp = "0" + lByte.toString(16);
          WordToHexValue = WordToHexValue + WordToHexValue_temp.substr(WordToHexValue_temp.length - 2, 2);
        };
        return WordToHexValue;
      };
      function Utf8Encode(string){

        string = string.replace(/\r\n/g, "\n");
        var utftext = "";
        for(var n = 0;n < string.length;n++){

          var c = string.charCodeAt(n);
          if(c < 128){

            utftext += String.fromCharCode(c);
          } else if((c > 127) && (c < 2048)){

            utftext += String.fromCharCode((c >> 6) | 192);
            utftext += String.fromCharCode((c & 63) | 128);
          } else {

            utftext += String.fromCharCode((c >> 12) | 224);
            utftext += String.fromCharCode(((c >> 6) & 63) | 128);
            utftext += String.fromCharCode((c & 63) | 128);
          };
        };
        return utftext;
      };
      var x = Array();
      var k,AA,BB,CC,DD,a,b,c,d;
      var S11 = 7,S12 = 12,S13 = 17,S14 = 22;
      var S21 = 5,S22 = 9,S23 = 14,S24 = 20;
      var S31 = 4,S32 = 11,S33 = 16,S34 = 23;
      var S41 = 6,S42 = 10,S43 = 15,S44 = 21;
      string = Utf8Encode(string);
      x = ConvertToWordArray(string);
      a = 0x67452301;
      b = 0xEFCDAB89;
      c = 0x98BADCFE;
      d = 0x10325476;
      for(k = 0;k < x.length;k += 16){

        AA = a;
        BB = b;
        CC = c;
        DD = d;
        a = FF(a, b, c, d, x[k + 0], S11, 0xD76AA478);
        d = FF(d, a, b, c, x[k + 1], S12, 0xE8C7B756);
        c = FF(c, d, a, b, x[k + 2], S13, 0x242070DB);
        b = FF(b, c, d, a, x[k + 3], S14, 0xC1BDCEEE);
        a = FF(a, b, c, d, x[k + 4], S11, 0xF57C0FAF);
        d = FF(d, a, b, c, x[k + 5], S12, 0x4787C62A);
        c = FF(c, d, a, b, x[k + 6], S13, 0xA8304613);
        b = FF(b, c, d, a, x[k + 7], S14, 0xFD469501);
        a = FF(a, b, c, d, x[k + 8], S11, 0x698098D8);
        d = FF(d, a, b, c, x[k + 9], S12, 0x8B44F7AF);
        c = FF(c, d, a, b, x[k + 10], S13, 0xFFFF5BB1);
        b = FF(b, c, d, a, x[k + 11], S14, 0x895CD7BE);
        a = FF(a, b, c, d, x[k + 12], S11, 0x6B901122);
        d = FF(d, a, b, c, x[k + 13], S12, 0xFD987193);
        c = FF(c, d, a, b, x[k + 14], S13, 0xA679438E);
        b = FF(b, c, d, a, x[k + 15], S14, 0x49B40821);
        a = GG(a, b, c, d, x[k + 1], S21, 0xF61E2562);
        d = GG(d, a, b, c, x[k + 6], S22, 0xC040B340);
        c = GG(c, d, a, b, x[k + 11], S23, 0x265E5A51);
        b = GG(b, c, d, a, x[k + 0], S24, 0xE9B6C7AA);
        a = GG(a, b, c, d, x[k + 5], S21, 0xD62F105D);
        d = GG(d, a, b, c, x[k + 10], S22, 0x2441453);
        c = GG(c, d, a, b, x[k + 15], S23, 0xD8A1E681);
        b = GG(b, c, d, a, x[k + 4], S24, 0xE7D3FBC8);
        a = GG(a, b, c, d, x[k + 9], S21, 0x21E1CDE6);
        d = GG(d, a, b, c, x[k + 14], S22, 0xC33707D6);
        c = GG(c, d, a, b, x[k + 3], S23, 0xF4D50D87);
        b = GG(b, c, d, a, x[k + 8], S24, 0x455A14ED);
        a = GG(a, b, c, d, x[k + 13], S21, 0xA9E3E905);
        d = GG(d, a, b, c, x[k + 2], S22, 0xFCEFA3F8);
        c = GG(c, d, a, b, x[k + 7], S23, 0x676F02D9);
        b = GG(b, c, d, a, x[k + 12], S24, 0x8D2A4C8A);
        a = HH(a, b, c, d, x[k + 5], S31, 0xFFFA3942);
        d = HH(d, a, b, c, x[k + 8], S32, 0x8771F681);
        c = HH(c, d, a, b, x[k + 11], S33, 0x6D9D6122);
        b = HH(b, c, d, a, x[k + 14], S34, 0xFDE5380C);
        a = HH(a, b, c, d, x[k + 1], S31, 0xA4BEEA44);
        d = HH(d, a, b, c, x[k + 4], S32, 0x4BDECFA9);
        c = HH(c, d, a, b, x[k + 7], S33, 0xF6BB4B60);
        b = HH(b, c, d, a, x[k + 10], S34, 0xBEBFBC70);
        a = HH(a, b, c, d, x[k + 13], S31, 0x289B7EC6);
        d = HH(d, a, b, c, x[k + 0], S32, 0xEAA127FA);
        c = HH(c, d, a, b, x[k + 3], S33, 0xD4EF3085);
        b = HH(b, c, d, a, x[k + 6], S34, 0x4881D05);
        a = HH(a, b, c, d, x[k + 9], S31, 0xD9D4D039);
        d = HH(d, a, b, c, x[k + 12], S32, 0xE6DB99E5);
        c = HH(c, d, a, b, x[k + 15], S33, 0x1FA27CF8);
        b = HH(b, c, d, a, x[k + 2], S34, 0xC4AC5665);
        a = II(a, b, c, d, x[k + 0], S41, 0xF4292244);
        d = II(d, a, b, c, x[k + 7], S42, 0x432AFF97);
        c = II(c, d, a, b, x[k + 14], S43, 0xAB9423A7);
        b = II(b, c, d, a, x[k + 5], S44, 0xFC93A039);
        a = II(a, b, c, d, x[k + 12], S41, 0x655B59C3);
        d = II(d, a, b, c, x[k + 3], S42, 0x8F0CCC92);
        c = II(c, d, a, b, x[k + 10], S43, 0xFFEFF47D);
        b = II(b, c, d, a, x[k + 1], S44, 0x85845DD1);
        a = II(a, b, c, d, x[k + 8], S41, 0x6FA87E4F);
        d = II(d, a, b, c, x[k + 15], S42, 0xFE2CE6E0);
        c = II(c, d, a, b, x[k + 6], S43, 0xA3014314);
        b = II(b, c, d, a, x[k + 13], S44, 0x4E0811A1);
        a = II(a, b, c, d, x[k + 4], S41, 0xF7537E82);
        d = II(d, a, b, c, x[k + 11], S42, 0xBD3AF235);
        c = II(c, d, a, b, x[k + 2], S43, 0x2AD7D2BB);
        b = II(b, c, d, a, x[k + 9], S44, 0xEB86D391);
        a = AddUnsigned(a, AA);
        b = AddUnsigned(b, BB);
        c = AddUnsigned(c, CC);
        d = AddUnsigned(d, DD);
      };
      var temp = WordToHex(a) + WordToHex(b) + WordToHex(c) + WordToHex(d);
      return temp.toLowerCase();
    },
    base64 : {
      _keyStr : "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=",
      encode : function(input){

        var output = "";
        var chr1,chr2,chr3,enc1,enc2,enc3,enc4;
        var i = 0;
        input = xlsys.base.util.StringUtil.base64._utf8_encode(input);
        while(i < input.length){

          chr1 = input.charCodeAt(i++);
          chr2 = input.charCodeAt(i++);
          chr3 = input.charCodeAt(i++);
          enc1 = chr1 >> 2;
          enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
          enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
          enc4 = chr3 & 63;
          if(isNaN(chr2))enc3 = enc4 = 64; else if(isNaN(chr3))enc4 = 64;;
          output = output + this._keyStr.charAt(enc1) + this._keyStr.charAt(enc2) + this._keyStr.charAt(enc3) + this._keyStr.charAt(enc4);
        };
        return output;
      },
      decode : function(input){

        var output = "";
        var chr1,chr2,chr3;
        var enc1,enc2,enc3,enc4;
        var i = 0;
        input = input.replace(/[^A-Za-z0-9\+\/\=]/g, "");
        while(i < input.length){

          enc1 = this._keyStr.indexOf(input.charAt(i++));
          enc2 = this._keyStr.indexOf(input.charAt(i++));
          enc3 = this._keyStr.indexOf(input.charAt(i++));
          enc4 = this._keyStr.indexOf(input.charAt(i++));
          chr1 = (enc1 << 2) | (enc2 >> 4);
          chr2 = ((enc2 & 15) << 4) | (enc3 >> 2);
          chr3 = ((enc3 & 3) << 6) | enc4;
          output = output + String.fromCharCode(chr1);
          if(enc3 != 64)output = output + String.fromCharCode(chr2);
          if(enc4 != 64)output = output + String.fromCharCode(chr3);
        };
        output = xlsys.base.util.StringUtil.base64._utf8_decode(output);
        return output;
      },
      _utf8_encode : function(string){

        string = string.replace(/\r\n/g, "\n");
        var utftext = "";
        for(var n = 0;n < string.length;n++){

          var c = string.charCodeAt(n);
          if(c < 128)utftext += String.fromCharCode(c); else if((c > 127) && (c < 2048)){

            utftext += String.fromCharCode((c >> 6) | 192);
            utftext += String.fromCharCode((c & 63) | 128);
          } else {

            utftext += String.fromCharCode((c >> 12) | 224);
            utftext += String.fromCharCode(((c >> 6) & 63) | 128);
            utftext += String.fromCharCode((c & 63) | 128);
          };
        };
        return utftext;
      },
      _utf8_decode : function(utftext){

        var string = "";
        var i = 0;
        var c = 0;
        var c1 = 0;
        var c2 = 0;
        var c3 = 0;
        while(i < utftext.length){

          c = utftext.charCodeAt(i);
          if(c < 128){

            string += String.fromCharCode(c);
            i++;
          } else if((c > 191) && (c < 224)){

            c2 = utftext.charCodeAt(i + 1);
            string += String.fromCharCode(((c & 31) << 6) | (c2 & 63));
            i += 2;
          } else {

            c2 = utftext.charCodeAt(i + 1);
            c3 = utftext.charCodeAt(i + 2);
            string += String.fromCharCode(((c & 15) << 12) | ((c2 & 63) << 6) | (c3 & 63));
            i += 3;
          };
        };
        return string;
      }
    }
  }
});
qx.Class.define("xlsys.java.lang.StringBuilder", {
  extend : qx.core.Object,
  construct : function(){

    this.__strings = new Array();
    if(arguments.length == 1)this.__strings.push(arguments[0]);
  },
  members : {
    __strings : null,
    append : function(str){

      this.__strings.push(str);
      return this;
    },
    size : function(){

      var length = 0;
      for(var i = 0;i < this.__strings.length;++i){

        length += this.__strings[i].length;
      };
      return length;
    },
    isEmpty : function(){

      return this.size() == 0;
    },
    toString : function(){

      return this.__strings.join("");
    }
  }
});
qx.Class.define("xlsys.java.lang.Exception", {
  extend : xlsys.java.io.Serializable,
  members : {
    msg : null,
    stackTrace : null,
    cause : null,
    getMessage : function(){

      return this.msg;
    },
    getStackTrace : function(){

      return this.stackTrace;
    },
    setStackTrace : function(stackTrace){

      this.stackTrace = stackTrace;
    },
    getCause : function(){

      return this.cause;
    },
    toString : function(){

      return this.msg;
    },
    getClassName : function(){

      return "java.lang.Exception";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("msg");
      arr.push("stackTrace");
      arr.push("cause");
      return arr;
    }
  },
  construct : function(){

    this.msg = arguments[0];
    if(arguments.length > 1)this.cause = arguments[1];
    this.stackTrace = qx.dev.StackTrace.getStackTrace();
  }
});
qx.Class.define("xlsys.base.util.NumberUtil", {
  type : "singleton",
  extend : qx.core.Object,
  construct : function(){

    qx.core.Object.call(this);
  },
  members : {
    unsignedRightShift : function(num, bit){

      var bits = num.toString(2);
      if(bits.length < bit)return 0;
      bits = bits.substring(0, bits.length - bit);
      return parseInt(bits, 2);
    }
  }
});
qx.Interface.define("xlsys.base.dataset.IDataSet", {
  statics : {
    STYLE_NONE : 0,
    STYLE_VIRTUAL : 1,
    SORT_TYPE_ASC : 0,
    SORT_TYPE_DESC : 1,
    OPTION_LOCK_POST_VALUE_EVENT : 0,
    OPTION_LOCK_POST_ROW_EVENT : 1,
    OPTION_LOCK_CURSOR_CHANGE : 2,
    OPTION_LOCK_REMOVE_ROW_EVENT : 3,
    OPTION_LOCK_REMOVE_COL_EVENT : 4,
    OPTION_LOCK_INSERT_ROW_EVENT : 5,
    OPTION_LOCK_INSERT_COL_EVENT : 6
  },
  members : {
    setRowCount : function(rowCount){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getStyle : function(){
    },
    getExpandPerCount : function(){
    },
    setExpandPerCount : function(expandPerCount){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getPageRangeOfRowIndex : function(wantRowIndex){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    expandToRow : function(wantRowIndex){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    isVirtualRow : function(rowOrRowIndex){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    buildColumnMap : function(){
    },
    getColumnIndex : function(columnName){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    removeColumn : function(colNameOrColIdx){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getRowCount : function(){
    },
    getColumnCount : function(){
    },
    getRowCursor : function(){
    },
    getColCursor : function(){
    },
    getCurRow : function(){
    },
    getCurColumn : function(){
    },
    beforeFirst : function(){
    },
    gotoRow : function(){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    gotoColumn : function(colNameOrColIndex){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    gotoCell : function(rowOrRowIndex, colNameOrColIndex){

      this.assertArgumentsCount(arguments, 2, 3);
    },
    getRow : function(rowIndex){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getRowIndex : function(row){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getColumn : function(colNameOrColIndex){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getColumnName : function(colIndex){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    insertRow : function(row){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    insertRowAtFirst : function(row){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    insertRowAfterLast : function(row){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    insertRowAt : function(index, row){

      this.assertArgumentsCount(arguments, 2, 3);
    },
    insertNewRow : function(){

      this.assertArgumentsCount(arguments, 0, 1);
    },
    insertNewRowAtFirst : function(){

      this.assertArgumentsCount(arguments, 0, 1);
    },
    insertNewRowAfterLast : function(){

      this.assertArgumentsCount(arguments, 0, 1);
    },
    insertNewRowAt : function(index){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    insertNewColumnAtFirst : function(){
    },
    insertNewColumnAfterLast : function(){
    },
    insertNewColumn : function(){
    },
    insertNewColumnAt : function(index){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    removeRow : function(rowOrRowIndex){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    removeAllRow : function(){
    },
    truncateAllRow : function(){
    },
    getValue : function(){

      this.assertArgumentsCount(arguments, 0, 2);
    },
    setValue : function(){

      this.assertArgumentsCount(arguments, 1, 3);
    },
    postRow : function(){

      this.assertArgumentsCount(arguments, 0, 1);
    },
    setOption : function(option, value){

      this.assertArgumentsCount(arguments, 2, 3);
    },
    isOption : function(option){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    setSortColumn : function(){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    setSortColMap : function(sortColMap){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getSortColMap : function(){
    },
    sort : function(){
    },
    swapRow : function(i, j){

      this.assertArgumentsCount(arguments, 2, 2);
    },
    addDataSetListener : function(dataSetListener){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    removeDataSetListener : function(dataSetListener){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getDataSetListeners : function(){
    },
    setEventLock : function(){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    fireShowMessage : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireBeforePostValue : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireAfterPostValue : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireBeforePostRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireAfterPostRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireBeforeCursorChange : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireAfterCursorChange : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireCustomTrigger : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getColumns : function(){
    },
    getRows : function(){
    },
    getName : function(){
    },
    setName : function(name){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    refresh : function(){
    }
  }
});
qx.Class.define("xlsys.base.dataset.DataSet", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.base.dataset.IDataSet],
  construct : function(){

    this.name = null;
    this.style = null;
    this.columnMap = null;
    this.dataSetListenerSet = null;
    this.oldEditRow = null;
    this.regionChecking = null;
    this.sortColMap = new xlsys.java.util.LinkedHashMap();
    this.columns = new xlsys.java.util.ArrayList();
    this.rows = new xlsys.java.util.ArrayList();
    this.rowCursor = -1;
    this.colCursor = -1;
    this.expandPerCount = 32;
    this.optionMap = new xlsys.java.util.HashMap();
    var dataSetColumns = null;
    var style = null;
    if(arguments.length == 0)style = xlsys.base.dataset.IDataSet.STYLE_NONE; else if(arguments.length == 1){

      if(qx.lang.Type.isNumber(arguments[0]))style = arguments[0]; else {

        dataSetColumns = arguments[0];
        style = xlsys.base.dataset.IDataSet.STYLE_NONE;
      };
    } else if(arguments.length == 2){

      dataSetColumns = arguments[0];
      style = arguments[1];
    };;
    this.style = style;
    if(dataSetColumns != null){

      for(var i = 0;i < dataSetColumns.size();++i){

        var dsc = dataSetColumns.get(i);
        this.insertNewColumnAfterLast().cloneOf(dsc);
      };
      this.buildColumnMap();
    };
  },
  members : {
    name : null,
    style : null,
    columnMap : null,
    dataSetListenerSet : null,
    oldEditRow : null,
    regionChecking : null,
    sortColMap : null,
    columns : null,
    rows : null,
    rowCursor : null,
    colCursor : null,
    expandPerCount : null,
    optionMap : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("name");
      arr.push("style");
      arr.push("columnMap");
      arr.push("sortColMap");
      arr.push("columns");
      arr.push("rows");
      arr.push("expandPerCount");
      return arr;
    },
    getExpandPerCount : function(){

      return this.expandPerCount;
    },
    setExpandPerCount : function(expandPerCount){

      this.expandPerCount = expandPerCount;
    },
    setRowCount : function(rowCount){

      if(xlsys.base.util.ObjectUtil.hasBitProp(this.style, xlsys.base.dataset.IDataSet.STYLE_VIRTUAL)){

        var curRowCount = this.getRowCount();
        if(curRowCount < rowCount){

          this.setEventLock(true);
          var oldCursor = this.getRowCursor();
          for(var i = 0;i < rowCount - curRowCount;++i)this.insertNewRowAfterLast(true);
          this.setRowCursor(oldCursor);
          this.setEventLock(false);
        };
      };
    },
    setColumnCount : function(colCount){

      if(xlsys.base.util.ObjectUtil.hasBitProp(this.style, xlsys.base.dataset.IDataSet.STYLE_VIRTUAL)){

        var curColCount = this.getColumnCount();
        if(curColCount < colCount){

          this.setEventLock(true);
          var oldCursor = this.getColCursor();
          for(var i = 0;i < colCount - curColCount;++i)this.insertNewColumnAfterLast();
          this.setColCursor(oldCursor);
          this.setEventLock(false);
        };
      };
    },
    buildColumnMap : function(){

      if(this.columnMap == null)this.columnMap = new xlsys.java.util.HashMap(); else this.columnMap.clear();
      for(var i = 0;i < this.columns.size();++i){

        var column = this.columns.get(i);
        this.columnMap.put(column.getColumnName().toLowerCase(), i);
      };
    },
    getColumnIndex : function(columnName){

      if(columnName == null)return -1;
      if(this.columnMap == null || this.columnMap.isEmpty() || !this.columnMap.containsKey(columnName.toLowerCase())){

        this.buildColumnMap();
      };
      var i = this.columnMap.get(columnName.toLowerCase());
      return i == null ? -1 : i;
    },
    removeColumn : function(colNameOrColIdx){

      var colIdx = null;
      if(qx.lang.Type.isString(colNameOrColIdx))colIdx = this.getColumnIndex(colNameOrColIdx); else colIdx = colNameOrColIdx;
      if(!this.colRegionCheck(colIdx))return;
      var toRemoveCol = this.getColumn(colIdx);
      var event = new xlsys.base.dataset.DataSetEvent(this);
      event.col = toRemoveCol;
      this.fireBeforeRemoveCol(event);
      if(event.doit){

        for(var i = 0;i < this.rows.size();++i){

          var row = this.rows.get(i);
          row.removeCell(colIdx);
        };
        this.columns.removeAt(colIdx);
        this.buildColumnMap();
        var cursor = this.getColCursor();
        if(colIdx <= cursor)this.setColCursor(cursor - 1);
        event = new xlsys.base.dataset.DataSetEvent(this);
        event.col = toRemoveCol;
        this.fireAfterRemoveCol(event);
      };
    },
    getRowCount : function(){

      return this.rows.size();
    },
    getColumnCount : function(){

      return this.columns.size();
    },
    getRowCursor : function(){

      return this.rowCursor;
    },
    setRowCursor : function(rowCursor){

      var success = false;
      if(this.rowRegionCheck(rowCursor)){

        success = this.expandToRow(rowCursor);
      } else if(rowCursor == -1)success = true;;
      if(success)this.rowCursor = rowCursor;
      return success;
    },
    getColCursor : function(){

      return this.colCursor;
    },
    setColCursor : function(colCursor){

      var success = false;
      if(this.colRegionCheck(colCursor) || colCursor == -1)success = true;
      if(success)this.colCursor = colCursor;
      return success;
    },
    getPageRangeOfRowIndex : function(wantRowIndex){

      if(wantRowIndex < 0 || wantRowIndex >= this.getRowCount())return null;
      var beginRowIdx = Math.floor(wantRowIndex / this.expandPerCount) * this.expandPerCount;
      var endRowIdx = Math.min(beginRowIdx + this.expandPerCount - 1, this.getRowCount() - 1);
      var ret = new Array();
      ret.push(beginRowIdx);
      ret.push(endRowIdx);
      return ret;
    },
    expandToRow : function(wantRowIndex){

      if(arguments.length == 1)return this._expandToRow(wantRowIndex); else this._expandToRowWithCallback(wantRowIndex, arguments[1]);
    },
    _expandToRow : function(wantRowIndex){

      var success = true;
      if(wantRowIndex < 0 || wantRowIndex >= this.getRowCount())return success;
      if(xlsys.base.util.ObjectUtil.hasBitProp(this.style, xlsys.base.dataset.IDataSet.STYLE_VIRTUAL) && this.isVirtualRow(wantRowIndex)){

        var range = this.getPageRangeOfRowIndex(wantRowIndex);
        if(range != null){

          var event = new xlsys.base.dataset.DataSetEvent(this);
          event.beginIdxOfExpand = range[0];
          event.endIdxOfExpand = range[1];
          success = this.fireExpandRows(event);
          if(success){

            for(var i = event.beginIdxOfExpand;i <= event.endIdxOfExpand;++i){

              this.rows.get(i).setChangeStatus(xlsys.base.dataset.DataSetRow.STATUS_COMMON);
            };
          };
        };
      };
      return success;
    },
    _expandToRowWithCallback : function(wantRowIndex, callback){

      var success = true;
      if(wantRowIndex < 0 || wantRowIndex >= this.getRowCount())callback(success, "success");
      if(xlsys.base.util.ObjectUtil.hasBitProp(this.style, xlsys.base.dataset.IDataSet.STYLE_VIRTUAL) && this.isVirtualRow(wantRowIndex)){

        var range = this.getPageRangeOfRowIndex(wantRowIndex);
        if(range != null){

          var event = new xlsys.base.dataset.DataSetEvent(this);
          event.beginIdxOfExpand = range[0];
          event.endIdxOfExpand = range[1];
          this.fireExpandRows(event, qx.Bootstrap.bind(this._expandToRowWithCallback1, this, event, callback));
        } else callback(success, "success");
      } else callback(success, "success");
    },
    _expandToRowWithCallback1 : function(event, callback, success, status){

      if(success){

        for(var i = event.beginIdxOfExpand;i <= event.endIdxOfExpand;++i){

          this.rows.get(i).setChangeStatus(xlsys.base.dataset.DataSetRow.STATUS_COMMON);
        };
      };
      callback(success, "success");
    },
    isVirtualRow : function(rowOrRowIndex){

      var row = null;
      if(qx.lang.Type.isNumber(rowOrRowIndex))row = this.rows.get(rowOrRowIndex); else row = rowOrRowIndex;
      return row.getChangeStatus() == xlsys.base.dataset.DataSetRow.STATUS_VIRTUAL;
    },
    expandAllRows : function(){

      for(var i = 0;i < this.getRowCount();i += this.expandPerCount)this.expandToRow(i);
    },
    getCurRow : function(){

      var row = null;
      var cursor = this.getRowCursor();
      if(cursor >= 0)row = this.getRow(cursor);
      return row;
    },
    getCurColumn : function(){

      var col = null;
      var cursor = this.getColCursor();
      if(cursor >= 0)col = this.getColumn(cursor);
      return col;
    },
    beforeFirst : function(){

      return this.gotoRow(-1);
    },
    gotoRow : function(rowOrRowIndex){

      var rowIndex = null;
      if(qx.lang.Type.isNumber(rowOrRowIndex))rowIndex = rowOrRowIndex; else rowIndex = this.getRowIndex(rowOrRowIndex);
      var postLastEditRow = true;
      if(arguments.length == 2)postLastEditRow = arguments[1];
      return this.gotoCell(rowIndex, this.getColCursor(), postLastEditRow);
    },
    gotoColumn : function(colNameOrColIndex){

      var colIndex = null;
      if(qx.lang.Type.isString(colNameOrColIndex))colIndex = this.getColumnIndex(colNameOrColIndex); else colIndex = colNameOrColIndex;
      return this.gotoCell(this.getRowCursor(), colIndex, false);
    },
    gotoCell : function(rowOrRowIndex, colNameOrColIndex){

      var rowIndex = null;
      var colIndex = null;
      var postLastEditRow = true;
      if(qx.lang.Type.isNumber(rowOrRowIndex))rowIndex = rowOrRowIndex; else rowIndex = this.getRowIndex(rowOrRowIndex);
      if(qx.lang.Type.isString(colNameOrColIndex))colIndex = this.getColumnIndex(colNameOrColIndex); else colIndex = colNameOrColIndex;
      var success = false;
      if((!this.rowRegionCheck(rowIndex) && rowIndex != -1) || (!this.colRegionCheck(colIndex) && colIndex != -1))return false;
      if(rowIndex == this.getRowCursor() && colIndex == this.getColCursor())return true;
      var postSuccess = !postLastEditRow || rowIndex == this.getRowCursor();
      if(postSuccess || this.postRow()){

        var oldRowCursor = this.getRowCursor();
        var oldColCursor = this.getColCursor();
        var oldRow = this.getRow(oldRowCursor);
        var oldCol = this.getColumn(oldColCursor);
        var toRow = this.getRow(rowIndex);
        var toCol = this.getColumn(colIndex);
        var event = new xlsys.base.dataset.DataSetEvent(this);
        event.oldRow = oldRow;
        event.oldCol = oldCol;
        event.row = toRow;
        event.col = toCol;
        this.fireBeforeCursorChange(event);
        if(event.doit && this.setRowCursor(rowIndex) && this.setColCursor(colIndex)){

          success = true;
          event = new xlsys.base.dataset.DataSetEvent(this);
          event.oldRow = oldRow;
          event.oldCol = oldCol;
          event.row = toRow;
          event.col = toCol;
          this.fireAfterCursorChange(event);
        } else {

          this.setRowCursor(oldRowCursor);
          this.setColCursor(oldColCursor);
        };
      };
      return success;
    },
    getRow : function(rowIndex){

      if(!this.rowRegionCheck(rowIndex))return null;
      if(xlsys.base.util.ObjectUtil.hasBitProp(this.style, xlsys.base.dataset.IDataSet.STYLE_VIRTUAL)){

        if(!this.expandToRow(rowIndex))return null;
      };
      return this.rows.get(rowIndex);
    },
    getRowIndex : function(row){

      if(row == null)return -1;
      return this.rows.indexOf(row);
    },
    getColumn : function(colNameOrColIndex){

      var colIndex = null;
      if(qx.lang.Type.isNumber(colNameOrColIndex))colIndex = colNameOrColIndex; else colIndex = this.getColumnIndex(colNameOrColIndex);
      if(!this.colRegionCheck(colIndex))return null;
      return this.columns.get(colIndex);
    },
    getColumnName : function(columnIndex){

      var colName = null;
      var dsc = this.getColumn(columnIndex);
      if(dsc != null)colName = dsc.getColumnName();
      return colName;
    },
    rowRegionCheck : function(rowAt){

      if(this.regionChecking)return true;
      this.regionChecking = true;
      var success = true;
      if(rowAt < 0 || rowAt >= this.getRowCount())success = false;
      if(success)success = this.expandToRow(rowAt);
      this.regionChecking = false;
      return success;
    },
    colRegionCheck : function(colAt){

      if(this.regionChecking)return true;
      this.regionChecking = true;
      var success = true;
      if(colAt < 0 || colAt >= this.getColumnCount())success = false;
      this.regionChecking = false;
      return success;
    },
    regionCheck : function(rowAt, colAt){

      return this.rowRegionCheck(rowAt) && this.colRegionCheck(colAt);
    },
    insertRow : function(row){

      var clone = false;
      if(arguments.length == 2)clone = arguments[1];
      return this.insertRowAt(this.getRowCursor(), row, clone);
    },
    insertRowAtFirst : function(row){

      var clone = false;
      if(arguments.length == 2)clone = arguments[1];
      return this.insertRowAt(0, row, clone);
    },
    insertRowAfterLast : function(row){

      var clone = false;
      if(arguments.length == 2)clone = arguments[1];
      return this.insertRowAt(this.rows.size(), row, clone);
    },
    insertRowAt : function(index, row){

      var clone = false;
      if(arguments.length == 3)clone = arguments[2];
      var newRow = null;
      if(this.postRow()){

        newRow = this.doInsertRow(index, row, clone);
        if(this.gotoRow(newRow))this.oldEditRow = newRow;
      };
      return newRow;
    },
    doInsertRow : function(index, row, clone){

      var newRow = null;
      if(clone){

        newRow = new xlsys.base.dataset.DataSetRow();
        for(var i = 0;i < row.getCells().size();++i){

          var cell = new xlsys.base.dataset.DataSetCell();
          newRow.addCell(cell);
        };
        newRow.cloneOf(row);
      } else newRow = row;
      if(index < 0)index = 0; else if(index > this.rows.size())index = this.rows.size();;
      var event = new xlsys.base.dataset.DataSetEvent(this);
      event.row = newRow;
      this.fireBeforeInsertRow(event);
      this.rows.add(index, newRow);
      if(index <= this.getRowCursor())this.setRowCursor(index + 1);
      event = new xlsys.base.dataset.DataSetEvent(this);
      event.row = newRow;
      this.fireAfterInsertRow(event);
      return newRow;
    },
    insertNewRow : function(){

      var virtual = false;
      if(arguments.length == 1)virtual = arguments[0];
      return this.insertNewRowAt(this.getRowCursor(), virtual);
    },
    insertNewRowAtFirst : function(){

      var virtual = false;
      if(arguments.length == 1)virtual = arguments[0];
      return this.insertNewRowAt(0, virtual);
    },
    insertNewRowAfterLast : function(){

      var virtual = false;
      if(arguments.length == 1)virtual = arguments[0];
      return this.insertNewRowAt(this.rows.size(), virtual);
    },
    insertNewRowAt : function(index){

      var virtual = false;
      if(arguments.length == 2)virtual = arguments[1];
      var newRow = null;
      if(this.postRow()){

        newRow = this.doInsertNewRow(index, virtual);
        if(!virtual){

          if(this.gotoRow(newRow))this.oldEditRow = newRow;
        };
      };
      return newRow;
    },
    doInsertNewRow : function(index, virtual){

      if(index < 0)index = 0; else if(index > this.rows.size())index = this.rows.size();;
      var newRow = new xlsys.base.dataset.DataSetRow(virtual);
      for(var i = 0;i < this.columns.size();++i){

        var cell = new xlsys.base.dataset.DataSetCell();
        newRow.addCell(cell);
      };
      var event = new xlsys.base.dataset.DataSetEvent(this);
      event.row = newRow;
      this.fireBeforeInsertRow(event);
      this.rows.add(index, newRow);
      if(index <= this.getRowCursor())this.setRowCursor(index + 1);
      event = new xlsys.base.dataset.DataSetEvent(this);
      event.row = newRow;
      this.fireAfterInsertRow(event);
      return newRow;
    },
    insertNewColumnAtFirst : function(){

      return this.insertNewColumnAt(0);
    },
    insertNewColumnAfterLast : function(){

      return this.insertNewColumnAt(this.columns.size());
    },
    insertNewColumn : function(){

      return this.insertNewColumnAt(this.getColCursor());
    },
    insertNewColumnAt : function(index){

      var newColumn = null;
      if(this.postRow()){

        if(index < 0)index = 0; else if(index > this.columns.size())index = this.columns.size();;
        newColumn = new xlsys.base.dataset.DataSetColumn();
        var event = new xlsys.base.dataset.DataSetEvent(this);
        event.col = newColumn;
        this.fireBeforeInsertCol(event);
        this.columns.add(index, newColumn);
        for(var i = 0;i < this.rows.size();++i){

          var cell = new xlsys.base.dataset.DataSetCell();
          var row = this.rows.get(i);
          row.getCells().add(index, cell);
        };
        if(index <= this.getColCursor())this.setColCursor(index + 1);
        event = new xlsys.base.dataset.DataSetEvent(this);
        event.col = newColumn;
        this.fireAfterInsertCol(event);
      };
      return newColumn;
    },
    removeRow : function(rowOrRowIndex){

      var rowIndex = null;
      if(qx.lang.Type.isNumber(rowOrRowIndex))rowIndex = rowOrRowIndex; else rowIndex = this.getRowIndex(rowOrRowIndex);
      if(!this.rowRegionCheck(rowIndex) || !this.expandToRow(rowIndex))return null;
      var toRemoveRow = this.rows.get(rowIndex);
      var event = new xlsys.base.dataset.DataSetEvent(this);
      event.row = toRemoveRow;
      this.fireBeforeRemoveRow(event);
      if(event.doit){

        this.doRemoveRow(rowIndex);
        event = new xlsys.base.dataset.DataSetEvent(this);
        event.row = toRemoveRow;
        this.fireAfterRemoveRow(event);
      } else toRemoveRow = null;
      if(toRemoveRow != null){

        if(this.oldEditRow == toRemoveRow)this.oldEditRow = null;
        var cursor = this.getRowCursor();
        if(cursor > rowIndex)this.setRowCursor(cursor - 1); else if(cursor == rowIndex){

          if(cursor >= this.rows.size())this.gotoRow(cursor - 1); else {

            var oldCursor = cursor;
            this.setRowCursor(-1);
            this.gotoRow(oldCursor);
          };
        };
      };
      return toRemoveRow;
    },
    doRemoveRow : function(rowNum){

      var toRemoveRow = this.rows.get(rowNum);
      this.rows.removeAt(rowNum);
      return toRemoveRow;
    },
    removeAllRow : function(){

      for(var i = this.rows.size() - 1;i >= 0;--i)this.removeRow(i);
      this.truncateAllRow();
    },
    truncateAllRow : function(){

      this.rows.clear();
      this.oldEditRow = null;
      this.setRowCursor(-1);
    },
    getValue : function(){

      return this._getValue(arguments);
    },
    _getValue : function(args){

      var rowIndex = null;
      var colIndex = null;
      if(args.length == 0){

        rowIndex = this.getRowCursor();
        colIndex = this.getColCursor();
      } else if(args.length == 1){

        rowIndex = this.getRowCursor();
        if(qx.lang.Type.isNumber(args[0]))colIndex = args[0]; else colIndex = this.getColumnIndex(args[0]);
      } else if(args.length >= 2){

        if(qx.lang.Type.isNumber(args[0]))rowIndex = args[0]; else rowIndex = this.getRowIndex(args[0]);
        if(qx.lang.Type.isNumber(args[1]))colIndex = args[1]; else colIndex = this.getColumnIndex(args[1]);
      };;
      if(!this.regionCheck(rowIndex, colIndex))return null;
      this.expandToRow(rowIndex);
      var value = null;
      var row = this.rows.get(rowIndex);
      if(row != null){

        var cell = row.getCells().get(colIndex);
        if(cell != null)value = cell.getContent();
      };
      return value;
    },
    setValue : function(){

      var rowIndex = null;
      var colIndex = null;
      var value = null;
      if(arguments.length == 1){

        rowIndex = this.getRowCursor();
        colIndex = this.getColCursor();
        value = arguments[0];
      } else if(arguments.length == 2){

        rowIndex = this.getRowCursor();
        if(qx.lang.Type.isNumber(arguments[0]))colIndex = arguments[0]; else colIndex = this.getColumnIndex(arguments[0]);
        value = arguments[1];
      } else if(arguments.length >= 3){

        if(qx.lang.Type.isNumber(arguments[0]))rowIndex = arguments[0]; else rowIndex = this.getRowIndex(arguments[0]);
        if(qx.lang.Type.isNumber(arguments[1]))colIndex = arguments[1]; else colIndex = this.getColumnIndex(arguments[1]);
        value = arguments[2];
      };;
      var success = false;
      if(!this.regionCheck(rowIndex, colIndex))return success;
      var row = this.rows.get(rowIndex);
      if(row != null){

        var cell = row.getCells().get(colIndex);
        if(cell != null){

          var oldValue = cell.getContent();
          var needSet = false;
          if(xlsys.base.util.ObjectUtil.hashcode(value) != xlsys.base.util.ObjectUtil.hashcode(oldValue))needSet = true;
          if(needSet){

            var event = new xlsys.base.dataset.DataSetEvent(this);
            event.oldValue = oldValue;
            event.newValue = value;
            event.row = row;
            event.col = this.getColumn(colIndex);
            var postRowSuccess = true;
            if(this.oldEditRow != row){

              postRowSuccess = this.postRow();
            };
            if(postRowSuccess){

              this.fireBeforePostValue(event);
              if(event.doit){

                this.doSetValue(rowIndex, colIndex, event.newValue);
                this.oldEditRow = row;
                success = true;
                this.fireAfterPostValue(event);
              };
            };
          };
        } else {

          var event = new xlsys.base.dataset.DataSetEvent(this);
          event.errMsg = new xlsys.java.lang.Exception("Cell is not initialized. Row At : " + rowIndex + "     Column At : " + colIndex);
          event.logLevel = xlsys.base.log.Log.LOG_LEVEL_ERROR;
          this.fireShowMessage(event);
        };
      };
      return success;
    },
    doSetValue : function(rowIndex, colIndex, value){

      var cell = this.rows.get(rowIndex).getCells().get(colIndex);
      cell.setContent(value);
    },
    postRow : function(){

      var rowIndex = null;
      if(arguments.length == 0)rowIndex = this.getRowIndex(this.oldEditRow); else rowIndex = arguments[0];
      var success = false;
      if(!this.rowRegionCheck(rowIndex))return true;
      var event = new xlsys.base.dataset.DataSetEvent(this);
      var row = this.getRow(rowIndex);
      event.row = row;
      this.fireBeforePostRow(event);
      if(event.doit){

        if(row == this.oldEditRow)this.oldEditRow = null;
        success = true;
        event = new xlsys.base.dataset.DataSetEvent(this);
        event.row = row;
        this.fireAfterPostRow(event);
      };
      return success;
    },
    setOption : function(option, value){

      var useCount = false;
      if(arguments.length == 3)useCount = arguments[2];
      if(useCount){

        var oldCount = this.optionMap.get(option);
        if(oldCount == null)oldCount = 0;
        if(value)this.optionMap.put(option, ++oldCount); else {

          this.optionMap.put(option, --oldCount);
          if(oldCount <= 0)this.optionMap.remove(option);
        };
      } else {

        if(value)this.optionMap.put(option, 0); else this.optionMap.remove(option);
      };
    },
    isOption : function(option){

      return this.optionMap.containsKey(option);
    },
    refDataSet : function(toRefDataSet){

      var refRows = toRefDataSet.getRows();
      var refColumns = toRefDataSet.getColumns();
      if(xlsys.base.util.ObjectUtil.hasBitProp(this.style, xlsys.base.dataset.IDataSet.STYLE_VIRTUAL)){

        this.setRowCount(refRows.size());
        this.setColumnCount(refColumns.size());
        for(var i = 0;i < refRows.size();++i){

          this.rows.get(i).cloneOf(refRows.get(i));
        };
        for(var i = 0;i < refColumns.size();++i){

          this.columns.get(i).cloneOf(refColumns.get(i));
        };
      } else {

        this.rows = refRows;
        this.columns = refColumns;
      };
      this.buildColumnMap();
    },
    setSortColumn : function(){

      this._setSortColumn(arguments);
    },
    _setSortColumn : function(args){

      if(args.length == 1 && qx.Class.implementsInterface(args[0], xlsys.java.util.Map)){

        this.setSortColMap(args[0]);
      } else {

        var colNames = args[0];
        var sortTypes = null;
        if(args.length == 2)sortTypes = args[1];
        var sortColMap = new xlsys.java.util.LinkedHashMap();
        for(var i = 0;i < colNames.length;++i){

          var sortType = xlsys.base.dataset.IDataSet.SORT_TYPE_ASC;
          if(sortTypes != null && i < sortTypes.length)sortType = sortTypes[i];
          sortColMap.put(colNames[i], sortType);
        };
        this.setSortColMap(sortColMap);
      };
    },
    setSortColMap : function(sortColMap){

      this.sortColMap.clear();
      this.sortColMap.putAll(sortColMap);
    },
    sort : function(){

      this.expandAllRows();
      var sortColIdxMap = new xlsys.java.util.LinkedHashMap();
      var sortCols = this.sortColMap.keys();
      for(var i = 0;i < sortCols.length;++i){

        var sortColName = sortCols[i];
        var colIdx = this.getColumnIndex(sortColName);
        if(colIdx != -1){

          var sortType = this.sortColMap.get(sortColName);
          sortColIdxMap.put(colIdx, sortType);
        };
      };
      var rowArray = this.rows.toArray();
      rowArray.sort(qx.Bootstrap.bind(this._sortRow, this, sortColIdxMap));
      var curRow = this.getCurRow();
      this.setEventLock(true);
      this.rows.clear();
      for(var i = 0;i < rowArray.length;++i){

        this.rows.add(rowArray[i]);
      };
      this.setRowCursor(this.getRowIndex(curRow));
      this.setEventLock(false);
    },
    _sortRow : function(sortColIdxMap, row1, row2){

      var result = 0;
      var toSortColIndices = sortColIdxMap.keys();
      for(var i = 0;i < toSortColIndices.length;++i){

        var colIdx = toSortColIndices[i];
        var sortType = sortColIdxMap.get(colIdx);
        var column = this.getColumn(colIdx);
        var content = row1.getCell(colIdx).content;
        var oContent = row2.getCell(colIdx).content;
        if(content == null && oContent == null)result = 0; else if(content != null && oContent == null)result = (sortType == xlsys.base.dataset.IDataSet.SORT_TYPE_ASC ? 1 : -1); else if(content == null && oContent != null)result = (sortType == xlsys.base.dataset.IDataSet.SORT_TYPE_ASC ? -1 : 1); else {

          if(column.javaClass == "java.lang.String"){

            result = content.localeCompare(oContent);
          } else if(column.javaClass == "java.math.BigDecimal"){

            if(content < oContent)result = -1; else if(content > oContent)result = 1; else result = 0;;
          } else if(column.javaClass == "java.util.Date"){

            var time1 = content.getTime();
            var time2 = oContent.getTime();
            if(time1 < time2)result = -1; else if(time1 > time2)result = 1; else result = 0;;
          } else if(column.javaClass == "[B"){

            var byteStr1 = content.toString();
            var byteStr2 = oContent.toString();
            result = byteStr1.localeCompare(byteStr2);
          } else {

            if(content < oContent)result = -1; else if(content > oContent)result = 1; else result = 0;;
          };;;
          result = (sortType == xlsys.base.dataset.IDataSet.SORT_TYPE_ASC ? result : result * -1);
        };;
        if(result != 0)break;
      };
      return result;
    },
    swapRow : function(i, j){

      if(i == j)return;
      var min = i < j ? i : j;
      var max = i < j ? j : i;
      this.setEventLock(true);
      var maxRow = this.removeRow(max);
      var minRow = this.removeRow(min);
      this.insertRowAt(min, maxRow, false);
      this.insertRowAt(max, minRow, false);
      this.setEventLock(false);
    },
    addDataSetListener : function(dataSetListener){

      if(this.dataSetListenerSet == null)this.dataSetListenerSet = new xlsys.java.util.LinkedHashSet();
      this.dataSetListenerSet.add(dataSetListener);
      var event = new xlsys.base.dataset.DataSetEvent(this);
      this.fireAfterAddToDataSet(dataSetListener, event);
    },
    removeDataSetListener : function(dataSetListener){

      if(this.dataSetListenerSet != null){

        if(this.dataSetListenerSet.remove(dataSetListener)){

          var event = new xlsys.base.dataset.DataSetEvent(this);
          this.fireBeforeRemoveFromDataSet(dataSetListener, event);
        };
      };
    },
    getDataSetListeners : function(){

      return this.dataSetListenerSet;
    },
    refresh : function(){

      var event = new xlsys.base.dataset.DataSetEvent(this);
      this.fireBeforeRefresh(event);
      this.refreshing();
      event = new xlsys.base.dataset.DataSetEvent(this);
      this.fireAfterRefresh(event);
    },
    refreshing : function(){
    },
    setEventLock : function(){

      var dataSet = this;
      var lock = false;
      if(arguments.length == 1)lock = arguments[0]; else {

        dataSet = arguments[0];
        lock = arguments[1];
      };
      var thisClass = xlsys.base.util.ObjectUtil.getClass(this);
      var staticFieldMap = xlsys.base.util.ReflectUtil.getAllStaticFieldMap(thisClass);
      var staticFields = staticFieldMap.keys();
      for(var i = 0;i < staticFields.length;++i){

        var fieldName = staticFields[i];
        if(qx.lang.String.startsWith(fieldName, "OPTION_LOCK_")){

          this.setOption(staticFieldMap.get(fieldName), lock, true);
        };
      };
    },
    fireBeforeInsertRow : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_INSERT_ROW_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforeInsertRow(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterInsertRow : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_INSERT_ROW_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterInsertRow(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforeInsertCol : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_INSERT_COL_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforeInsertCol(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterInsertCol : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_INSERT_COL_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterInsertCol(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforeRemoveRow : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_REMOVE_ROW_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforeRemoveRow(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterRemoveRow : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_REMOVE_ROW_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterRemoveRow(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforeRemoveCol : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_REMOVE_COL_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforeRemoveCol(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterRemoveCol : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_REMOVE_COL_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterRemoveCol(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforeRefresh : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforeRefresh(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterRefresh : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterRefresh(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterAddToDataSet : function(dataSetListener, event){

      try{

        if(dataSetListener != null){

          dataSetListener.afterAddToDataSet(event);
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforeRemoveFromDataSet : function(dataSetListener, event){

      try{

        if(dataSetListener != null){

          dataSetListener.beforeRemoveFromDataSet(event);
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireShowMessage : function(event){

      if(this.dataSetListenerSet != null){

        var listeners = this.dataSetListenerSet.toArray();
        for(var i = 0;i < listeners.length;++i){

          var listener = listeners[i];
          listener.showMessage(event);
          if(event.interrupt)break;
        };
      };
    },
    fireBeforePostValue : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_POST_VALUE_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforePostValue(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterPostValue : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_POST_VALUE_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterPostValue(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforePostRow : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_POST_ROW_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforePostRow(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterPostRow : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_POST_ROW_EVENT))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterPostRow(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforeCursorChange : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_CURSOR_CHANGE))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.beforeCursorChange(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterCursorChange : function(event){

      if(this.isOption(xlsys.base.dataset.IDataSet.OPTION_LOCK_CURSOR_CHANGE))return;
      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.afterCursorChange(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireExpandRows : function(event){

      if(arguments.length == 1)return this._fireExpandRows(event); else this._fireExpandRowsWithCallback(event, arguments[1]);
    },
    _fireExpandRows : function(event){

      try{

        this.setEventLock(true);
        var oldRowCursor = this.getRowCursor();
        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.expandRows(event);
            if(event.interrupt)break;
          };
        };
        this.setRowCursor(oldRowCursor);
        this.setEventLock(false);
        if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
      return event.doit;
    },
    _fireExpandRowsWithCallback : function(event, callback){

      this.setEventLock(true);
      var oldRowCursor = this.getRowCursor();
      if(this.dataSetListenerSet != null){

        var listeners = this.dataSetListenerSet.toArray();
        if(listeners.length > 0){

          var listener = listeners[0];
          listener.expandRows(event, qx.Bootstrap.bind(this._expandCallBack1, this, callback, event, oldRowCursor, listeners, 0));
        };
      } else this._expandCallback2(callback, event, oldRowCursor);
    },
    _expandCallBack1 : function(callback, event, oldRowCursor, listeners, idx, data, status){

      var finish = false;
      if(!event.interrupt){

        var nextIdx = idx + 1;
        if(nextIdx < listeners.length){

          var listener = listeners[nextIdx];
          listener.expandRows(event, qx.Bootstrap.bind(this._expandCallBack1, this, callback, event, oldRowCursor, listeners, nextIdx));
        } else finish = true;
      } else finish = true;
      if(finish)this._expandCallback2(callback, event, oldRowCursor);
    },
    _expandCallback2 : function(callback, event, oldRowCursor){

      this.setRowCursor(oldRowCursor);
      this.setEventLock(false);
      if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
      callback(event.doit, "success");
    },
    fireCustomTrigger : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            listener.customTrigger(event);
            if(event.interrupt)break;
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    getColumns : function(){

      return this.columns;
    },
    getRows : function(){

      return this.rows;
    },
    getName : function(){

      return this.name;
    },
    setName : function(name){

      this.name = name;
    },
    getStyle : function(){

      return this.style;
    },
    getSortColMap : function(){

      return this.sortColMap;
    }
  }
});
qx.Interface.define("xlsys.java.util.Map", {
  members : {
    clear : function(){
    },
    containsKey : function(key){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    containsValue : function(value){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    get : function(key){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    isEmpty : function(){
    },
    put : function(key, value){

      this.assertArgumentsCount(arguments, 2, 2);
    },
    putAll : function(m){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    remove : function(key){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    size : function(){
    },
    keys : function(){
    },
    values : function(){
    },
    keySet : function(){
    },
    entrySet : function(){
    }
  }
});
qx.Class.define("xlsys.java.util.LinkedHashMap", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Map],
  construct : function(){

    this.__map = new Object();
    this.__keys = new Array();
  },
  members : {
    __map : null,
    __keys : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil._getHashKey(obj);
    },
    getClassName : function(){

      return "java.util.LinkedHashMap";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__map");
      arr.push("__keys");
      return arr;
    },
    clear : function(){

      for(var fieldName in this.__map){

        delete this.__map[fieldName];
      };
      while(this.__keys.pop() != null);
    },
    containsKey : function(key){

      var keyHash = this._getHashKey(key);
      return this.__map[keyHash] != null;
    },
    containsValue : function(value){

      var contains = false;
      for(var fieldName in this.__map){

        if(this._getHashKey(this.__map[fieldName]) == this._getHashKey(value)){

          contains = true;
          break;
        };
      };
      return contains;
    },
    get : function(key){

      var keyHash = this._getHashKey(key);
      return this.__map[keyHash];
    },
    isEmpty : function(){

      return this.__keys.length == 0;
    },
    put : function(key, value){

      if(!this.containsKey(key))this.__keys.push(key);
      var keyHash = this._getHashKey(key);
      this.__map[keyHash] = value;
    },
    putAll : function(m){

      var keyArr = m.keys();
      for(var i = 0;i < keyArr.length;++i){

        this.put(keyArr[i], m.get(keyArr[i]));
      };
    },
    remove : function(key){

      var keyHash = this._getHashKey(key);
      if(delete this.__map[keyHash]){

        for(var i = 0;i < this.__keys.length;++i){

          if(this._getHashKey(this.__keys[i]) == keyHash){

            this.__keys.splice(i, 1);
            break;
          };
        };
      };
    },
    size : function(){

      return this.__keys.length;
    },
    keys : function(){

      var tempArr = new Array();
      for(var i = 0;i < this.__keys.length;++i){

        tempArr.push(this.__keys[i]);
      };
      return tempArr;
    },
    values : function(){

      var tempArr = new Array();
      for(var i = 0;i < this.__keys.length;++i){

        var keyHash = this._getHashKey(this.__keys[i]);
        tempArr.push(this.__map[keyHash]);
      };
      return tempArr;
    },
    keySet : function(){

      var set = new xlsys.java.util.LinkedHashSet();
      for(var i = 0;i < this.__keys.length;++i){

        set.add(this.__keys[i]);
      };
      return set;
    },
    entrySet : function(){

      var set = new xlsys.java.util.LinkedHashSet();
      for(var i = 0;i < this.__keys.length;++i){

        var key = this.__keys[i];
        var keyHash = this._getHashKey(this.__keys[i]);
        var value = this.__map[keyHash];
        var entry = new xlsys.java.util.SimpleEntry(key, value);
        set.add(entry);
      };
      return set;
    }
  }
});
qx.Interface.define("xlsys.java.util.Collection", {
  members : {
    add : function(element){
    },
    addAll : function(collection){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    clear : function(){
    },
    contains : function(element){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    remove : function(element){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    size : function(){
    },
    isEmpty : function(){
    },
    toArray : function(){
    }
  }
});
qx.Interface.define("xlsys.java.util.Set", {
  extend : [xlsys.java.util.Collection]
});
qx.Class.define("xlsys.java.util.LinkedHashSet", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Set],
  construct : function(){

    this.__array = new Array();
    this.__map = new Object();
  },
  members : {
    __array : null,
    __map : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil._getHashKey(obj);
    },
    getClassName : function(){

      return "java.util.LinkedHashSet";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__array");
      arr.push("__map");
      return arr;
    },
    add : function(element){

      if(!this.contains(element))this.__array.push(element);
      var hash = this._getHashKey(element);
      this.__map[hash] = element;
    },
    addAll : function(collection){

      var arr = collection.toArray();
      for(var i = 0;i < arr.length;++i){

        this.add(arr[i]);
      };
    },
    clear : function(){

      for(var fieldName in this._map){

        delete this.__map[fieldName];
      };
      while(this.__array.pop() != null);
    },
    contains : function(element){

      var hash = this._getHashKey(element);
      var contain = this.__map[hash] != null;
      return contain;
    },
    remove : function(element){

      var hash = this._getHashKey(element);
      if(delete this.__map[hash]){

        for(var i = 0;i < this.__array.length;++i){

          if(this._getHashKey(this.__array[i]) == hash){

            this.__array.splice(i, 1);
            break;
          };
        };
      };
    },
    size : function(){

      return this.__array.length;
    },
    isEmpty : function(){

      return this.__array.length == 0;
    },
    toArray : function(){

      var tempArr = new Array();
      for(var i = 0;i < this.__array.length;++i){

        tempArr.push(this.__array[i]);
      };
      return tempArr;
    }
  }
});
qx.Interface.define("xlsys.java.util.Entry", {
  members : {
    getKey : function(){
    },
    getValue : function(){
    },
    setValue : function(value){

      this.assertArgumentsCount(arguments, 1, 1);
    }
  }
});
qx.Class.define("xlsys.java.util.SimpleEntry", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Entry],
  construct : function(key, value){

    this.__key = key;
    this.__value = value;
  },
  members : {
    __key : null,
    __value : null,
    getClassName : function(){

      return "java.util.AbstractMap.SimpleEntry";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__key");
      arr.push("__value");
      return arr;
    },
    getKey : function(){

      return this.__key;
    },
    getValue : function(){

      return this.__value;
    },
    setValue : function(value){

      this.__value = value;
    }
  }
});
qx.Interface.define("xlsys.java.util.List", {
  extend : [xlsys.java.util.Collection],
  members : {
    add : function(element){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    get : function(index){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    indexOf : function(element){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    removeAt : function(index){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    set : function(index, element){

      this.assertArgumentsCount(arguments, 2, 2);
    }
  }
});
qx.Class.define("xlsys.java.util.ArrayList", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.List],
  construct : function(){

    this.__array = new Array();
  },
  members : {
    __array : null,
    getClassName : function(){

      return "java.util.ArrayList";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__array");
      return arr;
    },
    add : function(){

      if(arguments.length == 1)this.__array.push(arguments[0]); else if(arguments.length >= 2)this.__array.splice(arguments[0], 0, arguments[1]);;
    },
    addAll : function(collection){

      var arr = collection.toArray();
      for(var i = 0;i < arr.length;++i){

        this.add(arr[i]);
      };
    },
    clear : function(){

      while(this.__array.pop() != null);
    },
    contains : function(element){

      return this.indexOf(element) != -1;
    },
    remove : function(element){

      var index = this.indexOf(element);
      if(index != -1)this.removeAt(index);
    },
    size : function(){

      return this.__array.length;
    },
    toArray : function(){

      var tempArr = new Array();
      for(var i = 0;i < this.__array.length;++i){

        tempArr.push(this.__array[i]);
      };
      return tempArr;
    },
    get : function(index){

      return this.__array[index];
    },
    indexOf : function(element){

      return this.__array.indexOf(element);
    },
    isEmpty : function(){

      return this.size() == 0;
    },
    removeAt : function(index){

      this.__array.splice(index, 1);
    },
    set : function(index, element){

      this.__array.splice(index, 1, element);
    }
  }
});
qx.Class.define("xlsys.java.util.HashMap", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Map],
  construct : function(){

    this.__keymap = new Object();
    this.__valuemap = new Object();
    this.__size = 0;
  },
  members : {
    __keymap : null,
    __valuemap : null,
    __size : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil._getHashKey(obj);
    },
    getClassName : function(){

      return "java.util.HashMap";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__keymap");
      arr.push("__valuemap");
      arr.push("__size");
      return arr;
    },
    clear : function(){

      for(var fieldName in this.__keymap){

        delete this.__keymap[fieldName];
      };
      for(var fieldName in this.__valuemap){

        delete this.__valuemap[fieldName];
      };
      this.__size = 0;
    },
    containsKey : function(key){

      var keyHash = this._getHashKey(key);
      var contains = this.__keymap[keyHash] != null;
      return contains;
    },
    containsValue : function(value){

      var contains = false;
      for(var fieldName in this.__valuemap){

        if(this._getHashKey(this.__valuemap[fieldName]) == this._getHashKey(value)){

          contains = true;
          break;
        };
      };
      return contains;
    },
    get : function(key){

      var keyHash = this._getHashKey(key);
      return this.__valuemap[keyHash];
    },
    isEmpty : function(){

      return this.__size == 0;
    },
    put : function(key, value){

      if(!this.containsKey(key))++this.__size;
      var keyHash = this._getHashKey(key);
      this.__keymap[keyHash] = key;
      this.__valuemap[keyHash] = value;
    },
    putAll : function(m){

      var keyArr = m.keys();
      for(var i = 0;i < keyArr.length;++i){

        this.put(keyArr[i], m.get(keyArr[i]));
      };
    },
    remove : function(key){

      var keyHash = this._getHashKey(key);
      if(delete this.__keymap[keyHash]){

        delete this.__valuemap[keyHash];
        --this.__size;
      };
    },
    size : function(){

      return this.__size;
    },
    keys : function(){

      var tempArr = new Array();
      for(var fieldName in this.__keymap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        tempArr.push(this.__keymap[fieldName]);
      };
      return tempArr;
    },
    values : function(){

      var tempArr = new Array();
      for(var fieldName in this.__valuemap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        tempArr.push(this.__valuemap[fieldName]);
      };
      return tempArr;
    },
    keySet : function(){

      var set = new xlsys.java.util.HashSet();
      for(var fieldName in this.__keymap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        set.add(this.__keymap[fieldName]);
      };
      return set;
    },
    entrySet : function(){

      var set = new xlsys.java.util.HashSet();
      for(var fieldName in this.__keymap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        var entry = new xlsys.java.util.SimpleEntry(this.__keymap[fieldName], this.__valuemap[fieldName]);
        set.add(entry);
      };
      return set;
    }
  }
});
qx.Class.define("xlsys.java.util.HashSet", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Set],
  construct : function(){

    this.__map = new Object();
    this.__size = 0;
  },
  members : {
    __map : null,
    __size : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil._getHashKey(obj);
    },
    getClassName : function(){

      return "java.util.HashSet";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__map");
      arr.push("__size");
      return arr;
    },
    add : function(element){

      var hash = this._getHashKey(element);
      if(!this.__map[hash])++this.__size;
      this.__map[hash] = element;
    },
    addAll : function(collection){

      var arr = collection.toArray();
      for(var i = 0;i < arr.length;++i){

        this.add(arr[i]);
      };
    },
    clear : function(){

      for(var fieldName in this.__map){

        delete this.__map[fieldName];
      };
      this.__size = 0;
    },
    contains : function(element){

      var hash = this._getHashKey(element);
      var contain = this.__map[hash] != null;
      return contain;
    },
    remove : function(element){

      var hash = this._getHashKey(element);
      if(delete this.__map[hash])--this.__size;
    },
    size : function(){

      return this.__size;
    },
    isEmpty : function(){

      return this.__size == 0;
    },
    toArray : function(){

      var tempArr = new Array();
      for(var fieldName in this.__map){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        tempArr.push(this.__map[fieldName]);
      };
      return tempArr;
    }
  }
});
qx.Class.define("xlsys.java.util.EventObject", {
  extend : xlsys.java.io.Serializable,
  construct : function(source){

    this.source = source;
  },
  members : {
    source : null,
    getSerializableMembers : function(){

      var arr = new Array();
      return arr;
    },
    getSource : function(){

      return this.source;
    }
  }
});
qx.Class.define("xlsys.base.event.XlsysEvent", {
  extend : xlsys.java.util.EventObject,
  construct : function(source){

    xlsys.java.util.EventObject.call(this, source);
    this.srcEvent = null;
    this.interrupt = false;
    this.doit = true;
    this.errMsg = null;
    this.data = null;
    this.dataMap = null;
    if(arguments.length == 2)this.srcEvent = arguments[1];
  },
  members : {
    srcEvent : null,
    interrupt : null,
    doit : null,
    errMsg : null,
    data : null,
    dataMap : null,
    getSerializableMembers : function(){

      var arr = xlsys.java.util.EventObject.prototype.getSerializableMembers.call(this);
      arr.push("srcEvent");
      arr.push("interrupt");
      arr.push("doit");
      arr.push("errMsg");
      return arr;
    },
    getSrcEvent : function(){

      return this.srcEvent;
    }
  }
});
qx.Class.define("xlsys.base.dataset.DataSetEvent", {
  extend : xlsys.base.event.XlsysEvent,
  construct : function(dataSet){

    if(arguments.length > 1)xlsys.base.event.XlsysEvent.call(this, dataSet, arguments[1]); else xlsys.base.event.XlsysEvent.call(this, dataSet);
    this.dataSet = dataSet;
    this.oldValue = null;
    this.newValue = null;
    this.oldRow = null;
    this.oldCol = null;
    this.row = null;
    this.col = null;
    this.beginIdxOfExpand = null;
    this.endIdxOfExpand = null;
    this.logLevel = null;
    this.customId = null;
    this.customData = null;
  },
  members : {
    dataSet : null,
    oldValue : null,
    newValue : null,
    oldRow : null,
    oldCol : null,
    row : null,
    col : null,
    beginIdxOfExpand : null,
    endIdxOfExpand : null,
    logLevel : null,
    customId : null,
    customData : null,
    getSerializableMembers : function(){

      var arr = xlsys.base.event.XlsysEvent.prototype.getSerializableMembers.call(this);
      arr.push("dataSet");
      arr.push("oldValue");
      arr.push("newValue");
      arr.push("oldRow");
      arr.push("oldCol");
      arr.push("row");
      arr.push("col");
      arr.push("beginIdxOfExpand");
      arr.push("endIdxOfExpand");
      arr.push("logLevel");
      arr.push("customId");
      arr.push("customData");
      return arr;
    },
    getDataSet : function(){

      return this.dataSet;
    }
  }
});
qx.Class.define("xlsys.base.dataset.DataSetRow", {
  extend : xlsys.java.io.Serializable,
  statics : {
    STATUS_VIRTUAL : 0,
    STATUS_COMMON : 1,
    STATUS_FOR_NEW : 2,
    STATUS_REPLACE : 4
  },
  construct : function(){

    this.changed = false;
    this.changeStatus = null;
    this.oldChangeStatus = null;
    this.cells = new xlsys.java.util.ArrayList();
    this.properties = null;
    if(arguments.length == 1 && arguments[0]){

      this.changeStatus = this.self(arguments).STATUS_VIRTUAL;
      this.oldChangeStatus = this.self(arguments).STATUS_VIRTUAL;
    } else {

      this.changeStatus = this.self(arguments).STATUS_COMMON;
      this.oldChangeStatus = this.self(arguments).STATUS_COMMON;
    };
  },
  members : {
    changed : null,
    changeStatus : null,
    oldChangeStatus : null,
    cells : null,
    properties : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("cells");
      return arr;
    },
    addCell : function(cell){

      this.cells.add(cell);
    },
    removeCell : function(cellIndex){

      this.cells.removeAt(cellIndex);
    },
    getCell : function(index){

      return this.cells.get(index);
    },
    setCell : function(index, cell){

      this.cells.set(index, cell);
    },
    getCells : function(){

      return this.cells;
    },
    setCells : function(cells){

      this.cells = cells;
    },
    isChanged : function(){

      return this.changed;
    },
    setChanged : function(changed){

      this.changed = changed;
    },
    getChangeStatus : function(){

      return this.changeStatus;
    },
    setChangeStatus : function(changeStatus){

      this.oldChangeStatus = this.changeStatus;
      this.changeStatus = changeStatus;
    },
    getOldChangeStatus : function(){

      return this.oldChangeStatus;
    },
    getProperties : function(){

      return this.properties;
    },
    putProperty : function(key, value){

      if(this.properties == null)this.properties = new xlsys.java.util.HashMap();
      this.properties.put(key, value);
    },
    containsProperty : function(key){

      var contains = false;
      if(this.properties != null){

        contains = this.properties.containsKey(key);
      };
      return contains;
    },
    removeProperty : function(key){

      if(this.properties != null){

        this.properties.remove(key);
      };
    },
    getProperty : function(key){

      var value = null;
      if(this.properties != null){

        value = this.properties.get(key);
      };
      return value;
    },
    cloneOf : function(anotherRow){

      for(var i = 0;i < anotherRow.cells.size();++i){

        var cell = null;
        if(i >= this.cells.size()){

          cell = new xlsys.base.dataset.DataSetCell();
          this.cells.add(cell);
        } else cell = this.cells.get(i);
        cell.setContent(anotherRow.cells.get(i).getContent());
      };
      for(var i = this.cells.size() - 1;i >= anotherRow.cells.size();--i)this.cells.removeAt(i);
      this.changed = anotherRow.changed;
      this.changeStatus = anotherRow.changeStatus;
      this.oldChangeStatus = anotherRow.oldChangeStatus;
    }
  }
});
qx.Class.define("xlsys.base.dataset.DataSetCell", {
  extend : xlsys.java.io.Serializable,
  construct : function(){

    this.content = null;
    this.oldContent = null;
  },
  members : {
    content : null,
    oldContent : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("content");
      arr.push("oldContent");
      return arr;
    },
    getContent : function(){

      return this.content;
    },
    setContent : function(content){

      this.content = content;
    },
    getOldContent : function(){

      return this.oldContent;
    },
    setOldContent : function(oldContent){

      this.oldContent = oldContent;
    }
  }
});
qx.Class.define("xlsys.base.dataset.DataSetColumn", {
  extend : xlsys.java.io.Serializable,
  construct : function(){

    this.columnName = null;
    this.javaClass = null;
    this.dbColumnType = null;
    this.sqlType = null;
    this.precision = null;
    this.scale = null;
    this.nullAble = null;
    this.primaryKey = null;
  },
  members : {
    columnName : null,
    javaClass : null,
    dbColumnType : null,
    sqlType : null,
    precision : null,
    scale : null,
    nullAble : null,
    primaryKey : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("columnName");
      arr.push("javaClass");
      arr.push("dbColumnType");
      arr.push("sqlType");
      arr.push("precision");
      arr.push("scale");
      arr.push("nullAble");
      arr.push("primaryKey");
      return arr;
    },
    getColumnName : function(){

      return this.columnName;
    },
    setColumnName : function(columnName){

      this.columnName = columnName;
    },
    getDbColumnType : function(){

      return this.dbColumnType;
    },
    setDbColumnType : function(dbColumnType){

      this.dbColumnType = dbColumnType;
    },
    getSqlType : function(){

      return this.sqlType;
    },
    setSqlType : function(sqlType){

      this.sqlType = sqlType;
    },
    getJavaClass : function(){

      return this.javaClass;
    },
    setJavaClass : function(javaClass){

      this.javaClass = javaClass;
    },
    getPrecision : function(){

      return this.precision;
    },
    setPrecision : function(precision){

      this.precision = precision;
    },
    getScale : function(){

      return this.scale;
    },
    setScale : function(scale){

      this.scale = scale;
    },
    isNullAble : function(){

      return this.nullAble;
    },
    setNullAble : function(nullAble){

      this.nullAble = nullAble;
    },
    isPrimaryKey : function(){

      return this.primaryKey;
    },
    setPrimaryKey : function(primaryKey){

      this.primaryKey = primaryKey;
    },
    cloneOf : function(anotherCol){

      if(anotherCol != null){

        this.columnName = anotherCol.getColumnName();
        this.javaClass = anotherCol.getJavaClass();
        this.dbColumnType = anotherCol.getDbColumnType();
        this.sqlType = anotherCol.getSqlType();
        this.precision = anotherCol.getPrecision();
        this.scale = anotherCol.getScale();
        this.nullAble = anotherCol.isNullAble();
        this.primaryKey = anotherCol.isPrimaryKey();
      };
    }
  }
});
qx.Class.define("xlsys.base.log.Log", {
  type : "abstract",
  extend : qx.core.Object,
  statics : {
    LOG_LEVEL_DEBUG : 50,
    LOG_LEVEL_INFO : 40,
    LOG_LEVEL_WARN : 30,
    LOG_LEVEL_ERROR : 20,
    LOG_LEVEL_FATAL : 10,
    LOG_LEVEL_NONE : 0
  },
  construct : function(logLevel){

    this.logLevel = logLevel;
  },
  members : {
    logLevel : null,
    print : function(){

      var level = this.logLevel;
      var content = null;
      if(arguments.length == 2){

        level = arguments[0];
        content = arguments[1];
      } else content = arguments[0];
      if(level <= this.logLevel)return this.write(level, content);
      return 0;
    },
    printInfo : function(content){

      return this.print(this.self(arguments).LOG_LEVEL_INFO, content);
    },
    printWarn : function(content){

      return this.print(this.self(arguments).LOG_LEVEL_WARN, content);
    },
    printError : function(content){

      return this.print(this.self(arguments).LOG_LEVEL_ERROR, content);
    },
    printFatal : function(content){

      return this.print(this.self(arguments).LOG_LEVEL_FATAL, content);
    },
    write : function(level, content){
    },
    println : function(){

      var level = this.logLevel;
      var content = null;
      if(arguments.length == 2){

        level = arguments[0];
        content = arguments[1];
      } else content = arguments[0];
      if(level <= this.logLevel)return this.writeln(level, content);
      return 0;
    },
    printlnInfo : function(content){

      return this.println(this.self(arguments).LOG_LEVEL_INFO, content);
    },
    printlnWarn : function(content){

      return this.println(this.self(arguments).LOG_LEVEL_WARN, content);
    },
    printlnError : function(content){

      return this.println(this.self(arguments).LOG_LEVEL_ERROR, content);
    },
    printlnFatal : function(content){

      return this.println(this.self(arguments).LOG_LEVEL_FATAL, content);
    },
    writeln : function(level, content){

      var ret = this.write(level, content);
      if(ret >= 0){

        ret += this.write(level, "\n");
      };
      return ret;
    },
    setLogLevel : function(logLevel){

      this.logLevel = logLevel;
    },
    getLogLevel : function(){

      return this.logLevel;
    },
    close : function(){
    }
  }
});
qx.Class.define("xlsys.base.util.ReflectUtil", {
  type : "static",
  statics : {
    newInstance : function(className, params){

      var targetClass = xlsys.base.util.ObjectUtil.getClassByName(className);
      var ret = null;
      var error = null;
      var sb = new xlsys.java.lang.StringBuilder();
      sb.append(className).append(".getInstance");
      if(eval(sb.toString()) != null){

        sb.append("(");
        this.__addInstanceParams(sb, params);
        sb.append(");");
        try{

          ret = eval(sb.toString());
        } catch(err) {

          error = err;
        };
      };
      if(ret == null){

        sb = new xlsys.java.lang.StringBuilder();
        sb.append("new ").append(className).append("(");
        this.__addInstanceParams(sb, params);
        sb.append(");");
        try{

          ret = eval(sb.toString());
        } catch(err) {

          error = err;
        };
      };
      if(ret == null && error != null)throw error;
      return ret;
    },
    __addInstanceParams : function(sb, params){

      if(params == null)return;
      if(qx.lang.Type.isArray(params)){

        for(var i = 0;i < params.length;++i){

          sb.append("params[").append(i).append("]");
          if(i != params.length - 1)sb.append(",");
        };
      } else {

        for(var i = 1;i < arguments.length;++i){

          sb.append("arguments[").append(i).append("]");
          if(i != arguments.length - 1)sb.append(",");
        };
      };
    },
    invokeStaticMethod : function(invokeStr){

      var arr = invokeStr.split(xlsys.base.XLSYS.PARAM_QUESTION);
      var map = null;
      if(arr.length > 1){

        map = new xlsys.java.util.HashMap();
        var params = arr[1].split(xlsys.base.XLSYS.PARAM_AND);
        for(var i = 0;i < params.length;++i){

          var varParam = params[i].split(xlsys.base.XLSYS.PARAM_RELATION);
          map.put(varParam[0], varParam[1]);
        };
      };
      var sb = new xlsys.java.lang.StringBuilder();
      sb.append(arr[0]).append("(");
      if(map != null)sb.append("map");
      sb.append(");");
      return eval(sb.toString());
    },
    getAllStaticFieldMap : function(objClass){

      if(objClass == null)return null;
      var staticFieldMap = new xlsys.java.util.LinkedHashMap();
      var field = null;
      var interfaces = qx.Class.getInterfaces(objClass);
      for(var i = 0;i < interfaces.length;++i){

        var tempInterface = interfaces[i];
        for(field in tempInterface){

          staticFieldMap.put(field, tempInterface[field]);
        };
      };
      var mixins = qx.Class.getMixins(objClass);
      for(var i = 0;i < mixins.length;++i){

        var tempMixin = mixins[i];
        for(field in tempMixin){

          staticFieldMap.put(field, tempMixin[field]);
        };
      };
      var tempClass = objClass;
      while(tempClass != null){

        for(field in tempClass){

          staticFieldMap.put(field, tempClass[field]);
        };
        tempClass = tempClass.superclass;
      };
      return staticFieldMap;
    },
    getStaticFieldMap : function(objClass){

      if(objClass == null)return null;
      var staticFieldMap = new xlsys.java.util.LinkedHashMap();
      var field = null;
      for(field in objClass){

        staticFieldMap.put(field, objClass[field]);
      };
      return staticFieldMap;
    },
    getStaticFieldMapWithPrefix : function(objClass, fieldPrefix, containsParent){

      var targetMap = new xlsys.java.util.LinkedHashMap();
      var staticFieldMap = null;
      if(containsParent)staticFieldMap = this.getAllStaticFieldMap(objClass); else staticFieldMap = this.getStaticFieldMap(objClass);
      var keys = staticFieldMap.keys();
      for(var i = 0;i < keys.length;++i){

        var fieldName = keys[i];
        if(!qx.lang.String.startsWith(fieldName, fieldPrefix))continue;
        targetMap.put(fieldName, staticFieldMap.get(fieldName));
      };
      return targetMap;
    },
    getFieldParamMap : function(paramStr){

      var paramMap = new xlsys.java.util.HashMap();
      if(paramStr != null){

        var paramArr = paramStr.split(xlsys.base.XLSYS.PARAM_AND);
        for(var i = 0;i < paramArr.length;++i){

          var pair = paramArr[i].split(xlsys.base.XLSYS.PARAM_RELATION);
          var beginIdx = pair[0].indexOf("(");
          var endIdx = pair[0].indexOf(")");
          var fieldName = pair[0];
          var fieldClass = "String";
          if(beginIdx != -1){

            fieldName = pair[0].substring(0, beginIdx);
            fieldClass = pair[0].substring(beginIdx + 1, endIdx);
          };
          var containsKeyCodeSeparator = pair[1].indexOf(xlsys.base.XLSYS.KEY_CODE_SEPARATOR) != -1;
          var containsCodeNameRelation = pair[1].indexOf(xlsys.base.XLSYS.CODE_NAME_RELATION) != -1;
          var fieldValue = null;
          if(containsCodeNameRelation){

            fieldValue = new xlsys.java.util.LinkedHashMap();
            var codeNameArr = pair[1].split(xlsys.base.XLSYS.KEY_CODE_SEPARATOR);
            for(var j = 0;j < codeNameArr.length;++j){

              var codeNamePair = codeNameArr[j].split(xlsys.base.XLSYS.CODE_NAME_RELATION);
              var code = this._getCodeDataWithFieldClass(fieldClass, codeNamePair[0]);
              fieldValue.put(code, codeNamePair[1]);
            };
          } else if(containsKeyCodeSeparator){

            fieldValue = new Array();
            var codeArr = pair[1].split(xlsys.base.XLSYS.KEY_CODE_SEPARATOR);
            for(var j = 0;j < codeArr.length;++j){

              var code = this._getCodeDataWithFieldClass(fieldClass, codeArr[j]);
              fieldValue.push(code);
            };
          } else {

            var code = this._getCodeDataWithFieldClass(fieldClass, pair[1]);
            fieldValue = code;
          };
          paramMap.put(fieldName, fieldValue);
        };
      };
      return paramMap;
    },
    _getCodeDataWithFieldClass : function(fieldClass, codeStr){

      var code = null;
      if(fieldClass == "String")code = codeStr; else if(fieldClass == "Number")code = Number(codeStr); else if(fieldClass == "Boolean")code = xlsys.base.util.ObjectUtil.objectToBoolean(codeStr);;;
      return code;
    },
    getStaticFieldCodeAndNameMap : function(){

      var objClass = null;
      var fieldPrefix = null;
      var containsParent = null;
      if(arguments.length == 1){

        var paramMap = arguments[0];
        var className = paramMap.get("className");
        objClass = xlsys.base.util.ObjectUtil.getClassByName(className);
        fieldPrefix = paramMap.get("fieldPrefix");
        containsParent = xlsys.base.util.ObjectUtil.objectToBoolean(paramMap.get("containsParent"));
      } else if(arguments.length == 3){

        objClass = arguments[0];
        fieldPrefix = arguments[1];
        containsParent = arguments[2];
      };
      var codeNameMap = new xlsys.java.util.LinkedHashMap();
      var staticFieldMap = null;
      if(containsParent)staticFieldMap = this.getAllStaticFieldMap(objClass); else staticFieldMap = this.getStaticFieldMap(objClass);
      var keys = staticFieldMap.keys();
      for(var i = 0;i < keys.length;++i){

        var fieldName = keys[i];
        if(!qx.lang.String.startsWith(fieldName, fieldPrefix))continue;
        var code = staticFieldMap.get(fieldName);
        var tempNameArr = fieldName.substring(fieldPrefix.length).toLowerCase().split("_");
        var name = tempNameArr[0];
        for(var j = 1;j < tempNameArr.length;++j){

          name += qx.lang.String.firstUp(tempNameArr[j]);
        };
        codeNameMap.put(code, name);
      };
      return codeNameMap;
    }
  }
});
qx.Interface.define("xlsys.base.XLSYS", {
  statics : {
    JSON_OBJ_HASHCODE : "_hashcode",
    JSON_OBJ_CONTENT : "_content",
    JSON_OBJ_DATA_TYPE : "_datatype",
    JSON_OBJ_CLASS : "_classname",
    PLATFORM : "_PLATFORM",
    PLATFORM_WEB : 1,
    PLATFORM_MOBILE : 2,
    PLATFORM_TEMPLATE : 3,
    PLATFORM_DESKTOP : 4,
    PLATFORM_PURE_JSON : 5,
    OS_ANDROID : 1,
    OS_IOS : 2,
    DATA_TYPE_NULL : 0,
    DATA_TYPE_STR : 1,
    DATA_TYPE_SHORT : 2,
    DATA_TYPE_INT : 3,
    DATA_TYPE_LONG : 4,
    DATA_TYPE_CHAR : 5,
    DATA_TYPE_BOOL : 7,
    DATA_TYPE_FLOAT : 8,
    DATA_TYPE_DOUBLE : 9,
    DATA_TYPE_BYTE : 10,
    DATA_TYPE_BYTE_ARRAY : 11,
    DATA_TYPE_OBJECT : 12,
    DATA_TYPE_OBJECT_ARRAY : 13,
    DATA_TYPE_COLLECTION : 14,
    DATA_TYPE_MAP : 15,
    DATA_TYPE_BIGDECIMAL : 16,
    DATA_TYPE_DATE : 17,
    DATA_TYPE_ENTRY : 18,
    DATA_TYPE_ENTRY_ARRAY : 19,
    DATA_TYPE_STR_ARRAY : 20,
    DATA_TYPE_EXCEPTION : 21,
    DATA_TYPE_DATA_SET_ROW : 22,
    COMMAND_PERMISSION_DENIED : "_COMMAND_PERMISSION_DENIED",
    COMMAND_OK : "_COMMAND_OK",
    COMMAND_WHOLE_SESSION : "_COMMAND_WHOLE_SESSION",
    COMMAND_BUSY : "_COMMAND_BUSY",
    COMMAND_INFO : "_COMMAND_INFO",
    COMMAND_ERROR : "_COMMAND_ERROR",
    COMMAND_FOR_TEST : "_COMMAND_FOR_TEST",
    COMMAND_DB_GET_ALL_TABLE_BASE_INFO : "_COMMAND_DB_GET_ALL_TABLE_BASE_INFO",
    COMMAND_DB_GET_TABLE_INFO : "_COMMAND_DB_GET_TABLE_INFO",
    COMMAND_DB_SQL_SELECT : "_COMMAND_DB_SQL_SELECT",
    COMMAND_DB_SQL_EXECUTE : "_COMMAND_DB_SQL_EXECUTE",
    COMMAND_DB_GET_RESULT_COUNT : "_COMMAND_DB_GET_RESULT_COUNT",
    COMMAND_DB_SQL_SELECT_AS_ONE_VALUE : "_COMMAND_DB_SQL_SELECT_AS_ONE_VALUE",
    COMMAND_DB_GET_SPLITED_PARAM_BEAN : "_COMMAND_DB_GET_SPLITED_PARAM_BEAN",
    COMMAND_DB_DISABLE_CONSTRAINT : "_COMMAND_DB_DISABLE_CONSTRAINT",
    COMMAND_DB_ENABLE_CONSTRAINT : "_COMMAND_DB_ENABLE_CONSTRAINT",
    COMMAND_DB_FUNC_LOWER : "_COMMAND_DB_FUNC_LOWER",
    COMMAND_DB_FUNC_UPPER : "_COMMAND_DB_FUNC_UPPER",
    COMMAND_DB_FUNC_BYTELENGTH : "_COMMAND_DB_FUNC_BYTELENGTH",
    COMMAND_DB_FUNC_SUBSTRING : "_COMMAND_DB_FUNC_SUBSTRING",
    COMMAND_DB_FUNC_TODATE : "_COMMAND_DB_FUNC_TODATE",
    COMMAND_ALLOC_ID : "_COMMAND_ALLOC_ID",
    COMMAND_GET_NEXT_VALUE : "_COMMAND_GET_NEXT_VALUE",
    COMMAND_GET_DATE : "_COMMAND_GET_DATE",
    COMMAND_MULTI_IDENTITY : "_COMMAND_MULTI_IDENTITY",
    COMMAND_MULTI_USER : "_COMMAND_MULTI_USER",
    COMMAND_GET_LOCK : "_COMMAND_GET_LOCK",
    COMMAND_TRY_LOCK : "_COMMAND_TRY_LOCK",
    COMMAND_RELEASE_LOCK : "_COMMAND_RELEASE_LOCK",
    COMMAND_UPLOAD_FILE : "_COMMAND_UPLOAD_FILE",
    COMMAND_DOWNLOAD_FILE : "_COMMAND_DOWNLOAD_FILE",
    COMMAND_GET_VIDEO_KEY_PIC : "COMMAND_GET_VIDEO_KEY_PIC",
    COMMAND_GET_FILE_URL : "_COMMAND_GET_FILE_URL",
    COMMAND_TRANSPORT_DATA : "_COMMAND_TRANSPORT_DATA",
    COMMAND_REFRESH_BUFFER : "_COMMAND_REFRESH_BUFFER",
    COMMAND_FORCE_RELOAD_BUFFER : "_COMMAND_FORCE_RELOAD_BUFFER",
    COMMAND_UPDATE_BUFFER_VERSION : "_COMMAND_UPDATE_BUFFER_VERSION",
    COMMAND_GET_BUFFER_VERSION : "_COMMAND_GET_BUFFER_VERSION",
    COMMAND_GET_LOCAL_BUFFER_VERSION : "_COMMAND_GET_LOCAL_BUFFER_VERSION",
    COMMAND_GET_ALL_BUFFER_NAME : "_COMMAND_GET_ALL_BUFFER_NAME",
    COMMAND_GET_ENV_MODEL : "_COMMAND_GET_ENV_MODEL",
    COMMAND_GET_MODEL : "_COMMAND_GET_MODEL",
    COMMAND_GET_ALL_MODEL : "_COMMAND_GET_ALL_MODEL",
    COMMAND_GET_MODEL_COUNT : "_COMMAND_GET_MODEL_COUNT",
    COMMAND_GET_TRANSLATE_DATA : "_COMMAND_GET_TRANSLATE_DATA",
    COMMAND_EXPORT_DATA : "_COMMAND_EXPORT_DATA",
    COMMAND_EXPORT_DATA_PROGRESS : "_COMMAND_EXPORT_DATA_PROGRESS",
    COMMAND_DB_BACKUP : "_COMMAND_DB_BACKUP",
    COMMAND_IMPORT_DATA : "_COMMAND_IMPORT_DATA",
    COMMAND_IMPORT_DATA_PROGRESS : "_COMMAND_IMPORT_DATA_PROGRESS",
    COMMAND_PRINT_EXCEL : "_COMMAND_PRINT_EXCEL",
    COMMAND_PASTE_RELATION_RECORD : "_COMMAND_PASTE_RELATION_RECORD",
    COMMAND_REMOVE_RELATION_RECORD : "_COMMAND_REMOVE_RELATION_RECORD",
    COMMAND_REMUXING_VIDEO : "_COMMAND_REMUXING_VIDEO",
    COMMAND_CHECK_UPDATE : "_COMMAND_CHECK_UPDATE",
    COMMAND_SAVE_CLIENT_BUFFER_TO_FILE : "_COMMAND_SAVE_CLIENT_BUFFER_TO_FILE",
    COMMAND_SAVE_CLIENT_BUFFER_TO_JS : "_COMMAND_SAVE_CLIENT_BUFFER_TO_JS",
    COMMAND_CREATE_PRELOAD_AND_CONFIG_JS : "_COMMAND_CREATE_PRELOAD_AND_CONFIG_JS",
    COMMAND_GET_ALL_DB_ID : "_COMMAND_GET_ALL_DB_ID",
    COMMAND_GET_ALL_ENV_ID : "_COMMAND_GET_ALL_ENV_ID",
    COMMAND_IDENTITY_VERIFICATION : "_COMMAND_IDENTITY_VERIFICATION",
    SESSION_DEFAULT_ID : "_SESSION_DEFAULT_ID",
    SESSION_ENV_ID : "_SESSION_ENV_ID",
    SESSION_USER_ID : "_SESSION_USER_ID",
    SESSION_USER_NAME : "_SESSION_USER_NAME",
    SESSION_PASS_WORD : "_SESSION_PASS_WORD",
    SESSION_DEPT_ID : "_SESSION_DEPT_ID",
    SESSION_PST_ID : "_SESSION_PST_ID",
    SESSION_KEEPDEPT_ID : "_SESSION_KEEPDEPT_ID",
    SESSION_IDENTITY : "_SESSION_IDENTITY",
    SESSION_ADMIN : "_SESSION_ADMIN",
    SESSION_SUPERMODE : "_SESSION_SUPERMODE",
    SESSION_SUPERMODE_ADMIN_ID : "_SESSION_SUPERMODE_ADMIN_ID",
    SESSION_SUPERMODE_ADMIN_NAME : "_SESSION_SUPERMODE_ADMIN_NAME",
    SESSION_LANGUAGE : "_SESSION_LANGUAGE",
    SESSION_OS : "_SESSION_OS",
    SESSION_TEMP_CONTEXT : "_SESSION_TEMP_CONTEXT",
    SESSION_TEMP_DATASET : "_SESSION_TEMP_DATASET",
    SESSION_TEMP_TABLE_NAME : "_SESSION_TEMP_TABLE_NAME",
    SESSION_TEMP_COLUMN_NAME : "_SESSION_TEMP_COLUMN_NAME",
    SESSION_TEMP_CODE_LIKE : "_SESSION_TEMP_CODE_LIKE",
    SESSION_TEMP_USE_CACHE : "_SESSION_TEMP_USE_CACHE",
    SESSION_TEMP_STEP : "_SESSION_TEMP_STEP",
    CODE_NAME_RELATION : ":",
    KEY_CODE_SEPARATOR : ";",
    PARAM_RELATION : "=",
    PARAM_QUESTION : "?",
    PARAM_AND : "&",
    BUFFER_FRAME_MODEL : "_BUFFER_FRAME_MODEL",
    BUFFER_UIMODULE_MODEL : "_BUFFER_UIMODULE_MODEL",
    BUFFER_TRANSLATION_PREFIX : "_BUFFER_TRANSLATION_",
    BUFFER_MENU_MODEL : "_BUFFER_MENU_MODEL",
    BUFFER_VIEW_MODEL : "_BUFFER_VIEW_MODEL",
    BUFFER_TOOL_MODEL : "_BUFFER_TOOL_MODEL",
    BUFFER_HANDLER_MODEL : "_BUFFER_HANDLER_MODEL",
    BUFFER_TABLE_INFO_PREFIX : "_BUFFER_TABLE_INFO_",
    STATIC_METHOD_PREFIX : "StaticMethod:",
    UPLOAD_PARAM_ATTACHMENT : "_UPLOAD_PARAM_ATTACHMENT",
    DOWNLOAD_PARAM_URL : "_DOWNLOAD_PARAM_URL",
    DOWNLOAD_PARAM_FILE_NAME : "_DOWNLOAD_PARAM_FILE_NAME",
    ENV_SERVLET_URL : "xlsys.servleturl",
    ENV_UPLOAD_URL : "xlsys.uploadurl",
    ENV_DOWNLOAD_URL : "xlsys.downloadurl",
    ENV_ENTRY_POINT : "xlsys.entrypoint",
    ENV_COOKIE_EXPIRES : "xlsys.cookieexpires",
    ENV_LOG_LEVEL : "xlsys.loglevel",
    ENV_LOG_CLASS : "xlsys.logclass",
    ENV_APP_VERSION : "xlsys.appversion",
    ENV_APP_NAME : "xlsys.appname",
    ENV_DEFAULT_ENV_ID : "xlsys.defaultEnvId",
    ENV_PRELOAD_BUFFER : "xlsys.preloadbuffer",
    CODELIKE_COMMON : "________________"
  }
});
qx.Interface.define("xlsys.base.dataset.IStorableDataSet", {
  extend : [xlsys.base.dataset.IDataSet],
  statics : {
    OPTION_LOCK_CHANGE : 10000,
    OPTION_LOCK_TO_BE_DELETE_ROW : 10001
  },
  members : {
    open : function(){
    },
    save : function(){
    },
    fireBeforeOpen : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireAfterOpen : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    firePrepareSave : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireBeforeSave : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireAfterSave : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireAfterSaveCommit : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    fireSaveFinally : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    isChanged : function(){
    },
    setChanged : function(changed){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getDataBase : function(){
    },
    getTableName : function(){
    },
    getSql : function(){
    },
    getSelectBean : function(){
    },
    addUnsaveCol : function(colName){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getUnSaveColNameSet : function(){
    },
    hasToBeDeleteRow : function(){
    },
    getToBeDeleteRowList : function(){
    },
    hasChangedRow : function(){
    },
    setSaveTransaction : function(saveTransaction){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    isSaveTransaction : function(){
    },
    isSorted : function(){
    }
  }
});
qx.Class.define("xlsys.base.dataset.StorableDataSet", {
  extend : xlsys.base.dataset.DataSet,
  implement : [xlsys.base.dataset.IStorableDataSet],
  construct : function(){

    xlsys.base.dataset.DataSet.call(this);
    this.dataBase = arguments[0];
    this.tableName = null;
    this.unSaveColNameSet = null;
    this.toBeDeleteRowList = null;
    this.changed = false;
    this.selectBean = null;
    this.sorted = null;
    this.saveTransaction = true;
    this.style = xlsys.base.dataset.IDataSet.STYLE_NONE;
    if(arguments.length == 2){

      this.tableName = arguments[1];
      var sql = "select * from " + this.tableName;
      this.selectBean = new xlsys.base.database.bean.ParamBean(sql);
    } else if(arguments.length == 3){

      if(arguments[1] instanceof xlsys.base.database.bean.ParamBean){

        this.selectBean = arguments[1];
        this.tableName = arguments[2];
      } else if(qx.lang.Type.isNumber(arguments[2])){

        this.tableName = arguments[1];
        this.selectBean = new xlsys.base.database.bean.ParamBean(this.getTableSelectSql(this.tableName));
        this.style = arguments[2];
      } else if(qx.lang.Type.isString(arguments[2])){

        this.selectBean = arguments[1];
        this.tableName = arguments[2];
      };;
    } else if(arguments.length == 4){

      if(qx.lang.Type.isString(arguments[1])){

        this.selectBean = new xlsys.base.database.bean.ParamBean(arguments[1]);
        this.tableName = arguments[2];
        this.style = arguments[3];
      } else {

        this.selectBean = arguments[1];
        this.tableName = arguments[2];
        this.style = arguments[3];
      };
    };;
    this.changed = false;
    this.sorted = false;
    this.saveTransaction = true;
    this.addExpandListener();
  },
  members : {
    dataBase : null,
    tableName : null,
    unSaveColNameSet : null,
    toBeDeleteRowList : null,
    changed : null,
    selectBean : null,
    sorted : null,
    saveTransaction : true,
    getSerializableMembers : function(){

      var arr = xlsys.base.dataset.DataSet.prototype.getSerializableMembers.call(this);
      arr.push("tableName");
      arr.push("unSaveColNameSet");
      arr.push("toBeDeleteRowList");
      arr.push("changed");
      arr.push("selectBean");
      arr.push("sorted");
      return arr;
    },
    getTableSelectSql : function(tableName){

      var tableInfo = this.dataBase.getTableInfo(tableName);
      var sb = new xlsys.java.lang.StringBuilder("select ");
      var dscList = tableInfo.getDataColumnList();
      for(var i = 0;i < dscList.size();++i){

        var dsCol = dscList.get(i);
        if(i != 0)sb.append(",");
        sb.append(dsCol.getColumnName());
      };
      sb.append(" from ").append(tableName);
      return sb.toString();
    },
    setSaveTransaction : function(saveTransaction){

      this.saveTransaction = saveTransaction;
    },
    isSorted : function(){

      return this.sorted;
    },
    isSaveTransaction : function(){

      return this.saveTransaction;
    },
    addExpandListener : function(){

      if(xlsys.base.util.ObjectUtil.hasBitProp(this.getStyle(), xlsys.base.dataset.IDataSet.STYLE_VIRTUAL)){

        this.addDataSetListener(new xlsys.base.dataset.SdsExpandListener());
      };
    },
    getSql : function(){

      return this.selectBean.getSelectSql();
    },
    getSelectBean : function(){

      return this.selectBean;
    },
    save : function(){

      var event = new xlsys.base.dataset.StorableDataSetEvent(this);
      this.firePrepareSave(event);
      if(arguments.length == 0)return this._save(); else if(arguments.length == 1)this._saveWithCallBack(arguments[0]);;
    },
    _initInsertOrUpdateSqlBean : function(){

      var insertEb = null;
      var updateEb = null;
      var rows = this.getRows();
      var cols = this.getColumns();
      var rowCount = rows.size();
      var colCount = cols.size();
      for(var i = 0;i < rowCount;++i){

        var row = rows.get(i);
        if(row.isChanged()){

          if(row.getChangeStatus() == xlsys.base.dataset.DataSetRow.STATUS_REPLACE){

            var updateDataMap = new xlsys.java.util.HashMap();
            var oldDataMap = new xlsys.java.util.HashMap();
            for(var j = 0;j < colCount;++j){

              var dsc = cols.get(j);
              var colName = dsc.getColumnName();
              if(this.unSaveColNameSet == null || !this.unSaveColNameSet.contains(colName)){

                updateDataMap.put(colName, this.getValue(row, colName));
              };
              if(dsc.isPrimaryKey()){

                var oldValue = row.getCell(this.getColumnIndex(colName)).getOldContent();
                if(oldValue == null){

                  oldValue = row.getCell(this.getColumnIndex(colName)).getContent();
                };
                oldDataMap.put(colName, oldValue);
              };
            };
            if(updateEb == null){

              updateEb = new xlsys.base.database.bean.ExecuteBean(xlsys.base.database.bean.ExecuteBean.EXECUTE_TYPE_UPDATE, this.tableName);
            };
            if(!updateDataMap.isEmpty())updateEb.addData(updateDataMap, oldDataMap);
          } else {

            var dataMap = new xlsys.java.util.HashMap();
            for(var j = 0;j < colCount;++j){

              var dsc = cols.get(j);
              var colName = dsc.getColumnName();
              if(this.unSaveColNameSet == null || !this.unSaveColNameSet.contains(colName)){

                dataMap.put(colName, row.getCell(this.getColumnIndex(colName)).getContent());
              };
            };
            if(row.getChangeStatus() == xlsys.base.dataset.DataSetRow.STATUS_FOR_NEW){

              if(insertEb == null){

                insertEb = new xlsys.base.database.bean.ExecuteBean(xlsys.base.database.bean.ExecuteBean.EXECUTE_TYPE_INSERT, this.tableName);
              };
              if(!dataMap.isEmpty())insertEb.addData(dataMap);
            } else {

              if(updateEb == null){

                updateEb = new xlsys.base.database.bean.ExecuteBean(xlsys.base.database.bean.ExecuteBean.EXECUTE_TYPE_UPDATE, this.tableName);
              };
              if(!dataMap.isEmpty())updateEb.addData(dataMap);
            };
          };
        };
      };
      var ret = new Array();
      ret.push(insertEb);
      ret.push(updateEb);
      return ret;
    },
    _save : function(){

      var success = false;
      var oldAutoCommit = true;
      try{

        oldAutoCommit = this.dataBase.getAutoCommit();
        if(this.saveTransaction)this.dataBase.setAutoCommit(false);
        if(this.postRow()){

          if(this.changed){

            var event = new xlsys.base.dataset.StorableDataSetEvent(this);
            this.fireBeforeSave(event);
            if(event.doit){

              var sqlBeanList = new xlsys.java.util.ArrayList();
              var tempArr = this._initInsertOrUpdateSqlBean();
              var insertEb = tempArr[0];
              var updateEb = tempArr[1];
              var deleteEb = null;
              if(this.toBeDeleteRowList != null){

                var tableInfo = this.dataBase.getTableInfo(this.tableName);
                var tempSize = this.toBeDeleteRowList.size();
                var pkColArray = tableInfo.getPkColSet().toArray();
                for(var i = 0;i < tempSize;++i){

                  var row = this.toBeDeleteRowList.get(i);
                  if(deleteEb == null){

                    deleteEb = new xlsys.base.database.bean.ExecuteBean(xlsys.base.database.bean.ExecuteBean.EXECUTE_TYPE_DELETE, this.tableName);
                  };
                  var dataMap = new xlsys.java.util.HashMap();
                  for(var j in pkColArray){

                    var colName = pkColArray[j];
                    dataMap.put(colName, row.getCell(this.getColumnIndex(colName)).getContent());
                  };
                  deleteEb.addData(dataMap);
                };
              };
              if(insertEb != null)sqlBeanList.add(insertEb);
              if(updateEb != null)sqlBeanList.add(updateEb);
              if(deleteEb != null)sqlBeanList.add(deleteEb);
              if(this.dataBase.sqlExecute(sqlBeanList)){

                success = true;
                this.fireAfterSave(new xlsys.base.dataset.StorableDataSetEvent(this));
              };
            } else {

              if(this.saveTransaction && !this.dataBase.getAutoCommit())this.dataBase.rollback();
            };
          } else success = true;
          if(this.saveTransaction && !this.dataBase.getAutoCommit())this.dataBase.commit();
          if(success){

            this.changed = false;
            if(this.toBeDeleteRowList != null)this.toBeDeleteRowList.clear();
            var rowsArray = this.getRows().toArray();
            for(var i in rowsArray){

              var row = rowsArray[i];
              row.setChanged(false);
              if(!this.isVirtualRow(row)){

                row.setChangeStatus(xlsys.base.dataset.DataSetRow.STATUS_COMMON);
              };
            };
          };
          this.fireAfterSaveCommit(new xlsys.base.dataset.StorableDataSetEvent(this));
        };
      } catch(err) {

        if(this.saveTransaction && !this.dataBase.getAutoCommit())this.dataBase.rollback();
        this.fireSaveFinally(new xlsys.base.dataset.StorableDataSetEvent(this));
        if(this.saveTransaction)this.dataBase.setAutoCommit(oldAutoCommit);
        throw err;
      };
      this.fireSaveFinally(new xlsys.base.dataset.StorableDataSetEvent(this));
      if(this.saveTransaction)this.dataBase.setAutoCommit(oldAutoCommit);
      return success;
    },
    _saveWithCallBack : function(callback){

      var oldAutoCommit = this.dataBase.getAutoCommit();
      if(this.saveTransaction)this.dataBase.setAutoCommit(false, qx.Bootstrap.bind(this._saveWithCallBack9, this, callback, oldAutoCommit)); else this._saveWithCallBack9(callback, oldAutoCommit);
    },
    _saveWithCallBack9 : function(callback, oldAutoCommit){

      if(this.postRow()){

        if(this.changed){

          var event = new xlsys.base.dataset.StorableDataSetEvent(this);
          this.fireBeforeSave(event);
          if(event.doit){

            var tempArr = this._initInsertOrUpdateSqlBean();
            if(this.toBeDeleteRowList != null){

              this.dataBase.getTableInfo(this.tableName, qx.Bootstrap.bind(this._saveWithCallBack1, this, callback, oldAutoCommit, tempArr[0], tempArr[1]));
            } else this._saveWithCallBack10(callback, oldAutoCommit, tempArr[0], tempArr[1], null);
          } else {

            if(this.saveTransaction && !this.dataBase.getAutoCommit())this.dataBase.rollback();
            this._saveWithCallBack6(callback, oldAutoCommit, false);
          };
        } else this._saveWithCallBack4(callback, oldAutoCommit, true);
      } else this._saveWithCallBack6(callback, oldAutoCommit, false);
    },
    _saveWithCallBack10 : function(callback, oldAutoCommit, insertEb, updateEb, deleteEb){

      var sqlBeanList = new xlsys.java.util.ArrayList();
      if(insertEb != null)sqlBeanList.add(insertEb);
      if(updateEb != null)sqlBeanList.add(updateEb);
      if(deleteEb != null)sqlBeanList.add(deleteEb);
      this.dataBase.sqlExecute(sqlBeanList, qx.Bootstrap.bind(this._saveWithCallBack3, this, callback, oldAutoCommit));
    },
    _saveWithCallBack1 : function(callback, oldAutoCommit, insertEb, updateEb, tableInfo, status){

      var deleteEb = null;
      var tempSize = this.toBeDeleteRowList.size();
      for(var i = 0;i < tempSize;++i){

        var row = this.toBeDeleteRowList.get(i);
        if(deleteEb == null){

          deleteEb = new xlsys.base.database.bean.ExecuteBean(xlsys.base.database.bean.ExecuteBean.EXECUTE_TYPE_DELETE, this.tableName);
        };
        var dataMap = new xlsys.java.util.HashMap();
        var pkColArray = tableInfo.getPkColSet().toArray();
        for(var j in pkColArray){

          var colName = pkColArray[j];
          dataMap.put(colName, row.getCell(this.getColumnIndex(colName)).getContent());
        };
        deleteEb.addData(dataMap);
      };
      this._saveWithCallBack10(callback, oldAutoCommit, insertEb, updateEb, deleteEb);
    },
    _saveWithCallBack3 : function(callback, oldAutoCommit, success, status){

      if(success){

        this.fireAfterSave(new xlsys.base.dataset.StorableDataSetEvent(this));
      };
      this._saveWithCallBack4(callback, oldAutoCommit, success);
    },
    _saveWithCallBack4 : function(callback, oldAutoCommit, success){

      if(this.saveTransaction && !this.dataBase.getAutoCommit()){

        this.dataBase.commit(qx.Bootstrap.bind(this._saveWithCallBack6, this, callback, oldAutoCommit, success));
      } else this._saveWithCallBack6(callback, oldAutoCommit, success);
    },
    _saveWithCallBack6 : function(callback, oldAutoCommit, success){

      if(success){

        this.changed = false;
        if(this.toBeDeleteRowList != null)this.toBeDeleteRowList.clear();
        var rowsArray = this.getRows().toArray();
        for(var i in rowsArray){

          var row = rowsArray[i];
          row.setChanged(false);
          if(!this.isVirtualRow(row)){

            row.setChangeStatus(xlsys.base.dataset.DataSetRow.STATUS_COMMON);
          };
        };
      };
      this.fireAfterSaveCommit(new xlsys.base.dataset.StorableDataSetEvent(this));
      this._saveWithCallBackFinal1(callback, oldAutoCommit, success);
    },
    _saveWithCallBackFinal1 : function(callback, oldAutoCommit, success){

      if(this.saveTransaction)this.dataBase.setAutoCommit(oldAutoCommit, qx.Bootstrap.bind(this._saveWithCallBackFinal3, this, callback, success)); else this._saveWithCallBackFinal3(callback, success);
    },
    _saveWithCallBackFinal3 : function(callback, success){

      this.fireSaveFinally(new xlsys.base.dataset.StorableDataSetEvent(this));
      callback(success);
    },
    open : function(){

      if(arguments.length == 0)this._open(); else if(arguments.length == 1)this._openWithCallBack(arguments[0]);;
    },
    _open : function(){

      var refds = null;
      try{

        var event = new xlsys.base.dataset.StorableDataSetEvent(this);
        event.selectBean = this.selectBean;
        this.fireBeforeOpen(event);
        this.selectBean = event.selectBean;
        if(event.refDataSet != null){

          refds = event.refDataSet;
        } else if(event.refDataSet == null && this.selectBean != null){

          if(xlsys.base.util.ObjectUtil.hasBitProp(this.getStyle(), xlsys.base.dataset.IDataSet.STYLE_VIRTUAL)){

            var sortColMap = this.getSortColMap();
            if(sortColMap != null && !sortColMap.isEmpty() && this.sorted){

              refds = this.dataBase.sqlSelect(this.selectBean, sortColMap, 0, this.getExpandPerCount() - 1);
            } else {

              refds = this.dataBase.sqlSelect(this.selectBean, 0, this.getExpandPerCount() - 1);
            };
            this.setColumnCount(refds.getColumnCount());
            this.setRowCount(this.dataBase.getResultCount(this.selectBean));
          } else {

            refds = this.dataBase.sqlSelect(this.selectBean);
          };
        };
        if(refds != null){

          this.refDataSet(refds);
          this.setRowCursor(-1);
          event = new xlsys.base.dataset.StorableDataSetEvent(this);
          this.fireAfterOpen(event);
        };
      } catch(err) {

        if(this.dataBase != null && !this.dataBase.getAutoCommit())this.dataBase.rollback();
        throw err;
      };
    },
    _openWithCallBack : function(callback){

      var refds = null;
      var event = new xlsys.base.dataset.StorableDataSetEvent(this);
      event.selectBean = this.selectBean;
      this.fireBeforeOpen(event);
      this.selectBean = event.selectBean;
      if(event.refDataSet != null){

        refds = event.refDataSet;
      } else if(event.refDataSet == null && this.selectBean != null){

        if(xlsys.base.util.ObjectUtil.hasBitProp(this.getStyle(), xlsys.base.dataset.IDataSet.STYLE_VIRTUAL)){

          var sortColMap = this.getSortColMap();
          var tempCallback = qx.Bootstrap.bind(this._openWithCallBack1, this, callback);
          if(sortColMap != null && !sortColMap.isEmpty() && this.sorted){

            this.dataBase.sqlSelect(this.selectBean, sortColMap, 0, this.getExpandPerCount() - 1, tempCallback);
          } else {

            this.dataBase.sqlSelect(this.selectBean, 0, this.getExpandPerCount() - 1, tempCallback);
          };
        } else {

          this.dataBase.sqlSelect(this.selectBean, qx.Bootstrap.bind(this._openWithCallBack3, this, callback));
        };
      } else this._openWithCallBack3(callback, this, refds);;
    },
    _openWithCallBack1 : function(callback, refds, status){

      this.setColumnCount(refds.getColumnCount());
      this.setRowCount(this.dataBase.getResultCount(this.selectBean));
      this._openWithCallBack3(callback, refds);
    },
    _openWithCallBack3 : function(callback, refds){

      if(refds != null){

        this.refDataSet(refds);
        this.setRowCursor(-1);
        var event = new xlsys.base.dataset.StorableDataSetEvent(this);
        this.fireAfterOpen(event);
      };
      callback(null, "success");
    },
    addUnsaveCol : function(colName){

      if(this.unSaveColNameSet == null)this.unSaveColNameSet = new xlsys.java.util.HashSet();
      this.unSaveColNameSet.add(colName);
    },
    addDeleteRow : function(row){

      if(row == null)return;
      if(!this.isOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_TO_BE_DELETE_ROW)){

        if(this.toBeDeleteRowList == null)this.toBeDeleteRowList = new xlsys.java.util.ArrayList();
        this.toBeDeleteRowList.add(row);
      };
    },
    setNewRowStatus : function(row, virtual){

      if(row != null){

        if(!this.isOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_CHANGE) && !virtual){

          row.setChanged(true);
          row.setChangeStatus(xlsys.base.dataset.DataSetRow.STATUS_FOR_NEW);
          this.changed = true;
        };
      };
    },
    doInsertRow : function(index, row, clone){

      var newRow = xlsys.base.dataset.DataSet.prototype.doInsertRow.call(this, index, row, clone);
      this.setNewRowStatus(newRow, false);
      return newRow;
    },
    doInsertNewRow : function(index, virtual){

      var newRow = xlsys.base.dataset.DataSet.prototype.doInsertNewRow.call(this, index, virtual);
      this.setNewRowStatus(newRow, virtual);
      return newRow;
    },
    doRemoveRow : function(rowNum){

      var row = xlsys.base.dataset.DataSet.prototype.doRemoveRow.call(this, rowNum);
      this.addDeleteRow(row);
      if(!this.isOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_CHANGE))this.changed = true;
      return row;
    },
    removeAllRow : function(){

      this.expandAllRows();
      if(!this.isOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_TO_BE_DELETE_ROW)){

        var rows = this.getRows();
        for(var i = 0;i < rows.size();++i)this.addDeleteRow(rows.get(i));
        if(!this.isOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_CHANGE))this.changed = true;
      };
      xlsys.base.dataset.DataSet.prototype.removeAllRow.call(this);
    },
    doSetValue : function(rowIndex, colIndex, value){

      var isPkCol = this.getColumn(colIndex).isPrimaryKey();
      var row = this.getRow(rowIndex);
      var needReplace = isPkCol && row.getChangeStatus() != xlsys.base.dataset.DataSetRow.STATUS_FOR_NEW;
      var oldContent = null;
      if(needReplace)oldContent = this.getValue(rowIndex, colIndex);
      xlsys.base.dataset.DataSet.prototype.doSetValue.call(this, rowIndex, colIndex, value);
      if(needReplace){

        row.getCell(colIndex).setOldContent(oldContent);
        row.setChangeStatus(xlsys.base.dataset.DataSetRow.STATUS_REPLACE);
      };
      if(!this.isOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_CHANGE)){

        if(!this.changed)this.changed = true;
        this.getRow(rowIndex).setChanged(this.changed);
      };
    },
    getValue : function(){

      var value = this._getValue(arguments);
      if(arguments.length == 2 && (arguments[0] instanceof xlsys.base.dataset.DataSetRow) && qx.lang.Type.isNumber(arguments[1])){

        var row = arguments[0];
        var colIndex = arguments[1];
        if(value == null && this.toBeDeleteRowList != null && this.toBeDeleteRowList.contains(row)){

          value = row.getCell(colIndex).getContent();
        };
      };
      return value;
    },
    refresh : function(){

      var event = new xlsys.base.dataset.DataSetEvent(this);
      this.fireBeforeRefresh(event);
      if(arguments.length == 0){

        this.refreshing();
        event = new xlsys.base.dataset.DataSetEvent(this);
        this.fireAfterRefresh(event);
      } else {

        this.refreshing(arguments[0]);
      };
    },
    refreshing : function(){

      if(this.toBeDeleteRowList != null)this.toBeDeleteRowList.clear();
      this.changed = false;
      this.sorted = false;
      this.getRows().clear();
      this.getColumns().clear();
      if(arguments.length == 0){

        try{

          this.open();
        } catch(err) {

          var event = new xlsys.base.dataset.DataSetEvent(this);
          event.errMsg = err;
          event.logLevel = xlsys.base.log.Log.LOG_LEVEL_ERROR;
          this.fireShowMessage(event);
        };
      } else {

        this.open(qx.Bootstrap.bind(this._refreshingCallback, this, arguments[0]));
      };
    },
    _refreshingCallback : function(callback, data, status){

      var event = new xlsys.base.dataset.DataSetEvent(this);
      this.fireAfterRefresh(event);
      callback(null, status);
    },
    fireBeforeOpen : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            if(qx.Class.implementsInterface(listener, xlsys.base.dataset.StorableDataSetListener)){

              listener.beforeOpen(event);
              if(event.interrupt)break;
            };
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterOpen : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            if(qx.Class.implementsInterface(listener, xlsys.base.dataset.StorableDataSetListener)){

              listener.afterOpen(event);
              if(event.interrupt)break;
            };
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    firePrepareSave : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            if(qx.Class.implementsInterface(listener, xlsys.base.dataset.StorableDataSetListener)){

              listener.prepareSave(event);
              if(event.interrupt)break;
            };
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireBeforeSave : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            if(qx.Class.implementsInterface(listener, xlsys.base.dataset.StorableDataSetListener)){

              listener.beforeSave(event);
              if(event.interrupt)break;
            };
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterSave : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            if(qx.Class.implementsInterface(listener, xlsys.base.dataset.StorableDataSetListener)){

              listener.afterSave(event);
              if(event.interrupt)break;
            };
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireAfterSaveCommit : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            if(qx.Class.implementsInterface(listener, xlsys.base.dataset.StorableDataSetListener)){

              listener.afterSaveCommit(event);
              if(event.interrupt)break;
            };
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    fireSaveFinally : function(event){

      try{

        if(this.dataSetListenerSet != null){

          var listeners = this.dataSetListenerSet.toArray();
          for(var i = 0;i < listeners.length;++i){

            var listener = listeners[i];
            if(qx.Class.implementsInterface(listener, xlsys.base.dataset.StorableDataSetListener)){

              listener.saveFinally(event);
              if(event.interrupt)break;
            };
          };
          if(!event.doit && event.errMsg != null)this.fireShowMessage(event);
        };
      } catch(err) {

        event.doit = false;
        event.errMsg = err;
        this.fireShowMessage(event);
      };
    },
    isChanged : function(){

      return this.changed;
    },
    setChanged : function(changed){

      this.changed = changed;
    },
    getDataBase : function(){

      return this.dataBase;
    },
    getTableName : function(){

      return this.tableName;
    },
    getUnSaveColNameSet : function(){

      return this.unSaveColNameSet;
    },
    hasToBeDeleteRow : function(){

      return this.toBeDeleteRowList != null && !this.toBeDeleteRowList.isEmpty();
    },
    getToBeDeleteRowList : function(){

      return this.toBeDeleteRowList;
    },
    hasChangedRow : function(){

      var hasChangedRow = false;
      var rowsArray = this.getRows().toArray();
      for(var i in rowsArray){

        var row = rowsArray[i];
        if(row.isChanged()){

          hasChangedRow = true;
          break;
        };
      };
      return hasChangedRow;
    },
    sort : function(){

      try{

        this.setEventLock(true);
        if(this.selectBean != null && xlsys.base.util.ObjectUtil.hasBitProp(this.getStyle(), xlsys.base.dataset.IDataSet.STYLE_VIRTUAL) && qx.Class.implementsInterface(this.dataBase, xlsys.base.database.IClientDataBase) && this.save()){

          this.getRows().clear();
          this.setRowCount(this.dataBase.getResultCount(this.selectBean));
        } else xlsys.base.dataset.DataSet.prototype.sort.call(this);
        this.setEventLock(false);
      } catch(err) {

        var event = new xlsys.base.dataset.DataSetEvent(this);
        event.errMsg = err;
        event.logLevel = xlsys.base.log.Log.LOG_LEVEL_ERROR;
        this.fireShowMessage(event);
        xlsys.base.dataset.DataSet.prototype.sort.call(this);
      };
      this.sorted = true;
    },
    setEventLock : function(){

      if(arguments.length == 1)xlsys.base.dataset.DataSet.prototype.setEventLock.call(this, arguments[0]); else if(arguments.length == 2)xlsys.base.dataset.DataSet.prototype.setEventLock.call(this, arguments[0], arguments[1]);;
      var dataSet = this;
      var lock = false;
      if(arguments.length == 1)lock = arguments[0]; else {

        dataSet = arguments[0];
        lock = arguments[1];
      };
      if(qx.Class.implementsInterface(dataSet, xlsys.base.dataset.IStorableDataSet)){

        this.setOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_CHANGE, lock, true);
        this.setOption(xlsys.base.dataset.IStorableDataSet.OPTION_LOCK_TO_BE_DELETE_ROW, lock, true);
      };
    }
  }
});
qx.Interface.define("xlsys.base.database.bean.ISqlBean");
qx.Class.define("xlsys.base.database.bean.ParamBean", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.base.database.bean.ISqlBean],
  construct : function(){

    this.selectSql = null;
    this.cursor = -1;
    this.paramsList = null;
    if(arguments.length >= 1){

      this.selectSql = arguments[0];
    };
  },
  members : {
    selectSql : null,
    cursor : -1,
    paramsList : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("selectSql");
      arr.push("paramsList");
      return arr;
    },
    next : function(){

      return this.gotoRow(this.cursor + 1);
    },
    previous : function(){

      return this.gotoRow(this.cursor - 1);
    },
    first : function(){

      return this.gotoRow(0);
    },
    last : function(){

      if(this.paramsList != null)return this.gotoRow(this.paramsList.size() - 1); else return false;
    },
    gotoRow : function(rowIdx){

      var success = false;
      if(this.paramsList != null && rowIdx >= 0 && rowIdx < this.paramsList.size()){

        this.cursor = rowIdx;
        success = true;
      };
      return success;
    },
    getRowIdx : function(){

      return this.cursor;
    },
    addParamGroup : function(){

      if(this.paramsList == null)this.paramsList = new xlsys.java.util.ArrayList();
      this.paramsList.add(new xlsys.java.util.ArrayList());
      this.cursor = this.paramsList.size() - 1;
    },
    setParam : function(){

      var idx = null;
      var value = null;
      var javaClass = null;
      if(arguments.length >= 3)javaClass = arguments[2];
      if(arguments.length >= 2){

        idx = arguments[0];
        value = arguments[1];
        if(javaClass == null){

          if(value != null)javaClass = xlsys.base.util.ObjectUtil.className(value); else throw new xlsys.java.lang.Exception("Can not set param using this method when value is null, use setParam(int, Serializable, String) instead.");
        };
        this.__setParam(this.cursor, idx, value, javaClass);
      } else throw new xlsys.java.lang.Exception("Invalid parameter");
    },
    __setParam : function(rowIdx, colIdx, value, javaClass){

      if(rowIdx < 0 || colIdx < 1)throw new xlsys.java.lang.Exception("Invalid parameter : row : " + rowIdx + " col : " + colIdx);
      if(this.paramsList == null)this.paramsList = new xlsys.java.util.ArrayList();
      while(this.paramsList.size() < rowIdx + 1){

        this.paramsList.add(new xlsys.java.util.ArrayList());
      };
      var params = this.paramsList.get(rowIdx);
      while(params.size() < colIdx){

        params.add(null);
      };
      var param = new xlsys.base.database.bean.Param(value, javaClass);
      params.set(colIdx - 1, param);
    },
    getParam : function(){

      var rowIdx = null;
      var colIdx = null;
      if(arguments.length == 1){

        rowIdx = this.cursor;
        colIdx = arguments[0];
      } else if(arguments.length == 2){

        rowIdx = arguments[0];
        colIdx = arguments[1];
      };
      var value = null;
      if(this.paramsList != null && rowIdx >= 0 && rowIdx < this.paramsList.size()){

        var params = this.paramsList.get(rowIdx);
        if(params != null && colIdx >= 1 && colIdx <= params.size()){

          value = params.get(colIdx - 1).value;
        };
      };
      return value;
    },
    setSelectSql : function(selectSql){

      this.selectSql = selectSql;
    },
    getSelectSql : function(){

      return this.selectSql;
    },
    getParamsList : function(){

      return this.paramsList;
    },
    setParamsList : function(paramsList){

      this.paramsList = paramsList;
    }
  }
});
qx.Class.define("xlsys.base.database.bean.Param", {
  extend : xlsys.java.io.Serializable,
  construct : function(){

    this.value = null;
    this.javaClass = null;
    if(arguments.length >= 2){

      this.value = arguments[0];
      this.javaClass = arguments[1];
    };
  },
  members : {
    value : null,
    javaClass : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("value");
      arr.push("javaClass");
      return arr;
    }
  }
});
qx.Interface.define("xlsys.base.dataset.DataSetListener", {
  members : {
    afterAddToDataSet : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeRemoveFromDataSet : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforePostValue : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterPostValue : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforePostRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterPostRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeCursorChange : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterCursorChange : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeInsertRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterInsertRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeInsertCol : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterInsertCol : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeRemoveRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterRemoveRow : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeRemoveCol : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterRemoveCol : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    expandRows : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeRefresh : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterRefresh : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    customTrigger : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    showMessage : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    }
  }
});
qx.Interface.define("xlsys.base.dataset.StorableDataSetListener", {
  extend : [xlsys.base.dataset.DataSetListener],
  members : {
    beforeOpen : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterOpen : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    prepareSave : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    beforeSave : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterSave : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    afterSaveCommit : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    saveFinally : function(event){

      this.assertArgumentsCount(arguments, 1, 1);
    }
  }
});
qx.Class.define("xlsys.base.dataset.StorableDataSetAdapter", {
  extend : qx.core.Object,
  implement : [xlsys.base.dataset.StorableDataSetListener],
  members : {
    afterAddToDataSet : function(event){
    },
    beforeRemoveFromDataSet : function(event){
    },
    beforePostValue : function(event){
    },
    afterPostValue : function(event){
    },
    beforePostRow : function(event){
    },
    afterPostRow : function(event){
    },
    beforeCursorChange : function(event){
    },
    afterCursorChange : function(event){
    },
    beforeInsertRow : function(event){
    },
    afterInsertRow : function(event){
    },
    beforeInsertCol : function(event){
    },
    afterInsertCol : function(event){
    },
    beforeRemoveRow : function(event){
    },
    afterRemoveRow : function(event){
    },
    beforeRemoveCol : function(event){
    },
    afterRemoveCol : function(event){
    },
    expandRows : function(event){
    },
    beforeRefresh : function(event){
    },
    afterRefresh : function(event){
    },
    customTrigger : function(event){
    },
    showMessage : function(event){
    },
    beforeOpen : function(event){
    },
    afterOpen : function(event){
    },
    prepareSave : function(event){
    },
    beforeSave : function(event){
    },
    afterSave : function(event){
    },
    afterSaveCommit : function(event){
    },
    saveFinally : function(event){
    }
  }
});
qx.Class.define("xlsys.base.dataset.SdsExpandListener", {
  extend : xlsys.base.dataset.StorableDataSetAdapter,
  members : {
    expandRows : function(event){

      if(arguments.length == 1)this._expandRows(event); else this._expandRowsWithCallback(event, arguments[1]);
    },
    _expandRows : function(event){

      var sds = event.getDataSet();
      xlsys.base.log.LogUtil.printlnInfo("event.beginIdxOfExpand=" + event.beginIdxOfExpand + " event.endIdxOfExpand=" + event.endIdxOfExpand);
      var selectBean = sds.getSelectBean();
      if(selectBean != null){

        var dataBase = null;
        try{

          dataBase = sds.getDataBase();
          var tempDataSet = null;
          if(sds.isSorted()){

            tempDataSet = dataBase.sqlSelect(selectBean, sds.getSortColMap(), event.beginIdxOfExpand, event.endIdxOfExpand);
          } else tempDataSet = dataBase.sqlSelect(selectBean, event.beginIdxOfExpand, event.endIdxOfExpand);
          if(tempDataSet != null){

            var tempRows = tempDataSet.getRows();
            for(var i = 0;i < tempRows.size();++i){

              sds.getRows().get(i + event.beginIdxOfExpand).cloneOf(tempRows.get(i));
            };
          };
        } catch(err) {

          event.doit = false;
          event.errMsg = err;
          event.interrupt = true;
          var msgEvent = new xlsys.base.dataset.DataSetEvent(event.getDataSet(), event);
          msgEvent.logLevel = xlsys.base.log.Log.LOG_LEVEL_ERROR;
          sds.fireShowMessage(event);
        };
      };
    },
    _expandRowsWithCallback : function(event, callback){

      var sds = event.getDataSet();
      xlsys.base.log.LogUtil.printlnInfo("event.beginIdxOfExpand=" + event.beginIdxOfExpand + " event.endIdxOfExpand=" + event.endIdxOfExpand);
      var selectBean = sds.getSelectBean();
      if(selectBean != null){

        var dataBase = sds.getDataBase();
        var tempCallback = qx.Bootstrap.bind(this._expandRowsWithCallback1, this, event, callback);
        if(sds.isSorted())dataBase.sqlSelect(selectBean, sds.getSortColMap(), event.beginIdxOfExpand, event.endIdxOfExpand, tempCallback); else dataBase.sqlSelect(selectBean, event.beginIdxOfExpand, event.endIdxOfExpand, tempCallback);
      } else callback(event, "success");
    },
    _expandRowsWithCallback1 : function(event, callback, tempDataSet, status){

      if(tempDataSet != null){

        var sds = event.getDataSet();
        var tempRows = tempDataSet.getRows();
        for(var i = 0;i < tempRows.size();++i){

          sds.getRows().get(i + event.beginIdxOfExpand).cloneOf(tempRows.get(i));
        };
      };
      callback(event, "success");
    }
  }
});
qx.Class.define("xlsys.base.log.LogUtil", {
  type : "static",
  statics : {
    __log : null,
    println : function(level, content){

      if(this.__log == null){

        var logLevel = qx.core.Environment.get(xlsys.base.XLSYS.ENV_LOG_LEVEL);
        var logClass = qx.core.Environment.get(xlsys.base.XLSYS.ENV_LOG_CLASS);
        this.__log = xlsys.base.util.ReflectUtil.newInstance(logClass, [logLevel]);
      };
      this.__log.println(level, content);
      return true;
    },
    printlnDebug : function(content){

      return this.println(xlsys.base.log.Log.LOG_LEVEL_DEBUG, content);
    },
    printlnInfo : function(content){

      return this.println(xlsys.base.log.Log.LOG_LEVEL_INFO, content);
    },
    printlnWarn : function(content){

      return this.println(xlsys.base.log.Log.LOG_LEVEL_WARN, content);
    },
    printlnError : function(content){

      return this.println(xlsys.base.log.Log.LOG_LEVEL_ERROR, content);
    },
    printlnFatal : function(content){

      return this.println(xlsys.base.log.Log.LOG_LEVEL_FATAL, content);
    }
  }
});
qx.Class.define("xlsys.base.dataset.StorableDataSetEvent", {
  extend : xlsys.base.dataset.DataSetEvent,
  construct : function(dataSet){

    xlsys.base.dataset.DataSetEvent.call(this, dataSet);
    this.selectBean = null;
    this.refDataSet = null;
  },
  members : {
    selectBean : null,
    refDataSet : null,
    getSerializableMembers : function(){

      var arr = xlsys.base.dataset.DataSetEvent.prototype.getSerializableMembers.call(this);
      arr.push("selectBean");
      arr.push("refDataSet");
      return arr;
    }
  }
});
qx.Class.define("xlsys.base.database.bean.ExecuteBean", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.base.database.bean.ISqlBean],
  statics : {
    EXECUTE_TYPE_INSERT : 0,
    EXECUTE_TYPE_UPDATE : 1,
    EXECUTE_TYPE_DELETE : 2,
    EXECUTE_TYPE_OTHER : 9
  },
  construct : function(){

    this.executeSql = null;
    this.dataList = null;
    this.oldDataMaps = null;
    this.paramColSet = null;
    this.updateWhereColSet = null;
    this.executeType = -1;
    this.tableName = null;
    if(arguments.length == 1){

      this.executeSql = arguments[0];
      var lowcaseSql = qx.lang.String.trimLeft(this.executeSql.toLowerCase());
      if(qx.lang.String.startsWith(lowcaseSql, "update ")){

        this.executeType = this.self(arguments).EXECUTE_TYPE_UPDATE;
        lowcaseSql = lowcaseSql.substring(7).trim();
        var idx = lowcaseSql.indexOf(" ");
        if(idx != -1)this.tableName = lowcaseSql.substring(0, idx);
      } else if(qx.lang.String.startsWith(lowcaseSql, "insert ")){

        this.executeType = this.self(arguments).EXECUTE_TYPE_INSERT;
        var idx = lowcaseSql.indexOf(" into ");
        lowcaseSql = lowcaseSql.substring(idx + 6).trim();
        idx = lowcaseSql.indexOf(" ");
        if(idx != -1)this.tableName = lowcaseSql.substring(0, idx);
        idx = this.tableName.indexOf("(");
        if(idx != -1)this.tableName = this.tableName.substring(0, idx);
      } else if(qx.lang.String.startsWith(lowcaseSql, "delete ")){

        this.executeType = this.self(arguments).EXECUTE_TYPE_DELETE;
        var idx = lowcaseSql.indexOf(" from ");
        lowcaseSql = lowcaseSql.substring(idx + 6).trim();
        idx = lowcaseSql.indexOf(" ");
        if(idx != -1)this.tableName = lowcaseSql.substring(0, idx); else this.tableName = lowcaseSql;
      } else {

        this.executeType = this.self(arguments).EXECUTE_TYPE_OTHER;
      };;
    } else if(arguments.length >= 2){

      this.executeType = arguments[0];
      this.tableName = arguments[1];
    };
  },
  members : {
    executeSql : null,
    dataList : null,
    oldDataMaps : null,
    paramColSet : null,
    updateWhereColSet : null,
    executeType : null,
    tableName : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("executeSql");
      arr.push("dataList");
      arr.push("oldDataMaps");
      arr.push("paramColSet");
      arr.push("updateWhereColSet");
      arr.push("executeType");
      arr.push("tableName");
      return arr;
    },
    addData : function(){

      if(arguments.length == 1){

        var dataMap = arguments[0];
        if(this.dataList == null)this.dataList = new xlsys.java.util.ArrayList();
        if(dataMap != null)this.dataList.add(dataMap);
      } else if(arguments.length >= 2){

        var dataMap = arguments[0];
        var oldDataMap = arguments[1];
        if(this.dataList == null)this.dataList = new xlsys.java.util.ArrayList();
        if(oldDataMap != null && this.oldDataMaps == null)this.oldDataMaps = new xlsys.java.util.HashMap();
        if(dataMap != null){

          this.dataList.add(dataMap);
          if(oldDataMap != null)this.oldDataMaps.put(dataMap, oldDataMap);
        };
      };
    },
    getExecuteType : function(){

      return this.executeType;
    },
    getTableName : function(){

      return this.tableName;
    },
    setExecuteSql : function(executeSql){

      this.executeSql = executeSql;
    },
    getExecuteSql : function(){

      return this.executeSql;
    },
    getDataList : function(){

      return this.dataList;
    },
    setDataList : function(dataList){

      this.dataList = dataList;
    },
    getOldDataMaps : function(){

      return this.oldDataMaps;
    },
    setOldDataMaps : function(oldDataMaps){

      this.oldDataMaps = oldDataMaps;
    },
    getParamColSet : function(){

      return this.paramColSet;
    },
    setParamColSet : function(paramColSet){

      this.paramColSet = paramColSet;
    },
    getUpdateWhereColSet : function(){

      return this.updateWhereColSet;
    },
    setUpdateWhereColSet : function(updateWhereColSet){

      this.updateWhereColSet = updateWhereColSet;
    }
  }
});
qx.Interface.define("xlsys.base.database.IDataBase", {
  statics : {
    BUFFER_KEY_TABLE_NAME : "_BUFFER_KEY_TABLE_NAME"
  },
  members : {
    getDataBaseId : function(){
    },
    getTableInfo : function(tableName){
    },
    getAllTableBaseInfo : function(){
    },
    getResultCount : function(paramBean){
    },
    sqlSelectAsOneValue : function(sqlOrPb){
    },
    sqlSelect : function(){
    },
    sqlExecute : function(){
    },
    getSplitedParamBean : function(paramBean, beginRowNum, endRowNum){
    },
    disableConstraint : function(tableName, constraintName){
    },
    enableConstraint : function(tableName, constraintName){
    },
    getLowerFunc : function(srcExp){
    },
    getUpperFunc : function(srcExp){
    },
    getByteLengthFunc : function(srcExp){
    },
    getSubStringFunc : function(){
    },
    getToDateFunc : function(date){
    },
    commit : function(){
    },
    rollback : function(){
    },
    setAutoCommit : function(autoCommit){
    },
    getAutoCommit : function(){
    },
    close : function(){
    },
    isClose : function(){
    }
  }
});
qx.Interface.define("xlsys.base.database.IClientDataBase", {
  extend : [xlsys.base.database.IDataBase],
  members : {
    getDataBaseId : function(){

      throw new xlsys.java.lang.Exception("UnsupportedOperation");
    },
    getEnvId : function(){
    },
    getTableInfo : function(tableName){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getAllTableBaseInfo : function(){

      this.assertArgumentsCount(arguments, 0, 1);
    },
    getResultCount : function(paramBean){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    sqlSelectAsOneValue : function(sqlOrPb){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    sqlSelect : function(){

      this.assertArgumentsCount(arguments, 1, 5);
    },
    sqlExecute : function(){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    disableConstraint : function(tableName, constraintName){

      this.assertArgumentsCount(arguments, 2, 3);
    },
    enableConstraint : function(tableName, constraintName){

      this.assertArgumentsCount(arguments, 2, 3);
    },
    getLowerFunc : function(srcExp){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getUpperFunc : function(srcExp){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getByteLengthFunc : function(srcExp){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getSubStringFunc : function(){

      this.assertArgumentsCount(arguments, 2, 4);
    },
    getToDateFunc : function(date){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    commit : function(){

      this.assertArgumentsCount(arguments, 0, 1);
    },
    rollback : function(){
    },
    setAutoCommit : function(autoCommit){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getAutoCommit : function(){
    },
    close : function(){

      this.assertArgumentsCount(arguments, 0, 1);
    },
    isClose : function(){
    }
  }
});
qx.Mixin.define("qx.dev.unit.MRequirementsBasic", {
  members : {
    require : function(featureList){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertArray(featureList);
      };
      for(var i = 0,l = featureList.length;i < l;i++){

        var feature = featureList[i];
        var hasMethodName = "has" + qx.lang.String.capitalize(feature);
        if(this[hasMethodName]){

          if(this[hasMethodName]() === true){

            continue;
          } else {

            throw new qx.dev.unit.RequirementError(feature);
          };
        };
        if(qx.core.Environment.getChecks()[feature]){

          var envValue = qx.core.Environment.get(feature);
          if(envValue === true){

            continue;
          };
          if(envValue === false){

            throw new qx.dev.unit.RequirementError(feature);
          } else {

            throw new Error("The Environment key " + feature + " cannot be used" + " as a Test Requirement since its value is not boolean!");
          };
        };
        if(qx.core.Environment.getAsyncChecks()[feature]){

          throw new Error('Unable to verify requirement ' + feature + ': ' + 'Asynchronous environment checks are not supported!');
        };
        throw new Error('Unable to verify requirement: No method "' + hasMethodName + '" or valid Environment key "' + feature + '" found');
      };
    }
  }
});
qx.Class.define("qx.dev.unit.RequirementError", {
  extend : Error,
  construct : function(requirement, message){

    this.__message = message || "Requirement not met";
    this.__requirement = requirement;
    var inst = Error.call(this, this.__message);
    if(inst.stack){

      this.stack = inst.stack;
    };
    if(inst.stacktrace){

      this.stacktrace = inst.stacktrace;
    };
  },
  members : {
    __message : null,
    __requirement : null,
    getRequirement : function(){

      return this.__requirement;
    },
    toString : function(){

      var msg = this.__message;
      if(this.__requirement){

        msg += ": " + this.__requirement;
      };
      return msg;
    }
  }
});
qx.Class.define("qx.dev.unit.TestCase", {
  extend : qx.core.Object,
  include : [qx.core.MAssert],
  events : {
    assertionFailed : "qx.event.type.Data"
  },
  properties : {
    testResult : {
      init : null
    },
    testFunc : {
      init : null
    }
  },
  members : {
    isDebugOn : function(){

      return (qx.core.Environment.get("qx.debug")) ? true : false;
    },
    wait : function(delay, deferredFunction, context){

      throw new qx.dev.unit.AsyncWrapper(delay, deferredFunction, context);
    },
    resume : function(deferredFunction, self){

      return this.getTestResult().run(this.getTestFunc(), deferredFunction || (function(){
      }), self || this, true);
    },
    resumeHandler : function(deferredFunction, self){

      if(qx.core.Environment.get("qx.debug")){

        this.assertFunction(deferredFunction, "First parameter of resumeHandler() must be a function!");
      };
      var func = deferredFunction;
      var that = this;
      return function(){

        var args = qx.lang.Array.fromArguments(arguments);
        return that.resume(func.bind.apply(func, [self || this].concat(args)), self);
      };
    },
    skip : function(message){

      throw new qx.dev.unit.RequirementError(null, message || "Called skip()");
    }
  }
});
qx.Class.define("qx.dev.unit.AsyncWrapper", {
  extend : qx.core.Object,
  construct : function(delay, deferredFunction, context){

    for(var i = 0;i < 2;i++){

      if(qx.lang.Type.isFunction(arguments[i])){

        this.setDeferredFunction(arguments[i]);
      } else if(qx.lang.Type.isNumber(arguments[i])){

        this.setDelay(arguments[i]);
      };
    };
    if(context){

      this.setContext(context);
    };
  },
  properties : {
    deferredFunction : {
      check : "Function",
      init : false
    },
    context : {
      check : "Object",
      init : null
    },
    delay : {
      check : "Integer",
      nullable : false,
      init : 5000
    }
  }
});
qx.Class.define("xlsys.test.DemoTest", {
  extend : qx.dev.unit.TestCase,
  include : [qx.dev.unit.MRequirementsBasic],
  members : {
    testSimple : function(){

      this.assertEquals(4, 3 + 1, "This should never fail!");
      this.assertFalse(false, "Can false be true?!");
    },
    testAdvanced : function(){

      var a = 3;
      var b = a;
      this.assertIdentical(a, b, "A rose by any other name is still a rose");
      this.assertInRange(3, 1, 10, "You must be kidding, 3 can never be outside [1,10]!");
    },
    hasNodeJs : function(){

      return qx.core.Environment.get("runtime.name") == "node.js";
    },
    testNodeJs : function(){

      this.require(["nodeJs"]);
    }
  }
});
qx.Class.define("xlsys.base.util.SystemUtil", {
  type : "static",
  statics : {
    getUserLanguage : function(){

      var language = null;
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      if(session != null)language = session.getAttribute(xlsys.base.XLSYS.SESSION_LANGUAGE); else language = qx.core.Environment.get("locale");
      return language;
    },
    getAppVersion : function(){

      return qx.core.Environment.get(xlsys.base.XLSYS.ENV_APP_VERSION);
    },
    isDebug : function(){

      var logLevel = qx.core.Environment.get(xlsys.base.XLSYS.ENV_LOG_LEVEL);
      return logLevel >= xlsys.base.log.Log.LOG_LEVEL_DEBUG;
    },
    getPlatform : function(){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      return session.getAttribute(xlsys.base.XLSYS.PLATFORM);
    },
    getOsName : function(){

      return qx.core.Environment.get("os.name");
    },
    getOsVersion : function(){

      return qx.core.Environment.get("os.version");
    },
    getDeviceType : function(){

      return qx.core.Environment.get("device.type");
    },
    getBrowserName : function(){

      return qx.core.Environment.get("browser.name");
    },
    getBrowserVersion : function(){

      return qx.core.Environment.get("browser.version");
    },
    getBrowserEngineName : function(){

      return qx.core.Environment.get("engine.name");
    },
    getBrowserEngineVersion : function(){

      return qx.core.Environment.get("engine.version");
    }
  }
});
qx.Class.define("xlsys.base.session.SessionManager", {
  type : "singleton",
  extend : qx.core.Object,
  construct : function(){

    this.defaultSession = new xlsys.base.session.Session(xlsys.base.XLSYS.SESSION_DEFAULT_ID);
  },
  members : {
    currentSession : null,
    defaultSession : null,
    setCurrentSession : function(session){

      this.currentSession = session;
    },
    getCurrentSession : function(){

      return this.currentSession;
    }
  }
});
qx.Class.define("xlsys.base.session.Session", {
  extend : xlsys.java.io.Serializable,
  statics : {
    TYPE_WHOLE : 0,
    TYPE_INCREMENTAL : 1
  },
  construct : function(sessionId){

    this.sessionId = sessionId;
    this.sessionType = this.self(arguments).TYPE_WHOLE;
    this.sessionEnv = new xlsys.java.util.HashMap();
    this.tempEnv = new xlsys.java.util.HashMap();
    this.changedKeys = new xlsys.java.util.HashSet();
  },
  members : {
    sessionId : null,
    sessionType : null,
    sessionEnv : null,
    tempEnv : null,
    changedKeys : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("sessionId");
      arr.push("sessionType");
      arr.push("sessionEnv");
      return arr;
    },
    setSessionId : function(sessionId){

      this.sessionId = sessionId;
    },
    getSessionId : function(){

      return this.sessionId;
    },
    getSessionType : function(){

      return this.sessionType;
    },
    setSessionType : function(sessionType){

      this.sessionType = sessionType;
    },
    getEnvKeySet : function(){

      return this.sessionEnv.keySet();
    },
    getTempEnv : function(){

      return this.tempEnv;
    },
    getChangedEnvKeys : function(){

      return this.changedKeys;
    },
    setAttribute : function(key, value){

      var oldValue = this.sessionEnv.get(key);
      if(oldValue == value)return;
      if((oldValue != null && value == null) || (value != null && oldValue == null))this.changedKeys.add(key); else if(xlsys.base.util.ObjectUtil.hashcode(oldValue) != xlsys.base.util.ObjectUtil.hashcode(value))this.changedKeys.add(key);;
      this.sessionEnv.put(key, value);
    },
    getAttribute : function(key){

      return this.sessionEnv.get(key);
    },
    setTempAttribute : function(key, value){

      this.tempEnv.put(key, value);
    },
    getTempAttribute : function(key){

      return this.tempEnv.get(key);
    },
    clone : function(){

      var cloneSession = new xlsys.base.session.Session(this.sessionId);
      cloneSession.sessionType = this.sessionType;
      cloneSession.sessionEnv.putAll(this.sessionEnv);
      cloneSession.tempEnv.putAll(this.tempEnv);
      cloneSession.changedKeys.addAll(this.changedKeys);
      return cloneSession;
    }
  }
});
qx.Bootstrap.define("qx.bom.client.Locale", {
  statics : {
    getLocale : function(){

      var locale = qx.bom.client.Locale.__getNavigatorLocale();
      var index = locale.indexOf("-");
      if(index != -1){

        locale = locale.substr(0, index);
      };
      return locale;
    },
    getVariant : function(){

      var locale = qx.bom.client.Locale.__getNavigatorLocale();
      var variant = "";
      var index = locale.indexOf("-");
      if(index != -1){

        variant = locale.substr(index + 1);
      };
      return variant;
    },
    __getNavigatorLocale : function(){

      var locale = (navigator.userLanguage || navigator.language || "");
      if(qx.bom.client.OperatingSystem.getName() == "android"){

        var match = /(\w{2})-(\w{2})/i.exec(navigator.userAgent);
        if(match){

          locale = match[0];
        };
      };
      return locale.toLowerCase();
    }
  },
  defer : function(statics){

    qx.core.Environment.add("locale", statics.getLocale);
    qx.core.Environment.add("locale.variant", statics.getVariant);
  }
});
qx.Bootstrap.define("qx.bom.client.Device", {
  statics : {
    __ids : {
      "Windows Phone" : "iemobile",
      "iPod" : "ipod",
      "iPad" : "ipad",
      "iPhone" : "iphone",
      "PSP" : "psp",
      "PLAYSTATION 3" : "ps3",
      "Nintendo Wii" : "wii",
      "Nintendo DS" : "ds",
      "XBOX" : "xbox",
      "Xbox" : "xbox"
    },
    getName : function(){

      var str = [];
      for(var key in qx.bom.client.Device.__ids){

        str.push(key);
      };
      var reg = new RegExp("(" + str.join("|").replace(/\./g, "\.") + ")", "g");
      var match = reg.exec(navigator.userAgent);
      if(match && match[1]){

        return qx.bom.client.Device.__ids[match[1]];
      };
      return "pc";
    },
    getType : function(){

      return qx.bom.client.Device.detectDeviceType(navigator.userAgent);
    },
    detectDeviceType : function(userAgentString){

      if(qx.bom.client.Device.detectTabletDevice(userAgentString)){

        return "tablet";
      } else if(qx.bom.client.Device.detectMobileDevice(userAgentString)){

        return "mobile";
      };
      return "desktop";
    },
    detectMobileDevice : function(userAgentString){

      return /android.+mobile|ip(hone|od)|bada\/|blackberry|BB10|maemo|opera m(ob|in)i|fennec|NetFront|phone|psp|symbian|IEMobile|windows (ce|phone)|xda/i.test(userAgentString);
    },
    detectTabletDevice : function(userAgentString){

      var isIE10Tablet = (/MSIE 10/i.test(userAgentString)) && (/ARM/i.test(userAgentString)) && !(/windows phone/i.test(userAgentString));
      var isCommonTablet = (!(/android.+mobile|Tablet PC/i.test(userAgentString)) && (/Android|ipad|tablet|playbook|silk|kindle|psp/i.test(userAgentString)));
      return isIE10Tablet || isCommonTablet;
    },
    getDevicePixelRatio : function(){

      if(typeof window.devicePixelRatio !== "undefined"){

        return window.devicePixelRatio;
      };
      return 1;
    },
    getTouch : function(){

      return (("ontouchstart" in window) || window.navigator.maxTouchPoints > 0 || window.navigator.msMaxTouchPoints > 0);
    }
  },
  defer : function(statics){

    qx.core.Environment.add("device.name", statics.getName);
    qx.core.Environment.add("device.touch", statics.getTouch);
    qx.core.Environment.add("device.type", statics.getType);
    qx.core.Environment.add("device.pixelRatio", statics.getDevicePixelRatio);
  }
});
qx.Class.define("xlsys.base.util.MapUtil", {
  type : "static",
  statics : {
    getReverseMap : function(srcMap){

      var reverseMap = xlsys.base.util.ReflectUtil.newInstance(srcMap.classname);
      var keys = srcMap.keys();
      for(var i = 0;i < keys.length;++i){

        reverseMap.put(srcMap.get(keys[i]), keys[i]);
      };
      return reverseMap;
    }
  }
});
qx.Class.define("xlsys.base.database.util.SqlUtil", {
  type : "static",
  statics : {
    isSelectSql : function(sql){

      var success = false;
      if(sql != null)success = qx.lang.String.startsWith(qx.lang.String.trimLeft(sql.toLowerCase()), "select ");
      return success;
    },
    createExpressionSql : function(left, rightValue, macroMap){

      var connectToken = "=";
      var regexStr = "^(.*(%|_).*)$";
      var regex = new RegExp(regexStr);
      if(regex.test(rightValue))connectToken = " like ";
      var sb = new xlsys.java.lang.StringBuilder();
      regex.compile("^(.*\\[.*\\].*)$");
      if(regex.test(rightValue)){

        var rightResult = this.replaceExpression(rightValue, macroMap);
        sb.append("(");
        for(var i = 0;i < rightResult.length;++i){

          sb.append(left).append(connectToken).append("\'").append(rightResult[i]).append("\'");
          if(i != rightResult.length - 1)sb.append(" or ");
        };
        sb.append(")");
      } else {

        sb.append(left).append(connectToken).append("\'").append(rightValue).append("\'");
      };
      return sb.toString();
    },
    replaceExpression : function(rightValue, macroMap){

      var valueToken = xlsys.base.util.StringUtil.split(rightValue, "[", "]", true);
      var multiKey = null;
      var multiValue = null;
      for(var i = 0;i < valueToken.length;++i){

        var token = valueToken[i];
        if(qx.lang.String.startsWith(token, "[") && qx.lang.String.endsWith(token, "]")){

          var params = token.substring(1, token.length - 1).split(",");
          if(macroMap.containsKey(params[0])){

            if(macroMap.get(params[0]).indexOf(xlsys.base.XLSYS.KEY_CODE_SEPARATOR) != -1){

              multiValue = macroMap.get(params[0]).split(xlsys.base.XLSYS.KEY_CODE_SEPARATOR);
              multiKey = params[0];
              break;
            };
          };
        };
      };
      var result = null;
      var len = 1;
      if(multiValue != null)len = multiValue.length;
      result = new Array();
      for(var n = 0;n < len;++n){

        result.push("");
        for(var i = 0;i < valueToken.length;++i){

          var token = valueToken[i];
          if(qx.lang.String.startsWith(token, "[") && qx.lang.String.endsWith(token, "]")){

            var params = token.substring(1, token.length - 1).split(",");
            if(macroMap.containsKey(params[0])){

              var macroValue = macroMap.get(params[0]);
              if(params[0] == multiKey)macroValue = multiValue[n];
              if(params.length == 1)result[n] += macroValue; else if(params.length == 2){

                var startIdx = parseInt(params[1]);
                result[n] += macroValue.substring(startIdx);
              } else if(params.length == 3){

                var startIdx = parseInt(params[1]);
                var endIdx = parseInt(params[2]);
                result[n] += macroValue.substring(startIdx, endIdx);
              };;
            };
          } else result[n] += token;
        };
      };
      return result;
    },
    removeComment : function(sql){

      var splitArr = xlsys.base.util.StringUtil.split(sql, "/\\*", "\\*/", false);
      sql = splitArr.join("");
      var regex = new RegExp("\r\n|\n\r|\n|\r", "g");
      var splitArr = sql.split(regex);
      var sb = new xlsys.java.lang.StringBuilder();
      for(var i = 0;i < splitArr.length;++i){

        var pieces = splitArr[i];
        var idx = xlsys.base.util.StringUtil.indexOfIgnoreMark(pieces, "--", 0, pieces.length, "'");
        if(idx != -1)sb.append(pieces.substring(0, idx)).append("\n"); else sb.append(pieces);
      };
      return sb.toString();
    },
    getSplitedSql : function(sqlText){

      sqlText = this.removeComment(sqlText);
      var ignoreArr = xlsys.base.util.StringUtil.getAllIndexOf(sqlText, "'", 0, sqlText.length);
      var curIdx = 0;
      var indexArr = new Array();
      while((curIdx = sqlText.indexOf(";", curIdx)) != -1){

        if(xlsys.base.util.StringUtil.__isIndexBetweenMark(curIdx, ignoreArr)){

          curIdx += 1;
          continue;
        };
        indexArr.push(curIdx);
        curIdx += 1;
      };
      var arr = new Array();
      var lastIndex = -1;
      for(var i = 0;i < indexArr.length;++i){

        arr.push(sqlText.substring(lastIndex + 1, indexArr[i]));
        lastIndex = indexArr[i];
      };
      if(lastIndex + 1 < sqlText.length)arr.push(sqlText.substring(lastIndex + 1));
      return arr;
    }
  }
});
qx.Class.define("xlsys.base.database.TableConstraint", {
  extend : xlsys.java.io.Serializable,
  statics : {
    CONSTRAINT_TYPE_UNKNOWN : 0,
    CONSTRAINT_TYPE_PK : 1,
    CONSTRAINT_TYPE_FK : 2,
    CONSTRAINT_TYPE_U : 3
  },
  construct : function(constraintName){

    this.constraintName = constraintName;
    this.tableName = null;
    this.constraintType = null;
    this.refConstraintName = null;
    this.refTableName = null;
    this.columnNameSet = new xlsys.java.util.HashSet();
  },
  members : {
    constraintName : null,
    tableName : null,
    constraintType : null,
    refConstraintName : null,
    refTableName : null,
    columnNameSet : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("constraintName");
      arr.push("tableName");
      arr.push("constraintType");
      arr.push("refConstraintName");
      arr.push("refTableName");
      arr.push("columnNameSet");
      return arr;
    },
    addColumnName : function(columnName){

      this.columnNameSet.add(this.columnName.toLowerCase());
    },
    getColumnNameSet : function(){

      return this.columnNameSet;
    },
    getConstraintName : function(){

      return this.constraintName;
    },
    setConstraintName : function(constraintName){

      this.constraintName = constraintName.toLowerCase();
    },
    getTableName : function(){

      return this.tableName;
    },
    setTableName : function(tableName){

      this.tableName = tableName.toLowerCase();
    },
    getConstraintType : function(){

      return this.constraintType;
    },
    setConstraintType : function(constraintType){

      this.constraintType = constraintType;
    },
    getRefConstraintName : function(){

      return this.refConstraintName;
    },
    setRefConstraintName : function(refConstraintName){

      this.refConstraintName = (refConstraintName == null ? refConstraintName : refConstraintName.toLowerCase());
    },
    getRefTableName : function(){

      return this.refTableName;
    },
    setRefTableName : function(refTableName){

      this.refTableName = (refTableName == null ? refTableName : refTableName.toLowerCase());
    }
  }
});
qx.Class.define("xlsys.base.io.util.ByteDataInputStream", {
  extend : qx.core.Object,
  construct : function(bytes){

    this.bytes = bytes;
    this.pos = 0;
  },
  members : {
    bytes : null,
    pos : null,
    _atEnd : function(){

      return this.pos >= this.bytes.length;
    },
    _checkRegion : function(count){

      if(this._atEnd() && count > 0)throw new Error("EOF!");
      if(count != null && (this.pos + count > this.bytes.length))throw new Error("EOF!");
    },
    read : function(){

      if(this._atEnd())return -1;
      return this.readByte();
    },
    readByte : function(){

      this._checkRegion();
      return this.bytes[this.pos++];
    },
    readChar : function(){

      var charCode = this.readShort();
      return String.fromCharCode(charCode);
    },
    readShort : function(){

      this._checkRegion(2);
      var a = this.bytes[this.pos++];
      var b = this.bytes[this.pos++];
      return (((a & 0xff) << 8) | (b & 0xff));
    },
    readInt : function(){

      this._checkRegion(4);
      var a = this.bytes[this.pos++];
      var b = this.bytes[this.pos++];
      var c = this.bytes[this.pos++];
      var d = this.bytes[this.pos++];
      return (((a & 0xff) << 24) | ((b & 0xff) << 16) | ((c & 0xff) << 8) | (d & 0xff));
    },
    readLong : function(){

      this._checkRegion(8);
      var a = this.bytes[this.pos++];
      var b = this.bytes[this.pos++];
      var c = this.bytes[this.pos++];
      var d = this.bytes[this.pos++];
      var e = this.bytes[this.pos++];
      var f = this.bytes[this.pos++];
      var g = this.bytes[this.pos++];
      var h = this.bytes[this.pos++];
      return (((a & 0xff) << 56) | ((b & 0xff) << 48) | ((c & 0xff) << 40) | ((d & 0xff) << 32) | ((e & 0xff) << 24) | ((f & 0xff) << 16) | ((g & 0xff) << 8) | ((h & 0xff)));
    },
    readFully : function(b, off, len){

      this._checkRegion(len);
      if(off == null)off = 0;
      if(len == null)len = this.bytes.length - this.pos;
      for(var i = 0;i < len;++i){

        b[i + off] = this.bytes[this.pos++];
      };
    },
    available : function(){

      return this.bytes.length - this.pos;
    }
  }
});
qx.Class.define("xlsys.java.util.StrictLinkedHashSet", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Set],
  construct : function(){

    this.__array = new Array();
    this.__map = new Object();
  },
  members : {
    __array : null,
    __map : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil.hashcode(obj);
    },
    getClassName : function(){

      return "java.util.LinkedHashSet";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__array");
      arr.push("__map");
      return arr;
    },
    add : function(element){

      if(!this.contains(element))this.__array.push(element);
      var hash = this._getHashKey(element);
      this.__map[hash] = element;
    },
    addAll : function(collection){

      var arr = collection.toArray();
      for(var i = 0;i < arr.length;++i){

        this.add(arr[i]);
      };
    },
    clear : function(){

      for(var fieldName in this._map){

        delete this.__map[fieldName];
      };
      while(this.__array.pop() != null);
    },
    contains : function(element){

      var hash = this._getHashKey(element);
      var contain = this.__map[hash] != null;
      return contain;
    },
    remove : function(element){

      var hash = this._getHashKey(element);
      if(delete this.__map[hash]){

        for(var i = 0;i < this.__array.length;++i){

          if(this._getHashKey(this.__array[i]) == hash){

            this.__array.splice(i, 1);
            break;
          };
        };
      };
    },
    size : function(){

      return this.__array.length;
    },
    isEmpty : function(){

      return this.__array.length == 0;
    },
    toArray : function(){

      var tempArr = new Array();
      for(var i = 0;i < this.__array.length;++i){

        tempArr.push(this.__array[i]);
      };
      return tempArr;
    }
  }
});
qx.Interface.define("xlsys.base.model.IModel", {
  members : {
    toHashCode : function(){
    },
    getClassName : function(){
    },
    getSerializableMembers : function(){
    }
  }
});
qx.Class.define("xlsys.base.io.attachment.XlsysAttachment", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.base.model.IModel],
  statics : {
    STYLE_FILE_SYSTEM : 1,
    STYLE_FTP : 2
  },
  construct : function(attachmentName, lastModified, style, attachmentData, compress){

    this.setAttachmentName(attachmentName);
    this.lastModified = lastModified;
    this.style = style;
    this.setAttachmentData(attachmentData);
    this.compress = compress;
  },
  members : {
    attachmentName : null,
    innerName : null,
    size : null,
    lastModified : null,
    type : null,
    style : null,
    compress : null,
    attachmentData : null,
    md5 : null,
    id : null,
    path : null,
    setAttachmentName : function(attachmentName){

      this.attachmentName = attachmentName;
      if(attachmentName != null){

        var baseStr = attachmentName + (new Date()).getTime() + qx.core.ObjectRegistry.toHashCode(this);
        this.innerName = xlsys.base.util.StringUtil.getMD5String(baseStr);
      } else this.innerName = null;
    },
    getAttachmentName : function(){

      return this.attachmentName;
    },
    getInnerName : function(){

      return this.innerName;
    },
    getStyle : function(){

      return this.style;
    },
    setSize : function(size){

      this.size = size;
    },
    getSize : function(){

      return this.size;
    },
    isCompress : function(){

      return this.compress;
    },
    getAttachmentData : function(){

      return this.attachmentData;
    },
    setAttachmentData : function(attachmentData){

      this.attachmentData = attachmentData;
      if(attachmentData != null){

        this.size = attachmentData.length;
        this.setMd5(xlsys.base.util.StringUtil.getMD5String(attachmentData));
      };
    },
    getPath : function(){

      return this.path;
    },
    getLastModified : function(){

      return this.lastModified;
    },
    setType : function(type){

      this.type = type;
    },
    getType : function(){

      return this.type;
    },
    setPath : function(path){

      this.path = path;
    },
    getId : function(){

      return this.id;
    },
    setId : function(id){

      this.id = id;
    },
    getMd5 : function(){

      return this.md5;
    },
    setMd5 : function(md5){

      this.md5 = md5;
    },
    getSerializableMembers : function(){

      var ret = new Array();
      ret.push("attachmentName");
      ret.push("innerName");
      ret.push("size");
      ret.push("lastModified");
      ret.push("type");
      ret.push("style");
      ret.push("compress");
      ret.push("attachmentData");
      ret.push("md5");
      ret.push("id");
      ret.push("path");
      return ret;
    },
    getMemberDataType : function(memberName){

      var type = null;
      if(memberName == "size" || memberName == "lastModified")type = xlsys.base.XLSYS.DATA_TYPE_LONG; else if(memberName == "style")type = xlsys.base.XLSYS.DATA_TYPE_INT; else if(memberName == "attachmentData")type = xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY;;;
      return type;
    }
  }
});
qx.Interface.define("xlsys.base.buffer.XlsysBuffer", {
  statics : {
    MARK_ALL : "all"
  },
  members : {
    getStorageObject : function(bufferName, mark){

      this.assertArgumentsCount(arguments, 2, 2);
    },
    isBufferComplete : function(bufferName, callback){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    reloadDataDirectly : function(bufferName, paramMap, forceLoad, callback){

      this.assertArgumentsCount(arguments, 1, 4);
    },
    loadDataFromStorageObject : function(bufferName, storageObj, mark){

      this.assertArgumentsCount(arguments, 3, 3);
    },
    doGetBufferData : function(bufferName, paramMap, callback){

      this.assertArgumentsCount(arguments, 1, 3);
    },
    saveDataToLocalStorage : function(bufferName, storageObject, callback){

      this.assertArgumentsCount(arguments, 2, 3);
    },
    reloadDataFromLocalStorage : function(bufferName, callback){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getLocalStorageVersion : function(bufferName, callback){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getFinalStorageObject : function(bufferName, mark){

      this.assertArgumentsCount(arguments, 2, 2);
    },
    getBufferData : function(bufferName, paramMap, callback){

      this.assertArgumentsCount(arguments, 1, 3);
    },
    updateCurrentVersion : function(bufferName, callback){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    getCurrentVersion : function(bufferName, callback){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    reloadAllData : function(bufferName, forceLoad, callback){

      this.assertArgumentsCount(arguments, 1, 3);
    },
    reloadData : function(bufferName, paramMap, forceLoad, callback){

      this.assertArgumentsCount(arguments, 1, 4);
    }
  }
});
qx.Mixin.define("xlsys.base.buffer.MXlsysBuffer", {
  statics : {
    versionMap : null,
    accessBuffers : {
    }
  },
  members : {
    _getFinalStorageObject : function(bufferName, mark){

      var preloadBuffer = qx.core.Environment.get(xlsys.base.XLSYS.ENV_PRELOAD_BUFFER);
      var delegateClass = null;
      if(preloadBuffer != null && preloadBuffer["bufferConfig"] && preloadBuffer["bufferConfig"][bufferName]){

        var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
        var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
        var cfgArr = preloadBuffer["bufferConfig"][bufferName];
        for(var i = 0;i < cfgArr.length;++i){

          var cfg = cfgArr[i];
          var tempEnvId = cfg["envId"];
          var tempMark = cfg["mark"];
          if(tempEnvId != envId || tempMark != mark)continue;
          var tempDelegate = cfg["delegate"];
          if(tempDelegate != null)delegateClass = tempDelegate;
          break;
        };
      };
      var storageObject = null;
      if(delegateClass == null)storageObject = this.getStorageObject(bufferName, mark); else {

        var delegate = xlsys.base.util.ReflectUtil.newInstance(delegateClass);
        storageObject = delegate.getStorageObject(this, bufferName, mark);
      };
      return storageObject;
    },
    _getBufferData : function(bufferName, paramMap, callback){

      if(callback)this.isBufferComplete(bufferName, qx.Bootstrap.bind(this.__getBufferData0, this, bufferName, paramMap, callback)); else {

        var isComplete = this.isBufferComplete(bufferName);
        if(!isComplete)this.reloadDataFromLocalStorage(bufferName);
        var ret = this.doGetBufferData(bufferName, paramMap);
        if(!isComplete && this.isBufferComplete(bufferName)){

          var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
          this.saveDataToLocalStorage(bufferName, storageObject);
        };
        return ret;
      };
    },
    __getBufferData0 : function(bufferName, paramMap, callback, isComplete){

      if(!isComplete)this.reloadDataFromLocalStorage(bufferName, qx.Bootstrap.bind(this.__getBufferData1, this, bufferName, paramMap, callback, isComplete)); else this.__getBufferData1(bufferName, paramMap, callback, isComplete);
    },
    __getBufferData1 : function(bufferName, paramMap, callback, isComplete){

      this.doGetBufferData(bufferName, paramMap, qx.Bootstrap.bind(this.__getBufferData2, this, bufferName, callback, isComplete));
    },
    __getBufferData2 : function(bufferName, callback, isComplete, ret){

      callback(ret);
      this.isBufferComplete(bufferName, qx.Bootstrap.bind(this.__getBufferData3, this, bufferName, isComplete));
    },
    __getBufferData3 : function(bufferName, isComplete, isComplete2){

      if(!isComplete && isComplete2){

        var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
        this.saveDataToLocalStorage(bufferName, storageObject, qx.Bootstrap.bind(this.__whatEver, this));
      };
    },
    __whatEver : function(){
    },
    _updateCurrentVersion : function(bufferName, callback){

      if(callback)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_UPDATE_BUFFER_VERSION, bufferName, qx.Bootstrap.bind(this.__updateCurrentVersion1, this, bufferName, callback)); else {

        var version = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_UPDATE_BUFFER_VERSION, bufferName);
        this.__updateCurrentVersion2(bufferName, version);
        return version;
      };
    },
    __updateCurrentVersion1 : function(bufferName, callback, version){

      this.__updateCurrentVersion2(bufferName, version);
      callback(version);
    },
    __updateCurrentVersion2 : function(bufferName, version){

      var versionMap = xlsys.base.buffer.MXlsysBuffer.versionMap;
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var tempMap = versionMap.get(envId);
      if(tempMap == null){

        tempMap = new xlsys.java.util.HashMap();
        versionMap.put(envId, tempMap);
      };
      tempMap.put(bufferName, version);
    },
    _getCurrentVersion : function(bufferName, callback){

      if(xlsys.base.buffer.MXlsysBuffer.versionMap == null)xlsys.base.buffer.MXlsysBuffer.versionMap = new xlsys.java.util.HashMap();
      var versionMap = xlsys.base.buffer.MXlsysBuffer.versionMap;
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var tempMap = versionMap.get(envId);
      if(tempMap == null){

        tempMap = new xlsys.java.util.HashMap();
        versionMap.put(envId, tempMap);
      };
      var version = tempMap.get(bufferName);
      if(callback){

        if(version == -1 || version == null)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_GET_BUFFER_VERSION, bufferName, qx.Bootstrap.bind(this.__getCurrentVersion1, this, tempMap, bufferName, callback)); else this.__getCurrentVersion1(tempMap, bufferName, callback, version);
      } else {

        if(version == -1 || version == null)version = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_GET_BUFFER_VERSION, bufferName);
        tempMap.put(bufferName, version);
        return version;
      };
    },
    __getCurrentVersion1 : function(tempMap, bufferName, callback, version){

      tempMap.put(bufferName, version);
      callback(version);
    },
    _reloadAllData : function(bufferName, forceLoad, callback){

      if(forceLoad == null)forceLoad = false;
      if(callback)this.reloadDataFromLocalStorage(bufferName, qx.Bootstrap.bind(this.__reloadAllData1, this, bufferName, forceLoad, callback)); else {

        if(!this.reloadDataFromLocalStorage(bufferName)){

          this.reloadDataDirectly(bufferName, null, forceLoad);
          if(this.isBufferComplete(bufferName)){

            var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
            this.saveDataToLocalStorage(bufferName, storageObject);
          };
        };
      };
    },
    __reloadAllData1 : function(bufferName, forceLoad, callback, success){

      if(!success)this.reloadDataDirectly(bufferName, null, forceLoad, qx.Bootstrap.bind(this.__reloadData1, this, bufferName, callback)); else callback();
    },
    _reloadData : function(bufferName, paramMap, forceLoad, callback){

      if(forceLoad == null)forceLoad = false;
      if(callback){

        if(paramMap == null)this.reloadAllData(bufferName, forceLoad, callback); else this.reloadDataDirectly(bufferName, paramMap, forceLoad, qx.Bootstrap.bind(this.__reloadData1, this, bufferName, callback));
      } else {

        if(paramMap == null)this.reloadAllData(bufferName, forceLoad); else {

          this.reloadDataDirectly(bufferName, paramMap, forceLoad);
          if(this.isBufferComplete(bufferName)){

            var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
            this.saveDataToLocalStorage(bufferName, storageObject);
          };
        };
      };
    },
    __reloadData1 : function(bufferName, callback){

      callback();
      this.isBufferComplete(bufferName, qx.Bootstrap.bind(this.__reloadData2, this, bufferName));
    },
    __reloadData2 : function(bufferName, isComplete){

      if(isComplete){

        var storageObject = this.getFinalStorageObject(bufferName, xlsys.base.buffer.XlsysBuffer.MARK_ALL);
        this.saveDataToLocalStorage(bufferName, storageObject, qx.Bootstrap.bind(this.__whatEver, this));
      };
    }
  }
});
qx.Class.define("xlsys.base.io.transfer.client.ClientTransfer", {
  type : "static",
  statics : {
    defaultPost : function(cmd, obj, callback, platform){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      if(session == null)session = xlsys.base.session.SessionManager.getInstance().defaultSession;
      if(callback == null)return this.post(session, cmd, obj, false, callback, platform); else this.post(session, cmd, obj, false, callback, platform);
    },
    post : function(session, cmd, obj, retPkg, callback, platform, wholeSession){

      if(wholeSession == null)wholeSession = false;
      var srcSession = session;
      if(!wholeSession && session != null && session.getSessionId() != xlsys.base.XLSYS.SESSION_DEFAULT_ID){

        var cloneSession = new xlsys.base.session.Session(session.getSessionId());
        cloneSession.setSessionType(xlsys.base.session.Session.TYPE_INCREMENTAL);
        var changedKeys = session.getChangedEnvKeys().toArray();
        for(var i = 0;i < changedKeys.length;++i){

          cloneSession.setAttribute(changedKeys[i], session.getAttribute(changedKeys[i]));
        };
        session.getChangedEnvKeys().clear();
        session = cloneSession;
      };
      if(platform == null)platform = xlsys.base.XLSYS.PLATFORM_PURE_JSON;
      var data = new Object();
      data.WEB_COMMAND = cmd;
      if(platform == xlsys.base.XLSYS.PLATFORM_PURE_JSON){

        data.WEB_SESSION = xlsys.base.io.util.IOUtil.getCommonJSONFromObj(session);
        data.WEB_DATA = xlsys.base.io.util.IOUtil.getCommonJSONFromObj(obj);
      } else {

        data.WEB_SESSION = xlsys.base.io.util.IOUtil.getJSONStr(session);
        data.WEB_DATA = xlsys.base.io.util.IOUtil.getJSONStr(obj);
      };
      var req = new qx.io.request.Xhr();
      req.setUrl(qx.core.Environment.get(xlsys.base.XLSYS.ENV_SERVLET_URL));
      req.setMethod("POST");
      req.setRequestHeader(xlsys.base.XLSYS.PLATFORM, "" + platform);
      req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
      var sb = new xlsys.java.lang.StringBuilder();
      var isFirst = true;
      for(var fieldName in data){

        if(!isFirst)sb.append("&"); else isFirst = false;
        sb.append(fieldName).append("=").append(encodeURIComponent(data[fieldName]));
      };
      req.setRequestData(sb.toString());
      var isAsync = (callback != null);
      req.setAsync(isAsync);
      if(isAsync)req.addListener("success", qx.Bootstrap.bind(this.__onRequestSuccess, this, srcSession, cmd, obj, retPkg, callback, platform), this);
      req.send();
      if(!isAsync){

        var retObj = null;
        if(platform == xlsys.base.XLSYS.PLATFORM_PURE_JSON)retObj = xlsys.base.io.util.IOUtil.getObjFromCommonJSON(req.getResponse()); else retObj = xlsys.base.io.util.IOUtil.getObjFromJSON(req.getResponse());
        if(retObj.getCommand() == xlsys.base.XLSYS.COMMAND_WHOLE_SESSION){

          return this.post(xlsys.base.session.SessionManager.getInstance().getCurrentSession(), cmd, obj, retPkg, callback, platform, true);
        } else {

          this.__setSessionIncremental(srcSession, retObj.getSession());
          if(!retPkg)retObj = retObj.getObj();
          return retObj;
        };
      };
    },
    __setSessionIncremental : function(srcSession, increSession){

      if(srcSession == null || increSession == null)return;
      if(increSession.getSessionType() != xlsys.base.session.Session.TYPE_INCREMENTAL)return;
      var keys = increSession.getEnvKeySet().toArray();
      for(var i = 0;i < keys.length;++i){

        srcSession.setAttribute(keys[i], increSession.getAttribute(keys[i]));
      };
      srcSession.getChangedEnvKeys().clear();
    },
    __onRequestSuccess : function(srcSession, cmd, obj, retPkg, callback, platform, event){

      var req = event.getTarget();
      var retObj = null;
      if(platform == xlsys.base.XLSYS.PLATFORM_PURE_JSON)retObj = xlsys.base.io.util.IOUtil.getObjFromCommonJSON(req.getResponse()); else retObj = xlsys.base.io.util.IOUtil.getObjFromJSON(req.getResponse());
      if(retObj.getCommand() == xlsys.base.XLSYS.COMMAND_WHOLE_SESSION){

        this.post(xlsys.base.session.SessionManager.getInstance().getCurrentSession(), cmd, obj, retPkg, callback, platform, true);
      } else {

        this.__setSessionIncremental(srcSession, retObj.getSession());
        if(!retPkg)retObj = retObj.getObj();
        callback(retObj, "success");
      };
    }
  }
});
qx.Class.define("qx.io.request.AbstractRequest", {
  type : "abstract",
  extend : qx.core.Object,
  construct : function(url){

    qx.core.Object.call(this);
    if(url !== undefined){

      this.setUrl(url);
    };
    this.__requestHeaders = {
    };
    var transport = this._transport = this._createTransport();
    this._setPhase("unsent");
    this.__onReadyStateChangeBound = qx.lang.Function.bind(this._onReadyStateChange, this);
    this.__onLoadBound = qx.lang.Function.bind(this._onLoad, this);
    this.__onLoadEndBound = qx.lang.Function.bind(this._onLoadEnd, this);
    this.__onAbortBound = qx.lang.Function.bind(this._onAbort, this);
    this.__onTimeoutBound = qx.lang.Function.bind(this._onTimeout, this);
    this.__onErrorBound = qx.lang.Function.bind(this._onError, this);
    transport.onreadystatechange = this.__onReadyStateChangeBound;
    transport.onload = this.__onLoadBound;
    transport.onloadend = this.__onLoadEndBound;
    transport.onabort = this.__onAbortBound;
    transport.ontimeout = this.__onTimeoutBound;
    transport.onerror = this.__onErrorBound;
  },
  events : {
    "readyStateChange" : "qx.event.type.Event",
    "success" : "qx.event.type.Event",
    "load" : "qx.event.type.Event",
    "loadEnd" : "qx.event.type.Event",
    "abort" : "qx.event.type.Event",
    "timeout" : "qx.event.type.Event",
    "error" : "qx.event.type.Event",
    "statusError" : "qx.event.type.Event",
    "fail" : "qx.event.type.Event",
    "changeResponse" : "qx.event.type.Data",
    "changePhase" : "qx.event.type.Data"
  },
  properties : {
    url : {
      check : "String"
    },
    timeout : {
      check : "Number",
      nullable : true,
      init : 0
    },
    requestData : {
      check : function(value){

        return qx.lang.Type.isString(value) || qx.Class.isSubClassOf(value.constructor, qx.core.Object) || qx.lang.Type.isObject(value) || qx.lang.Type.isArray(value) || qx.Bootstrap.getClass(value) == "Blob" || qx.Bootstrap.getClass(value) == "ArrayBuffer" || qx.Bootstrap.getClass(value) == "FormData";
      },
      nullable : true
    },
    authentication : {
      check : "qx.io.request.authentication.IAuthentication",
      nullable : true
    }
  },
  members : {
    __onReadyStateChangeBound : null,
    __onLoadBound : null,
    __onLoadEndBound : null,
    __onAbortBound : null,
    __onTimeoutBound : null,
    __onErrorBound : null,
    __response : null,
    __abort : null,
    __phase : null,
    __requestHeaders : null,
    __requestHeadersDeprecated : null,
    _transport : null,
    _createTransport : function(){

      throw new Error("Abstract method call");
    },
    _getConfiguredUrl : function(){
    },
    _getConfiguredRequestHeaders : function(){
    },
    _getParsedResponse : function(){

      throw new Error("Abstract method call");
    },
    _getMethod : function(){

      return "GET";
    },
    _isAsync : function(){

      return true;
    },
    send : function(){

      var transport = this._transport,url,method,async,requestData;
      url = this._getConfiguredUrl();
      if(/\#/.test(url)){

        url = url.replace(/\#.*/, "");
      };
      transport.timeout = this.getTimeout();
      method = this._getMethod();
      async = this._isAsync();
      if(qx.core.Environment.get("qx.debug.io")){

        this.debug("Open low-level request with method: " + method + ", url: " + url + ", async: " + async);
      };
      transport.open(method, url, async);
      this._setPhase("opened");
      requestData = this.getRequestData();
      if(["ArrayBuffer", "Blob", "FormData"].indexOf(qx.Bootstrap.getClass(requestData)) == -1){

        requestData = this._serializeData(requestData);
      };
      this._setRequestHeaders();
      if(qx.core.Environment.get("qx.debug.io")){

        this.debug("Send low-level request");
      };
      method == "GET" ? transport.send() : transport.send(requestData);
      this._setPhase("sent");
    },
    abort : function(){

      if(qx.core.Environment.get("qx.debug.io")){

        this.debug("Abort request");
      };
      this.__abort = true;
      this.__phase = "abort";
      this._transport.abort();
    },
    _setRequestHeaders : function(){

      var transport = this._transport,requestHeaders = this._getAllRequestHeaders();
      for(var key in requestHeaders){

        transport.setRequestHeader(key, requestHeaders[key]);
      };
    },
    _getAllRequestHeaders : function(){

      var requestHeaders = {
      };
      qx.lang.Object.mergeWith(requestHeaders, this._getConfiguredRequestHeaders());
      qx.lang.Object.mergeWith(requestHeaders, this.__getAuthRequestHeaders());
      qx.lang.Object.mergeWith(requestHeaders, this.__requestHeadersDeprecated);
      qx.lang.Object.mergeWith(requestHeaders, this.__requestHeaders);
      return requestHeaders;
    },
    __getAuthRequestHeaders : function(){

      var auth = this.getAuthentication(),headers = {
      };
      if(auth){

        auth.getAuthHeaders().forEach(function(header){

          headers[header.key] = header.value;
        });
        return headers;
      };
    },
    setRequestHeader : function(key, value){

      this.__requestHeaders[key] = value;
    },
    getRequestHeader : function(key){

      return this.__requestHeaders[key];
    },
    removeRequestHeader : function(key){

      if(this.__requestHeaders[key]){

        delete this.__requestHeaders[key];
      };
    },
    getTransport : function(){

      return this._transport;
    },
    getReadyState : function(){

      return this._transport.readyState;
    },
    getPhase : function(){

      return this.__phase;
    },
    getStatus : function(){

      return this._transport.status;
    },
    getStatusText : function(){

      return this._transport.statusText;
    },
    getResponseText : function(){

      return this._transport.responseText;
    },
    getAllResponseHeaders : function(){

      return this._transport.getAllResponseHeaders();
    },
    getResponseHeader : function(key){

      return this._transport.getResponseHeader(key);
    },
    overrideResponseContentType : function(contentType){

      return this._transport.overrideMimeType(contentType);
    },
    getResponseContentType : function(){

      return this.getResponseHeader("Content-Type");
    },
    isDone : function(){

      return this.getReadyState() === 4;
    },
    getResponse : function(){

      return this.__response;
    },
    _setResponse : function(response){

      var oldResponse = response;
      if(this.__response !== response){

        this.__response = response;
        this.fireEvent("changeResponse", qx.event.type.Data, [this.__response, oldResponse]);
      };
    },
    _onReadyStateChange : function(){

      var readyState = this.getReadyState();
      if(qx.core.Environment.get("qx.debug.io")){

        this.debug("Fire readyState: " + readyState);
      };
      this.fireEvent("readyStateChange");
      if(this.__abort){

        return;
      };
      if(readyState === 3){

        this._setPhase("loading");
      };
      if(this.isDone()){

        this.__onReadyStateDone();
      };
    },
    __onReadyStateDone : function(){

      if(qx.core.Environment.get("qx.debug.io")){

        this.debug("Request completed with HTTP status: " + this.getStatus());
      };
      this._setPhase("load");
      if(qx.util.Request.isSuccessful(this.getStatus())){

        if(qx.core.Environment.get("qx.debug.io")){

          this.debug("Response is of type: '" + this.getResponseContentType() + "'");
        };
        this._setResponse(this._getParsedResponse());
        this._fireStatefulEvent("success");
      } else {

        try{

          this._setResponse(this._getParsedResponse());
        } catch(e) {
        };
        if(this.getStatus() !== 0){

          this._fireStatefulEvent("statusError");
          this.fireEvent("fail");
        };
      };
    },
    _onLoad : function(){

      this.fireEvent("load");
    },
    _onLoadEnd : function(){

      this.fireEvent("loadEnd");
    },
    _onAbort : function(){

      this._fireStatefulEvent("abort");
    },
    _onTimeout : function(){

      this._fireStatefulEvent("timeout");
      this.fireEvent("fail");
    },
    _onError : function(){

      this.fireEvent("error");
      this.fireEvent("fail");
    },
    _fireStatefulEvent : function(evt){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertString(evt);
      };
      this._setPhase(evt);
      this.fireEvent(evt);
    },
    _setPhase : function(phase){

      var previousPhase = this.__phase;
      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertString(phase);
        qx.core.Assert.assertMatch(phase, /^(unsent)|(opened)|(sent)|(loading)|(load)|(success)|(abort)|(timeout)|(statusError)$/);
      };
      this.__phase = phase;
      this.fireDataEvent("changePhase", phase, previousPhase);
    },
    _serializeData : function(data){

      var isPost = typeof this.getMethod !== "undefined" && this.getMethod() == "POST",isJson = (/application\/.*\+?json/).test(this.getRequestHeader("Content-Type"));
      if(!data){

        return null;
      };
      if(qx.lang.Type.isString(data)){

        return data;
      };
      if(qx.Class.isSubClassOf(data.constructor, qx.core.Object)){

        return qx.util.Serializer.toUriParameter(data);
      };
      if(isJson && (qx.lang.Type.isObject(data) || qx.lang.Type.isArray(data))){

        return qx.lang.Json.stringify(data);
      };
      if(qx.lang.Type.isObject(data)){

        return qx.util.Uri.toParameter(data, isPost);
      };
      return null;
    }
  },
  environment : {
    "qx.debug.io" : false
  },
  destruct : function(){

    var transport = this._transport,noop = function(){
    };
    if(this._transport){

      transport.onreadystatechange = transport.onload = transport.onloadend = transport.onabort = transport.ontimeout = transport.onerror = noop;
      window.setTimeout(function(){

        transport.dispose();
      }, 0);
    };
  }
});
qx.Bootstrap.define("qx.lang.Object", {
  statics : {
    empty : function(map){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertMap(map, "Invalid argument 'map'");
      };
      for(var key in map){

        if(map.hasOwnProperty(key)){

          delete map[key];
        };
      };
    },
    isEmpty : function(map){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertMap(map, "Invalid argument 'map'");
      };
      for(var key in map){

        return false;
      };
      return true;
    },
    getLength : qx.Bootstrap.objectGetLength,
    getValues : function(map){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertMap(map, "Invalid argument 'map'");
      };
      var arr = [];
      var keys = Object.keys(map);
      for(var i = 0,l = keys.length;i < l;i++){

        arr.push(map[keys[i]]);
      };
      return arr;
    },
    mergeWith : qx.Bootstrap.objectMergeWith,
    clone : function(source, deep){

      if(qx.lang.Type.isObject(source)){

        var clone = {
        };
        for(var key in source){

          if(deep){

            clone[key] = qx.lang.Object.clone(source[key], deep);
          } else {

            clone[key] = source[key];
          };
        };
        return clone;
      } else if(qx.lang.Type.isArray(source)){

        var clone = [];
        for(var i = 0;i < source.length;i++){

          if(deep){

            clone[i] = qx.lang.Object.clone(source[i], deep);
          } else {

            clone[i] = source[i];
          };
        };
        return clone;
      };
      return source;
    },
    equals : function(object1, object2){

      return qx.lang.Object.__equals(object1, object2, [], []);
    },
    __equals : function(object1, object2, aStack, bStack){

      if(object1 === object2){

        return object1 !== 0 || 1 / object1 == 1 / object2;
      };
      if(object1 == null || object2 == null){

        return object1 === object2;
      };
      var className = Object.prototype.toString.call(object1);
      if(className != Object.prototype.toString.call(object2)){

        return false;
      };
      switch(className){case '[object String]':
      return object1 == String(object2);case '[object Number]':
      return object1 != +object1 ? object2 != +object2 : (object1 == 0 ? 1 / object1 == 1 / object2 : object1 == +object2);case '[object Date]':case '[object Boolean]':
      return +object1 == +object2;case '[object RegExp]':
      return object1.source == object2.source && object1.global == object2.global && object1.multiline == object2.multiline && object1.ignoreCase == object2.ignoreCase;};
      if(typeof object1 != 'object' || typeof object2 != 'object'){

        return false;
      };
      var length = aStack.length;
      while(length--){

        if(aStack[length] == object1){

          return bStack[length] == object2;
        };
      };
      var aCtor = object1.constructor,bCtor = object2.constructor;
      if(aCtor !== bCtor && !(qx.Bootstrap.isFunction(aCtor) && (aCtor instanceof aCtor) && qx.Bootstrap.isFunction(bCtor) && (bCtor instanceof bCtor)) && ('constructor' in object1 && 'constructor' in object2)){

        return false;
      };
      aStack.push(object1);
      bStack.push(object2);
      var size = 0,result = true;
      if(className == '[object Array]'){

        size = object1.length;
        result = size == object2.length;
        if(result){

          while(size--){

            if(!(result = qx.lang.Object.__equals(object1[size], object2[size], aStack, bStack))){

              break;
            };
          };
        };
      } else {

        for(var key in object1){

          if(Object.prototype.hasOwnProperty.call(object1, key)){

            size++;
            if(!(result = Object.prototype.hasOwnProperty.call(object2, key) && qx.lang.Object.__equals(object1[key], object2[key], aStack, bStack))){

              break;
            };
          };
        };
        if(result){

          for(key in object2){

            if(Object.prototype.hasOwnProperty.call(object2, key) && !(size--)){

              break;
            };
          };
          result = !size;
        };
      };
      aStack.pop();
      bStack.pop();
      return result;
    },
    invert : function(map){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertMap(map, "Invalid argument 'map'");
      };
      var result = {
      };
      for(var key in map){

        result[map[key].toString()] = key;
      };
      return result;
    },
    getKeyFromValue : function(map, value){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertMap(map, "Invalid argument 'map'");
      };
      for(var key in map){

        if(map.hasOwnProperty(key) && map[key] === value){

          return key;
        };
      };
      return null;
    },
    contains : function(map, value){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertMap(map, "Invalid argument 'map'");
      };
      return this.getKeyFromValue(map, value) !== null;
    },
    fromArray : function(array){

      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert && qx.core.Assert.assertArray(array, "Invalid argument 'array'");
      };
      var obj = {
      };
      for(var i = 0,l = array.length;i < l;i++){

        if(qx.core.Environment.get("qx.debug")){

          switch(typeof array[i]){case "object":case "function":case "undefined":
          throw new Error("Could not convert complex objects like " + array[i] + " at array index " + i + " to map syntax");};
        };
        obj[array[i].toString()] = true;
      };
      return obj;
    }
  }
});
qx.Bootstrap.define("qx.util.Request", {
  statics : {
    isCrossDomain : function(url){

      var result = qx.util.Uri.parseUri(url),location = window.location;
      if(!location){

        return false;
      };
      var protocol = location.protocol;
      if(!(url.indexOf("//") !== -1)){

        return false;
      };
      if(protocol.substr(0, protocol.length - 1) == result.protocol && location.host === result.host && location.port === result.port){

        return false;
      };
      return true;
    },
    isSuccessful : function(status){

      return (status >= 200 && status < 300 || status === 304);
    },
    isMethod : function(method){

      var knownMethods = ["GET", "POST", "PUT", "DELETE", "HEAD", "OPTIONS", "TRACE", "CONNECT", "PATCH"];
      return (knownMethods.indexOf(method) !== -1) ? true : false;
    },
    methodAllowsRequestBody : function(method){

      return !((/^(GET|HEAD)$/).test(method));
    }
  }
});
qx.Bootstrap.define("qx.util.Uri", {
  statics : {
    parseUri : function(str, strict){

      var options = {
        key : ["source", "protocol", "authority", "userInfo", "user", "password", "host", "port", "relative", "path", "directory", "file", "query", "anchor"],
        q : {
          name : "queryKey",
          parser : /(?:^|&)([^&=]*)=?([^&]*)/g
        },
        parser : {
          strict : /^(?:([^:\/?#]+):)?(?:\/\/((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?))?((((?:[^?#\/]*\/)*)([^?#]*))(?:\?([^#]*))?(?:#(.*))?)/,
          loose : /^(?:(?![^:@]+:[^:@\/]*@)([^:\/?#.]+):)?(?:\/\/)?((?:(([^:@]*)(?::([^:@]*))?)?@)?([^:\/?#]*)(?::(\d*))?)(((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[?#]|$)))*\/?)?([^?#\/]*))(?:\?([^#]*))?(?:#(.*))?)/
        }
      };
      var o = options,m = options.parser[strict ? "strict" : "loose"].exec(str),uri = {
      },i = 14;
      while(i--){

        uri[o.key[i]] = m[i] || "";
      };
      uri[o.q.name] = {
      };
      uri[o.key[12]].replace(o.q.parser, function($0, $1, $2){

        if($1){

          uri[o.q.name][$1] = $2;
        };
      });
      return uri;
    },
    appendParamsToUrl : function(url, params){

      if(params === undefined){

        return url;
      };
      if(qx.core.Environment.get("qx.debug")){

        if(!(qx.lang.Type.isString(params) || qx.lang.Type.isObject(params))){

          throw new Error("params must be either string or object");
        };
      };
      if(qx.lang.Type.isObject(params)){

        params = qx.util.Uri.toParameter(params);
      };
      if(!params){

        return url;
      };
      return url += (/\?/).test(url) ? "&" + params : "?" + params;
    },
    toParameter : function(obj, post){

      var key,parts = [];
      for(key in obj){

        if(obj.hasOwnProperty(key)){

          var value = obj[key];
          if(value instanceof Array){

            for(var i = 0;i < value.length;i++){

              this.__toParameterPair(key, value[i], parts, post);
            };
          } else {

            this.__toParameterPair(key, value, parts, post);
          };
        };
      };
      return parts.join("&");
    },
    __toParameterPair : function(key, value, parts, post){

      var encode = window.encodeURIComponent;
      if(post){

        parts.push(encode(key).replace(/%20/g, "+") + "=" + encode(value).replace(/%20/g, "+"));
      } else {

        parts.push(encode(key) + "=" + encode(value));
      };
    },
    getAbsolute : function(uri){

      var div = document.createElement("div");
      div.innerHTML = '<a href="' + uri + '">0</a>';
      return div.firstChild.href;
    }
  }
});
qx.Class.define("qx.util.Serializer", {
  statics : {
    toUriParameter : function(object, qxSerializer, dateFormat){

      var result = "";
      var properties = qx.util.PropertyUtil.getAllProperties(object.constructor);
      for(var name in properties){

        if(properties[name].group != undefined){

          continue;
        };
        var value = object["get" + qx.lang.String.firstUp(name)]();
        if(qx.lang.Type.isArray(value)){

          var isdataArray = qx.data && qx.data.IListData && qx.Class.hasInterface(value && value.constructor, qx.data.IListData);
          for(var i = 0;i < value.length;i++){

            var valueAtI = isdataArray ? value.getItem(i) : value[i];
            result += this.__toUriParameter(name, valueAtI, qxSerializer);
          };
        } else if(qx.lang.Type.isDate(value) && dateFormat != null){

          result += this.__toUriParameter(name, dateFormat.format(value), qxSerializer);
        } else {

          result += this.__toUriParameter(name, value, qxSerializer);
        };
      };
      return result.substring(0, result.length - 1);
    },
    __toUriParameter : function(name, value, qxSerializer){

      if(value && value.$$type == "Class"){

        value = value.classname;
      };
      if(value && (value.$$type == "Interface" || value.$$type == "Mixin")){

        value = value.name;
      };
      if(value instanceof qx.core.Object && qxSerializer != null){

        var encValue = encodeURIComponent(qxSerializer(value));
        if(encValue === undefined){

          var encValue = encodeURIComponent(value);
        };
      } else {

        var encValue = encodeURIComponent(value);
      };
      return encodeURIComponent(name) + "=" + encValue + "&";
    },
    toNativeObject : function(object, qxSerializer, dateFormat){

      var result;
      if(object == null){

        return null;
      };
      if(qx.data && qx.data.IListData && qx.Class.hasInterface(object.constructor, qx.data.IListData)){

        result = [];
        for(var i = 0;i < object.getLength();i++){

          result.push(qx.util.Serializer.toNativeObject(object.getItem(i), qxSerializer, dateFormat));
        };
        return result;
      };
      if(qx.lang.Type.isArray(object)){

        result = [];
        for(var i = 0;i < object.length;i++){

          result.push(qx.util.Serializer.toNativeObject(object[i], qxSerializer, dateFormat));
        };
        return result;
      };
      if(object.$$type == "Class"){

        return object.classname;
      };
      if(object.$$type == "Interface" || object.$$type == "Mixin"){

        return object.name;
      };
      if(object instanceof qx.core.Object){

        if(qxSerializer != null){

          var returnValue = qxSerializer(object);
          if(returnValue != undefined){

            return returnValue;
          };
        };
        result = {
        };
        var properties = qx.util.PropertyUtil.getAllProperties(object.constructor);
        for(var name in properties){

          if(properties[name].group != undefined){

            continue;
          };
          var value = object["get" + qx.lang.String.firstUp(name)]();
          result[name] = qx.util.Serializer.toNativeObject(value, qxSerializer, dateFormat);
        };
        return result;
      };
      if(qx.lang.Type.isDate(object) && dateFormat != null){

        return dateFormat.format(object);
      };
      if(qx.locale && qx.locale.LocalizedString && object instanceof qx.locale.LocalizedString){

        return object.toString();
      };
      if(qx.lang.Type.isObject(object)){

        result = {
        };
        for(var key in object){

          result[key] = qx.util.Serializer.toNativeObject(object[key], qxSerializer, dateFormat);
        };
        return result;
      };
      return object;
    },
    toJson : function(object, qxSerializer, dateFormat){

      var result = "";
      if(object == null){

        return "null";
      };
      if(qx.data && qx.data.IListData && qx.Class.hasInterface(object.constructor, qx.data.IListData)){

        result += "[";
        for(var i = 0;i < object.getLength();i++){

          result += qx.util.Serializer.toJson(object.getItem(i), qxSerializer, dateFormat) + ",";
        };
        if(result != "["){

          result = result.substring(0, result.length - 1);
        };
        return result + "]";
      };
      if(qx.lang.Type.isArray(object)){

        result += "[";
        for(var i = 0;i < object.length;i++){

          result += qx.util.Serializer.toJson(object[i], qxSerializer, dateFormat) + ",";
        };
        if(result != "["){

          result = result.substring(0, result.length - 1);
        };
        return result + "]";
      };
      if(object.$$type == "Class"){

        return '"' + object.classname + '"';
      };
      if(object.$$type == "Interface" || object.$$type == "Mixin"){

        return '"' + object.name + '"';
      };
      if(object instanceof qx.core.Object){

        if(qxSerializer != null){

          var returnValue = qxSerializer(object);
          if(returnValue != undefined){

            return '"' + returnValue + '"';
          };
        };
        result += "{";
        var properties = qx.util.PropertyUtil.getAllProperties(object.constructor);
        for(var name in properties){

          if(properties[name].group != undefined){

            continue;
          };
          var value = object["get" + qx.lang.String.firstUp(name)]();
          result += '"' + name + '":' + qx.util.Serializer.toJson(value, qxSerializer, dateFormat) + ",";
        };
        if(result != "{"){

          result = result.substring(0, result.length - 1);
        };
        return result + "}";
      };
      if(qx.locale && qx.locale.LocalizedString && object instanceof qx.locale.LocalizedString){

        object = object.toString();
      };
      if(qx.lang.Type.isDate(object) && dateFormat != null){

        return '"' + dateFormat.format(object) + '"';
      };
      if(qx.lang.Type.isObject(object)){

        result += "{";
        for(var key in object){

          result += '"' + key + '":' + qx.util.Serializer.toJson(object[key], qxSerializer, dateFormat) + ",";
        };
        if(result != "{"){

          result = result.substring(0, result.length - 1);
        };
        return result + "}";
      };
      if(qx.lang.Type.isString(object)){

        object = object.replace(/([\\])/g, '\\\\');
        object = object.replace(/(["])/g, '\\"');
        object = object.replace(/([\r])/g, '\\r');
        object = object.replace(/([\f])/g, '\\f');
        object = object.replace(/([\n])/g, '\\n');
        object = object.replace(/([\t])/g, '\\t');
        object = object.replace(/([\b])/g, '\\b');
        return '"' + object + '"';
      };
      if(qx.lang.Type.isDate(object) || qx.lang.Type.isRegExp(object)){

        return '"' + object + '"';
      };
      return object + "";
    }
  }
});
qx.Class.define("qx.util.PropertyUtil", {
  statics : {
    getProperties : function(clazz){

      return clazz.$$properties;
    },
    getAllProperties : function(clazz){

      var properties = {
      };
      var superclass = clazz;
      while(superclass != qx.core.Object){

        var currentProperties = this.getProperties(superclass);
        for(var property in currentProperties){

          properties[property] = currentProperties[property];
        };
        superclass = superclass.superclass;
      };
      return properties;
    },
    getUserValue : function(object, propertyName){

      return object["$$user_" + propertyName];
    },
    setUserValue : function(object, propertyName, value){

      object["$$user_" + propertyName] = value;
    },
    deleteUserValue : function(object, propertyName){

      delete (object["$$user_" + propertyName]);
    },
    getInitValue : function(object, propertyName){

      return object["$$init_" + propertyName];
    },
    setInitValue : function(object, propertyName, value){

      object["$$init_" + propertyName] = value;
    },
    deleteInitValue : function(object, propertyName){

      delete (object["$$init_" + propertyName]);
    },
    getThemeValue : function(object, propertyName){

      return object["$$theme_" + propertyName];
    },
    setThemeValue : function(object, propertyName, value){

      object["$$theme_" + propertyName] = value;
    },
    deleteThemeValue : function(object, propertyName){

      delete (object["$$theme_" + propertyName]);
    },
    setThemed : function(object, propertyName, value){

      var styler = qx.core.Property.$$method.setThemed;
      object[styler[propertyName]](value);
    },
    resetThemed : function(object, propertyName){

      var unstyler = qx.core.Property.$$method.resetThemed;
      object[unstyler[propertyName]]();
    }
  }
});
qx.Class.define("qx.io.request.Xhr", {
  extend : qx.io.request.AbstractRequest,
  construct : function(url, method){

    if(method !== undefined){

      this.setMethod(method);
    };
    qx.io.request.AbstractRequest.call(this, url);
    this._parser = this._createResponseParser();
  },
  events : {
    "readyStateChange" : "qx.event.type.Event",
    "success" : "qx.event.type.Event",
    "load" : "qx.event.type.Event",
    "statusError" : "qx.event.type.Event"
  },
  properties : {
    method : {
      init : "GET"
    },
    async : {
      check : "Boolean",
      init : true
    },
    accept : {
      check : "String",
      nullable : true
    },
    cache : {
      check : function(value){

        return qx.lang.Type.isBoolean(value) || qx.lang.Type.isString(value);
      },
      init : true
    }
  },
  members : {
    _parser : null,
    _createTransport : function(){

      return new qx.bom.request.Xhr();
    },
    _getConfiguredUrl : function(){

      var url = this.getUrl(),serializedData;
      if(this.getMethod() === "GET" && this.getRequestData()){

        serializedData = this._serializeData(this.getRequestData());
        url = qx.util.Uri.appendParamsToUrl(url, serializedData);
      };
      if(this.getCache() === false){

        url = qx.util.Uri.appendParamsToUrl(url, {
          nocache : new Date().valueOf()
        });
      };
      return url;
    },
    _getConfiguredRequestHeaders : function(){

      var headers = {
      },isAllowsBody = qx.util.Request.methodAllowsRequestBody(this.getMethod());
      if(!qx.util.Request.isCrossDomain(this.getUrl())){

        headers["X-Requested-With"] = "XMLHttpRequest";
      };
      if(qx.lang.Type.isString(this.getCache())){

        headers["Cache-Control"] = this.getCache();
      };
      if(this.getRequestData() !== "null" && isAllowsBody){

        headers["Content-Type"] = "application/x-www-form-urlencoded";
      };
      if(this.getAccept()){

        if(qx.core.Environment.get("qx.debug.io")){

          this.debug("Accepting: '" + this.getAccept() + "'");
        };
        headers["Accept"] = this.getAccept();
      };
      return headers;
    },
    _getMethod : function(){

      return this.getMethod();
    },
    _isAsync : function(){

      return this.isAsync();
    },
    _createResponseParser : function(){

      return new qx.util.ResponseParser();
    },
    _getParsedResponse : function(){

      var response = this._transport.responseText,contentType = this.getResponseContentType() || "";
      return this._parser.parse(response, contentType);
    },
    setParser : function(parser){

      return this._parser.setParser(parser);
    }
  }
});
qx.Bootstrap.define("qx.bom.request.Xhr", {
  extend : Object,
  construct : function(){

    var boundFunc = qx.Bootstrap.bind(this.__onNativeReadyStateChange, this);
    if(qx.event && qx.event.GlobalError && qx.event.GlobalError.observeMethod){

      this.__onNativeReadyStateChangeBound = qx.event.GlobalError.observeMethod(boundFunc);
    } else {

      this.__onNativeReadyStateChangeBound = boundFunc;
    };
    this.__onNativeAbortBound = qx.Bootstrap.bind(this.__onNativeAbort, this);
    this.__onTimeoutBound = qx.Bootstrap.bind(this.__onTimeout, this);
    this.__initNativeXhr();
    this._emitter = new qx.event.Emitter();
    if(window.attachEvent){

      this.__onUnloadBound = qx.Bootstrap.bind(this.__onUnload, this);
      window.attachEvent("onunload", this.__onUnloadBound);
    };
  },
  statics : {
    UNSENT : 0,
    OPENED : 1,
    HEADERS_RECEIVED : 2,
    LOADING : 3,
    DONE : 4
  },
  events : {
    "readystatechange" : "qx.bom.request.Xhr",
    "error" : "qx.bom.request.Xhr",
    "loadend" : "qx.bom.request.Xhr",
    "timeout" : "qx.bom.request.Xhr",
    "abort" : "qx.bom.request.Xhr",
    "load" : "qx.bom.request.Xhr"
  },
  members : {
    readyState : 0,
    responseText : "",
    responseXML : null,
    status : 0,
    statusText : "",
    timeout : 0,
    open : function(method, url, async, user, password){

      this.__checkDisposed();
      if(typeof url === "undefined"){

        throw new Error("Not enough arguments");
      } else if(typeof method === "undefined"){

        method = "GET";
      };
      this.__abort = false;
      this.__send = false;
      this.__conditional = false;
      this.__url = url;
      if(typeof async == "undefined"){

        async = true;
      };
      this.__async = async;
      if(!this.__supportsManyRequests() && this.readyState > qx.bom.request.Xhr.UNSENT){

        this.dispose();
        this.__initNativeXhr();
      };
      this.__nativeXhr.onreadystatechange = this.__onNativeReadyStateChangeBound;
      try{

        if(qx.core.Environment.get("qx.debug.io")){

          qx.Bootstrap.debug(qx.bom.request.Xhr, "Open native request with method: " + method + ", url: " + url + ", async: " + async);
        };
        this.__nativeXhr.open(method, url, async, user, password);
      } catch(OpenError) {

        if(!qx.util.Request.isCrossDomain(url)){

          throw OpenError;
        };
        if(!this.__async){

          this.__openError = OpenError;
        };
        if(this.__async){

          if(window.XDomainRequest){

            this.readyState = 4;
            this.__nativeXhr = new XDomainRequest();
            this.__nativeXhr.onerror = qx.Bootstrap.bind(function(){

              this._emit("readystatechange");
              this._emit("error");
              this._emit("loadend");
            }, this);
            if(qx.core.Environment.get("qx.debug.io")){

              qx.Bootstrap.debug(qx.bom.request.Xhr, "Retry open native request with method: " + method + ", url: " + url + ", async: " + async);
            };
            this.__nativeXhr.open(method, url, async, user, password);
            return;
          };
          window.setTimeout(qx.Bootstrap.bind(function(){

            if(this.__disposed){

              return;
            };
            this.readyState = 4;
            this._emit("readystatechange");
            this._emit("error");
            this._emit("loadend");
          }, this));
        };
      };
      if(qx.core.Environment.get("engine.name") === "mshtml" && qx.core.Environment.get("browser.documentmode") < 9 && this.__nativeXhr.readyState > 0){

        this.__nativeXhr.setRequestHeader("If-Modified-Since", "-1");
      };
      if(qx.core.Environment.get("engine.name") === "gecko" && parseInt(qx.core.Environment.get("engine.version"), 10) < 2 && !this.__async){

        this.readyState = qx.bom.request.Xhr.OPENED;
        this._emit("readystatechange");
      };
    },
    setRequestHeader : function(key, value){

      this.__checkDisposed();
      if(key == "If-Match" || key == "If-Modified-Since" || key == "If-None-Match" || key == "If-Range"){

        this.__conditional = true;
      };
      this.__nativeXhr.setRequestHeader(key, value);
      return this;
    },
    send : function(data){

      this.__checkDisposed();
      if(!this.__async && this.__openError){

        throw this.__openError;
      };
      if(qx.core.Environment.get("engine.name") === "opera" && this.timeout === 0){

        this.timeout = 10000;
      };
      if(this.timeout > 0){

        this.__timerId = window.setTimeout(this.__onTimeoutBound, this.timeout);
      };
      data = typeof data == "undefined" ? null : data;
      var dataType = qx.Bootstrap.getClass(data);
      data = (data !== null && this.__dataTypeWhiteList.indexOf(dataType) === -1) ? data.toString() : data;
      try{

        if(qx.core.Environment.get("qx.debug.io")){

          qx.Bootstrap.debug(qx.bom.request.Xhr, "Send native request");
        };
        this.__nativeXhr.send(data);
      } catch(SendError) {

        if(!this.__async){

          throw SendError;
        };
        if(this._getProtocol() === "file:"){

          this.readyState = 2;
          this.__readyStateChange();
          var that = this;
          window.setTimeout(function(){

            if(that.__disposed){

              return;
            };
            that.readyState = 3;
            that.__readyStateChange();
            that.readyState = 4;
            that.__readyStateChange();
          });
        };
      };
      if(qx.core.Environment.get("engine.name") === "gecko" && !this.__async){

        this.__onNativeReadyStateChange();
      };
      this.__send = true;
      return this;
    },
    abort : function(){

      this.__checkDisposed();
      this.__abort = true;
      this.__nativeXhr.abort();
      if(this.__nativeXhr){

        this.readyState = this.__nativeXhr.readyState;
      };
      return this;
    },
    _emit : function(event){

      if(this["on" + event]){

        this["on" + event]();
      };
      this._emitter.emit(event, this);
    },
    onreadystatechange : function(){
    },
    onload : function(){
    },
    onloadend : function(){
    },
    onerror : function(){
    },
    onabort : function(){
    },
    ontimeout : function(){
    },
    on : function(name, listener, ctx){

      this._emitter.on(name, listener, ctx);
      return this;
    },
    getResponseHeader : function(header){

      this.__checkDisposed();
      if(qx.core.Environment.get("browser.documentmode") === 9 && this.__nativeXhr.aborted){

        return "";
      };
      return this.__nativeXhr.getResponseHeader(header);
    },
    getAllResponseHeaders : function(){

      this.__checkDisposed();
      if(qx.core.Environment.get("browser.documentmode") === 9 && this.__nativeXhr.aborted){

        return "";
      };
      return this.__nativeXhr.getAllResponseHeaders();
    },
    overrideMimeType : function(mimeType){

      this.__checkDisposed();
      if(this.__nativeXhr.overrideMimeType){

        this.__nativeXhr.overrideMimeType(mimeType);
      } else {

        throw new Error("Native XHR object doesn't support overrideMimeType.");
      };
      return this;
    },
    getRequest : function(){

      return this.__nativeXhr;
    },
    dispose : function(){

      if(this.__disposed){

        return false;
      };
      window.clearTimeout(this.__timerId);
      if(window.detachEvent){

        window.detachEvent("onunload", this.__onUnloadBound);
      };
      try{

        this.__nativeXhr.onreadystatechange;
      } catch(PropertiesNotAccessable) {

        return false;
      };
      var noop = function(){
      };
      this.__nativeXhr.onreadystatechange = noop;
      this.__nativeXhr.onload = noop;
      this.__nativeXhr.onerror = noop;
      this.abort();
      this.__nativeXhr = null;
      this.__disposed = true;
      return true;
    },
    isDisposed : function(){

      return !!this.__disposed;
    },
    _createNativeXhr : function(){

      var xhr = qx.core.Environment.get("io.xhr");
      if(xhr === "xhr"){

        return new XMLHttpRequest();
      };
      if(xhr == "activex"){

        return new window.ActiveXObject("Microsoft.XMLHTTP");
      };
      qx.Bootstrap.error(this, "No XHR support available.");
    },
    _getProtocol : function(){

      var url = this.__url;
      var protocolRe = /^(\w+:)\/\//;
      if(url !== null && url.match){

        var match = url.match(protocolRe);
        if(match && match[1]){

          return match[1];
        };
      };
      return window.location.protocol;
    },
    __nativeXhr : null,
    __async : null,
    __onNativeReadyStateChangeBound : null,
    __onNativeAbortBound : null,
    __onUnloadBound : null,
    __onTimeoutBound : null,
    __send : null,
    __url : null,
    __abort : null,
    __timeout : null,
    __disposed : null,
    __timerId : null,
    __openError : null,
    __conditional : null,
    __dataTypeWhiteList : null,
    __initNativeXhr : function(){

      this.__nativeXhr = this._createNativeXhr();
      this.__nativeXhr.onreadystatechange = this.__onNativeReadyStateChangeBound;
      if(this.__nativeXhr.onabort){

        this.__nativeXhr.onabort = this.__onNativeAbortBound;
      };
      this.__disposed = this.__send = this.__abort = false;
      this.__dataTypeWhiteList = ["ArrayBuffer", "Blob", "HTMLDocument", "String", "FormData"];
    },
    __onNativeAbort : function(){

      if(!this.__abort){

        this.abort();
      };
    },
    __onNativeReadyStateChange : function(){

      var nxhr = this.__nativeXhr,propertiesReadable = true;
      if(qx.core.Environment.get("qx.debug.io")){

        qx.Bootstrap.debug(qx.bom.request.Xhr, "Received native readyState: " + nxhr.readyState);
      };
      if(this.readyState == nxhr.readyState){

        return;
      };
      this.readyState = nxhr.readyState;
      if(this.readyState === qx.bom.request.Xhr.DONE && this.__abort && !this.__send){

        return;
      };
      if(!this.__async && (nxhr.readyState == 2 || nxhr.readyState == 3)){

        return;
      };
      this.status = 0;
      this.statusText = this.responseText = "";
      this.responseXML = null;
      if(this.readyState >= qx.bom.request.Xhr.HEADERS_RECEIVED){

        try{

          this.status = nxhr.status;
          this.statusText = nxhr.statusText;
          this.responseText = nxhr.responseText;
          this.responseXML = nxhr.responseXML;
        } catch(XhrPropertiesNotReadable) {

          propertiesReadable = false;
        };
        if(propertiesReadable){

          this.__normalizeStatus();
          this.__normalizeResponseXML();
        };
      };
      this.__readyStateChange();
      if(this.readyState == qx.bom.request.Xhr.DONE){

        if(nxhr){

          nxhr.onreadystatechange = function(){
          };
        };
      };
    },
    __readyStateChange : function(){

      if(this.readyState === qx.bom.request.Xhr.DONE){

        window.clearTimeout(this.__timerId);
      };
      this._emit("readystatechange");
      if(this.readyState === qx.bom.request.Xhr.DONE){

        this.__readyStateChangeDone();
      };
    },
    __readyStateChangeDone : function(){

      if(this.__timeout){

        this._emit("timeout");
        if(qx.core.Environment.get("engine.name") === "opera"){

          this._emit("error");
        };
        this.__timeout = false;
      } else {

        if(this.__abort){

          this._emit("abort");
        } else {

          if(this.__isNetworkError()){

            this._emit("error");
          } else {

            this._emit("load");
          };
        };
      };
      this._emit("loadend");
    },
    __isNetworkError : function(){

      var error;
      if(this._getProtocol() === "file:"){

        error = !this.responseText;
      } else {

        error = !this.statusText && this.status !== 204;
      };
      return error;
    },
    __onTimeout : function(){

      var nxhr = this.__nativeXhr;
      this.readyState = qx.bom.request.Xhr.DONE;
      this.__timeout = true;
      nxhr.aborted = true;
      nxhr.abort();
      this.responseText = "";
      this.responseXML = null;
      this.__readyStateChange();
    },
    __normalizeStatus : function(){

      var isDone = this.readyState === qx.bom.request.Xhr.DONE;
      if(this._getProtocol() === "file:" && this.status === 0 && isDone){

        if(!this.__isNetworkError()){

          this.status = 200;
        };
      };
      if(this.status === 1223){

        this.status = 204;
      };
      if(qx.core.Environment.get("engine.name") === "opera"){

        if(isDone && this.__conditional && !this.__abort && this.status === 0){

          this.status = 304;
        };
      };
    },
    __normalizeResponseXML : function(){

      if(qx.core.Environment.get("engine.name") == "mshtml" && (this.getResponseHeader("Content-Type") || "").match(/[^\/]+\/[^\+]+\+xml/) && this.responseXML && !this.responseXML.documentElement){

        var dom = new window.ActiveXObject("Microsoft.XMLDOM");
        dom.async = false;
        dom.validateOnParse = false;
        dom.loadXML(this.responseText);
        this.responseXML = dom;
      };
    },
    __onUnload : function(){

      try{

        if(this){

          this.dispose();
        };
      } catch(e) {
      };
    },
    __supportsManyRequests : function(){

      var name = qx.core.Environment.get("engine.name");
      var version = qx.core.Environment.get("browser.version");
      return !(name == "mshtml" && version < 9 || name == "gecko" && version < 3.5);
    },
    __checkDisposed : function(){

      if(this.__disposed){

        throw new Error("Already disposed");
      };
    }
  },
  defer : function(){

    qx.core.Environment.add("qx.debug.io", false);
  }
});
qx.Bootstrap.define("qx.event.Emitter", {
  extend : Object,
  statics : {
    __storage : []
  },
  members : {
    __listener : null,
    __any : null,
    on : function(name, listener, ctx){

      var id = qx.event.Emitter.__storage.length;
      this.__getStorage(name).push({
        listener : listener,
        ctx : ctx,
        id : id,
        name : name
      });
      qx.event.Emitter.__storage.push({
        name : name,
        listener : listener,
        ctx : ctx
      });
      return id;
    },
    once : function(name, listener, ctx){

      var id = qx.event.Emitter.__storage.length;
      this.__getStorage(name).push({
        listener : listener,
        ctx : ctx,
        once : true,
        id : id
      });
      qx.event.Emitter.__storage.push({
        name : name,
        listener : listener,
        ctx : ctx
      });
      return id;
    },
    off : function(name, listener, ctx){

      var storage = this.__getStorage(name);
      for(var i = storage.length - 1;i >= 0;i--){

        var entry = storage[i];
        if(entry.listener == listener && entry.ctx == ctx){

          storage.splice(i, 1);
          qx.event.Emitter.__storage[entry.id] = null;
          return entry.id;
        };
      };
      return null;
    },
    offById : function(id){

      var entry = qx.event.Emitter.__storage[id];
      if(entry){

        this.off(entry.name, entry.listener, entry.ctx);
      };
      return null;
    },
    addListener : function(name, listener, ctx){

      return this.on(name, listener, ctx);
    },
    addListenerOnce : function(name, listener, ctx){

      return this.once(name, listener, ctx);
    },
    removeListener : function(name, listener, ctx){

      this.off(name, listener, ctx);
    },
    removeListenerById : function(id){

      this.offById(id);
    },
    emit : function(name, data){

      var storage = this.__getStorage(name).concat();
      var toDelete = [];
      for(var i = 0;i < storage.length;i++){

        var entry = storage[i];
        entry.listener.call(entry.ctx, data);
        if(entry.once){

          toDelete.push(entry);
        };
      };
      toDelete.forEach(function(entry){

        var origStorage = this.__getStorage(name);
        var idx = origStorage.indexOf(entry);
        origStorage.splice(idx, 1);
      }.bind(this));
      storage = this.__getStorage("*");
      for(var i = storage.length - 1;i >= 0;i--){

        var entry = storage[i];
        entry.listener.call(entry.ctx, data);
      };
    },
    getListeners : function(){

      return this.__listener;
    },
    getEntryById : function(id){

      for(var name in this.__listener){

        var store = this.__listener[name];
        for(var i = 0,j = store.length;i < j;i++){

          if(store[i].id === id){

            return store[i];
          };
        };
      };
    },
    __getStorage : function(name){

      if(this.__listener == null){

        this.__listener = {
        };
      };
      if(this.__listener[name] == null){

        this.__listener[name] = [];
      };
      return this.__listener[name];
    }
  }
});
qx.Bootstrap.define("qx.bom.client.Transport", {
  statics : {
    getMaxConcurrentRequestCount : function(){

      var maxConcurrentRequestCount;
      var versionParts = qx.bom.client.Engine.getVersion().split(".");
      var versionMain = 0;
      var versionMajor = 0;
      var versionMinor = 0;
      if(versionParts[0]){

        versionMain = versionParts[0];
      };
      if(versionParts[1]){

        versionMajor = versionParts[1];
      };
      if(versionParts[2]){

        versionMinor = versionParts[2];
      };
      if(window.maxConnectionsPerServer){

        maxConcurrentRequestCount = window.maxConnectionsPerServer;
      } else if(qx.bom.client.Engine.getName() == "opera"){

        maxConcurrentRequestCount = 8;
      } else if(qx.bom.client.Engine.getName() == "webkit"){

        maxConcurrentRequestCount = 4;
      } else if(qx.bom.client.Engine.getName() == "gecko" && ((versionMain > 1) || ((versionMain == 1) && (versionMajor > 9)) || ((versionMain == 1) && (versionMajor == 9) && (versionMinor >= 1)))){

        maxConcurrentRequestCount = 6;
      } else {

        maxConcurrentRequestCount = 2;
      };;;
      return maxConcurrentRequestCount;
    },
    getSsl : function(){

      return window.location.protocol === "https:";
    },
    getXmlHttpRequest : function(){

      var supports = window.ActiveXObject ? (function(){

        if(window.location.protocol !== "file:"){

          try{

            new window.XMLHttpRequest();
            return "xhr";
          } catch(noXhr) {
          };
        };
        try{

          new window.ActiveXObject("Microsoft.XMLHTTP");
          return "activex";
        } catch(noActiveX) {
        };
      })() : (function(){

        try{

          new window.XMLHttpRequest();
          return "xhr";
        } catch(noXhr) {
        };
      })();
      return supports || "";
    }
  },
  defer : function(statics){

    qx.core.Environment.add("io.maxrequests", statics.getMaxConcurrentRequestCount);
    qx.core.Environment.add("io.ssl", statics.getSsl);
    qx.core.Environment.add("io.xhr", statics.getXmlHttpRequest);
  }
});
qx.Bootstrap.define("qx.bom.client.Plugin", {
  statics : {
    getGears : function(){

      return !!(window.google && window.google.gears);
    },
    getActiveX : function(){

      if(typeof window.ActiveXObject === "function"){

        return true;
      };
      try{

        return (typeof (new window.ActiveXObject("Microsoft.XMLHTTP")) === "object" || typeof (new window.ActiveXObject("MSXML2.DOMDocument.6.0")) === "object");
      } catch(ex) {

        return false;
      };
    },
    getSkype : function(){

      if(qx.bom.client.Plugin.getActiveX()){

        try{

          new ActiveXObject("Skype.Detection");
          return true;
        } catch(e) {
        };
      };
      var mimeTypes = navigator.mimeTypes;
      if(mimeTypes){

        if("application/x-skype" in mimeTypes){

          return true;
        };
        for(var i = 0;i < mimeTypes.length;i++){

          var desc = mimeTypes[i];
          if(desc.type.indexOf("skype.click2call") != -1){

            return true;
          };
        };
      };
      return false;
    },
    __db : {
      quicktime : {
        plugin : ["QuickTime"],
        control : "QuickTimeCheckObject.QuickTimeCheck.1"
      },
      wmv : {
        plugin : ["Windows Media"],
        control : "WMPlayer.OCX.7"
      },
      divx : {
        plugin : ["DivX Web Player"],
        control : "npdivx.DivXBrowserPlugin.1"
      },
      silverlight : {
        plugin : ["Silverlight"],
        control : "AgControl.AgControl"
      },
      pdf : {
        plugin : ["Chrome PDF Viewer", "Adobe Acrobat"],
        control : "AcroPDF.PDF"
      }
    },
    getQuicktimeVersion : function(){

      var entry = qx.bom.client.Plugin.__db["quicktime"];
      return qx.bom.client.Plugin.__getVersion(entry.control, entry.plugin);
    },
    getWindowsMediaVersion : function(){

      var entry = qx.bom.client.Plugin.__db["wmv"];
      return qx.bom.client.Plugin.__getVersion(entry.control, entry.plugin, true);
    },
    getDivXVersion : function(){

      var entry = qx.bom.client.Plugin.__db["divx"];
      return qx.bom.client.Plugin.__getVersion(entry.control, entry.plugin);
    },
    getSilverlightVersion : function(){

      var entry = qx.bom.client.Plugin.__db["silverlight"];
      return qx.bom.client.Plugin.__getVersion(entry.control, entry.plugin);
    },
    getPdfVersion : function(){

      var entry = qx.bom.client.Plugin.__db["pdf"];
      return qx.bom.client.Plugin.__getVersion(entry.control, entry.plugin);
    },
    getQuicktime : function(){

      var entry = qx.bom.client.Plugin.__db["quicktime"];
      return qx.bom.client.Plugin.__isAvailable(entry.control, entry.plugin);
    },
    getWindowsMedia : function(){

      var entry = qx.bom.client.Plugin.__db["wmv"];
      return qx.bom.client.Plugin.__isAvailable(entry.control, entry.plugin, true);
    },
    getDivX : function(){

      var entry = qx.bom.client.Plugin.__db["divx"];
      return qx.bom.client.Plugin.__isAvailable(entry.control, entry.plugin);
    },
    getSilverlight : function(){

      var entry = qx.bom.client.Plugin.__db["silverlight"];
      return qx.bom.client.Plugin.__isAvailable(entry.control, entry.plugin);
    },
    getPdf : function(){

      var entry = qx.bom.client.Plugin.__db["pdf"];
      return qx.bom.client.Plugin.__isAvailable(entry.control, entry.plugin);
    },
    __getVersion : function(activeXName, pluginNames, forceActiveX){

      var available = qx.bom.client.Plugin.__isAvailable(activeXName, pluginNames, forceActiveX);
      if(!available){

        return "";
      };
      if(qx.bom.client.Engine.getName() == "mshtml" && (qx.bom.client.Browser.getDocumentMode() < 11 || forceActiveX)){

        try{

          var obj = new ActiveXObject(activeXName);
          var version;
          if(obj.GetVersions && obj.GetVersions()){

            version = obj.GetVersions().split(',');
            if(version.length > 1){

              version = version[0].split('=');
              if(version.length === 2){

                return version[1];
              };
            };
          };
          version = obj.versionInfo;
          if(version != undefined){

            return version;
          };
          version = obj.version;
          if(version != undefined){

            return version;
          };
          version = obj.settings.version;
          if(version != undefined){

            return version;
          };
        } catch(ex) {

          return "";
        };
        return "";
      } else {

        var plugins = navigator.plugins;
        var verreg = /([0-9]\.[0-9])/g;
        for(var i = 0;i < plugins.length;i++){

          var plugin = plugins[i];
          for(var j = 0;j < pluginNames.length;j++){

            if(plugin.name.indexOf(pluginNames[j]) !== -1){

              if(verreg.test(plugin.name) || verreg.test(plugin.description)){

                return RegExp.$1;
              };
            };
          };
        };
        return "";
      };
    },
    __isAvailable : function(activeXName, pluginNames, forceActiveX){

      if(qx.bom.client.Engine.getName() == "mshtml" && (qx.bom.client.Browser.getDocumentMode() < 11 || forceActiveX)){

        if(!this.getActiveX()){

          return false;
        };
        try{

          new ActiveXObject(activeXName);
        } catch(ex) {

          return false;
        };
        return true;
      } else {

        var plugins = navigator.plugins;
        if(!plugins){

          return false;
        };
        var name;
        for(var i = 0;i < plugins.length;i++){

          name = plugins[i].name;
          for(var j = 0;j < pluginNames.length;j++){

            if(name.indexOf(pluginNames[j]) !== -1){

              return true;
            };
          };
        };
        return false;
      };
    }
  },
  defer : function(statics){

    qx.core.Environment.add("plugin.gears", statics.getGears);
    qx.core.Environment.add("plugin.quicktime", statics.getQuicktime);
    qx.core.Environment.add("plugin.quicktime.version", statics.getQuicktimeVersion);
    qx.core.Environment.add("plugin.windowsmedia", statics.getWindowsMedia);
    qx.core.Environment.add("plugin.windowsmedia.version", statics.getWindowsMediaVersion);
    qx.core.Environment.add("plugin.divx", statics.getDivX);
    qx.core.Environment.add("plugin.divx.version", statics.getDivXVersion);
    qx.core.Environment.add("plugin.silverlight", statics.getSilverlight);
    qx.core.Environment.add("plugin.silverlight.version", statics.getSilverlightVersion);
    qx.core.Environment.add("plugin.pdf", statics.getPdf);
    qx.core.Environment.add("plugin.pdf.version", statics.getPdfVersion);
    qx.core.Environment.add("plugin.activex", statics.getActiveX);
    qx.core.Environment.add("plugin.skype", statics.getSkype);
  }
});
qx.Bootstrap.define("qx.xml.Document", {
  statics : {
    DOMDOC : null,
    XMLHTTP : null,
    isXmlDocument : function(elem){

      if(elem.nodeType === 9){

        return elem.documentElement.nodeName !== "HTML";
      } else if(elem.ownerDocument){

        return this.isXmlDocument(elem.ownerDocument);
      } else {

        return false;
      };
    },
    create : function(namespaceUri, qualifiedName){

      if(qx.core.Environment.get("plugin.activex")){

        var obj = new ActiveXObject(this.DOMDOC);
        if(this.DOMDOC == "MSXML2.DOMDocument.3.0"){

          obj.setProperty("SelectionLanguage", "XPath");
        };
        if(qualifiedName){

          var str = '<\?xml version="1.0" encoding="utf-8"?>\n<';
          str += qualifiedName;
          if(namespaceUri){

            str += " xmlns='" + namespaceUri + "'";
          };
          str += " />";
          obj.loadXML(str);
        };
        return obj;
      };
      if(qx.core.Environment.get("xml.implementation")){

        return document.implementation.createDocument(namespaceUri || "", qualifiedName || "", null);
      };
      throw new Error("No XML implementation available!");
    },
    fromString : function(str){

      if(qx.core.Environment.get("plugin.activex")){

        var dom = qx.xml.Document.create();
        dom.loadXML(str);
        return dom;
      };
      if(qx.core.Environment.get("xml.domparser")){

        var parser = new DOMParser();
        return parser.parseFromString(str, "text/xml");
      };
      throw new Error("No XML implementation available!");
    }
  },
  defer : function(statics){

    if(qx.core.Environment.get("plugin.activex")){

      var domDoc = ["MSXML2.DOMDocument.6.0", "MSXML2.DOMDocument.3.0"];
      var httpReq = ["MSXML2.XMLHTTP.6.0", "MSXML2.XMLHTTP.3.0"];
      for(var i = 0,l = domDoc.length;i < l;i++){

        try{

          new ActiveXObject(domDoc[i]);
          new ActiveXObject(httpReq[i]);
        } catch(ex) {

          continue;
        };
        statics.DOMDOC = domDoc[i];
        statics.XMLHTTP = httpReq[i];
        break;
      };
    };
  }
});
qx.Bootstrap.define("qx.bom.client.Xml", {
  statics : {
    getImplementation : function(){

      return document.implementation && document.implementation.hasFeature && document.implementation.hasFeature("XML", "1.0");
    },
    getDomParser : function(){

      return typeof window.DOMParser !== "undefined";
    },
    getSelectSingleNode : function(){

      return typeof qx.xml.Document.create().selectSingleNode !== "undefined";
    },
    getSelectNodes : function(){

      return typeof qx.xml.Document.create().selectNodes !== "undefined";
    },
    getElementsByTagNameNS : function(){

      return typeof qx.xml.Document.create().getElementsByTagNameNS !== "undefined";
    },
    getDomProperties : function(){

      var doc = qx.xml.Document.create();
      return ("getProperty" in doc && typeof doc.getProperty("SelectionLanguage") === "string");
    },
    getAttributeNS : function(){

      var docElem = qx.xml.Document.fromString("<a></a>").documentElement;
      return typeof docElem.getAttributeNS === "function" && typeof docElem.setAttributeNS === "function";
    },
    getCreateElementNS : function(){

      return typeof qx.xml.Document.create().createElementNS === "function";
    },
    getCreateNode : function(){

      return typeof qx.xml.Document.create().createNode !== "undefined";
    },
    getQualifiedItem : function(){

      var docElem = qx.xml.Document.fromString("<a></a>").documentElement;
      return typeof docElem.attributes.getQualifiedItem !== "undefined";
    }
  },
  defer : function(statics){

    qx.core.Environment.add("xml.implementation", statics.getImplementation);
    qx.core.Environment.add("xml.domparser", statics.getDomParser);
    qx.core.Environment.add("xml.selectsinglenode", statics.getSelectSingleNode);
    qx.core.Environment.add("xml.selectnodes", statics.getSelectNodes);
    qx.core.Environment.add("xml.getelementsbytagnamens", statics.getElementsByTagNameNS);
    qx.core.Environment.add("xml.domproperties", statics.getDomProperties);
    qx.core.Environment.add("xml.attributens", statics.getAttributeNS);
    qx.core.Environment.add("xml.createelementns", statics.getCreateElementNS);
    qx.core.Environment.add("xml.createnode", statics.getCreateNode);
    qx.core.Environment.add("xml.getqualifieditem", statics.getQualifiedItem);
  }
});
qx.Bootstrap.define("qx.util.ResponseParser", {
  construct : function(parser){

    if(parser !== undefined){

      this.setParser(parser);
    };
  },
  statics : {
    PARSER : {
      json : qx.lang.Json.parse,
      xml : qx.xml.Document.fromString
    }
  },
  members : {
    __parser : null,
    parse : function(response, contentType){

      var parser = this._getParser(contentType);
      if(typeof parser === "function"){

        if(response !== ""){

          return parser.call(this, response);
        };
      };
      return response;
    },
    setParser : function(parser){

      if(typeof qx.util.ResponseParser.PARSER[parser] === "function"){

        return this.__parser = qx.util.ResponseParser.PARSER[parser];
      };
      if(qx.core.Environment.get("qx.debug")){

        qx.core.Assert.assertFunction(parser);
      };
      return this.__parser = parser;
    },
    _getParser : function(contentType){

      var parser = this.__parser,contentTypeOrig = "",contentTypeNormalized = "";
      if(parser){

        return parser;
      };
      contentTypeOrig = contentType || "";
      contentTypeNormalized = contentTypeOrig.replace(/;.*$/, "");
      if((/^application\/(\w|\.)*\+?json$/).test(contentTypeNormalized)){

        parser = qx.util.ResponseParser.PARSER.json;
      };
      if((/^application\/xml$/).test(contentTypeNormalized)){

        parser = qx.util.ResponseParser.PARSER.xml;
      };
      if((/[^\/]+\/[^\+]+\+xml$/).test(contentTypeOrig)){

        parser = qx.util.ResponseParser.PARSER.xml;
      };
      return parser;
    }
  }
});
qx.Class.define("xlsys.base.io.util.IOUtil", {
  type : "static",
  statics : {
    __rRegExp : new RegExp("\r", "g"),
    __nRegExp : new RegExp("\n", "g"),
    __escapeRRegExp : new RegExp("&#13;", "g"),
    __escapeNRegExp : new RegExp("&#10;", "g"),
    getJSONStr : function(obj){

      var hasWriteObjMap = new xlsys.java.util.LinkedHashMap();
      this.prepareJSONStr(obj, hasWriteObjMap);
      var sb = new xlsys.java.lang.StringBuilder();
      sb.append("[");
      var keyArray = hasWriteObjMap.keys();
      for(var i = 0;i < keyArray.length;++i){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_HASHCODE, keyArray[i]));
        sb.append(",").append(this.getDQMStr(xlsys.base.XLSYS.JSON_OBJ_CONTENT)).append(":").append(hasWriteObjMap.get(keyArray[i]));
        sb.append("}");
        if(i != keyArray.length - 1)sb.append(",");
      };
      sb.append("]");
      return sb.toString();
    },
    getDQMStr : function(str){

      return "\"" + str + "\"";
    },
    createJSONAttr : function(attrName, attrValue){

      var sb = new xlsys.java.lang.StringBuilder();
      sb.append("\"").append(attrName).append("\":");
      if(attrValue == null)sb.append("null"); else if((typeof attrValue) == "string")sb.append("\"").append(attrValue).append("\""); else sb.append(attrValue);;
      return sb.toString();
    },
    prepareJSONStr : function(obj, hasWriteObjMap, dataType){

      if(hasWriteObjMap.containsKey(xlsys.base.util.ObjectUtil.hashcode(obj)))return;
      hasWriteObjMap.put(xlsys.base.util.ObjectUtil.hashcode(obj), "");
      var sb = new xlsys.java.lang.StringBuilder();
      sb.append("{");
      if(obj == undefined || obj == null)dataType = xlsys.base.XLSYS.DATA_TYPE_NULL;
      if(dataType == null){

        if(qx.lang.Type.isString(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_STR; else if(qx.lang.Type.isArray(obj)){

          dataType = xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY;
          var typeofSet = new xlsys.java.util.HashSet();
          for(var i = 0;i < obj.length;++i){

            typeofSet.add(xlsys.base.util.ObjectUtil.className(obj[i]));
          };
          if(typeofSet.size() == 1){

            var typeNames = typeofSet.toArray();
            if(typeNames[0] == "java.math.BigDecimal")dataType = xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY; else if(typeNames[0] == "java.lang.String")dataType = xlsys.base.XLSYS.DATA_TYPE_STR_ARRAY; else if(typeNames[0] == "java.util.AbstractMap.SimpleEntry")dataType = xlsys.base.XLSYS.DATA_TYPE_ENTRY_ARRAY; else dataType = xlsys.base.XLSYS.DATA_TYPE_OBJECT_ARRAY;;;
          } else dataType = xlsys.base.XLSYS.DATA_TYPE_OBJECT_ARRAY;
        } else if(qx.lang.Type.isNumber(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL; else if(qx.lang.Type.isBoolean(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_BOOL; else if(qx.lang.Type.isDate(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_DATE; else if(qx.Interface.objectImplements(obj, xlsys.java.util.Entry))dataType = xlsys.base.XLSYS.DATA_TYPE_ENTRY; else if(qx.Interface.objectImplements(obj, xlsys.java.util.Collection))dataType = xlsys.base.XLSYS.DATA_TYPE_COLLECTION; else if(qx.Interface.objectImplements(obj, xlsys.java.util.Map))dataType = xlsys.base.XLSYS.DATA_TYPE_MAP; else if(obj instanceof xlsys.java.io.Serializable)dataType = xlsys.base.XLSYS.DATA_TYPE_OBJECT; else throw new xlsys.java.lang.Exception("Unsupported Transfer Object!");;;;;;;;;
      };
      if(dataType == xlsys.base.XLSYS.DATA_TYPE_NULL){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_NULL));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_STR){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_STR));
        sb.append(",");
        if(obj.indexOf("\n") >= 0 || obj.indexOf("\r") >= 0){

          var temp = obj.replace(this.__nRegExp, "&#10;").replace(this.__rRegExp, "&#13;");
          sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, temp));
        } else sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, obj));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_SHORT){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_SHORT));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, "" + parseInt(obj) & 0x0000ffff));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_INT){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_INT));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, "" + parseInt(obj)));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_LONG){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_LONG));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, "" + parseInt(obj)));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_CHAR){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_CHAR));
        sb.append(",");
        if(qx.lang.Type.isString(obj))obj = obj.charCodeAt(0);
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, "" + parseInt(obj) & 0x000000ff));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_FLOAT){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_FLOAT));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, obj.toString()));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_DOUBLE){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_DOUBLE));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, obj.toString()));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BYTE){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_BYTE));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, "" + parseInt(obj) & 0x000000ff));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY || dataType == xlsys.base.XLSYS.DATA_TYPE_STR_ARRAY || dataType == xlsys.base.XLSYS.DATA_TYPE_ENTRY_ARRAY || dataType == xlsys.base.XLSYS.DATA_TYPE_OBJECT_ARRAY){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, dataType));
        sb.append(",");
        sb.append(this.getDQMStr(xlsys.base.XLSYS.JSON_OBJ_CONTENT)).append(":[");
        if(dataType == xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY){

          for(var i = 0;i < obj.length;++i){

            sb.append(obj[i]);
            if(i != (obj.length - 1))sb.append(",");
          };
        } else {

          for(var i = 0;i < obj.length;++i){

            sb.append(xlsys.base.util.ObjectUtil.hashcode(obj[i]));
            if(i != (obj.length - 1))sb.append(",");
            this.prepareJSONStr(obj[i], hasWriteObjMap);
          };
        };
        sb.append("]");
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, obj.toString()));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BOOL){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_BOOL));
        sb.append(",");
        sb.append(this.getDQMStr(xlsys.base.XLSYS.JSON_OBJ_CONTENT)).append(":").append(obj.toString());
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_DATE){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_DATE));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CONTENT, obj.getTime()));
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_ENTRY){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_ENTRY));
        sb.append(",");
        sb.append(this.getDQMStr(xlsys.base.XLSYS.JSON_OBJ_CONTENT)).append(":[");
        var key = obj.getKey();
        sb.append(xlsys.base.util.ObjectUtil.hashcode(key));
        this.prepareJSONStr(key, hasWriteObjMap);
        sb.append(",");
        var value = obj.getValue();
        sb.append(xlsys.base.util.ObjectUtil.hashcode(value));
        this.prepareJSONStr(value, hasWriteObjMap);
        sb.append("]");
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_COLLECTION){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_COLLECTION));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CLASS, xlsys.base.util.ObjectUtil.className(obj)));
        sb.append(",");
        sb.append(this.getDQMStr(xlsys.base.XLSYS.JSON_OBJ_CONTENT)).append(":[");
        var objArr = obj.toArray();
        for(var i = 0;i < objArr.length;++i){

          sb.append(xlsys.base.util.ObjectUtil.hashcode(objArr[i]));
          if(i != (objArr.length - 1))sb.append(",");
          this.prepareJSONStr(objArr[i], hasWriteObjMap);
        };
        sb.append("]");
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_MAP){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_MAP));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CLASS, xlsys.base.util.ObjectUtil.className(obj)));
        sb.append(",");
        sb.append(this.getDQMStr(xlsys.base.XLSYS.JSON_OBJ_CONTENT)).append(":[");
        var keyArr = obj.keys();
        for(var i = 0;i < keyArr.length;++i){

          sb.append(xlsys.base.util.ObjectUtil.hashcode(keyArr[i])).append(",");
          this.prepareJSONStr(keyArr[i], hasWriteObjMap);
          var value = obj.get(keyArr[i]);
          sb.append(xlsys.base.util.ObjectUtil.hashcode(value));
          if(i != (keyArr.length - 1))sb.append(",");
          this.prepareJSONStr(value, hasWriteObjMap);
        };
        sb.append("]");
      } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_OBJECT){

        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_OBJECT));
        sb.append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CLASS, xlsys.base.util.ObjectUtil.className(obj)));
        sb.append(",");
        sb.append(this.getDQMStr(xlsys.base.XLSYS.JSON_OBJ_CONTENT)).append(":{");
        var isFirstField = true;
        var needMembers = obj.getSerializableMembers();
        for(var x in needMembers){

          var fieldName = needMembers[x];
          var fieldObj = obj[fieldName];
          if(isFirstField)isFirstField = false; else sb.append(",");
          sb.append(this.createJSONAttr(fieldName, xlsys.base.util.ObjectUtil.hashcode(fieldObj)));
          var fieldDataType = obj.getMemberDataType(fieldName);
          this.prepareJSONStr(fieldObj, hasWriteObjMap, fieldDataType);
        };
        sb.append("}");
      } else throw new xlsys.java.lang.Exception("Unsupported Transfer Object!");;;;;;;;;;;;;;;;;
      sb.append("}");
      hasWriteObjMap.put(xlsys.base.util.ObjectUtil.hashcode(obj), sb.toString());
    },
    getObjFromJSON : function(jsonStr){

      var allJson = JSON.parse(jsonStr);
      return this.getObjFromJSONObj(allJson);
    },
    getObjFromJSONObj : function(allJson){

      var obj = null;
      var firstHashcode = 0;
      var hasWriteObjMap = new xlsys.java.util.HashMap();
      for(var i = 0;i < allJson.length;++i){

        var jsonObj = allJson[i];
        var hashcode = jsonObj[xlsys.base.XLSYS.JSON_OBJ_HASHCODE];
        if(firstHashcode == 0)firstHashcode = hashcode;
        var content = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        hasWriteObjMap.put(hashcode, content);
      };
      var rebuiltObjMap = new xlsys.java.util.HashMap();
      obj = this.rebuildJSONObject(firstHashcode, hasWriteObjMap, rebuiltObjMap);
      return obj;
    },
    rebuildJSONObject : function(hashcode, hasWriteObjMap, rebuiltObjMap){

      var obj = null;
      if(rebuiltObjMap.containsKey(hashcode))obj = rebuiltObjMap.get(hashcode); else {

        var jsonObj = hasWriteObjMap.get(hashcode);
        var type = jsonObj[xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE];
        if(type == xlsys.base.XLSYS.DATA_TYPE_NULL){
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_STR){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          obj = obj.replace(this.__escapeNRegExp, "\n").replace(this.__escapeRRegExp, "\r");
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_STR_ARRAY){

          var jsonArray = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          var strArr = new Array();
          for(var i = 0;i < jsonArray.length;++i){

            var tempHashCode = jsonArray[i];
            strArr.push(this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap));
          };
          obj = strArr;
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_SHORT){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_INT){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_LONG){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_CHAR){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BOOL){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_FLOAT){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_DOUBLE){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BYTE){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY){

          obj = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL){

          obj = Number(jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT]);
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_DATE){

          var time = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          obj = new Date();
          obj.setTime(time);
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_ENTRY){

          var jsonArr = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          var tempHashCode = jsonArr[0];
          var key = this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap);
          tempHashCode = jsonArr[1];
          var value = this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap);
          obj = new xlsys.java.util.SimpleEntry(key, value);
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_ENTRY_ARRAY){

          var jsonArr = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          var entrys = new Array();
          for(var i = 0;i < jsonArr.length;++i){

            var tempHashCode = jsonArr[i];
            entrys.push(this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap));
          };
          obj = entrys;
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_OBJECT_ARRAY){

          var jsonArr = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          var objArr = new Array();
          for(var i = 0;i < jsonArr.length;++i){

            var tempHashCode = jsonArr[i];
            objArr.push(this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap));
          };
          obj = objArr;
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_COLLECTION){

          var objClassName = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CLASS];
          obj = xlsys.base.util.ObjectUtil.tryInitObj(objClassName);
          if(obj == null)throw new xlsys.java.lang.Exception("Unsupported Class : " + objClassName);
          rebuiltObjMap.put(hashcode, obj);
          var collection = obj;
          var jsonArr = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          for(var i = 0;i < jsonArr.length;++i){

            var tempHashCode = jsonArr[i];
            collection.add(this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap));
          };
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_MAP){

          var objClassName = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CLASS];
          obj = xlsys.base.util.ObjectUtil.tryInitObj(objClassName);
          if(obj == null)throw "Unsupported Class : " + objClassName;
          rebuiltObjMap.put(hashcode, obj);
          var map = obj;
          var jsonArr = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          for(var i = 0;i < jsonArr.length;i += 2){

            var tempHashCode = jsonArr[i];
            var key = this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap);
            tempHashCode = jsonArr[i + 1];
            var value = this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap);
            map.put(key, value);
          };
        } else {

          var objClassName = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CLASS];
          obj = xlsys.base.util.ObjectUtil.tryInitObj(objClassName);
          if(obj == null)throw "Unsupported Class : " + objClassName;
          rebuiltObjMap.put(hashcode, obj);
          var allField = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CONTENT];
          for(var fieldName in allField){

            var tempHashCode = allField[fieldName];
            var fieldObj = this.rebuildJSONObject(tempHashCode, hasWriteObjMap, rebuiltObjMap);
            obj[fieldName] = fieldObj;
          };
        };;;;;;;;;;;;;;;;;;
        rebuiltObjMap.put(hashcode, obj);
      };
      return obj;
    },
    readInternalObject : function(bytes){

      if(bytes == null || bytes.length == 0)return null;
      var dis = new xlsys.base.io.util.ByteDataInputStream(bytes);
      var firstHashcode = 0;
      var hasWriteObjMap = new xlsys.java.util.HashMap();
      var totalLength = dis.readInt();
      var totalContent = new Array(totalLength);
      dis.readFully(totalContent, 0, totalLength);
      var tempDis = new xlsys.base.io.util.ByteDataInputStream(totalContent);
      while(tempDis.available() > 0){

        var hashcode = tempDis.readInt();
        if(firstHashcode == 0)firstHashcode = hashcode;
        var length = tempDis.readInt();
        var content = new Array(length);
        tempDis.readFully(content, 0, length);
        hasWriteObjMap.put(hashcode, content);
      };
      var rebuiltObjMap = new xlsys.java.util.HashMap();
      return this.rebuildInternalObject(firstHashcode, hasWriteObjMap, rebuiltObjMap);
    },
    rebuildInternalObject : function(hashcode, hasWriteObjMap, rebuiltObjMap){

      var obj = null;
      if(rebuiltObjMap.containsKey(hashcode))obj = rebuiltObjMap.get(hashcode); else {

        var content = hasWriteObjMap.get(hashcode);
        var dis = new xlsys.base.io.util.ByteDataInputStream(content);
        var type = dis.readByte();
        if(type == xlsys.base.XLSYS.DATA_TYPE_NULL){
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_STR){

          var length = dis.readInt();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          obj = xlsys.base.util.StringUtil.bytesToString(bytes);
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_STR_ARRAY){

          var length = dis.readInt();
          obj = new Array();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          while(tempIn.available() > 0){

            var tempHashcode = tempIn.readInt();
            obj.push(this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap));
          };
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_SHORT){

          obj = dis.readShort();
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_INT){

          obj = dis.readInt();
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_LONG){

          obj = dis.readLong();
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_CHAR){

          obj = dis.readChar();
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BOOL){

          obj = dis.readByte() == 1 ? true : false;
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_FLOAT){

          throw new Error("Unsupported!");
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_DOUBLE){

          throw new Error("Unsupported!");
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BYTE){

          obj = dis.readByte();
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY){

          var length = dis.readInt();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          obj = bytes;
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL){

          var numHashcode = dis.readInt();
          var numStr = this.rebuildInternalObject(numHashcode, hasWriteObjMap, rebuiltObjMap);
          obj = Number(numStr);
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_DATE){

          var time = dis.readLong();
          obj = new Date(time);
          obj.setTime(time);
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_ENTRY){

          var length = dis.readInt();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          var tempHashcode = tempIn.readInt();
          var key = this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap);
          tempHashcode = tempIn.readInt();
          var value = this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap);
          obj = new xlsys.java.util.SimpleEntry(key, value);
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_ENTRY_ARRAY){

          var length = dis.readInt();
          var obj = new Array();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          while(tempIn.available() > 0){

            var tempHashcode = tempIn.readInt();
            obj.push(this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap));
          };
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_OBJECT_ARRAY){

          var length = dis.readInt();
          var obj = new Array();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          while(tempIn.available() > 0){

            var tempHashcode = tempIn.readInt();
            obj.push(this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap));
          };
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_COLLECTION){

          var nameHashcode = dis.readInt();
          var objClassName = this.rebuildInternalObject(nameHashcode, hasWriteObjMap, rebuiltObjMap);
          obj = xlsys.base.util.ObjectUtil.tryInitObj(objClassName);
          if(obj == null)throw new Error("Unsupported");
          rebuiltObjMap.put(hashcode, obj);
          var length = dis.readInt();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          while(tempIn.available() > 0){

            var tempHashcode = tempIn.readInt();
            obj.add(this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap));
          };
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_MAP){

          var nameHashcode = dis.readInt();
          var objClassName = this.rebuildInternalObject(nameHashcode, hasWriteObjMap, rebuiltObjMap);
          obj = xlsys.base.util.ObjectUtil.tryInitObj(objClassName);
          if(obj == null)throw new Error("Unsupported");
          rebuiltObjMap.put(hashcode, obj);
          var length = dis.readInt();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          while(tempIn.available() > 0){

            var tempHashcode = tempIn.readInt();
            var key = this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap);
            tempHashcode = tempIn.readInt();
            var value = this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap);
            obj.put(key, value);
          };
        } else if(type == xlsys.base.XLSYS.DATA_TYPE_EXCEPTION){

          var nameHashcode = dis.readInt();
          var objClassName = this.rebuildInternalObject(nameHashcode, hasWriteObjMap, rebuiltObjMap);
          obj = xlsys.base.util.ObjectUtil.tryInitObj(objClassName);
          if(obj == null)throw new Error("Unsupported");
          var length = dis.readInt();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          var fieldNameHashcode = tempIn.readInt();
          this.rebuildInternalObject(fieldNameHashcode, hasWriteObjMap, rebuiltObjMap);
          var msgHashcode = tempIn.readInt();
          var message = this.rebuildInternalObject(msgHashcode, hasWriteObjMap, rebuiltObjMap);
          fieldNameHashcode = tempIn.readInt();
          this.rebuildInternalObject(fieldNameHashcode, hasWriteObjMap, rebuiltObjMap);
          var stackTraceHashcode = tempIn.readInt();
          var stackTrace = this.rebuildInternalObject(stackTraceHashcode, hasWriteObjMap, rebuiltObjMap);
          fieldNameHashcode = tempIn.readInt();
          this.rebuildInternalObject(fieldNameHashcode, hasWriteObjMap, rebuiltObjMap);
          var causeHashcode = tempIn.readInt();
          var cause = this.rebuildInternalObject(causeHashcode, hasWriteObjMap, rebuiltObjMap);
          obj.msg = message;
          obj.stackTrace = stackTrace;
          obj.cause = cause;
          rebuiltObjMap.put(hashcode, obj);
        } else {

          var nameHashcode = dis.readInt();
          var objClassName = this.rebuildInternalObject(nameHashcode, hasWriteObjMap, rebuiltObjMap);
          obj = xlsys.base.util.ObjectUtil.tryInitObj(objClassName);
          if(obj == null)throw new Error("Unsupported");
          rebuiltObjMap.put(hashcode, obj);
          var length = dis.readInt();
          var bytes = new Array(length);
          dis.readFully(bytes, 0, length);
          var tempIn = new xlsys.base.io.util.ByteDataInputStream(bytes);
          while(tempIn.available() > 0){

            var fieldNameHashcode = tempIn.readInt();
            var fieldName = this.rebuildInternalObject(fieldNameHashcode, hasWriteObjMap, rebuiltObjMap);
            var tempHashcode = tempIn.readInt();
            var fieldObj = this.rebuildInternalObject(tempHashcode, hasWriteObjMap, rebuiltObjMap);
            obj[fieldName] = fieldObj;
          };
        };;;;;;;;;;;;;;;;;;;
        rebuiltObjMap.put(hashcode, obj);
      };
      return obj;
    },
    getInternalObjectBytes : function(obj){

      var hasWriteObjMap = new xlsys.java.util.LinkedHashMap();
      this.prepareInternalBytes(obj, hasWriteObjMap);
      var baos = new xlsys.base.io.util.ByteDataOutputStream();
      var keys = hasWriteObjMap.keys();
      for(var i = 0;i < keys.length;++i){

        var hashcode = keys[i];
        baos.writeInt(hashcode);
        var content = hasWriteObjMap.get(hashcode);
        baos.writeInt(content.length);
        baos.write(content);
      };
      var out = new xlsys.base.io.util.ByteDataOutputStream();
      var temp = baos.toByteArray();
      out.writeInt(temp.length);
      out.write(temp);
      return out.toByteArray();
    },
    prepareInternalBytes : function(obj, hasWriteObjMap, dataType){

      if(hasWriteObjMap.containsKey(xlsys.base.util.ObjectUtil.hashcode(obj)))return;
      hasWriteObjMap.put(xlsys.base.util.ObjectUtil.hashcode(obj), null);
      var data = null;
      var out = new xlsys.base.io.util.ByteDataOutputStream();
      if(obj == null){

        out.writeByte(xlsys.base.XLSYS.DATA_TYPE_NULL);
      } else {

        if(dataType == null){

          if(qx.lang.Type.isString(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_STR; else if(qx.lang.Type.isArray(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_OBJECT_ARRAY; else if(qx.lang.Type.isNumber(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL; else if(qx.lang.Type.isBoolean(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_BOOL; else if(qx.lang.Type.isDate(obj))dataType = xlsys.base.XLSYS.DATA_TYPE_DATE; else if(qx.Class.implementsInterface(obj, xlsys.java.util.Entry))dataType = xlsys.base.XLSYS.DATA_TYPE_ENTRY; else if(qx.Class.implementsInterface(obj, xlsys.java.util.Collection))dataType = xlsys.base.XLSYS.DATA_TYPE_COLLECTION; else if(qx.Class.implementsInterface(obj, xlsys.java.util.Map))dataType = xlsys.base.XLSYS.DATA_TYPE_MAP; else if(obj instanceof xlsys.java.lang.Exception)dataType = xlsys.base.XLSYS.DATA_TYPE_EXCEPTION; else dataType = xlsys.base.XLSYS.DATA_TYPE_OBJECT;;;;;;;;;
        };
        if(dataType == xlsys.base.XLSYS.DATA_TYPE_STR){

          var bytes = xlsys.base.util.StringUtil.stringToBytes(obj);
          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_STR);
          out.writeInt(bytes.length);
          out.write(bytes);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_SHORT){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_SHORT);
          out.writeShort(obj);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_INT){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_INT);
          out.writeInt(obj);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_LONG){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_LONG);
          out.writeLong(obj);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_CHAR){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_CHAR);
          out.writeChar(obj);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BOOL){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_BOOL);
          out.writeByte(obj ? 1 : 0);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BYTE){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_BYTE);
          out.writeByte(obj);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY);
          out.writeInt(obj.length);
          out.write(obj);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_BIGDECIMAL);
          var numStr = "" + obj;
          out.writeInt(xlsys.base.util.ObjectUtil.hashcode(numStr));
          this.prepareInternalBytes(numStr, hasWriteObjMap);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_DATE){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_DATE);
          out.writeLong(obj.getTime());
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_ENTRY){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_ENTRY);
          var tempOut = new xlsys.base.io.util.ByteDataOutputStream();
          var key = obj.getKey();
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(key));
          this.prepareInternalBytes(key, hasWriteObjMap);
          var value = obj.getValue();
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(value));
          this.prepareInternalBytes(value, hasWriteObjMap);
          var arrBytes = tempOut.toByteArray();
          out.writeInt(arrBytes.length);
          out.write(arrBytes);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_ENTRY_ARRAY || dataType == xlsys.base.XLSYS.DATA_TYPE_OBJECT_ARRAY || dataType == xlsys.base.XLSYS.DATA_TYPE_STR_ARRAY){

          out.writeByte(dataType);
          var tempOut = new xlsys.base.io.util.ByteDataOutputStream();
          for(var i = 0;i < obj.length;++i){

            var temp = obj[i];
            tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(temp));
            this.prepareInternalBytes(temp, hasWriteObjMap);
          };
          var arrBytes = tempOut.toByteArray();
          out.writeInt(arrBytes.length);
          out.write(arrBytes);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_COLLECTION){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_COLLECTION);
          var name = xlsys.base.util.ObjectUtil.className(obj);
          out.writeInt(xlsys.base.util.ObjectUtil.hashcode(name));
          this.prepareInternalBytes(name, hasWriteObjMap);
          var tempOut = new xlsys.base.io.util.ByteDataOutputStream();
          var collectionArr = obj.toArray();
          for(var i = 0;i < collectionArr.length;++i){

            var temp = collectionArr[i];
            tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(temp));
            this.prepareInternalBytes(temp, hasWriteObjMap);
          };
          var arrBytes = tempOut.toByteArray();
          out.writeInt(arrBytes.length);
          out.write(arrBytes);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_MAP){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_MAP);
          var name = xlsys.base.util.ObjectUtil.className(obj);
          out.writeInt(xlsys.base.util.ObjectUtil.hashcode(name));
          this.prepareInternalBytes(name, hasWriteObjMap);
          var tempOut = new xlsys.base.io.util.ByteDataOutputStream();
          var keys = obj.keys();
          for(var i = 0;i < keys.length;++i){

            var key = keys[i];
            var value = obj.get(key);
            tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(key));
            this.prepareInternalBytes(key, hasWriteObjMap);
            tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(value));
            this.prepareInternalBytes(value, hasWriteObjMap);
          };
          var arrBytes = tempOut.toByteArray();
          out.writeInt(arrBytes.length);
          out.write(arrBytes);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_EXCEPTION){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_EXCEPTION);
          var name = xlsys.base.util.ObjectUtil.className(obj);
          out.writeInt(xlsys.base.util.ObjectUtil.hashcode(name));
          this.prepareInternalBytes(name, hasWriteObjMap);
          var tempOut = new xlsys.base.io.util.ByteDataOutputStream();
          var fieldName = "msg";
          var message = obj.getMessage();
          if(message == null)message = "";
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(fieldName));
          this.prepareInternalBytes(fieldName, hasWriteObjMap);
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(message));
          this.prepareInternalBytes(message, hasWriteObjMap);
          fieldName = "stackTrace";
          var stackTrace = obj.getStackTrace();
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(fieldName));
          this.prepareInternalBytes(fieldName, hasWriteObjMap);
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(stackTrace));
          this.prepareInternalBytes(stackTrace, hasWriteObjMap, xlsys.base.XLSYS.DATA_TYPE_STR_ARRAY);
          fieldName = "cause";
          var cause = obj.getCause();
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(fieldName));
          this.prepareInternalBytes(fieldName, hasWriteObjMap);
          tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(cause));
          this.prepareInternalBytes(cause, hasWriteObjMap);
          var fieldsData = tempOut.toByteArray();
          out.writeInt(fieldsData.length);
          out.write(fieldsData);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_OBJECT){

          out.writeByte(xlsys.base.XLSYS.DATA_TYPE_OBJECT);
          var name = xlsys.base.util.ObjectUtil.className(obj);
          out.writeInt(xlsys.base.util.ObjectUtil.hashcode(name));
          this.prepareInternalBytes(name, hasWriteObjMap);
          var tempOut = new xlsys.base.io.util.ByteDataOutputStream();
          var fields = obj.getSerializableMembers();
          for(var i = 0;i < fields.length;++i){

            var fieldName = fields[i];
            tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(fieldName));
            this.prepareInternalBytes(fieldName, hasWriteObjMap);
            var fieldObj = obj[fieldName];
            tempOut.writeInt(xlsys.base.util.ObjectUtil.hashcode(fieldObj));
            var fieldDataType = obj.getMemberDataType(fieldName);
            this.prepareInternalBytes(fieldObj, hasWriteObjMap, fieldDataType);
          };
          var fieldsData = tempOut.toByteArray();
          out.writeInt(fieldsData.length);
          out.write(fieldsData);
        };;;;;;;;;;;;;;;
      };
      data = out.toByteArray();
      hasWriteObjMap.put(xlsys.base.util.ObjectUtil.hashcode(obj), data);
    },
    bytesToHexStr : function(bytes){

      var sb = new xlsys.java.lang.StringBuilder();
      for(var i = 0;i < bytes.length;++i){

        var temp = bytes[i].toString(16);
        if(temp.length < 2)temp = "0" + temp;
        sb.append(temp);
      };
      return sb.toString();
    },
    hexStrToBytes : function(hexStr){

      var bytes = new Array();
      for(var i = 0;i < hexStr.length;i += 2){

        bytes.push(parseInt(hexStr.substring(i, i + 2), 16));
      };
      return bytes;
    },
    getCommonJSONFromObj : function(seriObj, dataType){

      var sb = new xlsys.java.lang.StringBuilder();
      if(seriObj == null)sb.append("null"); else if(qx.lang.Type.isArray(seriObj)){

        if((dataType != null && dataType == xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY) || (seriObj.length > 0 && qx.lang.Type.isNumber(seriObj[0]) && qx.lang.Type.isNumber(seriObj[seriObj.length - 1]))){

          sb.append("{");
          sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY)).append(",");
          sb.append(this.createJSONAttr("value", this.bytesToHexStr(seriObj)));
          sb.append("}");
        } else {

          sb.append("[");
          for(var i = 0;i < seriObj.length;++i){

            sb.append(this.getCommonJSONFromObj(seriObj[i]));
            if(i != seriObj.length - 1)sb.append(",");
          };
          sb.append("]");
        };
      } else if(qx.lang.Type.isBoolean(seriObj))sb.append(seriObj); else if(qx.lang.Type.isDate(seriObj)){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_DATE)).append(",");
        sb.append(this.createJSONAttr("value", seriObj.getTime()));
        sb.append("}");
      } else if(qx.lang.Type.isError(seriObj) || seriObj instanceof xlsys.java.lang.Exception){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_EXCEPTION)).append(",");
        if(qx.lang.Type.isError(seriObj))sb.append(this.createJSONAttr("value", seriObj.message)); else sb.append(this.createJSONAttr("value", seriObj.getMessage()));
        sb.append("}");
      } else if(qx.lang.Type.isNumber(seriObj))sb.append(seriObj); else if(qx.lang.Type.isString(seriObj)){

        if(seriObj.indexOf("\n") >= 0 || seriObj.indexOf("\r") >= 0){

          var temp = seriObj.replace(this.__nRegExp, "&#10;").replace(this.__rRegExp, "&#13;");
          sb.append("\"").append(temp).append("\"");
        } else sb.append("\"").append(seriObj).append("\"");
      } else if(qx.Class.implementsInterface(seriObj, xlsys.java.util.Collection)){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_COLLECTION)).append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CLASS, xlsys.base.util.ObjectUtil.className(seriObj))).append(",");
        sb.append("\"value\":").append("[");
        var tempArr = seriObj.toArray();
        for(var i = 0;i < tempArr.length;++i){

          sb.append(this.getCommonJSONFromObj(tempArr[i]));
          if(i != tempArr.length - 1)sb.append(",");
        };
        sb.append("]");
        sb.append("}");
      } else if(qx.Class.implementsInterface(seriObj, xlsys.java.util.Entry)){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_ENTRY)).append(",");
        sb.append("\"key\":").append(this.getCommonJSONFromObj(seriObj.getKey()));
        sb.append("\"value\":").append(this.getCommonJSONFromObj(seriObj.getValue()));
        sb.append("}");
      } else if(qx.Class.implementsInterface(seriObj, xlsys.java.util.Map)){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_MAP)).append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CLASS, xlsys.base.util.ObjectUtil.className(seriObj))).append(",");
        sb.append("\"value\":").append("[");
        var keyArr = seriObj.keys();
        for(var i = 0;i < keyArr.length;++i){

          sb.append(this.getCommonJSONFromObj(keyArr[i])).append(",");
          sb.append(this.getCommonJSONFromObj(seriObj.get(keyArr[i])));
          if(i != keyArr.length - 1)sb.append(",");
        };
        sb.append("]");
        sb.append("}");
      } else if(seriObj instanceof xlsys.base.dataset.DataSetRow){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_DATA_SET_ROW)).append(",");
        sb.append("\"value\":").append("[");
        var cellArr = seriObj.getCells().toArray();
        for(var i = 0;i < cellArr.length;++i){

          sb.append(this.getCommonJSONFromObj(cellArr[i].getContent()));
          if(i != cellArr.length - 1)sb.append(",");
        };
        sb.append("]");
        sb.append("}");
      } else if(seriObj instanceof xlsys.java.io.Serializable){

        sb.append("{");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE, xlsys.base.XLSYS.DATA_TYPE_OBJECT)).append(",");
        sb.append(this.createJSONAttr(xlsys.base.XLSYS.JSON_OBJ_CLASS, xlsys.base.util.ObjectUtil.className(seriObj))).append(",");
        var fields = seriObj.getSerializableMembers();
        for(var i = 0;i < fields.length;++i){

          var fieldName = fields[i];
          var fieldDataType = seriObj.getMemberDataType(fieldName);
          sb.append("\"").append(fieldName).append("\"").append(":").append(this.getCommonJSONFromObj(seriObj[fieldName], fieldDataType));
          if(i != fields.length - 1)sb.append(",");
        };
        sb.append("}");
      };;;;;;;;;;;
      return sb.toString();
    },
    getObjFromCommonJSON : function(jsonStr){

      var allJson = JSON.parse(jsonStr);
      return this._rebuildObjFromCommonJSON(allJson);
    },
    _rebuildObjFromCommonJSON : function(jsonObj){

      var obj = null;
      if(jsonObj == null)obj = null;
      if(qx.lang.Type.isArray(jsonObj)){

        obj = new Array();
        for(var i = 0;i < jsonObj.length;++i){

          obj.push(this._rebuildObjFromCommonJSON(jsonObj[i]));
        };
      } else if(qx.lang.Type.isBoolean(jsonObj))obj = jsonObj; else if(qx.lang.Type.isNumber(jsonObj))obj = jsonObj; else if(qx.lang.Type.isString(jsonObj)){

        obj = jsonObj;
        obj = obj.replace("&#10;", "\n").replace("&#13;", "\r");
      } else if(qx.lang.Type.isObject(jsonObj)){

        var dataType = jsonObj[xlsys.base.XLSYS.JSON_OBJ_DATA_TYPE];
        var className = jsonObj[xlsys.base.XLSYS.JSON_OBJ_CLASS];
        if(dataType == xlsys.base.XLSYS.DATA_TYPE_DATE){

          obj = new Date();
          obj.setTime(jsonObj["value"]);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_EXCEPTION){

          obj = new xlsys.java.lang.Exception(jsonObj["value"]);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_COLLECTION){

          obj = xlsys.base.util.ObjectUtil.tryInitObj(className);
          if(obj == null)throw new Error("Unsupported");
          var contentJsonArr = jsonObj["value"];
          for(var i = 0;i < contentJsonArr.length;++i){

            obj.add(this._rebuildObjFromCommonJSON(contentJsonArr[i]));
          };
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_ENTRY){

          var key = this._rebuildObjFromCommonJSON(jsonObj["key"]);
          var value = this._rebuildObjFromCommonJSON(jsonObj["value"]);
          obj = new xlsys.java.util.SimpleEntry(key, value);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_MAP){

          obj = xlsys.base.util.ObjectUtil.tryInitObj(className);
          if(obj == null)throw new Error("Unsupported");
          var contentJsonArr = jsonObj["value"];
          for(var i = 0;i < contentJsonArr.length;i += 2){

            var key = this._rebuildObjFromCommonJSON(contentJsonArr[i]);
            var value = this._rebuildObjFromCommonJSON(contentJsonArr[i + 1]);
            obj.put(key, value);
          };
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_BYTE_ARRAY){

          var hexStr = jsonObj["value"];
          obj = this.hexStrToBytes(hexStr);
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_DATA_SET_ROW){

          var row = new xlsys.base.dataset.DataSetRow();
          var contentJsonArr = jsonObj["value"];
          for(var i = 0;i < contentJsonArr.length;++i){

            var dsc = new xlsys.base.dataset.DataSetCell();
            dsc.setContent(this._rebuildObjFromCommonJSON(contentJsonArr[i]));
            row.getCells().add(dsc);
          };
          obj = row;
        } else if(dataType == xlsys.base.XLSYS.DATA_TYPE_OBJECT){

          obj = xlsys.base.util.ObjectUtil.tryInitObj(className);
          if(obj == null)throw new Error("Unsupported");
          var fields = obj.getSerializableMembers();
          for(var i = 0;i < fields.length;++i){

            var fieldName = fields[i];
            obj[fieldName] = this._rebuildObjFromCommonJSON(jsonObj[fieldName]);
          };
        };;;;;;;
      };;;;
      return obj;
    }
  }
});
qx.Class.define("xlsys.base.io.util.ByteDataOutputStream", {
  extend : qx.core.Object,
  construct : function(){

    this.bytes = new Array();
    this.pos = 0;
  },
  members : {
    bytes : null,
    write : function(){

      if(arguments.length == 1){

        if(qx.lang.Type.isArray(arguments[0])){

          this._write(arguments[0], 0, arguments[0].length);
        } else this.writeByte(arguments[0]);
      } else {

        this._write(arguments[0], arguments[1], arguments[2]);
      };
    },
    _write : function(b, off, len){

      for(var i = 0;i < len;++i){

        this.bytes.push(b[i + off] & 0xff);
      };
    },
    writeByte : function(v){

      qx.core.Assert.assertInteger(v);
      this.bytes.push(v & 0xff);
    },
    writeChar : function(v){

      this.writeShort(v);
    },
    writeShort : function(v){

      qx.core.Assert.assertInteger(v);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 8) & 0xff);
      this.bytes.push(v & 0xff);
    },
    writeInt : function(v){

      qx.core.Assert.assertInteger(v);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 24) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 16) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 8) & 0xff);
      this.bytes.push(v & 0xff);
    },
    writeLong : function(v){

      qx.core.Assert.assertInteger(v);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 56) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 48) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 40) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 32) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 24) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 16) & 0xff);
      this.bytes.push(xlsys.base.util.NumberUtil.getInstance().unsignedRightShift(v, 8) & 0xff);
      this.bytes.push(v & 0xff);
    },
    toByteArray : function(){

      return this.bytes;
    }
  }
});
qx.Class.define("xlsys.base.buffer.AbstractBuffer", {
  type : "abstract",
  extend : qx.core.Object,
  implement : [xlsys.base.buffer.XlsysBuffer],
  include : [xlsys.base.buffer.MXlsysBuffer],
  construct : function(){

    qx.core.Object.call(this);
    this.allEnvBufferMap = new xlsys.java.util.HashMap();
  },
  members : {
    allEnvBufferMap : null,
    getBufferMap : function(envId, bufferName, mapClass){

      if(mapClass == null)mapClass = "xlsys.java.util.LinkedHashMap";
      var envBufferMap = this.allEnvBufferMap.get(envId);
      if(envBufferMap == null){

        envBufferMap = new xlsys.java.util.HashMap();
        this.allEnvBufferMap.put(envId, envBufferMap);
      };
      var bufferMap = envBufferMap.get(bufferName);
      if(bufferMap == null){

        try{

          bufferMap = xlsys.base.util.ObjectUtil.tryInitObj(mapClass);
        } catch(err) {

          bufferMap = new xlsys.java.util.LinkedHashMap();
        };
        envBufferMap.put(bufferName, bufferMap);
      };
      return bufferMap;
    },
    getFinalStorageObject : function(bufferName, paramMap){

      return this._getFinalStorageObject(bufferName, paramMap);
    },
    getBufferData : function(bufferName, paramMap, callback){

      return this._getBufferData(bufferName, paramMap, callback);
    },
    updateCurrentVersion : function(bufferName, callback){

      return this._updateCurrentVersion(bufferName, callback);
    },
    getCurrentVersion : function(bufferName, callback){

      return this._getCurrentVersion(bufferName, callback);
    },
    reloadAllData : function(bufferName, forceLoad, callback){

      this._reloadAllData(bufferName, forceLoad, callback);
    },
    reloadData : function(bufferName, paramMap, forceLoad, callback){

      this._reloadData(bufferName, paramMap, forceLoad, callback);
    }
  }
});
qx.Class.define("xlsys.base.database.ClientTableInfoBuffer", {
  type : "singleton",
  extend : xlsys.base.buffer.AbstractBuffer,
  construct : function(){

    xlsys.base.buffer.AbstractBuffer.call(this);
    this._tableInfoBuffer = new xlsys.java.util.HashMap();
    var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
    var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
    xlsys.base.buffer.BufferManager.getInstance().registerBuffer("_ENV" + xlsys.base.XLSYS.BUFFER_TABLE_INFO_PREFIX + envId, this);
  },
  members : {
    _tableInfoBuffer : null,
    _tableCount : null,
    getStorageObject : function(bufferName, mark){

      var arr = new Array();
      arr.push(this._tableInfoBuffer);
      if(mark == xlsys.base.buffer.XlsysBuffer.MARK_ALL)arr.push(this._tableCount);
      return arr;
    },
    isBufferComplete : function(bufferName, callback){

      if(this._tableCount == null){

        var dataBase = xlsys.base.database.ClientDataBase.getInstance();
        if(callback){

          dataBase.getAllTableBaseInfo(qx.Bootstrap.bind(this.__isBufferComplete1, this, callback, dataBase));
          return;
        } else {

          this._tableCount = dataBase.getAllTableBaseInfo().size();
          dataBase.close();
        };
      };
      return this._tableInfoBuffer.size() == this._tableCount;
    },
    __isBufferComplete1 : function(callback, dataBase, allInfo){

      this._tableCount = allInfo.size();
      dataBase.close();
      callback(this._tableInfoBuffer.size() == this._tableCount);
    },
    reloadDataDirectly : function(bufferName, paramMap, forceLoad, callback){

      var tableName = null;
      if(paramMap != null)tableName = paramMap.get(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME);
      if(tableName != null)this._tableInfoBuffer.remove(tableName); else {

        this._tableInfoBuffer.clear();
        this._tableCount = null;
      };
      if(forceLoad)this.getBufferData(bufferName, paramMap, callback); else callback();
    },
    loadDataFromStorageObject : function(bufferName, storageObj, mark){

      if(mark == xlsys.base.buffer.XlsysBuffer.MARK_ALL){

        this._tableInfoBuffer = storageObj[0];
        this._tableCount = storageObj[1];
      } else this._tableInfoBuffer.putAll(storageObj);
      return true;
    },
    doGetBufferData : function(bufferName, paramMap, callback){

      var ret = null;
      var tableName = null;
      if(paramMap != null)tableName = paramMap.get(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME);
      if(tableName != null)ret = this._tableInfoBuffer.get(tableName); else {

        ret = this._tableInfoBuffer;
        if(this._tableCount == null || this._tableInfoBuffer.size() != this._tableCount)ret = null;
      };
      if(ret != null){

        if(callback)callback(ret); else return ret;
      } else {

        var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
        var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
        if(tableName != null){

          if(callback)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_TABLE_INFO, tableName, qx.Bootstrap.bind(this._getTableInfoRet, this, tableName, callback)); else {

            var tableInfo = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_TABLE_INFO, tableName);
            this._tableInfoBuffer.put(tableName, tableInfo);
            return tableInfo;
          };
        } else {

          if(callback){

            var dataBase = xlsys.base.database.ClientDataBase.getInstance();
            dataBase.getAllTableBaseInfo(qx.Bootstrap.bind(this._onLoadAllInfo1, this, dataBase, callback));
          } else {

            var dataBase = xlsys.base.database.ClientDataBase.getInstance();
            var allTableInfo = dataBase.getAllTableBaseInfo();
            this._tableCount = allTableInfo.size();
            var keys = allTableInfo.keys();
            for(var i = 0;i < keys.length;++i){

              var tempTable = keys[i];
              var tableInfo = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_TABLE_INFO, tempTable);
              this._tableInfoBuffer.put(tempTable, tableInfo);
            };
            dataBase.close();
            return this._tableInfoBuffer;
          };
        };
      };
    },
    _onLoadAllInfo1 : function(dataBase, callback, allTableInfo){

      this._tableCount = allTableInfo.size();
      var keys = allTableInfo.keys();
      var counter = [0];
      for(var i = 0;i < keys.length;++i){

        var tempTable = keys[i];
        xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_TABLE_INFO, tempTable, qx.Bootstrap.bind(this._onLoadAllInfo2, this, dataBase, keys, callback, counter, tempTable));
      };
    },
    _onLoadAllInfo2 : function(dataBase, keys, callback, counter, tempTable, tableInfo){

      this._tableInfoBuffer.put(tempTable, tableInfo);
      ++counter[0];
      if(counter[0] == keys.length){

        dataBase.close();
        callback(this._tableInfoBuffer);
      };
    },
    _getTableInfoRet : function(tableName, callback, data){

      this._tableInfoBuffer.put(tableName, data);
      callback(data);
    },
    getBufferData : function(bufferName, paramMap, callback){

      return this._getBufferData(bufferName, paramMap, callback);
    },
    getFinalStorageObject : function(bufferName, mark){

      return this._getFinalStorageObject(bufferName, mark);
    },
    updateCurrentVersion : function(bufferName){

      return this._updateCurrentVersion(bufferName);
    },
    getCurrentVersion : function(bufferName){

      return this._getCurrentVersion(bufferName);
    },
    reloadAllData : function(bufferName, forceLoad){

      this._reloadAllData(bufferName, forceLoad);
    },
    reloadData : function(bufferName, paramMap, forceLoad){

      this._reloadData(bufferName, paramMap, forceLoad);
    },
    saveDataToLocalStorage : function(bufferName, storageObject, callback){

      if(callback)callback(false); else return false;
    },
    reloadDataFromLocalStorage : function(bufferName, callback){

      if(callback)callback(false); else return false;
    },
    getLocalStorageVersion : function(bufferName, callback){

      if(callback)callback(-1); else return -1;
    }
  }
});
qx.Class.define("xlsys.base.buffer.BufferManager", {
  type : "singleton",
  extend : qx.core.Object,
  construct : function(){

    this.bufferMap = new xlsys.java.util.HashMap();
  },
  members : {
    bufferMap : null,
    registerBuffer : function(bufferName, buffer){

      if(bufferName != null && buffer != null)this.bufferMap.put(bufferName, buffer);
    },
    cancelRegisterBuffer : function(bufferName){

      if(bufferName != null)this.bufferMap.remove(bufferName);
    },
    isRegistered : function(bufferName){

      return this.bufferMap.containsKey(bufferName);
    },
    reloadBuffer : function(bufferName, paramMap, forceLoad, callback){

      if(forceLoad == null)forceLoad = false;
      if(bufferName == null){

        if(callback)callback();
        return;
      };
      var buffer = this.bufferMap.get(bufferName);
      if(buffer == null){

        if(callback)callback();
        return;
      };
      if(paramMap != null)buffer.reloadData(bufferName, paramMap, forceLoad, callback); else buffer.reloadAllData(bufferName, forceLoad, callback);
    },
    reloadAllBuffer : function(forceLoad, callback){

      if(forceLoad == null)forceLoad = false;
      var keyArray = this.bufferMap.keys();
      if(callback){

        var counter = [0];
        if(keyArray.length > 0){

          for(var i = 0;i < keyArray.length;++i){

            this.reloadBuffer(keyArray[i], null, forceLoad, qx.Bootstrap.bind(this.__reloadAllBuffer1, this, callback, keyArray, counter));
          };
        } else callback();
      } else {

        for(var i = 0;i < keyArray.length;++i){

          this.reloadBuffer(keyArray[i], null, forceLoad);
        };
      };
    },
    __reloadAllBuffer1 : function(callback, keyArray, counter){

      ++counter[0];
      if(counter[0] == keyArray.length)callback();
    },
    getAllRegisteredBufferNames : function(){

      return this.bufferMap.keys();
    },
    updateBufferVersion : function(bufferName, callback){

      var buffer = this.bufferMap.get(bufferName);
      if(buffer == null){

        if(callback)callback(-1);
        return -1;
      };
      return buffer.updateCurrentVersion(bufferName, callback);
    },
    getBufferVersion : function(bufferName){

      var buffer = this.bufferMap.get(bufferName);
      if(buffer == null)return -1;
      return buffer.getCurrentVersion(bufferName);
    },
    getLocalBufferVersion : function(bufferName){

      var buffer = this.bufferMap.get(bufferName);
      if(buffer == null)return -1;
      return buffer.getLocalStorageVersion(bufferName);
    }
  }
});
qx.Class.define("xlsys.base.database.ClientDataBase", {
  extend : qx.core.Object,
  implement : [xlsys.base.database.IClientDataBase],
  statics : {
    getInstance : function(){

      return new xlsys.base.database.ClientDataBase();
    }
  },
  construct : function(){

    this.autoCommit = true;
    this.transactionList = new xlsys.java.util.ArrayList();
  },
  members : {
    autoCommit : null,
    transactionList : null,
    getEnvId : function(){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      return session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
    },
    getTableInfo : function(tableName, callback){

      var envId = this.getEnvId();
      var bufferName = "_ENV" + xlsys.base.XLSYS.BUFFER_TABLE_INFO_PREFIX + envId;
      var paramMap = new xlsys.java.util.HashMap();
      paramMap.put(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME, tableName);
      if(callback == null)return xlsys.base.database.ClientTableInfoBuffer.getInstance().getBufferData(bufferName, paramMap); else xlsys.base.database.ClientTableInfoBuffer.getInstance().getBufferData(bufferName, paramMap, callback);
    },
    getAllTableBaseInfo : function(){

      if(arguments.length == 0){

        return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_ALL_TABLE_BASE_INFO, null);
      } else if(arguments.length == 1){

        xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_ALL_TABLE_BASE_INFO, null, arguments[0]);
      };
    },
    getResultCount : function(paramBean){

      if(arguments.length == 1){

        return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_RESULT_COUNT, paramBean);
      } else if(arguments.length == 2){

        xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_RESULT_COUNT, paramBean, arguments[1]);
      };
    },
    sqlSelectAsOneValue : function(sqlOrPb){

      var pb = null;
      if((typeof sqlOrPb) == "string")pb = new xlsys.base.database.bean.ParamBean(sqlOrPb); else pb = sqlOrPb;
      if(arguments.length == 1){

        return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT_AS_ONE_VALUE, pb);
      } else if(arguments.length == 2){

        xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT_AS_ONE_VALUE, pb, arguments[1]);
      };
    },
    sqlSelect : function(){

      if(arguments.length <= 2){

        var pb = null;
        if((typeof arguments[0]) == "string")pb = new xlsys.base.database.bean.ParamBean(arguments[0]); else pb = arguments[0];
        if(arguments.length == 1)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT, pb); else xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT, pb, arguments[1]);
      } else if(arguments.length == 3){

        var arr = new Array();
        arr.push(arguments[0]);
        arr.push(arguments[1]);
        arr.push(arguments[2]);
        return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT, arr);
      } else if(arguments.length == 4){

        if((typeof arguments[3]) == "number"){

          var arr = new Array();
          arr.push(arguments[0]);
          arr.push(arguments[1]);
          arr.push(arguments[2]);
          arr.push(arguments[3]);
          return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT, arr);
        } else {

          var arr = new Array();
          arr.push(arguments[0]);
          arr.push(arguments[1]);
          arr.push(arguments[2]);
          xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT, arr, arguments[3]);
        };
      } else if(arguments.length == 5){

        var arr = new Array();
        arr.push(arguments[0]);
        arr.push(arguments[1]);
        arr.push(arguments[2]);
        arr.push(arguments[3]);
        xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_SELECT, arr, arguments[4]);
      };;;
    },
    sqlExecute : function(){

      if((typeof arguments[0]) == "string"){

        var eb = new xlsys.base.database.bean.ExecuteBean(arguments[0]);
        if(arguments.length == 1)return this.__sqlExecute(eb); else if(arguments.length == 2)this.__sqlExecute(eb, arguments[1]);;
      } else {

        if(arguments.length == 1)return this.__sqlExecute(arguments[0]); else if(arguments.length == 2)this.__sqlExecute(arguments[0], arguments[1]);;
      };
    },
    __sqlExecute : function(sqlBeanOrList){

      if(this.autoCommit){

        if(arguments.length == 1)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_EXECUTE, sqlBeanOrList); else if(arguments.length == 2)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_EXECUTE, sqlBeanOrList, arguments[1]);;
      } else {

        if(qx.Interface.objectImplements(sqlBeanOrList, xlsys.java.util.List))this.transactionList.addAll(sqlBeanOrList); else this.transactionList.add(sqlBeanOrList);
        if(arguments.length == 2)arguments[1](true); else return true;
      };
    },
    getSplitedParamBean : function(paramBean, beginRowNum, endRowNum){

      var arr = new Array();
      arr.push(paramBean);
      arr.push(beginRowNum);
      arr.push(endRowNum);
      if(arguments.length == 3)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_SPLITED_PARAM_BEAN, arr); else if(arguments.length == 4)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_GET_SPLITED_PARAM_BEAN, arr, arguments[3]);;
    },
    disableConstraint : function(tableName, constraintName){

      var arr = new Array();
      arr.push(tableName);
      arr.push(constraintName);
      if(arguments.length == 2)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_DISABLE_CONSTRAINT, arr); else if(arguments.length == 3)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_DISABLE_CONSTRAINT, arr, arguments[2]);;
    },
    enableConstraint : function(tableName, constraintName){

      var arr = new Array();
      arr.push(tableName);
      arr.push(constraintName);
      if(arguments.length == 2)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_ENABLE_CONSTRAINT, arr); else if(arguments.length == 3)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_ENABLE_CONSTRAINT, arr, arguments[2]);;
    },
    getLowerFunc : function(srcExp){

      if(arguments.length == 1)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_LOWER, srcExp); else if(arguments.length == 2)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_LOWER, srcExp, arguments[1]);;
    },
    getUpperFunc : function(srcExp){

      if(arguments.length == 1)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_UPPER, srcExp); else if(arguments.length == 2)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_UPPER, srcExp, arguments[1]);;
    },
    getByteLengthFunc : function(srcExp){

      if(arguments.length == 1)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_BYTELENGTH, srcExp); else if(arguments.length == 2)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_BYTELENGTH, srcExp, arguments[1]);;
    },
    getSubStringFunc : function(){

      if(arguments.length == 2){

        var arr = new Array();
        arr.push(arguments[0]);
        arr.push(arguments[1]);
        return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_SUBSTRING, arr);
      } else if(arguments.length == 3){

        if((typeof arguments[2]) == "number"){

          var arr = new Array();
          arr.push(arguments[0]);
          arr.push(arguments[1]);
          arr.push(arguments[2]);
          return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_SUBSTRING, arr);
        } else {

          var arr = new Array();
          arr.push(arguments[0]);
          arr.push(arguments[1]);
          xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_SUBSTRING, arr, arguments[2]);
        };
      } else if(arguments.length == 4){

        var arr = new Array();
        arr.push(arguments[0]);
        arr.push(arguments[1]);
        arr.push(arguments[2]);
        xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_SUBSTRING, arr, arguments[3]);
      };;
    },
    getToDateFunc : function(date){

      if(arguments.length == 1)return xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_TODATE, date); else if(arguments.length == 2)xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_FUNC_TODATE, date, arguments[1]);;
    },
    getDataBaseId : function(){

      throw new xlsys.java.lang.Exception("Unsupported Operation!");
    },
    commit : function(){

      if(!this.autoCommit && this.transactionList.size() > 0){

        if(arguments.length == 0){

          var ret = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_EXECUTE, this.transactionList);
          if(ret instanceof xlsys.java.lang.Exception)throw ret; else this.transactionList.clear();
        } else if(arguments.length == 1){

          xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_DB_SQL_EXECUTE, this.transactionList, qx.Bootstrap.bind(this.__commitCallBack, this, arguments[0]));
        };
      } else {

        if(arguments.length == 0)return true; else if(arguments.length == 1)arguments[0](true);;
      };
    },
    __commitCallBack : function(callback, data, status){

      if(!(data instanceof xlsys.java.lang.Exception))this.transactionList.clear();
      callback(data, status);
    },
    rollback : function(){

      if(!this.autoCommit && this.transactionList.size() > 0){

        this.transactionList.clear();
      };
    },
    setAutoCommit : function(autoCommit){

      if(autoCommit && !this.autoCommit){

        if(arguments.length == 1){

          this.commit();
          this.autoCommit = autoCommit;
        } else if(arguments.length == 2){

          this.commit(qx.Bootstrap.bind(this.__setAutoCommitCallBack, this, autoCommit, arguments[1]));
        };
      } else {

        if(arguments.length == 1)this.autoCommit = autoCommit; else if(arguments.length == 2){

          this.autoCommit = autoCommit;
          arguments[1](null, "success");
        };
      };
    },
    __setAutoCommitCallBack : function(autoCommit, callback, data, status){

      this.autoCommit = autoCommit;
      callback(null, "success");
    },
    getAutoCommit : function(){

      return this.autoCommit;
    },
    close : function(){

      if(!this.autoCommit){

        if(arguments.length == 1)this.commit(); else if(arguments.length == 2)this.commit(arguments[0]);;
      };
    },
    isClose : function(){

      return false;
    }
  }
});
qx.Class.define("xlsys.java.util.StrictHashMap", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Map],
  construct : function(){

    this.__keymap = new Object();
    this.__valuemap = new Object();
    this.__size = 0;
  },
  members : {
    __keymap : null,
    __valuemap : null,
    __size : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil.hashcode(obj);
    },
    getClassName : function(){

      return "java.util.HashMap";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__keymap");
      arr.push("__valuemap");
      arr.push("__size");
      return arr;
    },
    clear : function(){

      for(var fieldName in this.__keymap){

        delete this.__keymap[fieldName];
      };
      for(var fieldName in this.__valuemap){

        delete this.__valuemap[fieldName];
      };
      this.__size = 0;
    },
    containsKey : function(key){

      var keyHash = this._getHashKey(key);
      var contains = this.__keymap[keyHash] != null;
      return contains;
    },
    containsValue : function(value){

      var contains = false;
      for(var fieldName in this.__valuemap){

        if(this._getHashKey(this.__valuemap[fieldName]) == this._getHashKey(value)){

          contains = true;
          break;
        };
      };
      return contains;
    },
    get : function(key){

      var keyHash = this._getHashKey(key);
      return this.__valuemap[keyHash];
    },
    isEmpty : function(){

      return this.__size == 0;
    },
    put : function(key, value){

      if(!this.containsKey(key))++this.__size;
      var keyHash = this._getHashKey(key);
      this.__keymap[keyHash] = key;
      this.__valuemap[keyHash] = value;
    },
    putAll : function(m){

      var keyArr = m.keys();
      for(var i = 0;i < keyArr.length;++i){

        this.put(keyArr[i], m.get(keyArr[i]));
      };
    },
    remove : function(key){

      var keyHash = this._getHashKey(key);
      if(delete this.__keymap[keyHash]){

        delete this.__valuemap[keyHash];
        --this.__size;
      };
    },
    size : function(){

      return this.__size;
    },
    keys : function(){

      var tempArr = new Array();
      for(var fieldName in this.__keymap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        tempArr.push(this.__keymap[fieldName]);
      };
      return tempArr;
    },
    values : function(){

      var tempArr = new Array();
      for(var fieldName in this.__valuemap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        tempArr.push(this.__valuemap[fieldName]);
      };
      return tempArr;
    },
    keySet : function(){

      var set = new xlsys.java.util.StrictHashSet();
      for(var fieldName in this.__keymap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        set.add(this.__keymap[fieldName]);
      };
      return set;
    },
    entrySet : function(){

      var set = new xlsys.java.util.StrictHashSet();
      for(var fieldName in this.__keymap){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        var entry = new xlsys.java.util.SimpleEntry(this.__keymap[fieldName], this.__valuemap[fieldName]);
        set.add(entry);
      };
      return set;
    }
  }
});
qx.Class.define("xlsys.java.util.StrictHashSet", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Set],
  construct : function(){

    this.__map = new Object();
    this.__size = 0;
  },
  members : {
    __map : null,
    __size : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil.hashcode(obj);
    },
    getClassName : function(){

      return "java.util.HashSet";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__map");
      arr.push("__size");
      return arr;
    },
    add : function(element){

      var hash = this._getHashKey(element);
      if(!this.__map[hash])++this.__size;
      this.__map[hash] = element;
    },
    addAll : function(collection){

      var arr = collection.toArray();
      for(var i = 0;i < arr.length;++i){

        this.add(arr[i]);
      };
    },
    clear : function(){

      for(var fieldName in this.__map){

        delete this.__map[fieldName];
      };
      this.__size = 0;
    },
    contains : function(element){

      var hash = this._getHashKey(element);
      var contain = this.__map[hash] != null;
      return contain;
    },
    remove : function(element){

      var hash = this._getHashKey(element);
      if(delete this.__map[hash])--this.__size;
    },
    size : function(){

      return this.__size;
    },
    isEmpty : function(){

      return this.__size == 0;
    },
    toArray : function(){

      var tempArr = new Array();
      for(var fieldName in this.__map){

        if(fieldName == "__hashcode" || fieldName == "$$hash")continue;
        tempArr.push(this.__map[fieldName]);
      };
      return tempArr;
    }
  }
});
qx.Interface.define("xlsys.base.model.ITableModel", {
  extend : xlsys.base.model.IModel,
  members : {
    getRefTableName : function(){
    }
  }
});
qx.Interface.define("xlsys.base.model.IModelCreator", {
  members : {
    getAllCount : function(dataBase, callback){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    createAllModels : function(dataBase, callback){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    createModel : function(dataBase, key, callback){

      this.assertArgumentsCount(arguments, 2, 3);
    }
  }
});
qx.Class.define("xlsys.base.model.ModelUtil", {
  type : "static",
  statics : {
    cloneModel : function(model){

      if(model == null)return null;
      var cloneModel = xlsys.base.util.ReflectUtil.newInstance(xlsys.base.util.ObjectUtil.className(model));
      var fields = model.getSerializableMembers();
      for(var i = 0;i < fields.length;++i){

        cloneModel[fields[i]] = model[fields[i]];
      };
      return cloneModel;
    },
    modelListToDataSet : function(modelList){

      if(modelList == null || modelList.isEmpty())return null;
      var dataSet = new xlsys.base.dataset.DataSet();
      var firstModel = modelList.get(0);
      var fields = firstModel.getSerializableMembers();
      var colFieldList = new xlsys.java.util.ArrayList();
      for(var i = 0;i < fields.length;++i){

        var fieldName = fields[i];
        if(qx.lang.String.endsWith(fieldName, "List"))continue;
        colFieldList.add(fieldName);
        var dsc = dataSet.insertNewColumnAfterLast();
        dsc.setColumnName(fieldName);
      };
      dataSet.buildColumnMap();
      for(var i = 0;i < modelList.size();++i){

        var model = modelList.get(i);
        dataSet.insertNewRowAfterLast();
        for(var j = 0;j < colFieldList.size();++j){

          var fieldName = colFieldList.get(j);
          dataSet.setValue(fieldName, model[fieldName]);
        };
      };
      return dataSet;
    },
    listToTreeModel : function(sortedList, treeFieldName, root){

      var addedSet = new xlsys.java.util.HashSet();
      for(var i = 0;i < sortedList.size();++i){

        if(!addedSet.contains(i)){

          var childModel = root.addChildData(sortedList.get(i));
          this.__addChildrenToTreeModel(sortedList, treeFieldName, childModel, i, addedSet);
        };
      };
      return root;
    },
    __addChildrenToTreeModel : function(sortedList, treeFieldName, treeModel, index, addedSet){

      var keyStr = xlsys.base.util.ObjectUtil.objectToString(treeModel.getData()[treeFieldName]);
      for(var i = index + 1;i < sortedList.size();++i){

        if(!addedSet.contains(i)){

          var temp = sortedList.get(i);
          var tempStr = xlsys.base.util.ObjectUtil.objectToString(temp[treeFieldName]);
          if(qx.lang.String.startsWith(tempStr, keyStr)){

            var childModel = treeModel.addChildData(temp);
            addedSet.add(i);
            this.__addChildrenToTreeModel(sortedList, treeFieldName, childModel, i, addedSet);
          };
        };
      };
    },
    dataSetToTreeModel : function(sortedDataSet, treeColumnName, root){

      var addedSet = new xlsys.java.util.HashSet();
      var rowList = sortedDataSet.getRows();
      for(var i = 0;i < rowList.size();++i){

        if(!addedSet.contains(i)){

          var childModel = root.addChildData(rowList.get(i));
          this.__addChildrenRowToTreeModel(sortedDataSet, treeColumnName, childModel, i, addedSet);
        };
      };
      return root;
    },
    __addChildrenRowToTreeModel : function(sortedDataSet, treeColumnName, treeModel, index, addedSet){

      var keyStr = xlsys.base.util.ObjectUtil.objectToString(sortedDataSet.getValue(index, treeColumnName));
      var rowList = sortedDataSet.getRows();
      for(var i = index + 1;i < rowList.size();++i){

        if(!addedSet.contains(i)){

          var tempStr = xlsys.base.util.ObjectUtil.objectToString(sortedDataSet.getValue(i, treeColumnName));
          if(qx.lang.String.startsWith(tempStr, keyStr)){

            var childModel = treeModel.addChildData(sortedDataSet.getRow(i));
            addedSet.add(i);
            this.__addChildrenRowToTreeModel(sortedDataSet, treeColumnName, childModel, i, addedSet);
          };
        };
      };
    }
  }
});
qx.Class.define("xlsys.base.database.TableInfo", {
  extend : xlsys.java.io.Serializable,
  construct : function(tableName){

    this.tableName = tableName;
    this.tableComment = null;
    this.dataColumnMap = new xlsys.java.util.HashMap();
    this.columnCommentMap = new xlsys.java.util.HashMap();
    this.dataColumnList = new xlsys.java.util.ArrayList();
    this.pkColSet = new xlsys.java.util.LinkedHashSet();
    this.constraintMap = new xlsys.java.util.HashMap();
  },
  members : {
    tableName : null,
    tableComment : null,
    dataColumnMap : null,
    columnCommentMap : null,
    dataColumnList : null,
    pkColSet : null,
    constraintMap : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("tableName");
      arr.push("tableComment");
      arr.push("dataColumnMap");
      arr.push("columnCommentMap");
      arr.push("dataColumnList");
      arr.push("pkColSet");
      arr.push("constraintMap");
      return arr;
    },
    getTableComment : function(){

      return this.tableComment;
    },
    setTableComment : function(tableComment){

      this.tableComment = tableComment;
    },
    addDataSetColumn : function(dsc){

      if(!this.dataColumnList.contains(dsc)){

        this.dataColumnMap.put(dsc.getColumnName(), dsc);
        this.dataColumnList.add(dsc);
        if(this.pkColSet.contains(dsc.getColumnName())){

          dsc.setPrimaryKey(true);
        };
        if(dsc.isPrimaryKey()){

          this.pkColSet.add(dsc.getColumnName());
        };
      };
    },
    addColumnComment : function(colName, comment){

      this.columnCommentMap.put(colName.toLowerCase(), comment);
    },
    getColumnComment : function(colName){

      return this.columnCommentMap.get(colName);
    },
    addPkCol : function(pkColName){

      pkColName = pkColName.toLowerCase();
      this.pkColSet.add(pkColName);
      var size = this.dataColumnList.size();
      for(var i = 0;i < size;++i){

        var dsc = this.dataColumnList.get(i);
        if(dsc.getColumnName() == pkColName){

          dsc.setPrimaryKey(true);
          break;
        };
      };
    },
    addConstraint : function(constraintName, constraint){

      this.constraintMap.put(constraintName, constraint);
    },
    getConstraint : function(constraintName){

      return this.constraintMap.get(constraintName);
    },
    getConstraintMap : function(){

      return this.constraintMap;
    },
    getDataSetColumn : function(colName){

      var dsc = this.dataColumnMap.get(colName.toLowerCase());
      return dsc;
    },
    getTableName : function(){

      return this.tableName;
    },
    getDataColumnList : function(){

      return this.dataColumnList;
    },
    getPkColSet : function(){

      return this.pkColSet;
    }
  }
});
qx.Class.define("xlsys.base.buffer.UnstorageBuffer", {
  type : "abstract",
  extend : xlsys.base.buffer.AbstractBuffer,
  members : {
    getStorageObject : function(bufferName, mark){

      return this.getBufferMap(bufferName);
    },
    isBufferComplete : function(bufferName, callback){

      if(callback)callback(false);
      return false;
    },
    reloadDataDirectly : function(bufferName, paramMap, forceLoad, callback){

      this.getBufferMap(bufferName).clear();
      if(callback)callback();
    },
    loadDataFromStorageObject : function(bufferName, storageObj, mark, callback){

      if(callback)callback(false); else return false;
    },
    doGetBufferData : function(bufferName, paramMap, callback){

      var bufferData = this.getBufferMap(bufferName);
      if(callback)callback(bufferData); else return bufferData;
    },
    saveDataToLocalStorage : function(bufferName, storageObject, callback){

      if(callback)callback(false); else return false;
    },
    reloadDataFromLocalStorage : function(bufferName, callback){

      if(callback)callback(false); else return false;
    },
    getLocalStorageVersion : function(bufferName, callback){

      if(callback)callback(-1); else return -1;
    }
  }
});
qx.Interface.define("xlsys.base.dataset.ITreeDataSet", {
  extend : [xlsys.base.dataset.IDataSet],
  members : {
    setTreeColumn : function(colNameOrIdx){

      this.assertArgumentsCount(arguments, 1, 2);
    },
    setTreeColIdx : function(treeColIdx){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getTreeColumnName : function(){
    },
    getTreeColumn : function(){
    },
    getRootRows : function(){
    },
    getRootRowNums : function(){
    },
    getChildrenRows : function(rowOrRowAt){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getChildrenRowNums : function(rowOrRowAt){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getAllChildrenRows : function(rowOrRowAt){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getAllChildrenRowNums : function(rowOrRowAt){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getParentRow : function(rowOrRowAt){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getParentRowNum : function(rowOrRowAt){

      this.assertArgumentsCount(arguments, 1, 1);
    },
    getAllParent : function(rowOrRowAt){

      this.assertArgumentsCount(arguments, 1, 1);
    }
  }
});
qx.Class.define("xlsys.base.XlsysContext", {
  type : "abstract",
  extend : qx.core.Object,
  construct : function(){

    if(arguments.length == 1)this.parent = arguments[0];
    this.defaultMap = new xlsys.java.util.HashMap();
  },
  members : {
    parent : null,
    defaultMap : null,
    sourceContext : null,
    clear : function(){

      this.defaultMap.clear();
      this.doClear();
    },
    getSourceContext : function(){

      return this.sourceContext;
    },
    setSourceContext : function(sourceContext){

      this.sourceContext = sourceContext;
    },
    doClear : function(){
    },
    containsKey : function(key){

      var contains = false;
      contains = this.doContainsKey(key);
      if(!contains){

        contains = this.defaultMap.containsKey(key);
        if(!contains && this.parent != null)contains = this.parent.containsKey(key);
      };
      return contains;
    },
    doContainsKey : function(key){
    },
    containsValue : function(value){

      var contains = false;
      contains = this.doContainsValue(value);
      if(!contains){

        contains = this.defaultMap.containsValue(value);
        if(!contains && this.parent != null)contains = this.parent.containsValue(value);
      };
      return contains;
    },
    doContainsValue : function(value){
    },
    entrySet : function(){

      var set = this.defaultMap.entrySet();
      var subSet = this.doEntrySet();
      if(subSet != null)set.addAll(subSet);
      return set;
    },
    doEntrySet : function(){
    },
    allEntrySet : function(){

      var set = this.entrySet();
      if(this.parent != null)set.addAll(this.parent.allEntrySet());
      return set;
    },
    get : function(key){

      var value = this.doGet(key);
      if(value == null)value = this.defaultMap.get(key);
      if(value == null && this.parent != null)value = this.parent.get(key);
      return value;
    },
    doGet : function(key){
    },
    isEmpty : function(){

      var empty = this.doIsEmpty();
      if(empty)empty = this.defaultMap.isEmpty();
      return empty;
    },
    doIsEmpty : function(){
    },
    isAllEmpty : function(){

      var empty = this.isEmpty();
      if(empty && this.parent != null)empty = this.parent.isAllEmpty();
      return empty;
    },
    keySet : function(){

      var set = new xlsys.java.util.HashSet();
      set.addAll(this.defaultMap.keySet());
      var subSet = this.doKeySet();
      if(subSet != null)set.addAll(subSet);
      return set;
    },
    doKeySet : function(){
    },
    allKeySet : function(){

      var set = new xlsys.java.util.HashSet();
      set.addAll(this.keySet());
      if(this.parent != null)set.addAll(this.parent.allKeySet());
      return set;
    },
    put : function(key, value){

      if(!this.doPut(key, value))this.defaultMap.put(key, value);
      return true;
    },
    doPut : function(key, value){
    },
    putAll : function(map){

      if(!this.doPutAll(map))this.defaultMap.putAll(map);
      return true;
    },
    doPutAll : function(map){
    },
    remove : function(key){

      var obj = null;
      if(this.doRemove(key) == null)obj = this.defaultMap.remove(key);
      return obj;
    },
    doRemove : function(key){
    },
    size : function(){

      var s = this.defaultMap.size();
      s += this.doSize();
      return s;
    },
    doSize : function(){
    },
    allSize : function(){

      var s = this.size();
      if(this.parent != null)s += this.parent.allSize();
      return s;
    },
    values : function(){

      var values = this.defaultMap.values();
      var subValues = this.doValues();
      if(subValues != null)values.addAll(subValues);
      return values;
    },
    doValues : function(){
    },
    allValues : function(){

      var values = this.values();
      if(this.parent != null)values.addAll(this.parent.allValues());
      return values;
    },
    getDefaultMap : function(){

      return this.defaultMap;
    },
    getParent : function(){

      return this.parent;
    }
  }
});
qx.Class.define("xlsys.base.io.pack.InnerPackage", {
  extend : xlsys.java.io.Serializable,
  construct : function(session){

    this.session = session;
    this.command = null;
    this.obj = null;
  },
  members : {
    session : null,
    command : null,
    obj : null,
    getSession : function(){

      return this.session;
    },
    setSession : function(session){

      this.session = session;
    },
    getCommand : function(){

      return this.command;
    },
    setCommand : function(command){

      this.command = command;
    },
    getObj : function(){

      return this.obj;
    },
    setObj : function(obj){

      this.obj = obj;
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("session");
      arr.push("command");
      arr.push("obj");
      return arr;
    }
  }
});
qx.Class.define("xlsys.base.buffer.ModelBuffer", {
  type : "abstract",
  extend : xlsys.base.buffer.AbstractBuffer,
  statics : {
    BUFFER_KEY_MODEL_KEY : "_BUFFER_KEY_MODEL_KEY",
    BUFFER_KEY_DATABASE : "_BUFFER_KEY_DATABASE",
    BUFFER_KEY_SESSION : "_BUFFER_KEY_SESSION",
    BUFFER_KEY_ENV_ID : "_BUFFER_KEY_ENV_ID"
  },
  construct : function(){

    xlsys.base.buffer.AbstractBuffer.call(this);
    this.bindModelCreatorMap = new xlsys.java.util.HashMap();
    this.modelCountMap = new xlsys.java.util.HashMap();
    this.modelTransMap = new xlsys.java.util.HashMap();
  },
  members : {
    bindModelCreatorMap : null,
    modelCountMap : null,
    modelTransMap : null,
    initAllModels : function(bufferName, dataBase, modelCreator, callback){

      if(modelCreator == null){

        modelCreator = this.bindModelCreatorMap.get(bufferName);
        if(modelCreator == null)throw new Error("Please bind model creator first!");
      };
      var envId = dataBase.getEnvId();
      var modelMap = this.getBufferMap(envId, bufferName);
      if(callback)this.getModelCount(bufferName, dataBase, qx.Bootstrap.bind(this.__initAllModels1, this, bufferName, dataBase, modelCreator, callback, modelMap)); else {

        var allCount = this.getModelCount(bufferName, dataBase);
        if(allCount == -1 || modelMap.size() < allCount){

          modelMap.clear();
          modelMap.putAll(modelCreator.createAllModels(dataBase));
        };
      };
    },
    __initAllModels1 : function(bufferName, dataBase, modelCreator, callback, modelMap, allCount){

      if(allCount == -1 || modelMap.size() < allCount){

        modelMap.clear();
        modelCreator.createAllModels(dataBase, qx.Bootstrap.bind(this.__initAllModels2, this, modelMap, callback));
      } else callback();
    },
    __initAllModels2 : function(modelMap, callback, allModels){

      modelMap.putAll(allModels);
      callback();
    },
    getModelCount : function(bufferName, sed, callback){

      var envId = null;
      var dataBase = null;
      if(qx.lang.Type.isNumber(sed))envId = sed; else if(sed instanceof xlsys.base.session.Session)envId = sed.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID); else if(qx.Class.implementsInterface(sed, xlsys.base.database.IDataBase)){

        dataBase = sed;
        envId = dataBase.getEnvId();
      };;
      var countMap = this.modelCountMap.get(envId);
      if(countMap == null){

        countMap = new xlsys.java.util.HashMap();
        this.modelCountMap.put(envId, countMap);
      };
      var allCount = countMap.get(bufferName);
      if(allCount == null){

        var modelCreator = this.bindModelCreatorMap.get(bufferName);
        if(modelCreator == null)throw new Error("Please bind model creator first!");
        var needClose = false;
        if(dataBase == null){

          dataBase = xlsys.base.database.ClientDataBase.getInstance();
          needClose = true;
        };
        if(callback)modelCreator.getAllCount(dataBase, qx.Bootstrap.bind(this.__getModelCount1, this, bufferName, dataBase, needClose, countMap, callback)); else {

          allCount = modelCreator.getAllCount(dataBase);
          if(needClose)dataBase.close();
          countMap.put(bufferName, allCount);
          return allCount;
        };
      } else {

        if(callback)callback(allCount); else return allCount;
      };
    },
    __getModelCount1 : function(bufferName, dataBase, needClose, countMap, callback, allCount){

      if(needClose)dataBase.close();
      countMap.put(bufferName, allCount);
      callback(allCount);
    },
    bindModelCreator : function(bufferName, modelCreator){

      this.bindModelCreatorMap.put(bufferName, modelCreator);
    },
    getAllModels : function(bufferName, sed, callback){

      var paramMap = new xlsys.java.util.HashMap();
      if(qx.lang.Type.isNumber(sed))paramMap.put(this.self(arguments).BUFFER_KEY_ENV_ID, sed); else if(sed instanceof xlsys.base.session.Session)paramMap.put(this.self(arguments).BUFFER_KEY_SESSION, sed); else if(qx.Class.implementsInterface(sed, xlsys.base.database.IDataBase))paramMap.put(this.self(arguments).BUFFER_KEY_DATABASE, sed);;;
      if(callback)this.getBufferData(bufferName, paramMap, callback); else return this.getBufferData(bufferName, paramMap);
    },
    _getAllTranslatedModels : function(srcModelList, envId, bufferName, dataBase, language, callback){

      if(srcModelList == null){

        if(callback)callback(null);
        return null;
      };
      var transModelList = new xlsys.java.util.ArrayList();
      if(callback){

        if(srcModelList.size() > 0){

          var counter = [0];
          for(var i = 0;i < srcModelList.size();++i){

            this._getTranslatedModel(srcModelList.get(i), envId, bufferName, dataBase, language, qx.Bootstrap.bind(this.__getAllTranslatedModels1, this, srcModelList, callback, transModelList, counter));
          };
        } else callback(transModelList);
      } else {

        for(var i = 0;i < srcModelList.size();++i){

          var transModel = this._getTranslatedModel(srcModelList.get(i), envId, bufferName, dataBase, language);
          transModelList.add(transModel);
        };
        return transModelList;
      };
    },
    __getAllTranslatedModels1 : function(srcModelList, callback, transModelList, counter, transModel){

      transModelList.add(transModel);
      ++counter[0];
      if(counter[0] == srcModelList.size())callback(transModelList);
    },
    _translateSubList : function(model, envId, bufferName, dataBase, language, callback){

      var fieldArr = model.getSerializableMembers();
      var todoMap = new xlsys.java.util.HashMap();
      for(var i = 0;i < fieldArr.length;++i){

        var field = fieldArr[i];
        if(model[field] != null && qx.Class.implementsInterface(model[field], xlsys.java.util.List)){

          if(!model[field].isEmpty() && qx.Class.implementsInterface(model[field].get(0), xlsys.base.model.IModel)){

            var subModelList = model[field];
            var cloneList = new xlsys.java.util.ArrayList();
            var size = subModelList.size();
            if(callback){

              if(size > 0)todoMap.put(field, size);
              for(var j = 0;j < subModelList.size();++j){

                this._getTranslatedModel(subModelList.get(j), envId, bufferName, dataBase, language, qx.Bootstrap.bind(this.__translateSubList1, this, model, callback, field, cloneList, todoMap));
              };
            } else {

              for(var j = 0;j < subModelList.size();++j){

                var transModel = this._getTranslatedModel(subModelList.get(j), envId, bufferName, dataBase, language);
                cloneList.add(transModel);
              };
              model[field] = cloneList;
            };
          };
        };
      };
      if(callback && todoMap.isEmpty())callback();
    },
    __translateSubList1 : function(model, callback, field, cloneList, todoMap, transModel){

      cloneList.add(transModel);
      if(cloneList.size() == todoMap.get(field)){

        model[field] = cloneList;
        todoMap.remove(field);
      };
      if(todoMap.isEmpty())callback();
    },
    __getAllModelsWithSession : function(bufferName, session, modelCreator, callback){

      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      return this.__getAllModelsWithEnvId(bufferName, envId, modelCreator, callback);
    },
    __getAllModelsWithEnvId : function(bufferName, envId, modelCreator, callback){

      var modelMap = this.getBufferMap(envId, bufferName);
      if(callback)this.getModelCount(bufferName, envId, qx.Bootstrap.bind(this.__getAllModelsWithEnvId1, this, bufferName, envId, modelCreator, callback, modelMap)); else {

        var allCount = this.getModelCount(bufferName, envId);
        if(allCount == -1 || modelMap.size() < allCount){

          var dataBase = xlsys.base.database.ClientDataBase.getInstance();
          this.initAllModels(bufferName, dataBase, modelCreator);
          dataBase.close();
        };
        var modelList = new xlsys.java.util.ArrayList();
        var valueArray = modelMap.values();
        for(var i = 0;i < valueArray.length;++i){

          modelList.add(valueArray[i]);
        };
        return modelList;
      };
    },
    __getAllModelsWithEnvId1 : function(bufferName, envId, modelCreator, callback, modelMap, allCount){

      if(allCount == -1 || modelMap.size() < allCount){

        var dataBase = xlsys.base.database.ClientDataBase.getInstance();
        this.initAllModels(bufferName, dataBase, modelCreator, qx.Bootstrap.bind(this.__getAllModelsWithEnvId2, this, bufferName, dataBase, modelCreator, callback, modelMap));
      } else this.__getAllModelsWithDataBase2(bufferName, modelCreator, callback, modelMap);
    },
    __getAllModelsWithEnvId2 : function(bufferName, dataBase, modelCreator, callback, modelMap){

      dataBase.close();
      this.__getAllModelsWithDataBase2(bufferName, modelCreator, callback, modelMap);
    },
    __getAllModelsWithDataBase : function(bufferName, dataBase, modelCreator, callback){

      var modelMap = this.getBufferMap(dataBase.getEnvId(), bufferName);
      if(callback)this.getModelCount(bufferName, dataBase.getEnvId(), qx.Bootstrap.bind(this.__getAllModelsWithDataBase1, this, bufferName, dataBase, modelCreator, callback, modelMap)); else {

        var allCount = this.getModelCount(bufferName, dataBase.getEnvId());
        if(allCount == -1 || modelMap.size() < allCount)this.initAllModels(bufferName, dataBase, modelCreator);
        var modelList = new xlsys.java.util.ArrayList();
        var valueArray = modelMap.values();
        for(var i = 0;i < valueArray.length;++i){

          modelList.add(valueArray[i]);
        };
        return modelList;
      };
    },
    __getAllModelsWithDataBase1 : function(bufferName, dataBase, modelCreator, callback, modelMap, allCount){

      if(allCount == -1 || modelMap.size() < allCount)this.initAllModels(bufferName, dataBase, modelCreator, qx.Bootstrap.bind(this.__getAllModelsWithDataBase2, this, bufferName, modelCreator, callback, modelMap)); else this.__getAllModelsWithDataBase2(bufferName, modelCreator, callback, modelMap);
    },
    __getAllModelsWithDataBase2 : function(bufferName, modelCreator, callback, modelMap){

      var modelList = new xlsys.java.util.ArrayList();
      var valueArray = modelMap.values();
      for(var i = 0;i < valueArray.length;++i){

        modelList.add(valueArray[i]);
      };
      callback(modelList);
    },
    getModel : function(bufferName, sed, key, modelCreator, callback){

      var paramMap = new xlsys.java.util.HashMap();
      paramMap.put(this.self(arguments).BUFFER_KEY_MODEL_KEY, key);
      if(qx.lang.Type.isNumber(sed))paramMap.put(this.self(arguments).BUFFER_KEY_ENV_ID, sed); else if(sed instanceof xlsys.base.session.Session)paramMap.put(this.self(arguments).BUFFER_KEY_SESSION, sed); else if(qx.Class.implementsInterface(sed, xlsys.base.database.IDataBase))paramMap.put(this.self(arguments).BUFFER_KEY_DATABASE, sed);;;
      return this.getBufferData(bufferName, paramMap, callback);
    },
    _getTranslatedModel : function(srcModel, envId, bufferName, dataBase, language, callback){

      if(srcModel == null)return null;
      var envTransMap = this.modelTransMap.get(envId);
      if(envTransMap == null){

        envTransMap = new xlsys.java.util.HashMap();
        this.modelTransMap.put(envId, envTransMap);
      };
      var bnTransMap = envTransMap.get(bufferName);
      if(bnTransMap == null){

        bnTransMap = new xlsys.java.util.HashMap();
        envTransMap.put(bufferName, bnTransMap);
      };
      var mTransMap = bnTransMap.get(srcModel);
      if(mTransMap == null){

        mTransMap = new xlsys.java.util.HashMap();
        bnTransMap.put(srcModel, mTransMap);
      };
      var transModel = mTransMap.get(language);
      if(transModel == null){

        if(callback)xlsys.base.util.TranslateUtil.getInstance(language).translateModel(envId, dataBase, srcModel, qx.Bootstrap.bind(this.__getTranslatedModel1, this, envId, bufferName, dataBase, language, callback, mTransMap)); else {

          transModel = xlsys.base.util.TranslateUtil.getInstance(language).translateModel(envId, dataBase, srcModel);
          this._translateSubList(transModel, envId, bufferName, dataBase, language);
          mTransMap.put(language, transModel);
          return transModel;
        };
      } else {

        if(callback)callback(transModel); else return transModel;
      };
    },
    __getTranslatedModel1 : function(envId, bufferName, dataBase, language, callback, mTransMap, transModel){

      this._translateSubList(transModel, envId, bufferName, dataBase, language, qx.Bootstrap.bind(this.__getTranslatedModel2, this, mTransMap, language, transModel, callback));
    },
    __getTranslatedModel2 : function(mTransMap, language, transModel, callback){

      mTransMap.put(language, transModel);
      callback(transModel);
    },
    __getModelWithSession : function(bufferName, session, key, modelCreator, callback){

      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      return this.__getModelWithEnvId(bufferName, envId, key, modelCreator, callback);
    },
    __getModelWithEnvId : function(bufferName, envId, key, modelCreator, callback){

      if(key == null)return null;
      var modelMap = this.getBufferMap(envId, bufferName);
      var model = modelMap.get(key);
      if(model == null){

        var dataBase = xlsys.base.database.ClientDataBase.getInstance();
        if(callback){

          this.__getModelWithDataBase(bufferName, dataBase, key, modelCreator, qx.Bootstrap.bind(this.__getModelWithEnvId1, this, dataBase, callback));
          return;
        } else {

          model = this.__getModelWithDataBase(bufferName, dataBase, key, modelCreator);
          dataBase.close();
        };
      } else {

        if(callback){

          callback(model);
          return;
        };
      };
      return model;
    },
    __getModelWithEnvId1 : function(dataBase, callback, model){

      dataBase.close();
      callback(model);
    },
    __getModelWithDataBase : function(bufferName, dataBase, key, modelCreator, callback){

      if(key == null){

        if(callback)callback(null);
        return null;
      };
      var modelMap = this.getBufferMap(dataBase.getEnvId(), bufferName);
      var model = modelMap.get(key);
      if(model == null){

        if(callback){

          modelCreator.createModel(dataBase, key, qx.Bootstrap.bind(this.__getModelWithDataBase1, this, modelMap, key, callback));
          return;
        } else {

          model = modelCreator.createModel(dataBase, key);
          modelMap.put(key, model);
        };
      } else {

        if(callback){

          callback(model);
          return;
        };
      };
      return model;
    },
    __getModelWithDataBase1 : function(modelMap, key, callback, model){

      modelMap.put(key, model);
      callback(model);
    },
    getStorageObject : function(bufferName, mark){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var bufferMap = this.allEnvBufferMap.get(envId).get(bufferName);
      var modelCount = this.modelCountMap.get(envId).get(bufferName);
      var transMap = this.modelTransMap.get(envId).get(bufferName);
      var storageObject = new Array();
      storageObject.push(bufferMap);
      storageObject.push(transMap);
      if(qx.lang.String.startsWith(mark, xlsys.base.buffer.XlsysBuffer.MARK_ALL))storageObject.push(modelCount);
      return storageObject;
    },
    isBufferComplete : function(bufferName, callback){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var envBufferMap = this.allEnvBufferMap.get(envId);
      var countMap = this.modelCountMap.get(envId);
      if(envBufferMap == null || countMap == null){

        if(callback)callback(false);
        return false;
      };
      var bufferMap = envBufferMap.get(bufferName);
      var count = countMap.get(bufferName);
      if(bufferMap == null || count == null){

        if(callback)callback(false);
        return false;
      };
      if(bufferMap.size() == count){

        if(callback)callback(true);
        return true;
      };
      if(callback)callback(false); else return false;
    },
    reloadDataDirectly : function(bufferName, paramMap, forceLoad, callback){

      if(forceLoad == null)forceLoad = false;
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var reloadAll = false;
      if(paramMap == null)reloadAll = true; else {

        var key = paramMap.get(this.self(arguments).BUFFER_KEY_MODEL_KEY);
        if(key == null)reloadAll = true; else {

          this.getBufferMap(envId, bufferName).remove(key);
          if(forceLoad)this.getModel(bufferName, envId, key, callback); else if(callback)callback();;
          return;
        };
      };
      if(reloadAll){

        this.getBufferMap(envId, bufferName).clear();
        var countMap = this.modelCountMap.get(envId);
        if(countMap != null)countMap.remove(bufferName);
        var envTransMap = this.modelTransMap.get(envId);
        if(envTransMap != null)envTransMap.remove(bufferName);
        if(forceLoad)this.getAllModels(bufferName, envId, callback); else callback();
      };
    },
    loadDataFromStorageObject : function(bufferName, storageObj, mark){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var objArr = storageObj;
      var bufferMap = objArr[0];
      var transMap = objArr[1];
      var curBufferMap = this.getBufferMap(envId, bufferName);
      curBufferMap.putAll(bufferMap);
      var envTransMap = this.modelTransMap.get(envId);
      if(envTransMap == null){

        envTransMap = new xlsys.java.util.HashMap();
        this.modelTransMap.put(envId, envTransMap);
      };
      var curTransMap = envTransMap.get(bufferName);
      if(curTransMap == null){

        curTransMap = new xlsys.java.util.HashMap();
        envTransMap.put(bufferName, curTransMap);
      };
      curTransMap.putAll(transMap);
      if(qx.lang.String.startsWith(mark, xlsys.base.buffer.XlsysBuffer.MARK_ALL)){

        var modelCount = objArr[2];
        var countMap = this.modelCountMap.get(envId);
        if(countMap == null){

          countMap = this.modelCountMap.get(envId);
          if(countMap == null){

            countMap = new xlsys.java.util.HashMap();
            this.modelCountMap.put(envId, countMap);
          };
        };
        countMap.put(bufferName, modelCount);
      };
      return true;
    },
    doGetBufferData : function(bufferName, paramMap, callback){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var language = session.getAttribute(xlsys.base.XLSYS.SESSION_LANGUAGE);
      var ret = null;
      var modelCreator = this.bindModelCreatorMap.get(bufferName);
      if(modelCreator == null)throw new Error("Please bind model creator first!");
      if(paramMap == null){

        if(callback){

          this.dispatchGetAllModels(bufferName, null, envId, null, modelCreator, qx.Bootstrap.bind(this.__doGetBufferData1, this, envId, bufferName, language, callback));
          return;
        } else {

          var modelList = this.dispatchGetAllModels(bufferName, null, envId, null, modelCreator);
          ret = this._getAllTranslatedModels(modelList, envId, bufferName, xlsys.base.database.ClientDataBase.getInstance(), language);
        };
      } else {

        var key = paramMap.get(this.self(arguments).BUFFER_KEY_MODEL_KEY);
        var session = paramMap.get(this.self(arguments).BUFFER_KEY_SESSION);
        var dataBase = paramMap.get(this.self(arguments).BUFFER_KEY_DATABASE);
        var tempEnvId = paramMap.get(this.self(arguments).BUFFER_KEY_ENV_ID);
        if(tempEnvId == null)tempEnvId = envId;
        if(key == null){

          if(callback){

            this.dispatchGetAllModels(bufferName, session, tempEnvId, dataBase, modelCreator, qx.Bootstrap.bind(this.__doGetBufferData1, this, envId, bufferName, language, callback));
            return;
          } else {

            var modelList = this.dispatchGetAllModels(bufferName, session, tempEnvId, dataBase, modelCreator);
            ret = this._getAllTranslatedModels(modelList, envId, bufferName, xlsys.base.database.ClientDataBase.getInstance(), language);
          };
        } else {

          if(callback){

            this.dispatchGetModel(bufferName, session, tempEnvId, dataBase, key, modelCreator, qx.Bootstrap.bind(this.__doGetBufferData2, this, envId, bufferName, language, callback));
            return;
          } else {

            var model = this.dispatchGetModel(bufferName, session, tempEnvId, dataBase, key, modelCreator);
            ret = this._getTranslatedModel(model, envId, bufferName, xlsys.base.database.ClientDataBase.getInstance(), language);
          };
        };
      };
      return ret;
    },
    __doGetBufferData1 : function(envId, bufferName, language, callback, modelList){

      this._getAllTranslatedModels(modelList, envId, bufferName, xlsys.base.database.ClientDataBase.getInstance(), language, callback);
    },
    __doGetBufferData2 : function(envId, bufferName, language, callback, model){

      this._getTranslatedModel(model, envId, bufferName, xlsys.base.database.ClientDataBase.getInstance(), language, callback);
    },
    saveDataToLocalStorage : function(bufferName, storageObject, callback){

      if(callback)callback(false); else return false;
    },
    reloadDataFromLocalStorage : function(bufferName, callback){

      if(callback)callback(false); else return false;
    },
    getLocalStorageVersion : function(bufferName, callback){

      if(callback)callback(-1); else return -1;
    },
    dispatchGetModel : function(bufferName, session, envId, dataBase, key, modelCreator, callback){

      if(callback){

        if(session != null)this.__getModelWithSession(bufferName, session, key, modelCreator, callback); else if(dataBase != null)this.__getModelWithDataBase(bufferName, dataBase, key, modelCreator, callback); else this.__getModelWithEnvId(bufferName, envId, key, modelCreator, callback);;
      } else {

        var model = null;
        if(session != null)model = this.__getModelWithSession(bufferName, session, key, modelCreator); else if(dataBase != null)model = this.__getModelWithDataBase(bufferName, dataBase, key, modelCreator); else model = this.__getModelWithEnvId(bufferName, envId, key, modelCreator);;
        return model;
      };
    },
    dispatchGetAllModels : function(bufferName, session, envId, dataBase, modelCreator, callback){

      if(callback){

        if(session != null)this.__getAllModelsWithSession(bufferName, session, modelCreator, callback); else if(dataBase != null)this.__getAllModelsWithDataBase(bufferName, dataBase, modelCreator, callback); else this.__getAllModelsWithEnvId(bufferName, envId, modelCreator, callback);;
      } else {

        var modelList = null;
        if(session != null)modelList = this.__getAllModelsWithSession(bufferName, session, modelCreator); else if(dataBase != null)modelList = this.__getAllModelsWithDataBase(bufferName, dataBase, modelCreator); else modelList = this.__getAllModelsWithEnvId(bufferName, envId, modelCreator);;
        return modelList;
      };
    }
  }
});
qx.Class.define("xlsys.base.util.TranslateUtil", {
  extend : xlsys.base.buffer.AbstractBuffer,
  statics : {
    DEFAULT_TABLENAME : "_default_table",
    tuMap : new xlsys.java.util.HashMap(),
    getInstance : function(language){

      if(language == null)language = xlsys.base.util.SystemUtil.getUserLanguage();
      var tu = this.tuMap.get(language);
      if(tu == null){

        tu = new xlsys.base.util.TranslateUtil(language);
        this.tuMap.put(language, tu);
      };
      return tu;
    }
  },
  construct : function(language){

    xlsys.base.buffer.AbstractBuffer.call(this);
    if(language == null)language = xlsys.base.util.SystemUtil.getUserLanguage();
    this._language = language;
    xlsys.base.buffer.BufferManager.getInstance().registerBuffer(xlsys.base.XLSYS.BUFFER_TRANSLATION_PREFIX + language, this);
  },
  members : {
    _language : null,
    _tableCount : null,
    getTranslateStr : function(){

      var envId = null;
      var dataBase = null;
      var srcStr = null;
      var tableNames = null;
      var callback = null;
      if(arguments.length == 2){

        dataBase = arguments[0];
        srcStr = arguments[1];
        envId = dataBase.getEnvId();
        tableNames = this.self(arguments).DEFAULT_TABLENAME;
      } else if(arguments.length == 3){

        if(qx.lang.Type.isNumber(arguments[0])){

          envId = arguments[0];
          dataBase = arguments[1];
          srcStr = arguments[2];
          tableNames = this.self(arguments).DEFAULT_TABLENAME;
        } else if(qx.lang.Type.isString(arguments[2])){

          dataBase = arguments[0];
          srcStr = arguments[1];
          tableNames = arguments[2];
          envId = dataBase.getEnvId();
        } else {

          dataBase = arguments[0];
          srcStr = arguments[1];
          envId = dataBase.getEnvId();
          tableNames = this.self(arguments).DEFAULT_TABLENAME;
          callback = arguments[2];
        };
      } else if(arguments.length == 4){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[3])){

            envId = arguments[0];
            dataBase = arguments[1];
            srcStr = arguments[2];
            tableNames = arguments[3];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            srcStr = arguments[2];
            tableNames = this.self(arguments).DEFAULT_TABLENAME;
            callback = arguments[3];
          };
        } else {

          dataBase = arguments[0];
          srcStr = arguments[1];
          tableNames = arguments[2];
          envId = dataBase.getEnvId();
          callback = arguments[3];
        };
      } else {

        envId = arguments[0];
        dataBase = arguments[1];
        srcStr = arguments[2];
        tableNames = arguments[3];
        callback = arguments[4];
      };;
      if(tableNames == null)tableNames = this.self(arguments).DEFAULT_TABLENAME; else if(this.self(arguments).DEFAULT_TABLENAME != tableNames && tableNames.indexOf(this.self(arguments).DEFAULT_TABLENAME) == -1)tableNames += xlsys.base.XLSYS.KEY_CODE_SEPARATOR + this.self(arguments).DEFAULT_TABLENAME;;
      var retStr = null;
      var paramMap = new xlsys.java.util.HashMap();
      paramMap.put(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME, tableNames);
      var bufferName = xlsys.base.XLSYS.BUFFER_TRANSLATION_PREFIX + this._language;
      if(callback)this.getBufferData(bufferName, paramMap, qx.Bootstrap.bind(this.__getTranslateStr1, this, srcStr, callback)); else {

        var tableMap = this.getBufferData(bufferName, paramMap);
        retStr = tableMap.get(srcStr);
        if(retStr == null)retStr = srcStr;
        return retStr;
      };
    },
    __getTranslateStr1 : function(srcStr, callback, tableMap){

      var retStr = tableMap.get(srcStr);
      if(retStr == null)retStr = srcStr;
      callback(retStr);
    },
    getTranslateMap : function(){

      var envId = null;
      var dataBase = null;
      var srcMap = null;
      var tableNames = null;
      var callback = null;
      if(arguments.length == 2){

        dataBase = arguments[0];
        srcMap = arguments[1];
        envId = dataBase.getEnvId();
        tableNames = this.self(arguments).DEFAULT_TABLENAME;
      } else if(arguments.length == 3){

        if(qx.lang.Type.isNumber(arguments[0])){

          envId = arguments[0];
          dataBase = arguments[1];
          srcMap = arguments[2];
          tableNames = this.self(arguments).DEFAULT_TABLENAME;
        } else if(qx.lang.Type.isString(arguments[2])){

          dataBase = arguments[0];
          srcMap = arguments[1];
          tableNames = arguments[2];
          envId = dataBase.getEnvId();
        } else {

          dataBase = arguments[0];
          srcMap = arguments[1];
          envId = dataBase.getEnvId();
          tableNames = this.self(arguments).DEFAULT_TABLENAME;
          callback = arguments[2];
        };
      } else if(arguments.length == 4){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[3])){

            envId = arguments[0];
            dataBase = arguments[1];
            srcMap = arguments[2];
            tableNames = arguments[3];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            srcMap = arguments[2];
            tableNames = this.self(arguments).DEFAULT_TABLENAME;
            callback = arguments[3];
          };
        } else {

          dataBase = arguments[0];
          srcMap = arguments[1];
          tableNames = arguments[2];
          envId = dataBase.getEnvId();
          callback = arguments[3];
        };
      } else {

        envId = arguments[0];
        dataBase = arguments[1];
        srcMap = arguments[2];
        tableNames = arguments[3];
        callback = arguments[4];
      };;
      if(tableNames == null)tableNames = this.self(arguments).DEFAULT_TABLENAME; else if(this.self(arguments).DEFAULT_TABLENAME != tableNames && tableNames.indexOf(this.self(arguments).DEFAULT_TABLENAME) == -1)tableNames += xlsys.base.XLSYS.KEY_CODE_SEPARATOR + this.self(arguments).DEFAULT_TABLENAME;;
      var paramMap = new xlsys.java.util.HashMap();
      paramMap.put(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME, tableNames);
      var bufferName = xlsys.base.XLSYS.BUFFER_TRANSLATION_PREFIX + this._language;
      if(callback)this.getBufferData(bufferName, paramMap, qx.Bootstrap.bind(this.__getTranslateMap1, this, srcMap, callback)); else {

        var tableMap = this.getBufferData(bufferName, paramMap);
        return this.__getTranslateMap1(srcMap, null, tableMap);
      };
    },
    __getTranslateMap1 : function(srcMap, callback, tableMap){

      var mapClass = srcMap.classname;
      var retMap = xlsys.base.util.ReflectUtil.newInstance(mapClass);
      if(!tableMap.isEmpty()){

        var keys = srcMap.keys();
        for(var i = 0;i < keys.length;++i){

          var transValue = tableMap.get(srcMap.get(keys[i]));
          if(transValue == null)retMap.put(keys[i], srcMap.get(keys[i])); else retMap.put(keys[i], transValue);
        };
      } else retMap.putAll(srcMap);
      if(callback)callback(retMap); else return retMap;
    },
    translateDataSet : function(){

      var envId = null;
      var dataBase = null;
      var dataSet = null;
      var tableNames = null;
      var transCols = null;
      var colSpliter = null;
      var callback = null;
      if(arguments.length == 2){

        dataBase = arguments[0];
        dataSet = arguments[1];
      } else if(arguments.length == 3){

        if(qx.lang.Type.isNumber(arguments[0])){

          envId = arguments[0];
          dataBase = arguments[1];
          dataSet = arguments[2];
        } else if(qx.lang.Type.isString(arguments[2])){

          dataBase = arguments[0];
          dataSet = arguments[1];
          callback = arguments[2];
        } else {

          dataBase = arguments[0];
          dataSet = arguments[1];
          tableNames = arguments[2];
        };
      } else if(arguments.length == 4){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[3])){

            envId = arguments[0];
            dataBase = arguments[1];
            dataSet = arguments[2];
            tableNames = arguments[3];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            dataSet = arguments[2];
            callback = arguments[3];
          };
        } else {

          if(qx.lang.Type.isString(arguments[3])){

            dataBase = arguments[0];
            dataSet = arguments[1];
            tableNames = arguments[2];
            transCols = arguments[3];
          } else {

            dataBase = arguments[0];
            dataSet = arguments[1];
            tableNames = arguments[2];
            callback = arguments[3];
          };
        };
      } else if(arguments.length == 5){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[4])){

            envId = arguments[0];
            dataBase = arguments[1];
            dataSet = arguments[2];
            tableNames = arguments[3];
            transCols = arguments[4];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            dataSet = arguments[2];
            tableNames = arguments[3];
            callback = arguments[4];
          };
        } else {

          dataBase = arguments[0];
          dataSet = arguments[1];
          tableNames = arguments[2];
          transCols = arguments[3];
          callback = arguments[4];
        };
      } else if(arguments.length == 6){

        if(qx.lang.Type.isNumber(arguments[0])){

          envId = arguments[0];
          dataBase = arguments[1];
          dataSet = arguments[2];
          tableNames = arguments[3];
          transCols = arguments[4];
          colSpliter = arguments[5];
        } else {

          envId = arguments[0];
          dataBase = arguments[1];
          dataSet = arguments[2];
          tableNames = arguments[3];
          transCols = arguments[4];
          callback = arguments[5];
        };
      } else {

        envId = arguments[0];
        dataBase = arguments[1];
        dataSet = arguments[2];
        tableNames = arguments[3];
        transCols = arguments[4];
        colSpliter = arguments[5];
        callback = arguments[6];
      };;;;
      if(dataSet == null || dataSet.getRowCount() == 0)return;
      if(envId == null)envId = dataBase.getEnvId();
      if(transCols == null)transCols = "name";
      if(colSpliter == null)colSpliter = xlsys.base.XLSYS.KEY_CODE_SEPARATOR;
      if(tableNames == null)tableNames = this.self(arguments).DEFAULT_TABLENAME; else if(this.self(arguments).DEFAULT_TABLENAME != tableNames && tableNames.indexOf(this.self(arguments).DEFAULT_TABLENAME) == -1)tableNames += xlsys.base.XLSYS.KEY_CODE_SEPARATOR + this.self(arguments).DEFAULT_TABLENAME;;
      if(dataSet.getTableName){

        var tableName = dataSet.getTableName();
        if(tableName != null && tableNames.indexOf(tableName) == -1)tableNames = tableName + xlsys.base.XLSYS.KEY_CODE_SEPARATOR + tableNames;
      };
      var paramMap = new xlsys.java.util.HashMap();
      paramMap.put(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME, tableNames);
      var bufferName = xlsys.base.XLSYS.BUFFER_TRANSLATION_PREFIX + this._language;
      if(callback)this.getBufferData(bufferName, paramMap, qx.Bootstrap.bind(this.__translateDataSet1, this, dataSet, transCols, colSpliter, callback)); else {

        var tableMap = this.getBufferData(bufferName, paramMap);
        this.__translateDataSet1(dataSet, transCols, colSpliter, null, tableMap);
      };
    },
    __translateDataSet1 : function(dataSet, transCols, colSpliter, callback, tableMap){

      if(!tableMap.isEmpty()){

        var transColArr = transCols.split(colSpliter);
        for(var i = 0;i < transColArr.length;++i){

          var colName = transColArr[i];
          var dsc = dataSet.getColumn(colName);
          if(dsc != null){

            var colIndex = dataSet.getColumnIndex(colName);
            var rowCount = dataSet.getRowCount();
            for(var j = 0;j < rowCount;++j){

              var dsCell = dataSet.getRow(j).getCell(colIndex);
              var oldValue = dsCell.getContent();
              var newValue = null;
              if(oldValue != null){

                newValue = tableMap.get(oldValue);
                if(newValue != null)dsCell.setContent(newValue);
              };
            };
          };
        };
      };
      if(callback)callback();
    },
    translateModel : function(){

      var envId = null;
      var dataBase = null;
      var model = null;
      var tableNames = null;
      var transFields = null;
      var fieldSpliter = null;
      var callback = null;
      if(arguments.length == 2){

        dataBase = arguments[0];
        model = arguments[1];
      } else if(arguments.length == 3){

        if(qx.lang.Type.isNumber(arguments[0])){

          envId = arguments[0];
          dataBase = arguments[1];
          model = arguments[2];
        } else if(qx.lang.Type.isString(arguments[2])){

          dataBase = arguments[0];
          model = arguments[1];
          tableNames = arguments[2];
        } else {

          dataBase = arguments[0];
          model = arguments[1];
          callback = arguments[2];
        };
      } else if(arguments.length == 4){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[3])){

            envId = arguments[0];
            dataBase = arguments[1];
            model = arguments[2];
            tableNames = arguments[3];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            model = arguments[2];
            callback = arguments[3];
          };
        } else {

          if(qx.lang.Type.isString(arguments[3])){

            dataBase = arguments[0];
            model = arguments[1];
            tableNames = arguments[2];
            transFields = arguments[3];
          } else {

            dataBase = arguments[0];
            model = arguments[1];
            tableNames = arguments[2];
            callback = arguments[3];
          };
        };
      } else if(arguments.length == 5){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[4])){

            envId = arguments[0];
            dataBase = arguments[1];
            model = arguments[2];
            tableNames = arguments[3];
            transFields = arguments[4];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            model = arguments[2];
            tableNames = arguments[3];
            callback = arguments[4];
          };
        } else {

          dataBase = arguments[0];
          model = arguments[1];
          tableNames = arguments[2];
          transFields = arguments[3];
          callback = arguments[4];
        };
      } else if(arguments.length == 6){

        if(qx.lang.Type.isString(arguments[5])){

          envId = arguments[0];
          dataBase = arguments[1];
          model = arguments[2];
          tableNames = arguments[3];
          transFields = arguments[4];
          fieldSpliter = arguments[5];
        } else {

          envId = arguments[0];
          dataBase = arguments[1];
          model = arguments[2];
          tableNames = arguments[3];
          transFields = arguments[4];
          callback = arguments[5];
        };
      } else {

        envId = arguments[0];
        dataBase = arguments[1];
        model = arguments[2];
        tableNames = arguments[3];
        transFields = arguments[4];
        fieldSpliter = arguments[5];
        callback = arguments[6];
      };;;;
      if(envId == null)envId = dataBase.getEnvId();
      if(transFields == null)transFields = "name";
      if(fieldSpliter == null)fieldSpliter = xlsys.base.XLSYS.KEY_CODE_SEPARATOR;
      var srcModelList = new xlsys.java.util.ArrayList();
      srcModelList.add(model);
      if(callback)this.translateModelList(envId, dataBase, srcModelList, tableNames, transFields, fieldSpliter, qx.Bootstrap.bind(this.__translateModel1, this, callback)); else {

        var translatedModelList = this.translateModelList(envId, dataBase, srcModelList, tableNames, transFields, fieldSpliter);
        if(translatedModelList.isEmpty())return null;
        return translatedModelList.get(0);
      };
    },
    __translateModel1 : function(callback, translatedModelList){

      if(translatedModelList.isEmpty())callback(null); else callback(translatedModelList.get(0));
    },
    translateModelList : function(){

      var envId = null;
      var dataBase = null;
      var modelList = null;
      var tableNames = null;
      var transFields = null;
      var fieldSpliter = null;
      var callback = null;
      if(arguments.length == 2){

        dataBase = arguments[0];
        modelList = arguments[1];
      } else if(arguments.length == 3){

        if(qx.lang.Type.isNumber(arguments[0])){

          envId = arguments[0];
          dataBase = arguments[1];
          modelList = arguments[2];
        } else if(qx.lang.Type.isString(arguments[2])){

          dataBase = arguments[0];
          modelList = arguments[1];
          tableNames = arguments[2];
        } else {

          dataBase = arguments[0];
          modelList = arguments[1];
          callback = arguments[2];
        };
      } else if(arguments.length == 4){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[3])){

            envId = arguments[0];
            dataBase = arguments[1];
            modelList = arguments[2];
            tableNames = arguments[3];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            modelList = arguments[2];
            callback = arguments[3];
          };
        } else {

          if(qx.lang.Type.isString(arguments[3])){

            dataBase = arguments[0];
            modelList = arguments[1];
            tableNames = arguments[2];
            transFields = arguments[3];
          } else {

            dataBase = arguments[0];
            modelList = arguments[1];
            tableNames = arguments[2];
            callback = arguments[3];
          };
        };
      } else if(arguments.length == 5){

        if(qx.lang.Type.isNumber(arguments[0])){

          if(qx.lang.Type.isString(arguments[4])){

            envId = arguments[0];
            dataBase = arguments[1];
            modelList = arguments[2];
            tableNames = arguments[3];
            transFields = arguments[4];
          } else {

            envId = arguments[0];
            dataBase = arguments[1];
            modelList = arguments[2];
            tableNames = arguments[3];
            callback = arguments[4];
          };
        } else {

          dataBase = arguments[0];
          modelList = arguments[1];
          tableNames = arguments[2];
          transFields = arguments[3];
          callback = arguments[4];
        };
      } else if(arguments.length == 6){

        if(qx.lang.Type.isString(arguments[5])){

          envId = arguments[0];
          dataBase = arguments[1];
          modelList = arguments[2];
          tableNames = arguments[3];
          transFields = arguments[4];
          fieldSpliter = arguments[5];
        } else {

          envId = arguments[0];
          dataBase = arguments[1];
          modelList = arguments[2];
          tableNames = arguments[3];
          transFields = arguments[4];
          callback = arguments[5];
        };
      } else {

        envId = arguments[0];
        dataBase = arguments[1];
        modelList = arguments[2];
        tableNames = arguments[3];
        transFields = arguments[4];
        fieldSpliter = arguments[5];
        callback = arguments[6];
      };;;;
      var cloneModelList = new xlsys.java.util.ArrayList();
      if(modelList == null || modelList.isEmpty())return cloneModelList;
      if(envId == null)envId = dataBase.getEnvId();
      if(tableNames == null)tableNames = this.self(arguments).DEFAULT_TABLENAME; else if(this.self(arguments).DEFAULT_TABLENAME != tableNames && tableNames.indexOf(this.self(arguments).DEFAULT_TABLENAME) == -1)tableNames += xlsys.base.XLSYS.KEY_CODE_SEPARATOR + this.self(arguments).DEFAULT_TABLENAME;;
      var firstModel = modelList.get(0);
      if(firstModel.getRefTableName){

        var tableName = firstModel.getRefTableName();
        if(tableName != null && tableNames.indexOf(tableName) == -1)tableNames = tableName + xlsys.base.XLSYS.KEY_CODE_SEPARATOR + tableNames;
      };
      var paramMap = new xlsys.java.util.HashMap();
      paramMap.put(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME, tableNames);
      var bufferName = xlsys.base.XLSYS.BUFFER_TRANSLATION_PREFIX + this._language;
      if(callback)this.getBufferData(bufferName, paramMap, qx.Bootstrap.bind(this.__translateModelList1, this, modelList, transFields, fieldSpliter, cloneModelList, callback)); else {

        var tableMap = this.getBufferData(bufferName, paramMap);
        return this.__translateModelList1(modelList, transFields, fieldSpliter, cloneModelList, null, tableMap);
      };
    },
    __translateModelList1 : function(modelList, transFields, fieldSpliter, cloneModelList, callback, tableMap){

      if(transFields == null)transFields = "name";
      if(fieldSpliter == null)fieldSpliter = xlsys.base.XLSYS.KEY_CODE_SEPARATOR;
      for(var i = 0;i < modelList.size();++i){

        var model = modelList.get(i);
        var cloneModel = xlsys.base.model.ModelUtil.cloneModel(model);
        cloneModelList.add(cloneModel);
      };
      if(!tableMap.isEmpty()){

        var transFieldArr = transFields.split(fieldSpliter);
        for(var i = 0;i < transFieldArr.length;++i){

          var fieldName = transFieldArr[i];
          for(var j = 0;j < cloneModelList.size();++j){

            var cloneModel = cloneModelList.get(j);
            var oldValue = cloneModel[fieldName];
            if(oldValue != null){

              var newValue = tableMap.get(oldValue);
              if(newValue != null)cloneModel[fieldName] = newValue;
            };
          };
        };
      };
      if(callback)callback(cloneModelList); else return cloneModelList;
    },
    getStorageObject : function(bufferName, mark){

      var arr = new Array();
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      arr.push(this.getBufferMap(envId, bufferName));
      if(mark == xlsys.base.buffer.XlsysBuffer.MARK_ALL)arr.push(this._tableCount);
      return arr;
    },
    isBufferComplete : function(bufferName, callback){

      if(this._tableCount == null){

        var dataBase = xlsys.base.database.ClientDataBase.getInstance();
        var selectSql = "select count(1) from (select distinct tablename from xlsys_translator where language=?) lxd_sub";
        var pb = new xlsys.base.database.bean.ParamBean(selectSql);
        pb.addParamGroup();
        pb.setParam(1, this._language);
        if(callback){

          dataBase.sqlSelectAsOneValue(pb, qx.Bootstrap.bind(this.__isBufferComplete1, this, dataBase, bufferName, callback));
          return;
        } else {

          this._tableCount = dataBase.sqlSelectAsOneValue(pb);
          dataBase.close();
        };
      };
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var isComplete = this.getBufferMap(envId, bufferName).size() == this._tableCount;
      if(callback)callback(isComplete); else return isComplete;
    },
    __isBufferComplete1 : function(dataBase, bufferName, callback, tableCount){

      this._tableCount = tableCount;
      dataBase.close();
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var isComplete = this.getBufferMap(envId, bufferName).size() == this._tableCount;
      callback(isComplete);
    },
    reloadDataDirectly : function(bufferName, paramMap, forceLoad, callback){

      var tableNames = null;
      if(paramMap != null)tableNames = paramMap.get(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME);
      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var dictionaryMap = this.getBufferMap(envId, bufferName);
      if(tableNames != null){

        var tableArr = tableNames.split(xlsys.base.XLSYS.KEY_CODE_SEPARATOR);
        for(var i = 0;i < tableArr.length;++i){

          dictionaryMap.remove(tableArr[i]);
        };
      } else {

        dictionaryMap.clear();
        this._tableCount = null;
      };
      if(forceLoad)this.getBufferData(bufferName, paramMap, callback);
    },
    loadDataFromStorageObject : function(bufferName, storageObj, mark){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var dictionaryMap = this.getBufferMap(envId, bufferName);
      if(mark == xlsys.base.buffer.XlsysBuffer.MARK_ALL){

        dictionaryMap.clear();
        this._tableCount = storageObj[1];
      };
      dictionaryMap.putAll(storageObj[0]);
      return true;
    },
    doGetBufferData : function(bufferName, paramMap, callback){

      var session = xlsys.base.session.SessionManager.getInstance().getCurrentSession();
      var envId = session.getAttribute(xlsys.base.XLSYS.SESSION_ENV_ID);
      var tableNames = null;
      if(paramMap != null)tableNames = paramMap.get(xlsys.base.database.IDataBase.BUFFER_KEY_TABLE_NAME);
      var dictionaryMap = this.getBufferMap(envId, bufferName);
      var ret = null;
      if(this._tableCount == null || this._tableCount != dictionaryMap.size()){

        var map = new xlsys.java.util.HashMap();
        map.put("language", this._language);
        dictionaryMap.clear();
        if(callback){

          xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_GET_TRANSLATE_DATA, map, qx.Bootstrap.bind(this.__doGetBufferData1, this, dictionaryMap, tableNames, callback));
          return;
        } else {

          var dataMap = xlsys.base.io.transfer.client.ClientTransfer.defaultPost(xlsys.base.XLSYS.COMMAND_GET_TRANSLATE_DATA, map);
          if(dataMap != null)dictionaryMap.putAll(dataMap);
          this._tableCount = dictionaryMap.size();
        };
      };
      return this.__doGetBufferData2(tableNames, dictionaryMap, null);
    },
    __doGetBufferData1 : function(dictionaryMap, tableNames, callback, dataMap){

      if(dataMap != null)dictionaryMap.putAll(dataMap);
      this._tableCount = dictionaryMap.size();
      this.__doGetBufferData2(tableNames, dictionaryMap, callback);
    },
    __doGetBufferData2 : function(tableNames, dictionaryMap, callback){

      var ret = null;
      if(tableNames != null){

        var tableMap = new xlsys.java.util.HashMap();
        var tableArr = tableNames.split(xlsys.base.XLSYS.KEY_CODE_SEPARATOR);
        for(var i = 0;i < tableArr.length;++i){

          var tablecolumnMap = dictionaryMap.get(tableArr[i]);
          if(tablecolumnMap != null)tableMap.putAll(tablecolumnMap);
        };
        ret = tableMap;
      } else ret = dictionaryMap;
      if(callback)callback(ret); else return ret;
    },
    saveDataToLocalStorage : function(bufferName, storageObject, callback){

      if(callback)callback(false); else return false;
    },
    reloadDataFromLocalStorage : function(bufferName, callback){

      if(callback)callback(false); else return false;
    },
    getLocalStorageVersion : function(bufferName, callback){

      if(callback)callback(-1); else return -1;
    }
  }
});
qx.Class.define("xlsys.java.util.StrictLinkedHashMap", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.java.util.Map],
  construct : function(){

    this.__map = new Object();
    this.__keys = new Array();
  },
  members : {
    __map : null,
    __keys : null,
    _getHashKey : function(obj){

      return xlsys.base.util.ObjectUtil.hashcode(obj);
    },
    getClassName : function(){

      return "java.util.LinkedHashMap";
    },
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("__map");
      arr.push("__keys");
      return arr;
    },
    clear : function(){

      for(var fieldName in this.__map){

        delete this.__map[fieldName];
      };
      while(this.__keys.pop() != null);
    },
    containsKey : function(key){

      var keyHash = this._getHashKey(key);
      return this.__map[keyHash] != null;
    },
    containsValue : function(value){

      var contains = false;
      for(var fieldName in this.__map){

        if(this._getHashKey(this.__map[fieldName]) == this._getHashKey(value)){

          contains = true;
          break;
        };
      };
      return contains;
    },
    get : function(key){

      var keyHash = this._getHashKey(key);
      return this.__map[keyHash];
    },
    isEmpty : function(){

      return this.__keys.length == 0;
    },
    put : function(key, value){

      if(!this.containsKey(key))this.__keys.push(key);
      var keyHash = this._getHashKey(key);
      this.__map[keyHash] = value;
    },
    putAll : function(m){

      var keyArr = m.keys();
      for(var i = 0;i < keyArr.length;++i){

        this.put(keyArr[i], m.get(keyArr[i]));
      };
    },
    remove : function(key){

      var keyHash = this._getHashKey(key);
      if(delete this.__map[keyHash]){

        for(var i = 0;i < this.__keys.length;++i){

          if(this._getHashKey(this.__keys[i]) == keyHash){

            this.__keys.splice(i, 1);
            break;
          };
        };
      };
    },
    size : function(){

      return this.__keys.length;
    },
    keys : function(){

      var tempArr = new Array();
      for(var i = 0;i < this.__keys.length;++i){

        tempArr.push(this.__keys[i]);
      };
      return tempArr;
    },
    values : function(){

      var tempArr = new Array();
      for(var i = 0;i < this.__keys.length;++i){

        var keyHash = this._getHashKey(this.__keys[i]);
        tempArr.push(this.__map[keyHash]);
      };
      return tempArr;
    },
    keySet : function(){

      var set = new xlsys.java.util.StrictLinkedHashSet();
      for(var i = 0;i < this.__keys.length;++i){

        set.add(this.__keys[i]);
      };
      return set;
    },
    entrySet : function(){

      var set = new xlsys.java.util.StrictLinkedHashSet();
      for(var i = 0;i < this.__keys.length;++i){

        var key = this.__keys[i];
        var keyHash = this._getHashKey(this.__keys[i]);
        var value = this.__map[keyHash];
        var entry = new xlsys.java.util.SimpleEntry(key, value);
        set.add(entry);
      };
      return set;
    }
  }
});
qx.Class.define("xlsys.base.dataset.StorableTreeDataSet", {
  extend : xlsys.base.dataset.StorableDataSet,
  implement : [xlsys.base.dataset.ITreeDataSet],
  construct : function(){

    this.treeColIdx = null;
    var style = null;
    var sds = null;
    if(arguments.length == 1){

      sds = arguments[0];
      style = sds.getStyle();
    } else if(arguments.length == 2){

      if(qx.Class.implementsInterface(arguments[0], xlsys.base.dataset.IStorableDataSet)){

        sds = arguments[0];
        style = arguments[1];
        xlsys.base.dataset.StorableDataSet.call(this, sds.getDataBase(), sds.getSelectBean(), sds.getTableName(), style);
        this.refDataSet(sds);
      } else {

        xlsys.base.dataset.StorableDataSet.call(this, arguments[0], arguments[1]);
      };
    } else if(arguments.length == 3){

      xlsys.base.dataset.StorableDataSet.call(this, arguments[0], arguments[1], arguments[2]);
    } else if(arguments.length == 4){

      xlsys.base.dataset.StorableDataSet.call(this, arguments[0], arguments[1], arguments[2], arguments[3]);
    };;;
  },
  members : {
    treeColIdx : null,
    open : function(){

      xlsys.base.dataset.StorableDataSet.prototype.open.call(this);
      if(this.getTreeColumn() != -1){

        this.sorted = false;
        this.sort();
      };
    },
    setTreeColumn : function(colNameOrIdx){

      var colIdx = null;
      if(qx.lang.Type.isString(colNameOrIdx))colIdx = this.getColumnIndex(colNameOrIdx); else colIdx = colNameOrIdx;
      var sortType = xlsys.base.dataset.IDataSet.SORT_TYPE_ASC;
      if(arguments.length == 2)sortType = arguments[1];
      return xlsys.base.dataset.TreeDataSet.doSetTreeColumn(this, colIdx, sortType);
    },
    setTreeColIdx : function(treeColIdx){

      this.treeColIdx = treeColIdx;
    },
    getTreeColumnName : function(){

      return xlsys.base.dataset.TreeDataSet.doGetTreeColumnName(this);
    },
    getTreeColumn : function(){

      return this.treeColIdx == null ? -1 : this.treeColIdx;
    },
    setSortColumn : function(){

      xlsys.base.dataset.TreeDataSet.doSetSortColumn(this);
    },
    swapRow : function(i, j){

      xlsys.base.dataset.TreeDataSet.doSwapRow(this);
    },
    getRootRows : function(){

      return xlsys.base.dataset.TreeDataSet.getRowList(this, this.getRootRowNums());
    },
    getRootRowNums : function(){

      return xlsys.base.dataset.TreeDataSet.doGetRootRowNums(this);
    },
    getChildrenRows : function(rowOrRowAt){

      return xlsys.base.dataset.TreeDataSet.getRowList(this, this.getChildrenRowNums(rowOrRowAt));
    },
    getChildrenRowNums : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return xlsys.base.dataset.TreeDataSet.doGetChildrenRowNums(this, rowAt);
    },
    getAllChildrenRows : function(rowOrRowAt){

      return xlsys.base.dataset.TreeDataSet.getRowList(this, this.getAllChildrenRowNums(rowOrRowAt));
    },
    getAllChildrenRowNums : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return xlsys.base.dataset.TreeDataSet.doGetAllChildrenRowNums(this, rowAt);
    },
    getParentRow : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return xlsys.base.dataset.TreeDataSet.doGetParentRow(this, rowAt);
    },
    getParentRowNum : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return xlsys.base.dataset.TreeDataSet.doGetParentRowNum(this, rowAt);
    },
    getAllParent : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return xlsys.base.dataset.TreeDataSet.doGetAllParent(this, rowAt);
    },
    removeRow : function(rowIndex){

      var children = this.getChildrenRowNums(rowIndex);
      if(children != null){

        for(var i = children.size() - 1;i >= 0;--i){

          this.removeRow(children.get(i));
        };
      };
      return xlsys.base.dataset.StorableDataSet.prototype.removeRow.call(this, rowIndex);
    }
  }
});
qx.Class.define("xlsys.base.dataset.TreeDataSet", {
  extend : xlsys.base.dataset.DataSet,
  implement : [xlsys.base.dataset.ITreeDataSet],
  construct : function(){

    this.treeColIdx = null;
    var style = null;
    var refDataSet = null;
    if(arguments.length == 0)xlsys.base.dataset.DataSet.call(this); else if(arguments.length == 1){

      if(qx.lang.Type.isNumber(arguments[0]))style = arguments[0]; else {

        refDataSet = arguments[0];
        style = xlsys.base.dataset.IDataSet.STYLE_NONE;
      };
    } else if(arguments.length == 2){

      refDataSet = arguments[0];
      style = arguments[1];
    };;
    if(style != null)xlsys.base.dataset.DataSet.call(this, style);
    if(refDataSet != null)this.refDataSet(refDataSet);
  },
  statics : {
    doSetTreeColumn : function(treeDataSet, columnIdx, sortType){

      var success = false;
      if(columnIdx >= 0 && columnIdx < treeDataSet.getColumnCount()){

        var sortColMap = new xlsys.java.util.HashMap();
        sortColMap.put(treeDataSet.getColumnName(columnIdx), sortType);
        treeDataSet.setSortColMap(sortColMap);
        treeDataSet.sort();
        treeDataSet.setTreeColIdx(columnIdx);
        success = true;
      };
      return success;
    },
    doGetTreeColumnName : function(treeDataSet){

      var colName = null;
      var treeColIdx = treeDataSet.getTreeColumn();
      if(treeColIdx != -1)colName = treeDataSet.getColumnName(treeColIdx);
      return colName;
    },
    doSetSortColumn : function(treeDataSet){

      throw new xlsys.java.lang.Exception("This method is unsupported for ITreeDataSet, try method : setTreeColumn instead.");
    },
    doSwapRow : function(treeDataSet){

      throw new xlsys.java.lang.Exception("This method is unsupported for ITreeDataSet.");
    },
    getRowList : function(treeDataSet, rowAtList){

      var rowList = null;
      if(rowAtList != null){

        rowList = new xlsys.java.util.ArrayList();
        var rows = treeDataSet.getRows();
        for(var i = 0;i < rowAtList.size();++i){

          var rowAt = rowAtList.get(i);
          rowList.add(rows.get(rowAt));
        };
      };
      return rowList;
    },
    doGetRootRowNums : function(treeDataSet){

      var root = null;
      var childrenSet = new xlsys.java.util.HashSet();
      var rows = treeDataSet.getRows();
      for(var i = 0;i < rows.size();++i){

        if(!childrenSet.contains(i)){

          if(root == null)root = new xlsys.java.util.ArrayList();
          root.add(i);
          var children = treeDataSet.getAllChildrenRowNums(i);
          if(children != null)childrenSet.addAll(children);
        };
      };
      return root;
    },
    doGetChildrenRowNums : function(treeDataSet, rowAt){

      var children = null;
      var treeColIdx = treeDataSet.getTreeColumn();
      if(treeColIdx != -1){

        var rows = treeDataSet.getRows();
        if(rowAt >= 0 && rowAt < rows.size()){

          var row = rows.get(rowAt);
          var rowStr = "" + row.getCell(treeColIdx).getContent();
          var lastStr = null;
          for(var i = rowAt + 1;i < rows.size();++i){

            var otherRow = rows.get(i);
            var otherRowStr = "" + otherRow.getCell(treeColIdx).getContent();
            if((lastStr == null || (lastStr != null && !qx.lang.String.startsWith(otherRowStr, lastStr))) && qx.lang.String.startsWith(otherRowStr, rowStr) && otherRowStr.length > rowStr.length){

              if(children == null)children = new xlsys.java.util.ArrayList();
              children.add(i);
              lastStr = otherRowStr;
            } else if(otherRowStr.length <= rowStr.length){

              break;
            };
          };
        };
      };
      return children;
    },
    doGetAllChildrenRowNums : function(treeDataSet, rowAt){

      var children = null;
      var treeColIdx = treeDataSet.getTreeColumn();
      if(treeColIdx != -1){

        var rows = treeDataSet.getRows();
        if(rowAt >= 0 && rowAt < rows.size()){

          var row = rows.get(rowAt);
          var rowStr = "" + row.getCell(treeColIdx).getContent();
          for(var i = rowAt + 1;i < rows.size();++i){

            var otherRow = rows.get(i);
            var otherRowStr = "" + otherRow.getCell(treeColIdx).getContent();
            if(qx.lang.String.startsWith(otherRowStr, rowStr) && otherRowStr.length > rowStr.length){

              if(children == null)children = new xlsys.java.util.ArrayList();
              children.add(i);
            } else {

              break;
            };
          };
        };
      };
      return children;
    },
    doGetParentRow : function(treeDataSet, rowAt){

      var parentRow = null;
      var parentIdx = treeDataSet.getParentRowNum(rowAt);
      if(parentIdx != -1)parentRow = treeDataSet.getRow(parentIdx);
      return parentRow;
    },
    doGetParentRowNum : function(treeDataSet, rowAt){

      var parentIdx = -1;
      var treeColIdx = treeDataSet.getTreeColumn();
      if(treeColIdx != -1){

        var rows = treeDataSet.getRows();
        if(rowAt >= 0 && rowAt < rows.size()){

          var row = rows.get(rowAt);
          var rowStr = "" + row.getCell(treeColIdx).getContent();
          for(var i = rowAt - 1;i >= 0;--i){

            var otherRow = rows.get(i);
            var otherRowStr = "" + otherRow.getCell(treeColIdx).getContent();
            if(qx.lang.String.startsWith(rowStr, otherRowStr) && otherRowStr.length < rowStr.length){

              parentIdx = i;
              break;
            };
          };
        };
      };
      return parentIdx;
    },
    doGetAllParent : function(treeDataSet, rowAt){

      var parentList = null;
      var treeColIdx = treeDataSet.getTreeColumn();
      if(treeColIdx != -1){

        var rows = treeDataSet.getRows();
        if(rowAt >= 0 && rowAt < rows.size()){

          var row = rows.get(rowAt);
          var rowStr = "" + row.getCell(treeColIdx).getContent();
          for(var i = rowAt - 1;i >= 0;--i){

            var otherRow = rows.get(i);
            var otherRowStr = "" + otherRow.getCell(treeColIdx).getContent();
            if(qx.lang.String.startsWith(rowStr, otherRowStr) && otherRowStr.length < rowStr.length){

              if(parentList == null)parentList = new xlsys.java.util.ArrayList();
              parentList.add(i);
            };
          };
        };
      };
      return parentList;
    }
  },
  members : {
    treeColIdx : null,
    setTreeColumn : function(colNameOrIdx){

      var colIdx = null;
      if(qx.lang.Type.isString(colNameOrIdx))colIdx = this.getColumnIndex(colNameOrIdx); else colIdx = colNameOrIdx;
      var sortType = xlsys.base.dataset.IDataSet.SORT_TYPE_ASC;
      if(arguments.length == 2)sortType = arguments[1];
      return this.self(arguments).doSetTreeColumn(this, colIdx, sortType);
    },
    setTreeColIdx : function(treeColIdx){

      this.treeColIdx = treeColIdx;
    },
    getTreeColumnName : function(){

      return this.self(arguments).doGetTreeColumnName(this);
    },
    getTreeColumn : function(){

      return this.treeColIdx == null ? -1 : this.treeColIdx;
    },
    setSortColumn : function(){

      this.self(arguments).doSetSortColumn(this);
    },
    swapRow : function(i, j){

      this.self(arguments).doSwapRow(this);
    },
    getRootRows : function(){

      return this.self(arguments).getRowList(this, this.getRootRowNums());
    },
    getRootRowNums : function(){

      return this.self(arguments).doGetRootRowNums(this);
    },
    getChildrenRows : function(rowOrRowAt){

      return this.self(arguments).getRowList(this, this.getChildrenRowNums(rowOrRowAt));
    },
    getChildrenRowNums : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return this.self(arguments).doGetChildrenRowNums(this, rowAt);
    },
    getAllChildrenRows : function(rowOrRowAt){

      return this.self(arguments).getRowList(this, this.getAllChildrenRowNums(rowOrRowAt));
    },
    getAllChildrenRowNums : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return this.self(arguments).doGetAllChildrenRowNums(this, rowAt);
    },
    getParentRow : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return this.self(arguments).doGetParentRow(this, rowAt);
    },
    getParentRowNum : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return this.self(arguments).doGetParentRowNum(this, rowAt);
    },
    getAllParent : function(rowOrRowAt){

      var rowAt = null;
      if(qx.lang.Type.isNumber(rowOrRowAt))rowAt = rowOrRowAt; else rowAt = this.getRowIndex(rowOrRowAt);
      return this.self(arguments).doGetAllParent(this, rowAt);
    },
    removeRow : function(rowIndex){

      var children = this.getChildrenRowNums(rowIndex);
      if(children != null){

        for(var i = children.size() - 1;i >= 0;--i){

          this.removeRow(children.get(i));
        };
      };
      return xlsys.base.dataset.DataSet.prototype.removeRow.call(this, rowIndex);
    }
  }
});
qx.Interface.define("xlsys.base.buffer.IBufferDelegate", {
  members : {
    getStorageObject : function(buffer, bufferName, mark, keys){

      this.assertArgumentsCount(arguments, 3, 4);
    }
  }
});
qx.Class.define("xlsys.base.log.ConsoleLog", {
  extend : xlsys.base.log.Log,
  construct : function(logLevel){

    xlsys.base.log.Log.call(this, logLevel);
    this.__sb = new xlsys.java.lang.StringBuilder();
  },
  members : {
    __sb : null,
    write : function(level, content){

      var str = xlsys.base.util.ObjectUtil.objectToString(content);
      if(qx.lang.String.endsWith(str, "\n")){

        this.__sb.append(str.substr(0, str.length - 1));
        if(xlsys.base.log.Log.LOG_LEVEL_DEBUG <= level)console.info(this.__sb.toString()); else if(xlsys.base.log.Log.LOG_LEVEL_INFO <= level)console.info(this.__sb.toString()); else if(xlsys.base.log.Log.LOG_LEVEL_WARN <= level)console.warn(this.__sb.toString()); else if(xlsys.base.log.Log.LOG_LEVEL_ERROR <= level)console.error(this.__sb.toString()); else if(xlsys.base.log.Log.LOG_LEVEL_FATAL <= level)console.error(this.__sb.toString()); else console.log(this.__sb.toString());;;;;
        delete this.__sb;
        this.__sb = new xlsys.java.lang.StringBuilder();
      } else this.__sb.append(str);
      return str.length;
    },
    close : function(){
    }
  }
});
qx.Class.define("xlsys.base.model.PairModel", {
  extend : xlsys.java.io.Serializable,
  implement : [xlsys.base.model.IModel],
  construct : function(first, second){

    this.first = first;
    this.second = second;
  },
  members : {
    first : null,
    second : null,
    getSerializableMembers : function(){

      var arr = new Array();
      arr.push("first");
      arr.push("second");
      return arr;
    }
  }
});

if (typeof exports != "undefined") {
    for (var key in qx) {
        exports[key] = qx[key];
    }
}

qx.$$loader.init();

